// Copyright 2014 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// This file has been auto-generated by code_generator_v8.py.
// DO NOT MODIFY!

// clang-format off
#ifndef FileOrUSVString_h
#define FileOrUSVString_h

#include "bindings/core/v8/Dictionary.h"
#include "bindings/core/v8/ExceptionState.h"
#include "bindings/core/v8/V8Binding.h"
#include "core/CoreExport.h"
#include "platform/heap/Handle.h"

namespace blink {

class File;

class CORE_EXPORT FileOrUSVString final {
  DISALLOW_NEW_EXCEPT_PLACEMENT_NEW();
 public:
  FileOrUSVString();
  bool isNull() const { return m_type == SpecificTypeNone; }

  bool isFile() const { return m_type == SpecificTypeFile; }
  File* getAsFile() const;
  void setFile(File*);
  static FileOrUSVString fromFile(File*);

  bool isUSVString() const { return m_type == SpecificTypeUSVString; }
  String getAsUSVString() const;
  void setUSVString(String);
  static FileOrUSVString fromUSVString(String);

  FileOrUSVString(const FileOrUSVString&);
  ~FileOrUSVString();
  FileOrUSVString& operator=(const FileOrUSVString&);
  DECLARE_TRACE();

 private:
  enum SpecificTypes {
    SpecificTypeNone,
    SpecificTypeFile,
    SpecificTypeUSVString,
  };
  SpecificTypes m_type;

  Member<File> m_file;
  String m_uSVString;

  friend CORE_EXPORT v8::Local<v8::Value> toV8(const FileOrUSVString&, v8::Local<v8::Object>, v8::Isolate*);
};

class V8FileOrUSVString final {
 public:
  CORE_EXPORT static void toImpl(v8::Isolate*, v8::Local<v8::Value>, FileOrUSVString&, UnionTypeConversionMode, ExceptionState&);
};

CORE_EXPORT v8::Local<v8::Value> toV8(const FileOrUSVString&, v8::Local<v8::Object>, v8::Isolate*);

template <class CallbackInfo>
inline void v8SetReturnValue(const CallbackInfo& callbackInfo, FileOrUSVString& impl) {
  v8SetReturnValue(callbackInfo, toV8(impl, callbackInfo.Holder(), callbackInfo.GetIsolate()));
}

template <>
struct NativeValueTraits<FileOrUSVString> {
  CORE_EXPORT static FileOrUSVString nativeValue(v8::Isolate*, v8::Local<v8::Value>, ExceptionState&);
};

}  // namespace blink

// We need to set canInitializeWithMemset=true because HeapVector supports
// items that can initialize with memset or have a vtable. It is safe to
// set canInitializeWithMemset=true for a union type object in practice.
// See https://codereview.chromium.org/1118993002/#msg5 for more details.
WTF_ALLOW_MOVE_AND_INIT_WITH_MEM_FUNCTIONS(blink::FileOrUSVString);

#endif  // FileOrUSVString_h
