// Copyright 2014 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// This file has been auto-generated by code_generator_v8.py.
// DO NOT MODIFY!

// clang-format off
#include "NodeListOrElement.h"

#include "bindings/core/v8/DictionarySequenceOrDictionary.h"
#include "bindings/core/v8/ToV8.h"
#include "bindings/core/v8/V8Element.h"
#include "bindings/core/v8/V8NodeList.h"
#include "core/animation/ElementAnimation.h"
#include "core/dom/ChildNode.h"
#include "core/dom/ElementFullscreen.h"
#include "core/dom/NameNodeList.h"
#include "core/dom/NodeList.h"
#include "core/dom/NonDocumentTypeChildNode.h"
#include "core/dom/ParentNode.h"
#include "core/dom/StaticNodeList.h"
#include "core/html/LabelsNodeList.h"

namespace blink {

NodeListOrElement::NodeListOrElement() : m_type(SpecificTypeNone) {}

NodeList* NodeListOrElement::getAsNodeList() const {
  DCHECK(isNodeList());
  return m_nodeList;
}

void NodeListOrElement::setNodeList(NodeList* value) {
  DCHECK(isNull());
  m_nodeList = value;
  m_type = SpecificTypeNodeList;
}

NodeListOrElement NodeListOrElement::fromNodeList(NodeList* value) {
  NodeListOrElement container;
  container.setNodeList(value);
  return container;
}

Element* NodeListOrElement::getAsElement() const {
  DCHECK(isElement());
  return m_element;
}

void NodeListOrElement::setElement(Element* value) {
  DCHECK(isNull());
  m_element = value;
  m_type = SpecificTypeElement;
}

NodeListOrElement NodeListOrElement::fromElement(Element* value) {
  NodeListOrElement container;
  container.setElement(value);
  return container;
}

NodeListOrElement::NodeListOrElement(const NodeListOrElement&) = default;
NodeListOrElement::~NodeListOrElement() = default;
NodeListOrElement& NodeListOrElement::operator=(const NodeListOrElement&) = default;

DEFINE_TRACE(NodeListOrElement) {
  visitor->trace(m_nodeList);
  visitor->trace(m_element);
}

void V8NodeListOrElement::toImpl(v8::Isolate* isolate, v8::Local<v8::Value> v8Value, NodeListOrElement& impl, UnionTypeConversionMode conversionMode, ExceptionState& exceptionState) {
  if (v8Value.IsEmpty())
    return;

  if (conversionMode == UnionTypeConversionMode::Nullable && isUndefinedOrNull(v8Value))
    return;

  if (V8NodeList::hasInstance(v8Value, isolate)) {
    NodeList* cppValue = V8NodeList::toImpl(v8::Local<v8::Object>::Cast(v8Value));
    impl.setNodeList(cppValue);
    return;
  }

  if (V8Element::hasInstance(v8Value, isolate)) {
    Element* cppValue = V8Element::toImpl(v8::Local<v8::Object>::Cast(v8Value));
    impl.setElement(cppValue);
    return;
  }

  exceptionState.throwTypeError("The provided value is not of type '(NodeList or Element)'");
}

v8::Local<v8::Value> toV8(const NodeListOrElement& impl, v8::Local<v8::Object> creationContext, v8::Isolate* isolate) {
  switch (impl.m_type) {
    case NodeListOrElement::SpecificTypeNone:
      return v8::Null(isolate);
    case NodeListOrElement::SpecificTypeNodeList:
      return toV8(impl.getAsNodeList(), creationContext, isolate);
    case NodeListOrElement::SpecificTypeElement:
      return toV8(impl.getAsElement(), creationContext, isolate);
    default:
      NOTREACHED();
  }
  return v8::Local<v8::Value>();
}

NodeListOrElement NativeValueTraits<NodeListOrElement>::nativeValue(v8::Isolate* isolate, v8::Local<v8::Value> value, ExceptionState& exceptionState) {
  NodeListOrElement impl;
  V8NodeListOrElement::toImpl(isolate, value, impl, UnionTypeConversionMode::NotNullable, exceptionState);
  return impl;
}

}  // namespace blink
