// Copyright 2014 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// This file has been auto-generated by code_generator_v8.py.
// DO NOT MODIFY!

// clang-format off
#include "StringOrArrayBuffer.h"

#include "bindings/core/v8/ToV8.h"
#include "bindings/core/v8/V8ArrayBuffer.h"

namespace blink {

StringOrArrayBuffer::StringOrArrayBuffer() : m_type(SpecificTypeNone) {}

String StringOrArrayBuffer::getAsString() const {
  DCHECK(isString());
  return m_string;
}

void StringOrArrayBuffer::setString(String value) {
  DCHECK(isNull());
  m_string = value;
  m_type = SpecificTypeString;
}

StringOrArrayBuffer StringOrArrayBuffer::fromString(String value) {
  StringOrArrayBuffer container;
  container.setString(value);
  return container;
}

DOMArrayBuffer* StringOrArrayBuffer::getAsArrayBuffer() const {
  DCHECK(isArrayBuffer());
  return m_arrayBuffer;
}

void StringOrArrayBuffer::setArrayBuffer(DOMArrayBuffer* value) {
  DCHECK(isNull());
  m_arrayBuffer = value;
  m_type = SpecificTypeArrayBuffer;
}

StringOrArrayBuffer StringOrArrayBuffer::fromArrayBuffer(DOMArrayBuffer* value) {
  StringOrArrayBuffer container;
  container.setArrayBuffer(value);
  return container;
}

StringOrArrayBuffer::StringOrArrayBuffer(const StringOrArrayBuffer&) = default;
StringOrArrayBuffer::~StringOrArrayBuffer() = default;
StringOrArrayBuffer& StringOrArrayBuffer::operator=(const StringOrArrayBuffer&) = default;

DEFINE_TRACE(StringOrArrayBuffer) {
  visitor->trace(m_arrayBuffer);
}

void V8StringOrArrayBuffer::toImpl(v8::Isolate* isolate, v8::Local<v8::Value> v8Value, StringOrArrayBuffer& impl, UnionTypeConversionMode conversionMode, ExceptionState& exceptionState) {
  if (v8Value.IsEmpty())
    return;

  if (conversionMode == UnionTypeConversionMode::Nullable && isUndefinedOrNull(v8Value))
    return;

  if (v8Value->IsArrayBuffer()) {
    DOMArrayBuffer* cppValue = V8ArrayBuffer::toImpl(v8::Local<v8::Object>::Cast(v8Value));
    impl.setArrayBuffer(cppValue);
    return;
  }

  {
    V8StringResource<> cppValue = v8Value;
    if (!cppValue.prepare(exceptionState))
      return;
    impl.setString(cppValue);
    return;
  }
}

v8::Local<v8::Value> toV8(const StringOrArrayBuffer& impl, v8::Local<v8::Object> creationContext, v8::Isolate* isolate) {
  switch (impl.m_type) {
    case StringOrArrayBuffer::SpecificTypeNone:
      return v8::Null(isolate);
    case StringOrArrayBuffer::SpecificTypeString:
      return v8String(isolate, impl.getAsString());
    case StringOrArrayBuffer::SpecificTypeArrayBuffer:
      return toV8(impl.getAsArrayBuffer(), creationContext, isolate);
    default:
      NOTREACHED();
  }
  return v8::Local<v8::Value>();
}

StringOrArrayBuffer NativeValueTraits<StringOrArrayBuffer>::nativeValue(v8::Isolate* isolate, v8::Local<v8::Value> value, ExceptionState& exceptionState) {
  StringOrArrayBuffer impl;
  V8StringOrArrayBuffer::toImpl(isolate, value, impl, UnionTypeConversionMode::NotNullable, exceptionState);
  return impl;
}

}  // namespace blink
