// Copyright 2014 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// This file has been auto-generated by code_generator_v8.py.
// DO NOT MODIFY!

// clang-format off
#include "V8BlobCallback.h"

#include "bindings/core/v8/ScriptController.h"
#include "bindings/core/v8/V8Binding.h"
#include "bindings/core/v8/V8Blob.h"
#include "core/dom/ExecutionContext.h"
#include "wtf/Assertions.h"
#include "wtf/GetPtr.h"
#include "wtf/RefPtr.h"

namespace blink {

V8BlobCallback::V8BlobCallback(v8::Local<v8::Function> callback, ScriptState* scriptState)
    : ActiveDOMCallback(scriptState->getExecutionContext())
    , m_scriptState(scriptState) {
  m_callback.set(scriptState->isolate(), callback);
}

V8BlobCallback::~V8BlobCallback() {}

DEFINE_TRACE(V8BlobCallback) {
  BlobCallback::trace(visitor);
  ActiveDOMCallback::trace(visitor);
}

void V8BlobCallback::handleEvent(Blob* blob) {
  if (!canInvokeCallback())
    return;

  if (!m_scriptState->contextIsValid())
    return;

  ScriptState::Scope scope(m_scriptState.get());
  v8::Local<v8::Value> blobHandle = toV8(blob, m_scriptState->context()->Global(), m_scriptState->isolate());
  v8::Local<v8::Value> argv[] = { blobHandle };

  V8ScriptRunner::callFunction(m_callback.newLocal(m_scriptState->isolate()), m_scriptState->getExecutionContext(), v8::Undefined(m_scriptState->isolate()), 1, argv, m_scriptState->isolate());
}

}  // namespace blink
