// Copyright 2014 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// This file has been auto-generated by code_generator_v8.py.
// DO NOT MODIFY!

// clang-format off
#include "V8CSSAngleValue.h"

#include "bindings/core/v8/ExceptionState.h"
#include "bindings/core/v8/GeneratedCodeHelper.h"
#include "bindings/core/v8/V8DOMConfiguration.h"
#include "bindings/core/v8/V8ObjectConstructor.h"
#include "core/dom/Document.h"
#include "core/frame/LocalDOMWindow.h"
#include "platform/RuntimeEnabledFeatures.h"
#include "wtf/GetPtr.h"
#include "wtf/RefPtr.h"

namespace blink {

// Suppress warning: global constructors, because struct WrapperTypeInfo is trivial
// and does not depend on another global objects.
#if defined(COMPONENT_BUILD) && defined(WIN32) && COMPILER(CLANG)
#pragma clang diagnostic push
#pragma clang diagnostic ignored "-Wglobal-constructors"
#endif
const WrapperTypeInfo V8CSSAngleValue::wrapperTypeInfo = { gin::kEmbedderBlink, V8CSSAngleValue::domTemplate, V8CSSAngleValue::trace, V8CSSAngleValue::traceWrappers, 0, nullptr, "CSSAngleValue", &V8CSSStyleValue::wrapperTypeInfo, WrapperTypeInfo::WrapperTypeObjectPrototype, WrapperTypeInfo::ObjectClassId, WrapperTypeInfo::NotInheritFromActiveScriptWrappable, WrapperTypeInfo::NotInheritFromEventTarget, WrapperTypeInfo::Independent };
#if defined(COMPONENT_BUILD) && defined(WIN32) && COMPILER(CLANG)
#pragma clang diagnostic pop
#endif

// This static member must be declared by DEFINE_WRAPPERTYPEINFO in CSSAngleValue.h.
// For details, see the comment of DEFINE_WRAPPERTYPEINFO in
// bindings/core/v8/ScriptWrappable.h.
const WrapperTypeInfo& CSSAngleValue::s_wrapperTypeInfo = V8CSSAngleValue::wrapperTypeInfo;

// not [ActiveScriptWrappable]
static_assert(
    !std::is_base_of<ActiveScriptWrappable, CSSAngleValue>::value,
    "CSSAngleValue inherits from ActiveScriptWrappable, but is not specifying "
    "[ActiveScriptWrappable] extended attribute in the IDL file.  "
    "Be consistent.");
static_assert(
    std::is_same<decltype(&CSSAngleValue::hasPendingActivity),
                 decltype(&ScriptWrappable::hasPendingActivity)>::value,
    "CSSAngleValue is overriding hasPendingActivity(), but is not specifying "
    "[ActiveScriptWrappable] extended attribute in the IDL file.  "
    "Be consistent.");

namespace CSSAngleValueV8Internal {

static void degreesAttributeGetter(const v8::FunctionCallbackInfo<v8::Value>& info) {
  v8::Local<v8::Object> holder = info.Holder();

  CSSAngleValue* impl = V8CSSAngleValue::toImpl(holder);

  v8SetReturnValue(info, impl->degrees());
}

void degreesAttributeGetterCallback(const v8::FunctionCallbackInfo<v8::Value>& info) {
  CSSAngleValueV8Internal::degreesAttributeGetter(info);
}

static void radiansAttributeGetter(const v8::FunctionCallbackInfo<v8::Value>& info) {
  v8::Local<v8::Object> holder = info.Holder();

  CSSAngleValue* impl = V8CSSAngleValue::toImpl(holder);

  v8SetReturnValue(info, impl->radians());
}

void radiansAttributeGetterCallback(const v8::FunctionCallbackInfo<v8::Value>& info) {
  CSSAngleValueV8Internal::radiansAttributeGetter(info);
}

static void gradiansAttributeGetter(const v8::FunctionCallbackInfo<v8::Value>& info) {
  v8::Local<v8::Object> holder = info.Holder();

  CSSAngleValue* impl = V8CSSAngleValue::toImpl(holder);

  v8SetReturnValue(info, impl->gradians());
}

void gradiansAttributeGetterCallback(const v8::FunctionCallbackInfo<v8::Value>& info) {
  CSSAngleValueV8Internal::gradiansAttributeGetter(info);
}

static void turnsAttributeGetter(const v8::FunctionCallbackInfo<v8::Value>& info) {
  v8::Local<v8::Object> holder = info.Holder();

  CSSAngleValue* impl = V8CSSAngleValue::toImpl(holder);

  v8SetReturnValue(info, impl->turns());
}

void turnsAttributeGetterCallback(const v8::FunctionCallbackInfo<v8::Value>& info) {
  CSSAngleValueV8Internal::turnsAttributeGetter(info);
}

static void constructor(const v8::FunctionCallbackInfo<v8::Value>& info) {
  ExceptionState exceptionState(info.GetIsolate(), ExceptionState::ConstructionContext, "CSSAngleValue");

  if (UNLIKELY(info.Length() < 2)) {
    exceptionState.throwTypeError(ExceptionMessages::notEnoughArguments(2, info.Length()));
    return;
  }

  double value;
  V8StringResource<> unit;
  value = toRestrictedDouble(info.GetIsolate(), info[0], exceptionState);
  if (exceptionState.hadException())
    return;

  unit = info[1];
  if (!unit.prepare())
    return;
  const char* validUnitValues[] = {
      "deg",
      "rad",
      "grad",
      "turn",
  };
  if (!isValidEnum(unit, validUnitValues, WTF_ARRAY_LENGTH(validUnitValues), "CSSAngleUnit", exceptionState)) {
    return;
  }

  CSSAngleValue* impl = CSSAngleValue::create(value, unit, exceptionState);
  if (exceptionState.hadException()) {
    return;
  }
  v8::Local<v8::Object> wrapper = info.Holder();
  wrapper = impl->associateWithWrapper(info.GetIsolate(), &V8CSSAngleValue::wrapperTypeInfo, wrapper);
  v8SetReturnValue(info, wrapper);
}

} // namespace CSSAngleValueV8Internal

const V8DOMConfiguration::AccessorConfiguration V8CSSAngleValueAccessors[] = {
    {"degrees", CSSAngleValueV8Internal::degreesAttributeGetterCallback, 0, 0, 0, nullptr, 0, v8::DEFAULT, static_cast<v8::PropertyAttribute>(v8::ReadOnly), V8DOMConfiguration::ExposedToAllScripts, V8DOMConfiguration::OnPrototype, V8DOMConfiguration::CheckHolder},
    {"radians", CSSAngleValueV8Internal::radiansAttributeGetterCallback, 0, 0, 0, nullptr, 0, v8::DEFAULT, static_cast<v8::PropertyAttribute>(v8::ReadOnly), V8DOMConfiguration::ExposedToAllScripts, V8DOMConfiguration::OnPrototype, V8DOMConfiguration::CheckHolder},
    {"gradians", CSSAngleValueV8Internal::gradiansAttributeGetterCallback, 0, 0, 0, nullptr, 0, v8::DEFAULT, static_cast<v8::PropertyAttribute>(v8::ReadOnly), V8DOMConfiguration::ExposedToAllScripts, V8DOMConfiguration::OnPrototype, V8DOMConfiguration::CheckHolder},
    {"turns", CSSAngleValueV8Internal::turnsAttributeGetterCallback, 0, 0, 0, nullptr, 0, v8::DEFAULT, static_cast<v8::PropertyAttribute>(v8::ReadOnly), V8DOMConfiguration::ExposedToAllScripts, V8DOMConfiguration::OnPrototype, V8DOMConfiguration::CheckHolder},
};

void V8CSSAngleValue::constructorCallback(const v8::FunctionCallbackInfo<v8::Value>& info) {
  if (!info.IsConstructCall()) {
    V8ThrowException::throwTypeError(info.GetIsolate(), ExceptionMessages::constructorNotCallableAsFunction("CSSAngleValue"));
    return;
  }

  if (ConstructorMode::current(info.GetIsolate()) == ConstructorMode::WrapExistingObject) {
    v8SetReturnValue(info, info.Holder());
    return;
  }

  CSSAngleValueV8Internal::constructor(info);
}

static void installV8CSSAngleValueTemplate(v8::Isolate* isolate, const DOMWrapperWorld& world, v8::Local<v8::FunctionTemplate> interfaceTemplate) {
  // Initialize the interface object's template.
  V8DOMConfiguration::initializeDOMInterfaceTemplate(isolate, interfaceTemplate, V8CSSAngleValue::wrapperTypeInfo.interfaceName, V8CSSStyleValue::domTemplate(isolate, world), V8CSSAngleValue::internalFieldCount);
  interfaceTemplate->SetCallHandler(V8CSSAngleValue::constructorCallback);
  interfaceTemplate->SetLength(2);
  v8::Local<v8::Signature> signature = v8::Signature::New(isolate, interfaceTemplate);
  ALLOW_UNUSED_LOCAL(signature);
  v8::Local<v8::ObjectTemplate> instanceTemplate = interfaceTemplate->InstanceTemplate();
  ALLOW_UNUSED_LOCAL(instanceTemplate);
  v8::Local<v8::ObjectTemplate> prototypeTemplate = interfaceTemplate->PrototypeTemplate();
  ALLOW_UNUSED_LOCAL(prototypeTemplate);
  // Register DOM constants, attributes and operations.
  if (RuntimeEnabledFeatures::cssTypedOMEnabled()) {
      V8DOMConfiguration::installAccessors(isolate, world, instanceTemplate, prototypeTemplate, interfaceTemplate, signature, V8CSSAngleValueAccessors, WTF_ARRAY_LENGTH(V8CSSAngleValueAccessors));
  }
}

v8::Local<v8::FunctionTemplate> V8CSSAngleValue::domTemplate(v8::Isolate* isolate, const DOMWrapperWorld& world) {
  return V8DOMConfiguration::domClassTemplate(isolate, world, const_cast<WrapperTypeInfo*>(&wrapperTypeInfo), installV8CSSAngleValueTemplate);
}

bool V8CSSAngleValue::hasInstance(v8::Local<v8::Value> v8Value, v8::Isolate* isolate) {
  return V8PerIsolateData::from(isolate)->hasInstance(&wrapperTypeInfo, v8Value);
}

v8::Local<v8::Object> V8CSSAngleValue::findInstanceInPrototypeChain(v8::Local<v8::Value> v8Value, v8::Isolate* isolate) {
  return V8PerIsolateData::from(isolate)->findInstanceInPrototypeChain(&wrapperTypeInfo, v8Value);
}

CSSAngleValue* V8CSSAngleValue::toImplWithTypeCheck(v8::Isolate* isolate, v8::Local<v8::Value> value) {
  return hasInstance(value, isolate) ? toImpl(v8::Local<v8::Object>::Cast(value)) : nullptr;
}

}  // namespace blink
