// Copyright 2014 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// This file has been auto-generated by code_generator_v8.py.
// DO NOT MODIFY!

// clang-format off
#include "V8DragEventInit.h"

#include "bindings/core/v8/ExceptionState.h"
#include "bindings/core/v8/V8DataTransfer.h"
#include "bindings/core/v8/V8MouseEventInit.h"

namespace blink {

void V8DragEventInit::toImpl(v8::Isolate* isolate, v8::Local<v8::Value> v8Value, DragEventInit& impl, ExceptionState& exceptionState) {
  if (isUndefinedOrNull(v8Value)) {
    return;
  }
  if (!v8Value->IsObject()) {
    exceptionState.throwTypeError("cannot convert to dictionary.");
    return;
  }

  V8MouseEventInit::toImpl(isolate, v8Value, impl, exceptionState);
  if (exceptionState.hadException())
    return;

  v8::TryCatch block(isolate);
  v8::Local<v8::Object> v8Object;
  if (!v8Call(v8Value->ToObject(isolate->GetCurrentContext()), v8Object, block)) {
    exceptionState.rethrowV8Exception(block.Exception());
    return;
  }
  v8::Local<v8::Value> dataTransferValue;
  if (!v8Object->Get(isolate->GetCurrentContext(), v8String(isolate, "dataTransfer")).ToLocal(&dataTransferValue)) {
    exceptionState.rethrowV8Exception(block.Exception());
    return;
  }
  if (dataTransferValue.IsEmpty() || dataTransferValue->IsUndefined()) {
    // Do nothing.
  } else if (dataTransferValue->IsNull()) {
    impl.setGetDataTransferToNull();
  } else {
    DataTransfer* dataTransfer = V8DataTransfer::toImplWithTypeCheck(isolate, dataTransferValue);
    if (!dataTransfer) {
      exceptionState.throwTypeError("member dataTransfer is not of type DataTransfer.");
      return;
    }
    impl.setGetDataTransfer(dataTransfer);
  }
}

v8::Local<v8::Value> DragEventInit::toV8Impl(v8::Local<v8::Object> creationContext, v8::Isolate* isolate) const {
  v8::Local<v8::Object> v8Object = v8::Object::New(isolate);
  if (!toV8DragEventInit(*this, v8Object, creationContext, isolate))
    return v8::Undefined(isolate);
  return v8Object;
}

bool toV8DragEventInit(const DragEventInit& impl, v8::Local<v8::Object> dictionary, v8::Local<v8::Object> creationContext, v8::Isolate* isolate) {
  if (!toV8MouseEventInit(impl, dictionary, creationContext, isolate))
    return false;

  if (impl.hasGetDataTransfer()) {
    if (!v8CallBoolean(dictionary->CreateDataProperty(isolate->GetCurrentContext(), v8String(isolate, "dataTransfer"), toV8(impl.getDataTransfer(), creationContext, isolate))))
      return false;
  } else {
    if (!v8CallBoolean(dictionary->CreateDataProperty(isolate->GetCurrentContext(), v8String(isolate, "dataTransfer"), v8::Null(isolate))))
      return false;
  }

  return true;
}

DragEventInit NativeValueTraits<DragEventInit>::nativeValue(v8::Isolate* isolate, v8::Local<v8::Value> value, ExceptionState& exceptionState) {
  DragEventInit impl;
  V8DragEventInit::toImpl(isolate, value, impl, exceptionState);
  return impl;
}

}  // namespace blink
