// Copyright 2014 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// This file has been auto-generated by code_generator_v8.py.
// DO NOT MODIFY!

// clang-format off
#include "V8HTMLFormElement.h"

#include "bindings/core/v8/ExceptionState.h"
#include "bindings/core/v8/GeneratedCodeHelper.h"
#include "bindings/core/v8/RadioNodeListOrElement.h"
#include "bindings/core/v8/V8DOMConfiguration.h"
#include "bindings/core/v8/V8Element.h"
#include "bindings/core/v8/V8HTMLFormControlsCollection.h"
#include "bindings/core/v8/V8ObjectConstructor.h"
#include "bindings/core/v8/V8RadioNodeList.h"
#include "core/HTMLNames.h"
#include "core/animation/ElementAnimation.h"
#include "core/dom/Document.h"
#include "core/dom/ElementFullscreen.h"
#include "core/dom/custom/CEReactionsScope.h"
#include "core/dom/custom/V0CustomElementProcessingStack.h"
#include "wtf/GetPtr.h"
#include "wtf/RefPtr.h"

namespace blink {

// Suppress warning: global constructors, because struct WrapperTypeInfo is trivial
// and does not depend on another global objects.
#if defined(COMPONENT_BUILD) && defined(WIN32) && COMPILER(CLANG)
#pragma clang diagnostic push
#pragma clang diagnostic ignored "-Wglobal-constructors"
#endif
const WrapperTypeInfo V8HTMLFormElement::wrapperTypeInfo = { gin::kEmbedderBlink, V8HTMLFormElement::domTemplate, V8HTMLFormElement::trace, V8HTMLFormElement::traceWrappers, 0, nullptr, "HTMLFormElement", &V8HTMLElement::wrapperTypeInfo, WrapperTypeInfo::WrapperTypeObjectPrototype, WrapperTypeInfo::NodeClassId, WrapperTypeInfo::NotInheritFromActiveScriptWrappable, WrapperTypeInfo::InheritFromEventTarget, WrapperTypeInfo::Dependent };
#if defined(COMPONENT_BUILD) && defined(WIN32) && COMPILER(CLANG)
#pragma clang diagnostic pop
#endif

// This static member must be declared by DEFINE_WRAPPERTYPEINFO in HTMLFormElement.h.
// For details, see the comment of DEFINE_WRAPPERTYPEINFO in
// bindings/core/v8/ScriptWrappable.h.
const WrapperTypeInfo& HTMLFormElement::s_wrapperTypeInfo = V8HTMLFormElement::wrapperTypeInfo;

// not [ActiveScriptWrappable]
static_assert(
    !std::is_base_of<ActiveScriptWrappable, HTMLFormElement>::value,
    "HTMLFormElement inherits from ActiveScriptWrappable, but is not specifying "
    "[ActiveScriptWrappable] extended attribute in the IDL file.  "
    "Be consistent.");
static_assert(
    std::is_same<decltype(&HTMLFormElement::hasPendingActivity),
                 decltype(&ScriptWrappable::hasPendingActivity)>::value,
    "HTMLFormElement is overriding hasPendingActivity(), but is not specifying "
    "[ActiveScriptWrappable] extended attribute in the IDL file.  "
    "Be consistent.");

namespace HTMLFormElementV8Internal {

static void acceptCharsetAttributeGetter(const v8::FunctionCallbackInfo<v8::Value>& info) {
  v8::Local<v8::Object> holder = info.Holder();

  HTMLFormElement* impl = V8HTMLFormElement::toImpl(holder);

  v8SetReturnValueString(info, impl->fastGetAttribute(HTMLNames::accept_charsetAttr), info.GetIsolate());
}

void acceptCharsetAttributeGetterCallback(const v8::FunctionCallbackInfo<v8::Value>& info) {
  HTMLFormElementV8Internal::acceptCharsetAttributeGetter(info);
}

static void acceptCharsetAttributeSetter(v8::Local<v8::Value> v8Value, const v8::FunctionCallbackInfo<v8::Value>& info) {
  v8::Local<v8::Object> holder = info.Holder();
  HTMLFormElement* impl = V8HTMLFormElement::toImpl(holder);

  // Prepare the value to be set.
  V8StringResource<> cppValue = v8Value;
  if (!cppValue.prepare())
    return;

  impl->setAttribute(HTMLNames::accept_charsetAttr, cppValue);
}

void acceptCharsetAttributeSetterCallback(const v8::FunctionCallbackInfo<v8::Value>& info) {
  v8::Local<v8::Value> v8Value = info[0];

  CEReactionsScope ceReactionsScope;

  V0CustomElementProcessingStack::CallbackDeliveryScope deliveryScope;

  HTMLFormElementV8Internal::acceptCharsetAttributeSetter(v8Value, info);
}

static void actionAttributeGetter(const v8::FunctionCallbackInfo<v8::Value>& info) {
  v8::Local<v8::Object> holder = info.Holder();

  HTMLFormElement* impl = V8HTMLFormElement::toImpl(holder);

  v8SetReturnValueString(info, impl->getURLAttribute(HTMLNames::actionAttr), info.GetIsolate());
}

void actionAttributeGetterCallback(const v8::FunctionCallbackInfo<v8::Value>& info) {
  HTMLFormElementV8Internal::actionAttributeGetter(info);
}

static void actionAttributeSetter(v8::Local<v8::Value> v8Value, const v8::FunctionCallbackInfo<v8::Value>& info) {
  v8::Local<v8::Object> holder = info.Holder();
  HTMLFormElement* impl = V8HTMLFormElement::toImpl(holder);

  // Prepare the value to be set.
  V8StringResource<> cppValue = v8Value;
  if (!cppValue.prepare())
    return;

  impl->setAttribute(HTMLNames::actionAttr, cppValue);
}

void actionAttributeSetterCallback(const v8::FunctionCallbackInfo<v8::Value>& info) {
  v8::Local<v8::Value> v8Value = info[0];

  CEReactionsScope ceReactionsScope;

  V0CustomElementProcessingStack::CallbackDeliveryScope deliveryScope;

  HTMLFormElementV8Internal::actionAttributeSetter(v8Value, info);
}

static void autocompleteAttributeGetter(const v8::FunctionCallbackInfo<v8::Value>& info) {
  v8::Local<v8::Object> holder = info.Holder();

  HTMLFormElement* impl = V8HTMLFormElement::toImpl(holder);

  String cppValue(impl->fastGetAttribute(HTMLNames::autocompleteAttr));

  if (cppValue.isEmpty()) {
    cppValue = "on";
  } else if (equalIgnoringASCIICase(cppValue, "on")) {
    cppValue = "on";
  } else if (equalIgnoringASCIICase(cppValue, "off")) {
    cppValue = "off";
  } else {
    cppValue = "on";
  }

  v8SetReturnValueString(info, cppValue, info.GetIsolate());
}

void autocompleteAttributeGetterCallback(const v8::FunctionCallbackInfo<v8::Value>& info) {
  HTMLFormElementV8Internal::autocompleteAttributeGetter(info);
}

static void autocompleteAttributeSetter(v8::Local<v8::Value> v8Value, const v8::FunctionCallbackInfo<v8::Value>& info) {
  v8::Local<v8::Object> holder = info.Holder();
  HTMLFormElement* impl = V8HTMLFormElement::toImpl(holder);

  // Prepare the value to be set.
  V8StringResource<> cppValue = v8Value;
  if (!cppValue.prepare())
    return;

  impl->setAttribute(HTMLNames::autocompleteAttr, cppValue);
}

void autocompleteAttributeSetterCallback(const v8::FunctionCallbackInfo<v8::Value>& info) {
  v8::Local<v8::Value> v8Value = info[0];

  CEReactionsScope ceReactionsScope;

  V0CustomElementProcessingStack::CallbackDeliveryScope deliveryScope;

  HTMLFormElementV8Internal::autocompleteAttributeSetter(v8Value, info);
}

static void enctypeAttributeGetter(const v8::FunctionCallbackInfo<v8::Value>& info) {
  v8::Local<v8::Object> holder = info.Holder();

  HTMLFormElement* impl = V8HTMLFormElement::toImpl(holder);

  v8SetReturnValueString(info, impl->enctype(), info.GetIsolate());
}

void enctypeAttributeGetterCallback(const v8::FunctionCallbackInfo<v8::Value>& info) {
  HTMLFormElementV8Internal::enctypeAttributeGetter(info);
}

static void enctypeAttributeSetter(v8::Local<v8::Value> v8Value, const v8::FunctionCallbackInfo<v8::Value>& info) {
  v8::Local<v8::Object> holder = info.Holder();
  HTMLFormElement* impl = V8HTMLFormElement::toImpl(holder);

  // Skip on compact node DOMString getters.
  V0CustomElementProcessingStack::CallbackDeliveryScope deliveryScope;

  // Prepare the value to be set.
  V8StringResource<> cppValue = v8Value;
  if (!cppValue.prepare())
    return;

  impl->setEnctype(cppValue);
}

void enctypeAttributeSetterCallback(const v8::FunctionCallbackInfo<v8::Value>& info) {
  v8::Local<v8::Value> v8Value = info[0];

  CEReactionsScope ceReactionsScope;

  V0CustomElementProcessingStack::CallbackDeliveryScope deliveryScope;

  HTMLFormElementV8Internal::enctypeAttributeSetter(v8Value, info);
}

static void encodingAttributeGetter(const v8::FunctionCallbackInfo<v8::Value>& info) {
  v8::Local<v8::Object> holder = info.Holder();

  HTMLFormElement* impl = V8HTMLFormElement::toImpl(holder);

  v8SetReturnValueString(info, impl->encoding(), info.GetIsolate());
}

void encodingAttributeGetterCallback(const v8::FunctionCallbackInfo<v8::Value>& info) {
  HTMLFormElementV8Internal::encodingAttributeGetter(info);
}

static void encodingAttributeSetter(v8::Local<v8::Value> v8Value, const v8::FunctionCallbackInfo<v8::Value>& info) {
  v8::Local<v8::Object> holder = info.Holder();
  HTMLFormElement* impl = V8HTMLFormElement::toImpl(holder);

  // Skip on compact node DOMString getters.
  V0CustomElementProcessingStack::CallbackDeliveryScope deliveryScope;

  // Prepare the value to be set.
  V8StringResource<> cppValue = v8Value;
  if (!cppValue.prepare())
    return;

  impl->setEncoding(cppValue);
}

void encodingAttributeSetterCallback(const v8::FunctionCallbackInfo<v8::Value>& info) {
  v8::Local<v8::Value> v8Value = info[0];

  CEReactionsScope ceReactionsScope;

  V0CustomElementProcessingStack::CallbackDeliveryScope deliveryScope;

  HTMLFormElementV8Internal::encodingAttributeSetter(v8Value, info);
}

static void methodAttributeGetter(const v8::FunctionCallbackInfo<v8::Value>& info) {
  v8::Local<v8::Object> holder = info.Holder();

  HTMLFormElement* impl = V8HTMLFormElement::toImpl(holder);

  v8SetReturnValueString(info, impl->method(), info.GetIsolate());
}

void methodAttributeGetterCallback(const v8::FunctionCallbackInfo<v8::Value>& info) {
  HTMLFormElementV8Internal::methodAttributeGetter(info);
}

static void methodAttributeSetter(v8::Local<v8::Value> v8Value, const v8::FunctionCallbackInfo<v8::Value>& info) {
  v8::Local<v8::Object> holder = info.Holder();
  HTMLFormElement* impl = V8HTMLFormElement::toImpl(holder);

  // Skip on compact node DOMString getters.
  V0CustomElementProcessingStack::CallbackDeliveryScope deliveryScope;

  // Prepare the value to be set.
  V8StringResource<> cppValue = v8Value;
  if (!cppValue.prepare())
    return;

  impl->setMethod(cppValue);
}

void methodAttributeSetterCallback(const v8::FunctionCallbackInfo<v8::Value>& info) {
  v8::Local<v8::Value> v8Value = info[0];

  CEReactionsScope ceReactionsScope;

  V0CustomElementProcessingStack::CallbackDeliveryScope deliveryScope;

  HTMLFormElementV8Internal::methodAttributeSetter(v8Value, info);
}

static void nameAttributeGetter(const v8::FunctionCallbackInfo<v8::Value>& info) {
  v8::Local<v8::Object> holder = info.Holder();

  HTMLFormElement* impl = V8HTMLFormElement::toImpl(holder);

  v8SetReturnValueString(info, impl->getNameAttribute(), info.GetIsolate());
}

void nameAttributeGetterCallback(const v8::FunctionCallbackInfo<v8::Value>& info) {
  HTMLFormElementV8Internal::nameAttributeGetter(info);
}

static void nameAttributeSetter(v8::Local<v8::Value> v8Value, const v8::FunctionCallbackInfo<v8::Value>& info) {
  v8::Local<v8::Object> holder = info.Holder();
  HTMLFormElement* impl = V8HTMLFormElement::toImpl(holder);

  // Prepare the value to be set.
  V8StringResource<> cppValue = v8Value;
  if (!cppValue.prepare())
    return;

  impl->setAttribute(HTMLNames::nameAttr, cppValue);
}

void nameAttributeSetterCallback(const v8::FunctionCallbackInfo<v8::Value>& info) {
  v8::Local<v8::Value> v8Value = info[0];

  CEReactionsScope ceReactionsScope;

  V0CustomElementProcessingStack::CallbackDeliveryScope deliveryScope;

  HTMLFormElementV8Internal::nameAttributeSetter(v8Value, info);
}

static void noValidateAttributeGetter(const v8::FunctionCallbackInfo<v8::Value>& info) {
  v8::Local<v8::Object> holder = info.Holder();

  HTMLFormElement* impl = V8HTMLFormElement::toImpl(holder);

  v8SetReturnValueBool(info, impl->fastHasAttribute(HTMLNames::novalidateAttr));
}

void noValidateAttributeGetterCallback(const v8::FunctionCallbackInfo<v8::Value>& info) {
  HTMLFormElementV8Internal::noValidateAttributeGetter(info);
}

static void noValidateAttributeSetter(v8::Local<v8::Value> v8Value, const v8::FunctionCallbackInfo<v8::Value>& info) {
  v8::Local<v8::Object> holder = info.Holder();
  HTMLFormElement* impl = V8HTMLFormElement::toImpl(holder);

  // Skip on compact node DOMString getters.
  V0CustomElementProcessingStack::CallbackDeliveryScope deliveryScope;

  ExceptionState exceptionState(info.GetIsolate(), ExceptionState::SetterContext, "HTMLFormElement", "noValidate");

  // Prepare the value to be set.
  bool cppValue = toBoolean(info.GetIsolate(), v8Value, exceptionState);
  if (exceptionState.hadException())
    return;

  impl->setBooleanAttribute(HTMLNames::novalidateAttr, cppValue);
}

void noValidateAttributeSetterCallback(const v8::FunctionCallbackInfo<v8::Value>& info) {
  v8::Local<v8::Value> v8Value = info[0];

  CEReactionsScope ceReactionsScope;

  V0CustomElementProcessingStack::CallbackDeliveryScope deliveryScope;

  HTMLFormElementV8Internal::noValidateAttributeSetter(v8Value, info);
}

static void targetAttributeGetter(const v8::FunctionCallbackInfo<v8::Value>& info) {
  v8::Local<v8::Object> holder = info.Holder();

  HTMLFormElement* impl = V8HTMLFormElement::toImpl(holder);

  v8SetReturnValueString(info, impl->fastGetAttribute(HTMLNames::targetAttr), info.GetIsolate());
}

void targetAttributeGetterCallback(const v8::FunctionCallbackInfo<v8::Value>& info) {
  HTMLFormElementV8Internal::targetAttributeGetter(info);
}

static void targetAttributeSetter(v8::Local<v8::Value> v8Value, const v8::FunctionCallbackInfo<v8::Value>& info) {
  v8::Local<v8::Object> holder = info.Holder();
  HTMLFormElement* impl = V8HTMLFormElement::toImpl(holder);

  // Prepare the value to be set.
  V8StringResource<> cppValue = v8Value;
  if (!cppValue.prepare())
    return;

  impl->setAttribute(HTMLNames::targetAttr, cppValue);
}

void targetAttributeSetterCallback(const v8::FunctionCallbackInfo<v8::Value>& info) {
  v8::Local<v8::Value> v8Value = info[0];

  CEReactionsScope ceReactionsScope;

  V0CustomElementProcessingStack::CallbackDeliveryScope deliveryScope;

  HTMLFormElementV8Internal::targetAttributeSetter(v8Value, info);
}

static void elementsAttributeGetter(const v8::FunctionCallbackInfo<v8::Value>& info) {
  v8::Local<v8::Object> holder = info.Holder();

  HTMLFormElement* impl = V8HTMLFormElement::toImpl(holder);

  v8SetReturnValueFast(info, WTF::getPtr(impl->elements()), impl);
}

void elementsAttributeGetterCallback(const v8::FunctionCallbackInfo<v8::Value>& info) {
  HTMLFormElementV8Internal::elementsAttributeGetter(info);
}

static void lengthAttributeGetter(const v8::FunctionCallbackInfo<v8::Value>& info) {
  v8::Local<v8::Object> holder = info.Holder();

  HTMLFormElement* impl = V8HTMLFormElement::toImpl(holder);

  v8SetReturnValueInt(info, impl->length());
}

void lengthAttributeGetterCallback(const v8::FunctionCallbackInfo<v8::Value>& info) {
  HTMLFormElementV8Internal::lengthAttributeGetter(info);
}

static void submitMethod(const v8::FunctionCallbackInfo<v8::Value>& info) {
  HTMLFormElement* impl = V8HTMLFormElement::toImpl(info.Holder());

  impl->submitFromJavaScript();
}

void submitMethodCallback(const v8::FunctionCallbackInfo<v8::Value>& info) {
  HTMLFormElementV8Internal::submitMethod(info);
}

static void resetMethod(const v8::FunctionCallbackInfo<v8::Value>& info) {
  HTMLFormElement* impl = V8HTMLFormElement::toImpl(info.Holder());

  V0CustomElementProcessingStack::CallbackDeliveryScope deliveryScope;

  impl->reset();
}

void resetMethodCallback(const v8::FunctionCallbackInfo<v8::Value>& info) {
  CEReactionsScope ceReactionsScope;
  HTMLFormElementV8Internal::resetMethod(info);
}

static void checkValidityMethod(const v8::FunctionCallbackInfo<v8::Value>& info) {
  HTMLFormElement* impl = V8HTMLFormElement::toImpl(info.Holder());

  v8SetReturnValueBool(info, impl->checkValidity());
}

void checkValidityMethodCallback(const v8::FunctionCallbackInfo<v8::Value>& info) {
  HTMLFormElementV8Internal::checkValidityMethod(info);
}

static void reportValidityMethod(const v8::FunctionCallbackInfo<v8::Value>& info) {
  HTMLFormElement* impl = V8HTMLFormElement::toImpl(info.Holder());

  v8SetReturnValueBool(info, impl->reportValidity());
}

void reportValidityMethodCallback(const v8::FunctionCallbackInfo<v8::Value>& info) {
  HTMLFormElementV8Internal::reportValidityMethod(info);
}

static void namedPropertyGetter(const AtomicString& name, const v8::PropertyCallbackInfo<v8::Value>& info) {
  HTMLFormElement* impl = V8HTMLFormElement::toImpl(info.Holder());
  RadioNodeListOrElement result;
  impl->anonymousNamedGetter(name, result);
  if (result.isNull())
    return;
  v8SetReturnValue(info, result);
}

void namedPropertyGetterCallback(v8::Local<v8::Name> name, const v8::PropertyCallbackInfo<v8::Value>& info) {
  if (!name->IsString())
    return;
  const AtomicString& propertyName = toCoreAtomicString(name.As<v8::String>());

  HTMLFormElementV8Internal::namedPropertyGetter(propertyName, info);
}

static void indexedPropertyGetter(uint32_t index, const v8::PropertyCallbackInfo<v8::Value>& info) {
  HTMLFormElement* impl = V8HTMLFormElement::toImpl(info.Holder());

  // We assume that all the implementations support length() method, although
  // the spec doesn't require that length() must exist.  It's okay that
  // the interface does not have length attribute as long as the
  // implementation supports length() member function.
  if (index >= impl->length())
    return;  // Returns undefined due to out-of-range.

  Element* result = impl->item(index);
  v8SetReturnValueFast(info, result, impl);
}

void indexedPropertyGetterCallback(uint32_t index, const v8::PropertyCallbackInfo<v8::Value>& info) {
  HTMLFormElementV8Internal::indexedPropertyGetter(index, info);
}

} // namespace HTMLFormElementV8Internal

const V8DOMConfiguration::AccessorConfiguration V8HTMLFormElementAccessors[] = {
    {"acceptCharset", HTMLFormElementV8Internal::acceptCharsetAttributeGetterCallback, HTMLFormElementV8Internal::acceptCharsetAttributeSetterCallback, 0, 0, nullptr, 0, v8::DEFAULT, static_cast<v8::PropertyAttribute>(v8::None), V8DOMConfiguration::ExposedToAllScripts, V8DOMConfiguration::OnPrototype, V8DOMConfiguration::CheckHolder},
    {"action", HTMLFormElementV8Internal::actionAttributeGetterCallback, HTMLFormElementV8Internal::actionAttributeSetterCallback, 0, 0, nullptr, 0, v8::DEFAULT, static_cast<v8::PropertyAttribute>(v8::None), V8DOMConfiguration::ExposedToAllScripts, V8DOMConfiguration::OnPrototype, V8DOMConfiguration::CheckHolder},
    {"autocomplete", HTMLFormElementV8Internal::autocompleteAttributeGetterCallback, HTMLFormElementV8Internal::autocompleteAttributeSetterCallback, 0, 0, nullptr, 0, v8::DEFAULT, static_cast<v8::PropertyAttribute>(v8::None), V8DOMConfiguration::ExposedToAllScripts, V8DOMConfiguration::OnPrototype, V8DOMConfiguration::CheckHolder},
    {"enctype", HTMLFormElementV8Internal::enctypeAttributeGetterCallback, HTMLFormElementV8Internal::enctypeAttributeSetterCallback, 0, 0, nullptr, 0, v8::DEFAULT, static_cast<v8::PropertyAttribute>(v8::None), V8DOMConfiguration::ExposedToAllScripts, V8DOMConfiguration::OnPrototype, V8DOMConfiguration::CheckHolder},
    {"encoding", HTMLFormElementV8Internal::encodingAttributeGetterCallback, HTMLFormElementV8Internal::encodingAttributeSetterCallback, 0, 0, nullptr, 0, v8::DEFAULT, static_cast<v8::PropertyAttribute>(v8::None), V8DOMConfiguration::ExposedToAllScripts, V8DOMConfiguration::OnPrototype, V8DOMConfiguration::CheckHolder},
    {"method", HTMLFormElementV8Internal::methodAttributeGetterCallback, HTMLFormElementV8Internal::methodAttributeSetterCallback, 0, 0, nullptr, 0, v8::DEFAULT, static_cast<v8::PropertyAttribute>(v8::None), V8DOMConfiguration::ExposedToAllScripts, V8DOMConfiguration::OnPrototype, V8DOMConfiguration::CheckHolder},
    {"name", HTMLFormElementV8Internal::nameAttributeGetterCallback, HTMLFormElementV8Internal::nameAttributeSetterCallback, 0, 0, nullptr, 0, v8::DEFAULT, static_cast<v8::PropertyAttribute>(v8::None), V8DOMConfiguration::ExposedToAllScripts, V8DOMConfiguration::OnPrototype, V8DOMConfiguration::CheckHolder},
    {"noValidate", HTMLFormElementV8Internal::noValidateAttributeGetterCallback, HTMLFormElementV8Internal::noValidateAttributeSetterCallback, 0, 0, nullptr, 0, v8::DEFAULT, static_cast<v8::PropertyAttribute>(v8::None), V8DOMConfiguration::ExposedToAllScripts, V8DOMConfiguration::OnPrototype, V8DOMConfiguration::CheckHolder},
    {"target", HTMLFormElementV8Internal::targetAttributeGetterCallback, HTMLFormElementV8Internal::targetAttributeSetterCallback, 0, 0, nullptr, 0, v8::DEFAULT, static_cast<v8::PropertyAttribute>(v8::None), V8DOMConfiguration::ExposedToAllScripts, V8DOMConfiguration::OnPrototype, V8DOMConfiguration::CheckHolder},
    {"elements", HTMLFormElementV8Internal::elementsAttributeGetterCallback, 0, 0, 0, nullptr, 0, v8::DEFAULT, static_cast<v8::PropertyAttribute>(v8::ReadOnly), V8DOMConfiguration::ExposedToAllScripts, V8DOMConfiguration::OnPrototype, V8DOMConfiguration::CheckHolder},
    {"length", HTMLFormElementV8Internal::lengthAttributeGetterCallback, 0, 0, 0, nullptr, 0, v8::DEFAULT, static_cast<v8::PropertyAttribute>(v8::ReadOnly), V8DOMConfiguration::ExposedToAllScripts, V8DOMConfiguration::OnPrototype, V8DOMConfiguration::CheckHolder},
};

const V8DOMConfiguration::MethodConfiguration V8HTMLFormElementMethods[] = {
    {"submit", HTMLFormElementV8Internal::submitMethodCallback, 0, 0, v8::None, V8DOMConfiguration::ExposedToAllScripts, V8DOMConfiguration::OnPrototype, V8DOMConfiguration::CheckHolder},
    {"reset", HTMLFormElementV8Internal::resetMethodCallback, 0, 0, v8::None, V8DOMConfiguration::ExposedToAllScripts, V8DOMConfiguration::OnPrototype, V8DOMConfiguration::CheckHolder},
    {"checkValidity", HTMLFormElementV8Internal::checkValidityMethodCallback, 0, 0, v8::None, V8DOMConfiguration::ExposedToAllScripts, V8DOMConfiguration::OnPrototype, V8DOMConfiguration::CheckHolder},
    {"reportValidity", HTMLFormElementV8Internal::reportValidityMethodCallback, 0, 0, v8::None, V8DOMConfiguration::ExposedToAllScripts, V8DOMConfiguration::OnPrototype, V8DOMConfiguration::CheckHolder},
};

static void installV8HTMLFormElementTemplate(v8::Isolate* isolate, const DOMWrapperWorld& world, v8::Local<v8::FunctionTemplate> interfaceTemplate) {
  // Initialize the interface object's template.
  V8DOMConfiguration::initializeDOMInterfaceTemplate(isolate, interfaceTemplate, V8HTMLFormElement::wrapperTypeInfo.interfaceName, V8HTMLElement::domTemplate(isolate, world), V8HTMLFormElement::internalFieldCount);
  v8::Local<v8::Signature> signature = v8::Signature::New(isolate, interfaceTemplate);
  ALLOW_UNUSED_LOCAL(signature);
  v8::Local<v8::ObjectTemplate> instanceTemplate = interfaceTemplate->InstanceTemplate();
  ALLOW_UNUSED_LOCAL(instanceTemplate);
  v8::Local<v8::ObjectTemplate> prototypeTemplate = interfaceTemplate->PrototypeTemplate();
  ALLOW_UNUSED_LOCAL(prototypeTemplate);
  // Register DOM constants, attributes and operations.
  V8DOMConfiguration::installAccessors(isolate, world, instanceTemplate, prototypeTemplate, interfaceTemplate, signature, V8HTMLFormElementAccessors, WTF_ARRAY_LENGTH(V8HTMLFormElementAccessors));
  V8DOMConfiguration::installMethods(isolate, world, instanceTemplate, prototypeTemplate, interfaceTemplate, signature, V8HTMLFormElementMethods, WTF_ARRAY_LENGTH(V8HTMLFormElementMethods));

  // Indexed properties
  v8::IndexedPropertyHandlerConfiguration indexedPropertyHandlerConfig(HTMLFormElementV8Internal::indexedPropertyGetterCallback, 0, 0, 0, indexedPropertyEnumerator<HTMLFormElement>, v8::Local<v8::Value>(), v8::PropertyHandlerFlags::kNone);
  instanceTemplate->SetHandler(indexedPropertyHandlerConfig);
  // Named properties
  v8::NamedPropertyHandlerConfiguration namedPropertyHandlerConfig(HTMLFormElementV8Internal::namedPropertyGetterCallback, 0, 0, 0, 0, v8::Local<v8::Value>(), static_cast<v8::PropertyHandlerFlags>(int(v8::PropertyHandlerFlags::kOnlyInterceptStrings)));
  instanceTemplate->SetHandler(namedPropertyHandlerConfig);

  // Array iterator (@@iterator)
  prototypeTemplate->SetIntrinsicDataProperty(v8::Symbol::GetIterator(isolate), v8::kArrayProto_values, v8::DontEnum);
}

v8::Local<v8::FunctionTemplate> V8HTMLFormElement::domTemplate(v8::Isolate* isolate, const DOMWrapperWorld& world) {
  return V8DOMConfiguration::domClassTemplate(isolate, world, const_cast<WrapperTypeInfo*>(&wrapperTypeInfo), installV8HTMLFormElementTemplate);
}

bool V8HTMLFormElement::hasInstance(v8::Local<v8::Value> v8Value, v8::Isolate* isolate) {
  return V8PerIsolateData::from(isolate)->hasInstance(&wrapperTypeInfo, v8Value);
}

v8::Local<v8::Object> V8HTMLFormElement::findInstanceInPrototypeChain(v8::Local<v8::Value> v8Value, v8::Isolate* isolate) {
  return V8PerIsolateData::from(isolate)->findInstanceInPrototypeChain(&wrapperTypeInfo, v8Value);
}

HTMLFormElement* V8HTMLFormElement::toImplWithTypeCheck(v8::Isolate* isolate, v8::Local<v8::Value> value) {
  return hasInstance(value, isolate) ? toImpl(v8::Local<v8::Object>::Cast(value)) : nullptr;
}

}  // namespace blink
