// Copyright 2014 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// This file has been auto-generated by code_generator_v8.py.
// DO NOT MODIFY!

// clang-format off
#include "V8ImageEncodeOptions.h"

#include "bindings/core/v8/ExceptionState.h"

namespace blink {

void V8ImageEncodeOptions::toImpl(v8::Isolate* isolate, v8::Local<v8::Value> v8Value, ImageEncodeOptions& impl, ExceptionState& exceptionState) {
  if (isUndefinedOrNull(v8Value)) {
    return;
  }
  if (!v8Value->IsObject()) {
    exceptionState.throwTypeError("cannot convert to dictionary.");
    return;
  }

  v8::TryCatch block(isolate);
  v8::Local<v8::Object> v8Object;
  if (!v8Call(v8Value->ToObject(isolate->GetCurrentContext()), v8Object, block)) {
    exceptionState.rethrowV8Exception(block.Exception());
    return;
  }
  v8::Local<v8::Value> qualityValue;
  if (!v8Object->Get(isolate->GetCurrentContext(), v8String(isolate, "quality")).ToLocal(&qualityValue)) {
    exceptionState.rethrowV8Exception(block.Exception());
    return;
  }
  if (qualityValue.IsEmpty() || qualityValue->IsUndefined()) {
    // Do nothing.
  } else {
    double quality = toDouble(isolate, qualityValue, exceptionState);
    if (exceptionState.hadException())
      return;
    impl.setQuality(quality);
  }

  v8::Local<v8::Value> typeValue;
  if (!v8Object->Get(isolate->GetCurrentContext(), v8String(isolate, "type")).ToLocal(&typeValue)) {
    exceptionState.rethrowV8Exception(block.Exception());
    return;
  }
  if (typeValue.IsEmpty() || typeValue->IsUndefined()) {
    // Do nothing.
  } else {
    V8StringResource<> type = typeValue;
    if (!type.prepare(exceptionState))
      return;
    impl.setType(type);
  }
}

v8::Local<v8::Value> ImageEncodeOptions::toV8Impl(v8::Local<v8::Object> creationContext, v8::Isolate* isolate) const {
  v8::Local<v8::Object> v8Object = v8::Object::New(isolate);
  if (!toV8ImageEncodeOptions(*this, v8Object, creationContext, isolate))
    return v8::Undefined(isolate);
  return v8Object;
}

bool toV8ImageEncodeOptions(const ImageEncodeOptions& impl, v8::Local<v8::Object> dictionary, v8::Local<v8::Object> creationContext, v8::Isolate* isolate) {
  if (impl.hasQuality()) {
    if (!v8CallBoolean(dictionary->CreateDataProperty(isolate->GetCurrentContext(), v8String(isolate, "quality"), v8::Number::New(isolate, impl.quality()))))
      return false;
  } else {
    if (!v8CallBoolean(dictionary->CreateDataProperty(isolate->GetCurrentContext(), v8String(isolate, "quality"), v8::Number::New(isolate, 1))))
      return false;
  }

  if (impl.hasType()) {
    if (!v8CallBoolean(dictionary->CreateDataProperty(isolate->GetCurrentContext(), v8String(isolate, "type"), v8String(isolate, impl.type()))))
      return false;
  } else {
    if (!v8CallBoolean(dictionary->CreateDataProperty(isolate->GetCurrentContext(), v8String(isolate, "type"), v8String(isolate, String("image/png")))))
      return false;
  }

  return true;
}

ImageEncodeOptions NativeValueTraits<ImageEncodeOptions>::nativeValue(v8::Isolate* isolate, v8::Local<v8::Value> value, ExceptionState& exceptionState) {
  ImageEncodeOptions impl;
  V8ImageEncodeOptions::toImpl(isolate, value, impl, exceptionState);
  return impl;
}

}  // namespace blink
