// Copyright 2014 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// This file has been auto-generated by code_generator_v8.py.
// DO NOT MODIFY!

// clang-format off
#include "V8InputDeviceCapabilitiesInit.h"

#include "bindings/core/v8/ExceptionState.h"

namespace blink {

void V8InputDeviceCapabilitiesInit::toImpl(v8::Isolate* isolate, v8::Local<v8::Value> v8Value, InputDeviceCapabilitiesInit& impl, ExceptionState& exceptionState) {
  if (isUndefinedOrNull(v8Value)) {
    return;
  }
  if (!v8Value->IsObject()) {
    exceptionState.throwTypeError("cannot convert to dictionary.");
    return;
  }

  v8::TryCatch block(isolate);
  v8::Local<v8::Object> v8Object;
  if (!v8Call(v8Value->ToObject(isolate->GetCurrentContext()), v8Object, block)) {
    exceptionState.rethrowV8Exception(block.Exception());
    return;
  }
  v8::Local<v8::Value> firesTouchEventsValue;
  if (!v8Object->Get(isolate->GetCurrentContext(), v8String(isolate, "firesTouchEvents")).ToLocal(&firesTouchEventsValue)) {
    exceptionState.rethrowV8Exception(block.Exception());
    return;
  }
  if (firesTouchEventsValue.IsEmpty() || firesTouchEventsValue->IsUndefined()) {
    // Do nothing.
  } else {
    bool firesTouchEvents = toBoolean(isolate, firesTouchEventsValue, exceptionState);
    if (exceptionState.hadException())
      return;
    impl.setFiresTouchEvents(firesTouchEvents);
  }
}

v8::Local<v8::Value> InputDeviceCapabilitiesInit::toV8Impl(v8::Local<v8::Object> creationContext, v8::Isolate* isolate) const {
  v8::Local<v8::Object> v8Object = v8::Object::New(isolate);
  if (!toV8InputDeviceCapabilitiesInit(*this, v8Object, creationContext, isolate))
    return v8::Undefined(isolate);
  return v8Object;
}

bool toV8InputDeviceCapabilitiesInit(const InputDeviceCapabilitiesInit& impl, v8::Local<v8::Object> dictionary, v8::Local<v8::Object> creationContext, v8::Isolate* isolate) {
  if (impl.hasFiresTouchEvents()) {
    if (!v8CallBoolean(dictionary->CreateDataProperty(isolate->GetCurrentContext(), v8String(isolate, "firesTouchEvents"), v8Boolean(impl.firesTouchEvents(), isolate))))
      return false;
  } else {
    if (!v8CallBoolean(dictionary->CreateDataProperty(isolate->GetCurrentContext(), v8String(isolate, "firesTouchEvents"), v8Boolean(false, isolate))))
      return false;
  }

  return true;
}

InputDeviceCapabilitiesInit NativeValueTraits<InputDeviceCapabilitiesInit>::nativeValue(v8::Isolate* isolate, v8::Local<v8::Value> value, ExceptionState& exceptionState) {
  InputDeviceCapabilitiesInit impl;
  V8InputDeviceCapabilitiesInit::toImpl(isolate, value, impl, exceptionState);
  return impl;
}

}  // namespace blink
