// Copyright 2014 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// This file has been auto-generated by code_generator_v8.py.
// DO NOT MODIFY!

// clang-format off
#include "V8PerformanceNavigation.h"

#include "bindings/core/v8/ExceptionState.h"
#include "bindings/core/v8/GeneratedCodeHelper.h"
#include "bindings/core/v8/ScriptState.h"
#include "bindings/core/v8/ScriptValue.h"
#include "bindings/core/v8/V8DOMConfiguration.h"
#include "bindings/core/v8/V8ObjectConstructor.h"
#include "core/dom/Document.h"
#include "wtf/GetPtr.h"
#include "wtf/RefPtr.h"

namespace blink {

// Suppress warning: global constructors, because struct WrapperTypeInfo is trivial
// and does not depend on another global objects.
#if defined(COMPONENT_BUILD) && defined(WIN32) && COMPILER(CLANG)
#pragma clang diagnostic push
#pragma clang diagnostic ignored "-Wglobal-constructors"
#endif
const WrapperTypeInfo V8PerformanceNavigation::wrapperTypeInfo = { gin::kEmbedderBlink, V8PerformanceNavigation::domTemplate, V8PerformanceNavigation::trace, V8PerformanceNavigation::traceWrappers, 0, nullptr, "PerformanceNavigation", 0, WrapperTypeInfo::WrapperTypeObjectPrototype, WrapperTypeInfo::ObjectClassId, WrapperTypeInfo::NotInheritFromActiveScriptWrappable, WrapperTypeInfo::NotInheritFromEventTarget, WrapperTypeInfo::Independent };
#if defined(COMPONENT_BUILD) && defined(WIN32) && COMPILER(CLANG)
#pragma clang diagnostic pop
#endif

// This static member must be declared by DEFINE_WRAPPERTYPEINFO in PerformanceNavigation.h.
// For details, see the comment of DEFINE_WRAPPERTYPEINFO in
// bindings/core/v8/ScriptWrappable.h.
const WrapperTypeInfo& PerformanceNavigation::s_wrapperTypeInfo = V8PerformanceNavigation::wrapperTypeInfo;

// not [ActiveScriptWrappable]
static_assert(
    !std::is_base_of<ActiveScriptWrappable, PerformanceNavigation>::value,
    "PerformanceNavigation inherits from ActiveScriptWrappable, but is not specifying "
    "[ActiveScriptWrappable] extended attribute in the IDL file.  "
    "Be consistent.");
static_assert(
    std::is_same<decltype(&PerformanceNavigation::hasPendingActivity),
                 decltype(&ScriptWrappable::hasPendingActivity)>::value,
    "PerformanceNavigation is overriding hasPendingActivity(), but is not specifying "
    "[ActiveScriptWrappable] extended attribute in the IDL file.  "
    "Be consistent.");

namespace PerformanceNavigationV8Internal {

static void typeAttributeGetter(const v8::FunctionCallbackInfo<v8::Value>& info) {
  v8::Local<v8::Object> holder = info.Holder();

  PerformanceNavigation* impl = V8PerformanceNavigation::toImpl(holder);

  v8SetReturnValueUnsigned(info, impl->type());
}

void typeAttributeGetterCallback(const v8::FunctionCallbackInfo<v8::Value>& info) {
  PerformanceNavigationV8Internal::typeAttributeGetter(info);
}

static void redirectCountAttributeGetter(const v8::FunctionCallbackInfo<v8::Value>& info) {
  v8::Local<v8::Object> holder = info.Holder();

  PerformanceNavigation* impl = V8PerformanceNavigation::toImpl(holder);

  v8SetReturnValueUnsigned(info, impl->redirectCount());
}

void redirectCountAttributeGetterCallback(const v8::FunctionCallbackInfo<v8::Value>& info) {
  PerformanceNavigationV8Internal::redirectCountAttributeGetter(info);
}

static void toJSONMethod(const v8::FunctionCallbackInfo<v8::Value>& info) {
  PerformanceNavigation* impl = V8PerformanceNavigation::toImpl(info.Holder());

  ScriptState* scriptState = ScriptState::forReceiverObject(info);

  ScriptValue result = impl->toJSONForBinding(scriptState);
  v8SetReturnValue(info, result.v8Value());
}

void toJSONMethodCallback(const v8::FunctionCallbackInfo<v8::Value>& info) {
  PerformanceNavigationV8Internal::toJSONMethod(info);
}

} // namespace PerformanceNavigationV8Internal

const V8DOMConfiguration::AccessorConfiguration V8PerformanceNavigationAccessors[] = {
    {"type", PerformanceNavigationV8Internal::typeAttributeGetterCallback, 0, 0, 0, nullptr, 0, v8::DEFAULT, static_cast<v8::PropertyAttribute>(v8::ReadOnly), V8DOMConfiguration::ExposedToAllScripts, V8DOMConfiguration::OnPrototype, V8DOMConfiguration::CheckHolder},
    {"redirectCount", PerformanceNavigationV8Internal::redirectCountAttributeGetterCallback, 0, 0, 0, nullptr, 0, v8::DEFAULT, static_cast<v8::PropertyAttribute>(v8::ReadOnly), V8DOMConfiguration::ExposedToAllScripts, V8DOMConfiguration::OnPrototype, V8DOMConfiguration::CheckHolder},
};

const V8DOMConfiguration::MethodConfiguration V8PerformanceNavigationMethods[] = {
    {"toJSON", PerformanceNavigationV8Internal::toJSONMethodCallback, 0, 0, v8::None, V8DOMConfiguration::ExposedToAllScripts, V8DOMConfiguration::OnPrototype, V8DOMConfiguration::CheckHolder},
};

static void installV8PerformanceNavigationTemplate(v8::Isolate* isolate, const DOMWrapperWorld& world, v8::Local<v8::FunctionTemplate> interfaceTemplate) {
  // Initialize the interface object's template.
  V8DOMConfiguration::initializeDOMInterfaceTemplate(isolate, interfaceTemplate, V8PerformanceNavigation::wrapperTypeInfo.interfaceName, v8::Local<v8::FunctionTemplate>(), V8PerformanceNavigation::internalFieldCount);
  v8::Local<v8::Signature> signature = v8::Signature::New(isolate, interfaceTemplate);
  ALLOW_UNUSED_LOCAL(signature);
  v8::Local<v8::ObjectTemplate> instanceTemplate = interfaceTemplate->InstanceTemplate();
  ALLOW_UNUSED_LOCAL(instanceTemplate);
  v8::Local<v8::ObjectTemplate> prototypeTemplate = interfaceTemplate->PrototypeTemplate();
  ALLOW_UNUSED_LOCAL(prototypeTemplate);
  // Register DOM constants, attributes and operations.
  const V8DOMConfiguration::ConstantConfiguration V8PerformanceNavigationConstants[] = {
      {"TYPE_NAVIGATE", 0, 0, V8DOMConfiguration::ConstantTypeUnsignedShort},
      {"TYPE_RELOAD", 1, 0, V8DOMConfiguration::ConstantTypeUnsignedShort},
      {"TYPE_BACK_FORWARD", 2, 0, V8DOMConfiguration::ConstantTypeUnsignedShort},
      {"TYPE_RESERVED", 255, 0, V8DOMConfiguration::ConstantTypeUnsignedShort},
  };
  V8DOMConfiguration::installConstants(isolate, interfaceTemplate, prototypeTemplate, V8PerformanceNavigationConstants, WTF_ARRAY_LENGTH(V8PerformanceNavigationConstants));
  static_assert(0 == PerformanceNavigation::kTypeNavigate, "the value of PerformanceNavigation_kTypeNavigate does not match with implementation");
  static_assert(1 == PerformanceNavigation::kTypeReload, "the value of PerformanceNavigation_kTypeReload does not match with implementation");
  static_assert(2 == PerformanceNavigation::kTypeBackForward, "the value of PerformanceNavigation_kTypeBackForward does not match with implementation");
  static_assert(255 == PerformanceNavigation::kTypeReserved, "the value of PerformanceNavigation_kTypeReserved does not match with implementation");
  V8DOMConfiguration::installAccessors(isolate, world, instanceTemplate, prototypeTemplate, interfaceTemplate, signature, V8PerformanceNavigationAccessors, WTF_ARRAY_LENGTH(V8PerformanceNavigationAccessors));
  V8DOMConfiguration::installMethods(isolate, world, instanceTemplate, prototypeTemplate, interfaceTemplate, signature, V8PerformanceNavigationMethods, WTF_ARRAY_LENGTH(V8PerformanceNavigationMethods));
}

v8::Local<v8::FunctionTemplate> V8PerformanceNavigation::domTemplate(v8::Isolate* isolate, const DOMWrapperWorld& world) {
  return V8DOMConfiguration::domClassTemplate(isolate, world, const_cast<WrapperTypeInfo*>(&wrapperTypeInfo), installV8PerformanceNavigationTemplate);
}

bool V8PerformanceNavigation::hasInstance(v8::Local<v8::Value> v8Value, v8::Isolate* isolate) {
  return V8PerIsolateData::from(isolate)->hasInstance(&wrapperTypeInfo, v8Value);
}

v8::Local<v8::Object> V8PerformanceNavigation::findInstanceInPrototypeChain(v8::Local<v8::Value> v8Value, v8::Isolate* isolate) {
  return V8PerIsolateData::from(isolate)->findInstanceInPrototypeChain(&wrapperTypeInfo, v8Value);
}

PerformanceNavigation* V8PerformanceNavigation::toImplWithTypeCheck(v8::Isolate* isolate, v8::Local<v8::Value> value) {
  return hasInstance(value, isolate) ? toImpl(v8::Local<v8::Object>::Cast(value)) : nullptr;
}

}  // namespace blink
