// Copyright 2014 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// This file has been auto-generated by code_generator_v8.py.
// DO NOT MODIFY!

// clang-format off
#include "V8SecurityPolicyViolationEvent.h"

#include "bindings/core/v8/ExceptionState.h"
#include "bindings/core/v8/GeneratedCodeHelper.h"
#include "bindings/core/v8/V8DOMConfiguration.h"
#include "bindings/core/v8/V8ObjectConstructor.h"
#include "bindings/core/v8/V8SecurityPolicyViolationEventInit.h"
#include "core/dom/Document.h"
#include "core/frame/LocalDOMWindow.h"
#include "core/frame/UseCounter.h"
#include "core/inspector/ConsoleMessage.h"
#include "wtf/GetPtr.h"
#include "wtf/RefPtr.h"

namespace blink {

// Suppress warning: global constructors, because struct WrapperTypeInfo is trivial
// and does not depend on another global objects.
#if defined(COMPONENT_BUILD) && defined(WIN32) && COMPILER(CLANG)
#pragma clang diagnostic push
#pragma clang diagnostic ignored "-Wglobal-constructors"
#endif
const WrapperTypeInfo V8SecurityPolicyViolationEvent::wrapperTypeInfo = { gin::kEmbedderBlink, V8SecurityPolicyViolationEvent::domTemplate, V8SecurityPolicyViolationEvent::trace, V8SecurityPolicyViolationEvent::traceWrappers, 0, nullptr, "SecurityPolicyViolationEvent", &V8Event::wrapperTypeInfo, WrapperTypeInfo::WrapperTypeObjectPrototype, WrapperTypeInfo::ObjectClassId, WrapperTypeInfo::NotInheritFromActiveScriptWrappable, WrapperTypeInfo::NotInheritFromEventTarget, WrapperTypeInfo::Independent };
#if defined(COMPONENT_BUILD) && defined(WIN32) && COMPILER(CLANG)
#pragma clang diagnostic pop
#endif

// This static member must be declared by DEFINE_WRAPPERTYPEINFO in SecurityPolicyViolationEvent.h.
// For details, see the comment of DEFINE_WRAPPERTYPEINFO in
// bindings/core/v8/ScriptWrappable.h.
const WrapperTypeInfo& SecurityPolicyViolationEvent::s_wrapperTypeInfo = V8SecurityPolicyViolationEvent::wrapperTypeInfo;

// not [ActiveScriptWrappable]
static_assert(
    !std::is_base_of<ActiveScriptWrappable, SecurityPolicyViolationEvent>::value,
    "SecurityPolicyViolationEvent inherits from ActiveScriptWrappable, but is not specifying "
    "[ActiveScriptWrappable] extended attribute in the IDL file.  "
    "Be consistent.");
static_assert(
    std::is_same<decltype(&SecurityPolicyViolationEvent::hasPendingActivity),
                 decltype(&ScriptWrappable::hasPendingActivity)>::value,
    "SecurityPolicyViolationEvent is overriding hasPendingActivity(), but is not specifying "
    "[ActiveScriptWrappable] extended attribute in the IDL file.  "
    "Be consistent.");

namespace SecurityPolicyViolationEventV8Internal {

static void documentURIAttributeGetter(const v8::FunctionCallbackInfo<v8::Value>& info) {
  v8::Local<v8::Object> holder = info.Holder();

  SecurityPolicyViolationEvent* impl = V8SecurityPolicyViolationEvent::toImpl(holder);

  v8SetReturnValueString(info, impl->documentURI(), info.GetIsolate());
}

void documentURIAttributeGetterCallback(const v8::FunctionCallbackInfo<v8::Value>& info) {
  UseCounter::countIfNotPrivateScript(info.GetIsolate(), currentExecutionContext(info.GetIsolate()), UseCounter::V8SecurityPolicyViolationEvent_DocumentURI_AttributeGetter);

  SecurityPolicyViolationEventV8Internal::documentURIAttributeGetter(info);
}

static void referrerAttributeGetter(const v8::FunctionCallbackInfo<v8::Value>& info) {
  v8::Local<v8::Object> holder = info.Holder();

  SecurityPolicyViolationEvent* impl = V8SecurityPolicyViolationEvent::toImpl(holder);

  v8SetReturnValueString(info, impl->referrer(), info.GetIsolate());
}

void referrerAttributeGetterCallback(const v8::FunctionCallbackInfo<v8::Value>& info) {
  SecurityPolicyViolationEventV8Internal::referrerAttributeGetter(info);
}

static void blockedURIAttributeGetter(const v8::FunctionCallbackInfo<v8::Value>& info) {
  v8::Local<v8::Object> holder = info.Holder();

  SecurityPolicyViolationEvent* impl = V8SecurityPolicyViolationEvent::toImpl(holder);

  v8SetReturnValueString(info, impl->blockedURI(), info.GetIsolate());
}

void blockedURIAttributeGetterCallback(const v8::FunctionCallbackInfo<v8::Value>& info) {
  UseCounter::countIfNotPrivateScript(info.GetIsolate(), currentExecutionContext(info.GetIsolate()), UseCounter::V8SecurityPolicyViolationEvent_BlockedURI_AttributeGetter);

  SecurityPolicyViolationEventV8Internal::blockedURIAttributeGetter(info);
}

static void violatedDirectiveAttributeGetter(const v8::FunctionCallbackInfo<v8::Value>& info) {
  v8::Local<v8::Object> holder = info.Holder();

  SecurityPolicyViolationEvent* impl = V8SecurityPolicyViolationEvent::toImpl(holder);

  v8SetReturnValueString(info, impl->violatedDirective(), info.GetIsolate());
}

void violatedDirectiveAttributeGetterCallback(const v8::FunctionCallbackInfo<v8::Value>& info) {
  SecurityPolicyViolationEventV8Internal::violatedDirectiveAttributeGetter(info);
}

static void effectiveDirectiveAttributeGetter(const v8::FunctionCallbackInfo<v8::Value>& info) {
  v8::Local<v8::Object> holder = info.Holder();

  SecurityPolicyViolationEvent* impl = V8SecurityPolicyViolationEvent::toImpl(holder);

  v8SetReturnValueString(info, impl->effectiveDirective(), info.GetIsolate());
}

void effectiveDirectiveAttributeGetterCallback(const v8::FunctionCallbackInfo<v8::Value>& info) {
  SecurityPolicyViolationEventV8Internal::effectiveDirectiveAttributeGetter(info);
}

static void originalPolicyAttributeGetter(const v8::FunctionCallbackInfo<v8::Value>& info) {
  v8::Local<v8::Object> holder = info.Holder();

  SecurityPolicyViolationEvent* impl = V8SecurityPolicyViolationEvent::toImpl(holder);

  v8SetReturnValueString(info, impl->originalPolicy(), info.GetIsolate());
}

void originalPolicyAttributeGetterCallback(const v8::FunctionCallbackInfo<v8::Value>& info) {
  SecurityPolicyViolationEventV8Internal::originalPolicyAttributeGetter(info);
}

static void dispositionAttributeGetter(const v8::FunctionCallbackInfo<v8::Value>& info) {
  v8::Local<v8::Object> holder = info.Holder();

  SecurityPolicyViolationEvent* impl = V8SecurityPolicyViolationEvent::toImpl(holder);

  v8SetReturnValueString(info, impl->disposition(), info.GetIsolate());
}

void dispositionAttributeGetterCallback(const v8::FunctionCallbackInfo<v8::Value>& info) {
  SecurityPolicyViolationEventV8Internal::dispositionAttributeGetter(info);
}

static void sourceFileAttributeGetter(const v8::FunctionCallbackInfo<v8::Value>& info) {
  v8::Local<v8::Object> holder = info.Holder();

  SecurityPolicyViolationEvent* impl = V8SecurityPolicyViolationEvent::toImpl(holder);

  v8SetReturnValueString(info, impl->sourceFile(), info.GetIsolate());
}

void sourceFileAttributeGetterCallback(const v8::FunctionCallbackInfo<v8::Value>& info) {
  SecurityPolicyViolationEventV8Internal::sourceFileAttributeGetter(info);
}

static void statusCodeAttributeGetter(const v8::FunctionCallbackInfo<v8::Value>& info) {
  v8::Local<v8::Object> holder = info.Holder();

  SecurityPolicyViolationEvent* impl = V8SecurityPolicyViolationEvent::toImpl(holder);

  v8SetReturnValueUnsigned(info, impl->statusCode());
}

void statusCodeAttributeGetterCallback(const v8::FunctionCallbackInfo<v8::Value>& info) {
  UseCounter::countIfNotPrivateScript(info.GetIsolate(), currentExecutionContext(info.GetIsolate()), UseCounter::V8SecurityPolicyViolationEvent_StatusCode_AttributeGetter);

  SecurityPolicyViolationEventV8Internal::statusCodeAttributeGetter(info);
}

static void lineNumberAttributeGetter(const v8::FunctionCallbackInfo<v8::Value>& info) {
  v8::Local<v8::Object> holder = info.Holder();

  SecurityPolicyViolationEvent* impl = V8SecurityPolicyViolationEvent::toImpl(holder);

  v8SetReturnValueInt(info, impl->lineNumber());
}

void lineNumberAttributeGetterCallback(const v8::FunctionCallbackInfo<v8::Value>& info) {
  SecurityPolicyViolationEventV8Internal::lineNumberAttributeGetter(info);
}

static void columnNumberAttributeGetter(const v8::FunctionCallbackInfo<v8::Value>& info) {
  v8::Local<v8::Object> holder = info.Holder();

  SecurityPolicyViolationEvent* impl = V8SecurityPolicyViolationEvent::toImpl(holder);

  v8SetReturnValueInt(info, impl->columnNumber());
}

void columnNumberAttributeGetterCallback(const v8::FunctionCallbackInfo<v8::Value>& info) {
  SecurityPolicyViolationEventV8Internal::columnNumberAttributeGetter(info);
}

static void isTrustedAttributeGetter(const v8::FunctionCallbackInfo<v8::Value>& info) {
  v8::Local<v8::Object> holder = info.Holder();

  SecurityPolicyViolationEvent* impl = V8SecurityPolicyViolationEvent::toImpl(holder);

  v8SetReturnValueBool(info, impl->isTrusted());
}

void isTrustedAttributeGetterCallback(const v8::FunctionCallbackInfo<v8::Value>& info) {
  SecurityPolicyViolationEventV8Internal::isTrustedAttributeGetter(info);
}

static void constructor(const v8::FunctionCallbackInfo<v8::Value>& info) {
  ExceptionState exceptionState(info.GetIsolate(), ExceptionState::ConstructionContext, "SecurityPolicyViolationEvent");

  if (UNLIKELY(info.Length() < 1)) {
    exceptionState.throwTypeError(ExceptionMessages::notEnoughArguments(1, info.Length()));
    return;
  }

  V8StringResource<> type;
  SecurityPolicyViolationEventInit eventInitDict;
  type = info[0];
  if (!type.prepare())
    return;

  if (!isUndefinedOrNull(info[1]) && !info[1]->IsObject()) {
    exceptionState.throwTypeError("parameter 2 ('eventInitDict') is not an object.");

    return;
  }
  V8SecurityPolicyViolationEventInit::toImpl(info.GetIsolate(), info[1], eventInitDict, exceptionState);
  if (exceptionState.hadException())
    return;

  SecurityPolicyViolationEvent* impl = SecurityPolicyViolationEvent::create(type, eventInitDict);
  v8::Local<v8::Object> wrapper = info.Holder();
  wrapper = impl->associateWithWrapper(info.GetIsolate(), &V8SecurityPolicyViolationEvent::wrapperTypeInfo, wrapper);
  v8SetReturnValue(info, wrapper);
}

} // namespace SecurityPolicyViolationEventV8Internal

const V8DOMConfiguration::AccessorConfiguration V8SecurityPolicyViolationEventAccessors[] = {
    {"documentURI", SecurityPolicyViolationEventV8Internal::documentURIAttributeGetterCallback, 0, 0, 0, nullptr, 0, v8::DEFAULT, static_cast<v8::PropertyAttribute>(v8::ReadOnly), V8DOMConfiguration::ExposedToAllScripts, V8DOMConfiguration::OnPrototype, V8DOMConfiguration::CheckHolder},
    {"referrer", SecurityPolicyViolationEventV8Internal::referrerAttributeGetterCallback, 0, 0, 0, nullptr, 0, v8::DEFAULT, static_cast<v8::PropertyAttribute>(v8::ReadOnly), V8DOMConfiguration::ExposedToAllScripts, V8DOMConfiguration::OnPrototype, V8DOMConfiguration::CheckHolder},
    {"blockedURI", SecurityPolicyViolationEventV8Internal::blockedURIAttributeGetterCallback, 0, 0, 0, nullptr, 0, v8::DEFAULT, static_cast<v8::PropertyAttribute>(v8::ReadOnly), V8DOMConfiguration::ExposedToAllScripts, V8DOMConfiguration::OnPrototype, V8DOMConfiguration::CheckHolder},
    {"violatedDirective", SecurityPolicyViolationEventV8Internal::violatedDirectiveAttributeGetterCallback, 0, 0, 0, nullptr, 0, v8::DEFAULT, static_cast<v8::PropertyAttribute>(v8::ReadOnly), V8DOMConfiguration::ExposedToAllScripts, V8DOMConfiguration::OnPrototype, V8DOMConfiguration::CheckHolder},
    {"effectiveDirective", SecurityPolicyViolationEventV8Internal::effectiveDirectiveAttributeGetterCallback, 0, 0, 0, nullptr, 0, v8::DEFAULT, static_cast<v8::PropertyAttribute>(v8::ReadOnly), V8DOMConfiguration::ExposedToAllScripts, V8DOMConfiguration::OnPrototype, V8DOMConfiguration::CheckHolder},
    {"originalPolicy", SecurityPolicyViolationEventV8Internal::originalPolicyAttributeGetterCallback, 0, 0, 0, nullptr, 0, v8::DEFAULT, static_cast<v8::PropertyAttribute>(v8::ReadOnly), V8DOMConfiguration::ExposedToAllScripts, V8DOMConfiguration::OnPrototype, V8DOMConfiguration::CheckHolder},
    {"disposition", SecurityPolicyViolationEventV8Internal::dispositionAttributeGetterCallback, 0, 0, 0, nullptr, 0, v8::DEFAULT, static_cast<v8::PropertyAttribute>(v8::ReadOnly), V8DOMConfiguration::ExposedToAllScripts, V8DOMConfiguration::OnPrototype, V8DOMConfiguration::CheckHolder},
    {"sourceFile", SecurityPolicyViolationEventV8Internal::sourceFileAttributeGetterCallback, 0, 0, 0, nullptr, 0, v8::DEFAULT, static_cast<v8::PropertyAttribute>(v8::ReadOnly), V8DOMConfiguration::ExposedToAllScripts, V8DOMConfiguration::OnPrototype, V8DOMConfiguration::CheckHolder},
    {"statusCode", SecurityPolicyViolationEventV8Internal::statusCodeAttributeGetterCallback, 0, 0, 0, nullptr, 0, v8::DEFAULT, static_cast<v8::PropertyAttribute>(v8::ReadOnly), V8DOMConfiguration::ExposedToAllScripts, V8DOMConfiguration::OnPrototype, V8DOMConfiguration::CheckHolder},
    {"lineNumber", SecurityPolicyViolationEventV8Internal::lineNumberAttributeGetterCallback, 0, 0, 0, nullptr, 0, v8::DEFAULT, static_cast<v8::PropertyAttribute>(v8::ReadOnly), V8DOMConfiguration::ExposedToAllScripts, V8DOMConfiguration::OnPrototype, V8DOMConfiguration::CheckHolder},
    {"columnNumber", SecurityPolicyViolationEventV8Internal::columnNumberAttributeGetterCallback, 0, 0, 0, nullptr, 0, v8::DEFAULT, static_cast<v8::PropertyAttribute>(v8::ReadOnly), V8DOMConfiguration::ExposedToAllScripts, V8DOMConfiguration::OnPrototype, V8DOMConfiguration::CheckHolder},
    {"isTrusted", SecurityPolicyViolationEventV8Internal::isTrustedAttributeGetterCallback, 0, 0, 0, nullptr, 0, v8::DEFAULT, static_cast<v8::PropertyAttribute>(v8::DontDelete | v8::ReadOnly), V8DOMConfiguration::ExposedToAllScripts, V8DOMConfiguration::OnInstance, V8DOMConfiguration::CheckHolder},
};

void V8SecurityPolicyViolationEvent::constructorCallback(const v8::FunctionCallbackInfo<v8::Value>& info) {
  if (!info.IsConstructCall()) {
    V8ThrowException::throwTypeError(info.GetIsolate(), ExceptionMessages::constructorNotCallableAsFunction("SecurityPolicyViolationEvent"));
    return;
  }

  if (ConstructorMode::current(info.GetIsolate()) == ConstructorMode::WrapExistingObject) {
    v8SetReturnValue(info, info.Holder());
    return;
  }

  SecurityPolicyViolationEventV8Internal::constructor(info);
}

static void installV8SecurityPolicyViolationEventTemplate(v8::Isolate* isolate, const DOMWrapperWorld& world, v8::Local<v8::FunctionTemplate> interfaceTemplate) {
  // Initialize the interface object's template.
  V8DOMConfiguration::initializeDOMInterfaceTemplate(isolate, interfaceTemplate, V8SecurityPolicyViolationEvent::wrapperTypeInfo.interfaceName, V8Event::domTemplate(isolate, world), V8SecurityPolicyViolationEvent::internalFieldCount);
  interfaceTemplate->SetCallHandler(V8SecurityPolicyViolationEvent::constructorCallback);
  interfaceTemplate->SetLength(1);
  v8::Local<v8::Signature> signature = v8::Signature::New(isolate, interfaceTemplate);
  ALLOW_UNUSED_LOCAL(signature);
  v8::Local<v8::ObjectTemplate> instanceTemplate = interfaceTemplate->InstanceTemplate();
  ALLOW_UNUSED_LOCAL(instanceTemplate);
  v8::Local<v8::ObjectTemplate> prototypeTemplate = interfaceTemplate->PrototypeTemplate();
  ALLOW_UNUSED_LOCAL(prototypeTemplate);
  // Register DOM constants, attributes and operations.
  V8DOMConfiguration::installAccessors(isolate, world, instanceTemplate, prototypeTemplate, interfaceTemplate, signature, V8SecurityPolicyViolationEventAccessors, WTF_ARRAY_LENGTH(V8SecurityPolicyViolationEventAccessors));
}

v8::Local<v8::FunctionTemplate> V8SecurityPolicyViolationEvent::domTemplate(v8::Isolate* isolate, const DOMWrapperWorld& world) {
  return V8DOMConfiguration::domClassTemplate(isolate, world, const_cast<WrapperTypeInfo*>(&wrapperTypeInfo), installV8SecurityPolicyViolationEventTemplate);
}

bool V8SecurityPolicyViolationEvent::hasInstance(v8::Local<v8::Value> v8Value, v8::Isolate* isolate) {
  return V8PerIsolateData::from(isolate)->hasInstance(&wrapperTypeInfo, v8Value);
}

v8::Local<v8::Object> V8SecurityPolicyViolationEvent::findInstanceInPrototypeChain(v8::Local<v8::Value> v8Value, v8::Isolate* isolate) {
  return V8PerIsolateData::from(isolate)->findInstanceInPrototypeChain(&wrapperTypeInfo, v8Value);
}

SecurityPolicyViolationEvent* V8SecurityPolicyViolationEvent::toImplWithTypeCheck(v8::Isolate* isolate, v8::Local<v8::Value> value) {
  return hasInstance(value, isolate) ? toImpl(v8::Local<v8::Object>::Cast(value)) : nullptr;
}

}  // namespace blink
