// Copyright 2014 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// This file has been auto-generated by code_generator_v8.py.
// DO NOT MODIFY!

// clang-format off
#include "V8VTTRegion.h"

#include "bindings/core/v8/ExceptionState.h"
#include "bindings/core/v8/GeneratedCodeHelper.h"
#include "bindings/core/v8/V8DOMConfiguration.h"
#include "bindings/core/v8/V8HiddenValue.h"
#include "bindings/core/v8/V8ObjectConstructor.h"
#include "bindings/core/v8/V8TextTrack.h"
#include "core/dom/Document.h"
#include "core/frame/LocalDOMWindow.h"
#include "platform/RuntimeEnabledFeatures.h"
#include "wtf/GetPtr.h"
#include "wtf/RefPtr.h"

namespace blink {

// Suppress warning: global constructors, because struct WrapperTypeInfo is trivial
// and does not depend on another global objects.
#if defined(COMPONENT_BUILD) && defined(WIN32) && COMPILER(CLANG)
#pragma clang diagnostic push
#pragma clang diagnostic ignored "-Wglobal-constructors"
#endif
const WrapperTypeInfo V8VTTRegion::wrapperTypeInfo = { gin::kEmbedderBlink, V8VTTRegion::domTemplate, V8VTTRegion::trace, V8VTTRegion::traceWrappers, 0, nullptr, "VTTRegion", 0, WrapperTypeInfo::WrapperTypeObjectPrototype, WrapperTypeInfo::ObjectClassId, WrapperTypeInfo::NotInheritFromActiveScriptWrappable, WrapperTypeInfo::NotInheritFromEventTarget, WrapperTypeInfo::Independent };
#if defined(COMPONENT_BUILD) && defined(WIN32) && COMPILER(CLANG)
#pragma clang diagnostic pop
#endif

// This static member must be declared by DEFINE_WRAPPERTYPEINFO in VTTRegion.h.
// For details, see the comment of DEFINE_WRAPPERTYPEINFO in
// bindings/core/v8/ScriptWrappable.h.
const WrapperTypeInfo& VTTRegion::s_wrapperTypeInfo = V8VTTRegion::wrapperTypeInfo;

// not [ActiveScriptWrappable]
static_assert(
    !std::is_base_of<ActiveScriptWrappable, VTTRegion>::value,
    "VTTRegion inherits from ActiveScriptWrappable, but is not specifying "
    "[ActiveScriptWrappable] extended attribute in the IDL file.  "
    "Be consistent.");
static_assert(
    std::is_same<decltype(&VTTRegion::hasPendingActivity),
                 decltype(&ScriptWrappable::hasPendingActivity)>::value,
    "VTTRegion is overriding hasPendingActivity(), but is not specifying "
    "[ActiveScriptWrappable] extended attribute in the IDL file.  "
    "Be consistent.");

namespace VTTRegionV8Internal {

static void widthAttributeGetter(const v8::FunctionCallbackInfo<v8::Value>& info) {
  v8::Local<v8::Object> holder = info.Holder();

  VTTRegion* impl = V8VTTRegion::toImpl(holder);

  v8SetReturnValue(info, impl->width());
}

void widthAttributeGetterCallback(const v8::FunctionCallbackInfo<v8::Value>& info) {
  VTTRegionV8Internal::widthAttributeGetter(info);
}

static void widthAttributeSetter(v8::Local<v8::Value> v8Value, const v8::FunctionCallbackInfo<v8::Value>& info) {
  v8::Local<v8::Object> holder = info.Holder();
  VTTRegion* impl = V8VTTRegion::toImpl(holder);

  ExceptionState exceptionState(info.GetIsolate(), ExceptionState::SetterContext, "VTTRegion", "width");

  // Prepare the value to be set.
  double cppValue = toRestrictedDouble(info.GetIsolate(), v8Value, exceptionState);
  if (exceptionState.hadException())
    return;

  impl->setWidth(cppValue, exceptionState);
}

void widthAttributeSetterCallback(const v8::FunctionCallbackInfo<v8::Value>& info) {
  v8::Local<v8::Value> v8Value = info[0];

  VTTRegionV8Internal::widthAttributeSetter(v8Value, info);
}

static void heightAttributeGetter(const v8::FunctionCallbackInfo<v8::Value>& info) {
  v8::Local<v8::Object> holder = info.Holder();

  VTTRegion* impl = V8VTTRegion::toImpl(holder);

  v8SetReturnValueInt(info, impl->height());
}

void heightAttributeGetterCallback(const v8::FunctionCallbackInfo<v8::Value>& info) {
  VTTRegionV8Internal::heightAttributeGetter(info);
}

static void heightAttributeSetter(v8::Local<v8::Value> v8Value, const v8::FunctionCallbackInfo<v8::Value>& info) {
  v8::Local<v8::Object> holder = info.Holder();
  VTTRegion* impl = V8VTTRegion::toImpl(holder);

  ExceptionState exceptionState(info.GetIsolate(), ExceptionState::SetterContext, "VTTRegion", "height");

  // Prepare the value to be set.
  int cppValue = toInt32(info.GetIsolate(), v8Value, NormalConversion, exceptionState);
  if (exceptionState.hadException())
    return;

  impl->setHeight(cppValue, exceptionState);
}

void heightAttributeSetterCallback(const v8::FunctionCallbackInfo<v8::Value>& info) {
  v8::Local<v8::Value> v8Value = info[0];

  VTTRegionV8Internal::heightAttributeSetter(v8Value, info);
}

static void regionAnchorXAttributeGetter(const v8::FunctionCallbackInfo<v8::Value>& info) {
  v8::Local<v8::Object> holder = info.Holder();

  VTTRegion* impl = V8VTTRegion::toImpl(holder);

  v8SetReturnValue(info, impl->regionAnchorX());
}

void regionAnchorXAttributeGetterCallback(const v8::FunctionCallbackInfo<v8::Value>& info) {
  VTTRegionV8Internal::regionAnchorXAttributeGetter(info);
}

static void regionAnchorXAttributeSetter(v8::Local<v8::Value> v8Value, const v8::FunctionCallbackInfo<v8::Value>& info) {
  v8::Local<v8::Object> holder = info.Holder();
  VTTRegion* impl = V8VTTRegion::toImpl(holder);

  ExceptionState exceptionState(info.GetIsolate(), ExceptionState::SetterContext, "VTTRegion", "regionAnchorX");

  // Prepare the value to be set.
  double cppValue = toRestrictedDouble(info.GetIsolate(), v8Value, exceptionState);
  if (exceptionState.hadException())
    return;

  impl->setRegionAnchorX(cppValue, exceptionState);
}

void regionAnchorXAttributeSetterCallback(const v8::FunctionCallbackInfo<v8::Value>& info) {
  v8::Local<v8::Value> v8Value = info[0];

  VTTRegionV8Internal::regionAnchorXAttributeSetter(v8Value, info);
}

static void regionAnchorYAttributeGetter(const v8::FunctionCallbackInfo<v8::Value>& info) {
  v8::Local<v8::Object> holder = info.Holder();

  VTTRegion* impl = V8VTTRegion::toImpl(holder);

  v8SetReturnValue(info, impl->regionAnchorY());
}

void regionAnchorYAttributeGetterCallback(const v8::FunctionCallbackInfo<v8::Value>& info) {
  VTTRegionV8Internal::regionAnchorYAttributeGetter(info);
}

static void regionAnchorYAttributeSetter(v8::Local<v8::Value> v8Value, const v8::FunctionCallbackInfo<v8::Value>& info) {
  v8::Local<v8::Object> holder = info.Holder();
  VTTRegion* impl = V8VTTRegion::toImpl(holder);

  ExceptionState exceptionState(info.GetIsolate(), ExceptionState::SetterContext, "VTTRegion", "regionAnchorY");

  // Prepare the value to be set.
  double cppValue = toRestrictedDouble(info.GetIsolate(), v8Value, exceptionState);
  if (exceptionState.hadException())
    return;

  impl->setRegionAnchorY(cppValue, exceptionState);
}

void regionAnchorYAttributeSetterCallback(const v8::FunctionCallbackInfo<v8::Value>& info) {
  v8::Local<v8::Value> v8Value = info[0];

  VTTRegionV8Internal::regionAnchorYAttributeSetter(v8Value, info);
}

static void viewportAnchorXAttributeGetter(const v8::FunctionCallbackInfo<v8::Value>& info) {
  v8::Local<v8::Object> holder = info.Holder();

  VTTRegion* impl = V8VTTRegion::toImpl(holder);

  v8SetReturnValue(info, impl->viewportAnchorX());
}

void viewportAnchorXAttributeGetterCallback(const v8::FunctionCallbackInfo<v8::Value>& info) {
  VTTRegionV8Internal::viewportAnchorXAttributeGetter(info);
}

static void viewportAnchorXAttributeSetter(v8::Local<v8::Value> v8Value, const v8::FunctionCallbackInfo<v8::Value>& info) {
  v8::Local<v8::Object> holder = info.Holder();
  VTTRegion* impl = V8VTTRegion::toImpl(holder);

  ExceptionState exceptionState(info.GetIsolate(), ExceptionState::SetterContext, "VTTRegion", "viewportAnchorX");

  // Prepare the value to be set.
  double cppValue = toRestrictedDouble(info.GetIsolate(), v8Value, exceptionState);
  if (exceptionState.hadException())
    return;

  impl->setViewportAnchorX(cppValue, exceptionState);
}

void viewportAnchorXAttributeSetterCallback(const v8::FunctionCallbackInfo<v8::Value>& info) {
  v8::Local<v8::Value> v8Value = info[0];

  VTTRegionV8Internal::viewportAnchorXAttributeSetter(v8Value, info);
}

static void viewportAnchorYAttributeGetter(const v8::FunctionCallbackInfo<v8::Value>& info) {
  v8::Local<v8::Object> holder = info.Holder();

  VTTRegion* impl = V8VTTRegion::toImpl(holder);

  v8SetReturnValue(info, impl->viewportAnchorY());
}

void viewportAnchorYAttributeGetterCallback(const v8::FunctionCallbackInfo<v8::Value>& info) {
  VTTRegionV8Internal::viewportAnchorYAttributeGetter(info);
}

static void viewportAnchorYAttributeSetter(v8::Local<v8::Value> v8Value, const v8::FunctionCallbackInfo<v8::Value>& info) {
  v8::Local<v8::Object> holder = info.Holder();
  VTTRegion* impl = V8VTTRegion::toImpl(holder);

  ExceptionState exceptionState(info.GetIsolate(), ExceptionState::SetterContext, "VTTRegion", "viewportAnchorY");

  // Prepare the value to be set.
  double cppValue = toRestrictedDouble(info.GetIsolate(), v8Value, exceptionState);
  if (exceptionState.hadException())
    return;

  impl->setViewportAnchorY(cppValue, exceptionState);
}

void viewportAnchorYAttributeSetterCallback(const v8::FunctionCallbackInfo<v8::Value>& info) {
  v8::Local<v8::Value> v8Value = info[0];

  VTTRegionV8Internal::viewportAnchorYAttributeSetter(v8Value, info);
}

static void scrollAttributeGetter(const v8::FunctionCallbackInfo<v8::Value>& info) {
  v8::Local<v8::Object> holder = info.Holder();

  VTTRegion* impl = V8VTTRegion::toImpl(holder);

  v8SetReturnValueString(info, impl->scroll(), info.GetIsolate());
}

void scrollAttributeGetterCallback(const v8::FunctionCallbackInfo<v8::Value>& info) {
  VTTRegionV8Internal::scrollAttributeGetter(info);
}

static void scrollAttributeSetter(v8::Local<v8::Value> v8Value, const v8::FunctionCallbackInfo<v8::Value>& info) {
  v8::Local<v8::Object> holder = info.Holder();
  VTTRegion* impl = V8VTTRegion::toImpl(holder);

  ExceptionState exceptionState(info.GetIsolate(), ExceptionState::SetterContext, "VTTRegion", "scroll");

  // Prepare the value to be set.
  V8StringResource<> cppValue = v8Value;
  if (!cppValue.prepare())
    return;

  impl->setScroll(cppValue, exceptionState);
}

void scrollAttributeSetterCallback(const v8::FunctionCallbackInfo<v8::Value>& info) {
  v8::Local<v8::Value> v8Value = info[0];

  VTTRegionV8Internal::scrollAttributeSetter(v8Value, info);
}

static void trackAttributeGetter(const v8::FunctionCallbackInfo<v8::Value>& info) {
  v8::Local<v8::Object> holder = info.Holder();

  VTTRegion* impl = V8VTTRegion::toImpl(holder);

  TextTrack* cppValue(WTF::getPtr(impl->track()));

  // Keep the wrapper object for the return value alive as long as |this|
  // object is alive in order to save creation time of the wrapper object.
  if (cppValue && DOMDataStore::setReturnValue(info.GetReturnValue(), cppValue))
    return;
  v8::Local<v8::Value> v8Value(toV8(cppValue, holder, info.GetIsolate()));
  const char kKeepAliveKey[] = "KeepAlive#VTTRegion#track";
  V8HiddenValue::setHiddenValue(ScriptState::current(info.GetIsolate()), holder, v8AtomicString(info.GetIsolate(), StringView(kKeepAliveKey, sizeof kKeepAliveKey)), v8Value);

  v8SetReturnValue(info, v8Value);
}

void trackAttributeGetterCallback(const v8::FunctionCallbackInfo<v8::Value>& info) {
  VTTRegionV8Internal::trackAttributeGetter(info);
}

static void idAttributeGetter(const v8::FunctionCallbackInfo<v8::Value>& info) {
  v8::Local<v8::Object> holder = info.Holder();

  VTTRegion* impl = V8VTTRegion::toImpl(holder);

  v8SetReturnValueString(info, impl->id(), info.GetIsolate());
}

void idAttributeGetterCallback(const v8::FunctionCallbackInfo<v8::Value>& info) {
  VTTRegionV8Internal::idAttributeGetter(info);
}

static void idAttributeSetter(v8::Local<v8::Value> v8Value, const v8::FunctionCallbackInfo<v8::Value>& info) {
  v8::Local<v8::Object> holder = info.Holder();
  VTTRegion* impl = V8VTTRegion::toImpl(holder);

  // Prepare the value to be set.
  V8StringResource<> cppValue = v8Value;
  if (!cppValue.prepare())
    return;

  impl->setId(cppValue);
}

void idAttributeSetterCallback(const v8::FunctionCallbackInfo<v8::Value>& info) {
  v8::Local<v8::Value> v8Value = info[0];

  VTTRegionV8Internal::idAttributeSetter(v8Value, info);
}

static void constructor(const v8::FunctionCallbackInfo<v8::Value>& info) {
  VTTRegion* impl = VTTRegion::create();
  v8::Local<v8::Object> wrapper = info.Holder();
  wrapper = impl->associateWithWrapper(info.GetIsolate(), &V8VTTRegion::wrapperTypeInfo, wrapper);
  v8SetReturnValue(info, wrapper);
}

} // namespace VTTRegionV8Internal

const V8DOMConfiguration::AccessorConfiguration V8VTTRegionAccessors[] = {
    {"width", VTTRegionV8Internal::widthAttributeGetterCallback, VTTRegionV8Internal::widthAttributeSetterCallback, 0, 0, nullptr, 0, v8::DEFAULT, static_cast<v8::PropertyAttribute>(v8::None), V8DOMConfiguration::ExposedToAllScripts, V8DOMConfiguration::OnPrototype, V8DOMConfiguration::CheckHolder},
    {"height", VTTRegionV8Internal::heightAttributeGetterCallback, VTTRegionV8Internal::heightAttributeSetterCallback, 0, 0, nullptr, 0, v8::DEFAULT, static_cast<v8::PropertyAttribute>(v8::None), V8DOMConfiguration::ExposedToAllScripts, V8DOMConfiguration::OnPrototype, V8DOMConfiguration::CheckHolder},
    {"regionAnchorX", VTTRegionV8Internal::regionAnchorXAttributeGetterCallback, VTTRegionV8Internal::regionAnchorXAttributeSetterCallback, 0, 0, nullptr, 0, v8::DEFAULT, static_cast<v8::PropertyAttribute>(v8::None), V8DOMConfiguration::ExposedToAllScripts, V8DOMConfiguration::OnPrototype, V8DOMConfiguration::CheckHolder},
    {"regionAnchorY", VTTRegionV8Internal::regionAnchorYAttributeGetterCallback, VTTRegionV8Internal::regionAnchorYAttributeSetterCallback, 0, 0, nullptr, 0, v8::DEFAULT, static_cast<v8::PropertyAttribute>(v8::None), V8DOMConfiguration::ExposedToAllScripts, V8DOMConfiguration::OnPrototype, V8DOMConfiguration::CheckHolder},
    {"viewportAnchorX", VTTRegionV8Internal::viewportAnchorXAttributeGetterCallback, VTTRegionV8Internal::viewportAnchorXAttributeSetterCallback, 0, 0, nullptr, 0, v8::DEFAULT, static_cast<v8::PropertyAttribute>(v8::None), V8DOMConfiguration::ExposedToAllScripts, V8DOMConfiguration::OnPrototype, V8DOMConfiguration::CheckHolder},
    {"viewportAnchorY", VTTRegionV8Internal::viewportAnchorYAttributeGetterCallback, VTTRegionV8Internal::viewportAnchorYAttributeSetterCallback, 0, 0, nullptr, 0, v8::DEFAULT, static_cast<v8::PropertyAttribute>(v8::None), V8DOMConfiguration::ExposedToAllScripts, V8DOMConfiguration::OnPrototype, V8DOMConfiguration::CheckHolder},
    {"scroll", VTTRegionV8Internal::scrollAttributeGetterCallback, VTTRegionV8Internal::scrollAttributeSetterCallback, 0, 0, nullptr, 0, v8::DEFAULT, static_cast<v8::PropertyAttribute>(v8::None), V8DOMConfiguration::ExposedToAllScripts, V8DOMConfiguration::OnPrototype, V8DOMConfiguration::CheckHolder},
    {"track", VTTRegionV8Internal::trackAttributeGetterCallback, 0, 0, 0, nullptr, 0, v8::DEFAULT, static_cast<v8::PropertyAttribute>(v8::ReadOnly), V8DOMConfiguration::ExposedToAllScripts, V8DOMConfiguration::OnPrototype, V8DOMConfiguration::CheckHolder},
    {"id", VTTRegionV8Internal::idAttributeGetterCallback, VTTRegionV8Internal::idAttributeSetterCallback, 0, 0, nullptr, 0, v8::DEFAULT, static_cast<v8::PropertyAttribute>(v8::None), V8DOMConfiguration::ExposedToAllScripts, V8DOMConfiguration::OnPrototype, V8DOMConfiguration::CheckHolder},
};

void V8VTTRegion::constructorCallback(const v8::FunctionCallbackInfo<v8::Value>& info) {
  if (!info.IsConstructCall()) {
    V8ThrowException::throwTypeError(info.GetIsolate(), ExceptionMessages::constructorNotCallableAsFunction("VTTRegion"));
    return;
  }

  if (ConstructorMode::current(info.GetIsolate()) == ConstructorMode::WrapExistingObject) {
    v8SetReturnValue(info, info.Holder());
    return;
  }

  VTTRegionV8Internal::constructor(info);
}

static void installV8VTTRegionTemplate(v8::Isolate* isolate, const DOMWrapperWorld& world, v8::Local<v8::FunctionTemplate> interfaceTemplate) {
  // Initialize the interface object's template.
  V8DOMConfiguration::initializeDOMInterfaceTemplate(isolate, interfaceTemplate, V8VTTRegion::wrapperTypeInfo.interfaceName, v8::Local<v8::FunctionTemplate>(), V8VTTRegion::internalFieldCount);
  interfaceTemplate->SetCallHandler(V8VTTRegion::constructorCallback);
  interfaceTemplate->SetLength(0);
  v8::Local<v8::Signature> signature = v8::Signature::New(isolate, interfaceTemplate);
  ALLOW_UNUSED_LOCAL(signature);
  v8::Local<v8::ObjectTemplate> instanceTemplate = interfaceTemplate->InstanceTemplate();
  ALLOW_UNUSED_LOCAL(instanceTemplate);
  v8::Local<v8::ObjectTemplate> prototypeTemplate = interfaceTemplate->PrototypeTemplate();
  ALLOW_UNUSED_LOCAL(prototypeTemplate);
  // Register DOM constants, attributes and operations.
  if (RuntimeEnabledFeatures::webVTTRegionsEnabled()) {
      V8DOMConfiguration::installAccessors(isolate, world, instanceTemplate, prototypeTemplate, interfaceTemplate, signature, V8VTTRegionAccessors, WTF_ARRAY_LENGTH(V8VTTRegionAccessors));
  }
}

v8::Local<v8::FunctionTemplate> V8VTTRegion::domTemplate(v8::Isolate* isolate, const DOMWrapperWorld& world) {
  return V8DOMConfiguration::domClassTemplate(isolate, world, const_cast<WrapperTypeInfo*>(&wrapperTypeInfo), installV8VTTRegionTemplate);
}

bool V8VTTRegion::hasInstance(v8::Local<v8::Value> v8Value, v8::Isolate* isolate) {
  return V8PerIsolateData::from(isolate)->hasInstance(&wrapperTypeInfo, v8Value);
}

v8::Local<v8::Object> V8VTTRegion::findInstanceInPrototypeChain(v8::Local<v8::Value> v8Value, v8::Isolate* isolate) {
  return V8PerIsolateData::from(isolate)->findInstanceInPrototypeChain(&wrapperTypeInfo, v8Value);
}

VTTRegion* V8VTTRegion::toImplWithTypeCheck(v8::Isolate* isolate, v8::Local<v8::Value> value) {
  return hasInstance(value, isolate) ? toImpl(v8::Local<v8::Object>::Cast(value)) : nullptr;
}

}  // namespace blink
