// Copyright 2014 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// This file has been auto-generated by code_generator_v8.py.
// DO NOT MODIFY!

// clang-format off
#include "V8WorkerNavigator.h"

#include "bindings/core/v8/ExceptionState.h"
#include "bindings/core/v8/GeneratedCodeHelper.h"
#include "bindings/core/v8/V8DOMConfiguration.h"
#include "bindings/core/v8/V8ObjectConstructor.h"
#include "core/dom/Document.h"
#include "wtf/GetPtr.h"
#include "wtf/RefPtr.h"

namespace blink {

// Suppress warning: global constructors, because struct WrapperTypeInfo is trivial
// and does not depend on another global objects.
#if defined(COMPONENT_BUILD) && defined(WIN32) && COMPILER(CLANG)
#pragma clang diagnostic push
#pragma clang diagnostic ignored "-Wglobal-constructors"
#endif
WrapperTypeInfo V8WorkerNavigator::wrapperTypeInfo = { gin::kEmbedderBlink, V8WorkerNavigator::domTemplate, V8WorkerNavigator::trace, V8WorkerNavigator::traceWrappers, 0, nullptr, "WorkerNavigator", 0, WrapperTypeInfo::WrapperTypeObjectPrototype, WrapperTypeInfo::ObjectClassId, WrapperTypeInfo::NotInheritFromActiveScriptWrappable, WrapperTypeInfo::NotInheritFromEventTarget, WrapperTypeInfo::Independent };
#if defined(COMPONENT_BUILD) && defined(WIN32) && COMPILER(CLANG)
#pragma clang diagnostic pop
#endif

// This static member must be declared by DEFINE_WRAPPERTYPEINFO in WorkerNavigator.h.
// For details, see the comment of DEFINE_WRAPPERTYPEINFO in
// bindings/core/v8/ScriptWrappable.h.
const WrapperTypeInfo& WorkerNavigator::s_wrapperTypeInfo = V8WorkerNavigator::wrapperTypeInfo;

// not [ActiveScriptWrappable]
static_assert(
    !std::is_base_of<ActiveScriptWrappable, WorkerNavigator>::value,
    "WorkerNavigator inherits from ActiveScriptWrappable, but is not specifying "
    "[ActiveScriptWrappable] extended attribute in the IDL file.  "
    "Be consistent.");
static_assert(
    std::is_same<decltype(&WorkerNavigator::hasPendingActivity),
                 decltype(&ScriptWrappable::hasPendingActivity)>::value,
    "WorkerNavigator is overriding hasPendingActivity(), but is not specifying "
    "[ActiveScriptWrappable] extended attribute in the IDL file.  "
    "Be consistent.");

namespace WorkerNavigatorV8Internal {

static void hardwareConcurrencyAttributeGetter(const v8::FunctionCallbackInfo<v8::Value>& info) {
  v8::Local<v8::Object> holder = info.Holder();

  WorkerNavigator* impl = V8WorkerNavigator::toImpl(holder);

  v8SetReturnValueUnsigned(info, impl->hardwareConcurrency());
}

void hardwareConcurrencyAttributeGetterCallback(const v8::FunctionCallbackInfo<v8::Value>& info) {
  WorkerNavigatorV8Internal::hardwareConcurrencyAttributeGetter(info);
}

static void appCodeNameAttributeGetter(const v8::FunctionCallbackInfo<v8::Value>& info) {
  v8::Local<v8::Object> holder = info.Holder();

  WorkerNavigator* impl = V8WorkerNavigator::toImpl(holder);

  v8SetReturnValueString(info, impl->appCodeName(), info.GetIsolate());
}

void appCodeNameAttributeGetterCallback(const v8::FunctionCallbackInfo<v8::Value>& info) {
  WorkerNavigatorV8Internal::appCodeNameAttributeGetter(info);
}

static void appNameAttributeGetter(const v8::FunctionCallbackInfo<v8::Value>& info) {
  v8::Local<v8::Object> holder = info.Holder();

  WorkerNavigator* impl = V8WorkerNavigator::toImpl(holder);

  v8SetReturnValueString(info, impl->appName(), info.GetIsolate());
}

void appNameAttributeGetterCallback(const v8::FunctionCallbackInfo<v8::Value>& info) {
  WorkerNavigatorV8Internal::appNameAttributeGetter(info);
}

static void appVersionAttributeGetter(const v8::FunctionCallbackInfo<v8::Value>& info) {
  v8::Local<v8::Object> holder = info.Holder();

  WorkerNavigator* impl = V8WorkerNavigator::toImpl(holder);

  v8SetReturnValueString(info, impl->appVersion(), info.GetIsolate());
}

void appVersionAttributeGetterCallback(const v8::FunctionCallbackInfo<v8::Value>& info) {
  WorkerNavigatorV8Internal::appVersionAttributeGetter(info);
}

static void platformAttributeGetter(const v8::FunctionCallbackInfo<v8::Value>& info) {
  v8::Local<v8::Object> holder = info.Holder();

  WorkerNavigator* impl = V8WorkerNavigator::toImpl(holder);

  v8SetReturnValueString(info, impl->platform(), info.GetIsolate());
}

void platformAttributeGetterCallback(const v8::FunctionCallbackInfo<v8::Value>& info) {
  WorkerNavigatorV8Internal::platformAttributeGetter(info);
}

static void productAttributeGetter(const v8::FunctionCallbackInfo<v8::Value>& info) {
  v8::Local<v8::Object> holder = info.Holder();

  WorkerNavigator* impl = V8WorkerNavigator::toImpl(holder);

  v8SetReturnValueString(info, impl->product(), info.GetIsolate());
}

void productAttributeGetterCallback(const v8::FunctionCallbackInfo<v8::Value>& info) {
  WorkerNavigatorV8Internal::productAttributeGetter(info);
}

static void userAgentAttributeGetter(const v8::FunctionCallbackInfo<v8::Value>& info) {
  v8::Local<v8::Object> holder = info.Holder();

  WorkerNavigator* impl = V8WorkerNavigator::toImpl(holder);

  v8SetReturnValueString(info, impl->userAgent(), info.GetIsolate());
}

void userAgentAttributeGetterCallback(const v8::FunctionCallbackInfo<v8::Value>& info) {
  WorkerNavigatorV8Internal::userAgentAttributeGetter(info);
}

static void onLineAttributeGetter(const v8::FunctionCallbackInfo<v8::Value>& info) {
  v8::Local<v8::Object> holder = info.Holder();

  WorkerNavigator* impl = V8WorkerNavigator::toImpl(holder);

  v8SetReturnValueBool(info, impl->onLine());
}

void onLineAttributeGetterCallback(const v8::FunctionCallbackInfo<v8::Value>& info) {
  WorkerNavigatorV8Internal::onLineAttributeGetter(info);
}

} // namespace WorkerNavigatorV8Internal

const V8DOMConfiguration::AccessorConfiguration V8WorkerNavigatorAccessors[] = {
    {"hardwareConcurrency", WorkerNavigatorV8Internal::hardwareConcurrencyAttributeGetterCallback, 0, 0, 0, nullptr, 0, v8::DEFAULT, static_cast<v8::PropertyAttribute>(v8::ReadOnly), V8DOMConfiguration::ExposedToAllScripts, V8DOMConfiguration::OnPrototype, V8DOMConfiguration::CheckHolder},
    {"appCodeName", WorkerNavigatorV8Internal::appCodeNameAttributeGetterCallback, 0, 0, 0, nullptr, 0, v8::DEFAULT, static_cast<v8::PropertyAttribute>(v8::ReadOnly), V8DOMConfiguration::ExposedToAllScripts, V8DOMConfiguration::OnPrototype, V8DOMConfiguration::CheckHolder},
    {"appName", WorkerNavigatorV8Internal::appNameAttributeGetterCallback, 0, 0, 0, nullptr, 0, v8::DEFAULT, static_cast<v8::PropertyAttribute>(v8::ReadOnly), V8DOMConfiguration::ExposedToAllScripts, V8DOMConfiguration::OnPrototype, V8DOMConfiguration::CheckHolder},
    {"appVersion", WorkerNavigatorV8Internal::appVersionAttributeGetterCallback, 0, 0, 0, nullptr, 0, v8::DEFAULT, static_cast<v8::PropertyAttribute>(v8::ReadOnly), V8DOMConfiguration::ExposedToAllScripts, V8DOMConfiguration::OnPrototype, V8DOMConfiguration::CheckHolder},
    {"platform", WorkerNavigatorV8Internal::platformAttributeGetterCallback, 0, 0, 0, nullptr, 0, v8::DEFAULT, static_cast<v8::PropertyAttribute>(v8::ReadOnly), V8DOMConfiguration::ExposedToAllScripts, V8DOMConfiguration::OnPrototype, V8DOMConfiguration::CheckHolder},
    {"product", WorkerNavigatorV8Internal::productAttributeGetterCallback, 0, 0, 0, nullptr, 0, v8::DEFAULT, static_cast<v8::PropertyAttribute>(v8::ReadOnly), V8DOMConfiguration::ExposedToAllScripts, V8DOMConfiguration::OnPrototype, V8DOMConfiguration::CheckHolder},
    {"userAgent", WorkerNavigatorV8Internal::userAgentAttributeGetterCallback, 0, 0, 0, nullptr, 0, v8::DEFAULT, static_cast<v8::PropertyAttribute>(v8::ReadOnly), V8DOMConfiguration::ExposedToAllScripts, V8DOMConfiguration::OnPrototype, V8DOMConfiguration::CheckHolder},
    {"onLine", WorkerNavigatorV8Internal::onLineAttributeGetterCallback, 0, 0, 0, nullptr, 0, v8::DEFAULT, static_cast<v8::PropertyAttribute>(v8::ReadOnly), V8DOMConfiguration::ExposedToAllScripts, V8DOMConfiguration::OnPrototype, V8DOMConfiguration::CheckHolder},
};

void V8WorkerNavigator::installV8WorkerNavigatorTemplate(v8::Isolate* isolate, const DOMWrapperWorld& world, v8::Local<v8::FunctionTemplate> interfaceTemplate) {
  // Initialize the interface object's template.
  V8DOMConfiguration::initializeDOMInterfaceTemplate(isolate, interfaceTemplate, V8WorkerNavigator::wrapperTypeInfo.interfaceName, v8::Local<v8::FunctionTemplate>(), V8WorkerNavigator::internalFieldCount);
  v8::Local<v8::Signature> signature = v8::Signature::New(isolate, interfaceTemplate);
  ALLOW_UNUSED_LOCAL(signature);
  v8::Local<v8::ObjectTemplate> instanceTemplate = interfaceTemplate->InstanceTemplate();
  ALLOW_UNUSED_LOCAL(instanceTemplate);
  v8::Local<v8::ObjectTemplate> prototypeTemplate = interfaceTemplate->PrototypeTemplate();
  ALLOW_UNUSED_LOCAL(prototypeTemplate);
  // Register DOM constants, attributes and operations.
  V8DOMConfiguration::installAccessors(isolate, world, instanceTemplate, prototypeTemplate, interfaceTemplate, signature, V8WorkerNavigatorAccessors, WTF_ARRAY_LENGTH(V8WorkerNavigatorAccessors));
}

v8::Local<v8::FunctionTemplate> V8WorkerNavigator::domTemplate(v8::Isolate* isolate, const DOMWrapperWorld& world) {
  return V8DOMConfiguration::domClassTemplate(isolate, world, const_cast<WrapperTypeInfo*>(&wrapperTypeInfo), V8WorkerNavigator::installV8WorkerNavigatorTemplateFunction);
}

bool V8WorkerNavigator::hasInstance(v8::Local<v8::Value> v8Value, v8::Isolate* isolate) {
  return V8PerIsolateData::from(isolate)->hasInstance(&wrapperTypeInfo, v8Value);
}

v8::Local<v8::Object> V8WorkerNavigator::findInstanceInPrototypeChain(v8::Local<v8::Value> v8Value, v8::Isolate* isolate) {
  return V8PerIsolateData::from(isolate)->findInstanceInPrototypeChain(&wrapperTypeInfo, v8Value);
}

WorkerNavigator* V8WorkerNavigator::toImplWithTypeCheck(v8::Isolate* isolate, v8::Local<v8::Value> value) {
  return hasInstance(value, isolate) ? toImpl(v8::Local<v8::Object>::Cast(value)) : nullptr;
}

InstallTemplateFunction V8WorkerNavigator::installV8WorkerNavigatorTemplateFunction = (InstallTemplateFunction)&V8WorkerNavigator::installV8WorkerNavigatorTemplate;

void V8WorkerNavigator::updateWrapperTypeInfo(InstallTemplateFunction installTemplateFunction, PreparePrototypeAndInterfaceObjectFunction preparePrototypeAndInterfaceObjectFunction) {
  V8WorkerNavigator::installV8WorkerNavigatorTemplateFunction = installTemplateFunction;
  if (preparePrototypeAndInterfaceObjectFunction)
    V8WorkerNavigator::wrapperTypeInfo.preparePrototypeAndInterfaceObjectFunction = preparePrototypeAndInterfaceObjectFunction;
}

}  // namespace blink
