// Copyright 2014 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// This file has been auto-generated by code_generator_v8.py.
// DO NOT MODIFY!

// clang-format off
#ifndef ArrayBufferOrArrayBufferViewOrDictionary_h
#define ArrayBufferOrArrayBufferViewOrDictionary_h

#include "bindings/core/v8/Dictionary.h"
#include "bindings/core/v8/ExceptionState.h"
#include "bindings/core/v8/V8Binding.h"
#include "modules/ModulesExport.h"
#include "platform/heap/Handle.h"

namespace blink {

class DOMArrayBuffer;
class DOMArrayBufferView;

class MODULES_EXPORT ArrayBufferOrArrayBufferViewOrDictionary final {
  DISALLOW_NEW_EXCEPT_PLACEMENT_NEW();
 public:
  ArrayBufferOrArrayBufferViewOrDictionary();
  bool isNull() const { return m_type == SpecificTypeNone; }

  bool isArrayBuffer() const { return m_type == SpecificTypeArrayBuffer; }
  DOMArrayBuffer* getAsArrayBuffer() const;
  void setArrayBuffer(DOMArrayBuffer*);
  static ArrayBufferOrArrayBufferViewOrDictionary fromArrayBuffer(DOMArrayBuffer*);

  bool isArrayBufferView() const { return m_type == SpecificTypeArrayBufferView; }
  DOMArrayBufferView* getAsArrayBufferView() const;
  void setArrayBufferView(DOMArrayBufferView*);
  static ArrayBufferOrArrayBufferViewOrDictionary fromArrayBufferView(DOMArrayBufferView*);

  bool isDictionary() const { return m_type == SpecificTypeDictionary; }
  Dictionary getAsDictionary() const;
  void setDictionary(Dictionary);
  static ArrayBufferOrArrayBufferViewOrDictionary fromDictionary(Dictionary);

  ArrayBufferOrArrayBufferViewOrDictionary(const ArrayBufferOrArrayBufferViewOrDictionary&);
  ~ArrayBufferOrArrayBufferViewOrDictionary();
  ArrayBufferOrArrayBufferViewOrDictionary& operator=(const ArrayBufferOrArrayBufferViewOrDictionary&);
  DECLARE_TRACE();

 private:
  enum SpecificTypes {
    SpecificTypeNone,
    SpecificTypeArrayBuffer,
    SpecificTypeArrayBufferView,
    SpecificTypeDictionary,
  };
  SpecificTypes m_type;

  Member<DOMArrayBuffer> m_arrayBuffer;
  Member<DOMArrayBufferView> m_arrayBufferView;
  Dictionary m_dictionary;

  friend MODULES_EXPORT v8::Local<v8::Value> toV8(const ArrayBufferOrArrayBufferViewOrDictionary&, v8::Local<v8::Object>, v8::Isolate*);
};

class V8ArrayBufferOrArrayBufferViewOrDictionary final {
 public:
  MODULES_EXPORT static void toImpl(v8::Isolate*, v8::Local<v8::Value>, ArrayBufferOrArrayBufferViewOrDictionary&, UnionTypeConversionMode, ExceptionState&);
};

MODULES_EXPORT v8::Local<v8::Value> toV8(const ArrayBufferOrArrayBufferViewOrDictionary&, v8::Local<v8::Object>, v8::Isolate*);

template <class CallbackInfo>
inline void v8SetReturnValue(const CallbackInfo& callbackInfo, ArrayBufferOrArrayBufferViewOrDictionary& impl) {
  v8SetReturnValue(callbackInfo, toV8(impl, callbackInfo.Holder(), callbackInfo.GetIsolate()));
}

template <>
struct NativeValueTraits<ArrayBufferOrArrayBufferViewOrDictionary> {
  MODULES_EXPORT static ArrayBufferOrArrayBufferViewOrDictionary nativeValue(v8::Isolate*, v8::Local<v8::Value>, ExceptionState&);
};

}  // namespace blink

// We need to set canInitializeWithMemset=true because HeapVector supports
// items that can initialize with memset or have a vtable. It is safe to
// set canInitializeWithMemset=true for a union type object in practice.
// See https://codereview.chromium.org/1118993002/#msg5 for more details.
WTF_ALLOW_MOVE_AND_INIT_WITH_MEM_FUNCTIONS(blink::ArrayBufferOrArrayBufferViewOrDictionary);

#endif  // ArrayBufferOrArrayBufferViewOrDictionary_h
