// Copyright 2014 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// This file has been auto-generated by code_generator_v8.py.
// DO NOT MODIFY!

// clang-format off
#ifndef RequestOrUSVString_h
#define RequestOrUSVString_h

#include "bindings/core/v8/Dictionary.h"
#include "bindings/core/v8/ExceptionState.h"
#include "bindings/core/v8/V8Binding.h"
#include "modules/ModulesExport.h"
#include "platform/heap/Handle.h"

namespace blink {

class Request;

class MODULES_EXPORT RequestOrUSVString final {
  DISALLOW_NEW_EXCEPT_PLACEMENT_NEW();
 public:
  RequestOrUSVString();
  bool isNull() const { return m_type == SpecificTypeNone; }

  bool isRequest() const { return m_type == SpecificTypeRequest; }
  Request* getAsRequest() const;
  void setRequest(Request*);
  static RequestOrUSVString fromRequest(Request*);

  bool isUSVString() const { return m_type == SpecificTypeUSVString; }
  String getAsUSVString() const;
  void setUSVString(String);
  static RequestOrUSVString fromUSVString(String);

  RequestOrUSVString(const RequestOrUSVString&);
  ~RequestOrUSVString();
  RequestOrUSVString& operator=(const RequestOrUSVString&);
  DECLARE_TRACE();

 private:
  enum SpecificTypes {
    SpecificTypeNone,
    SpecificTypeRequest,
    SpecificTypeUSVString,
  };
  SpecificTypes m_type;

  Member<Request> m_request;
  String m_uSVString;

  friend MODULES_EXPORT v8::Local<v8::Value> toV8(const RequestOrUSVString&, v8::Local<v8::Object>, v8::Isolate*);
};

class V8RequestOrUSVString final {
 public:
  MODULES_EXPORT static void toImpl(v8::Isolate*, v8::Local<v8::Value>, RequestOrUSVString&, UnionTypeConversionMode, ExceptionState&);
};

MODULES_EXPORT v8::Local<v8::Value> toV8(const RequestOrUSVString&, v8::Local<v8::Object>, v8::Isolate*);

template <class CallbackInfo>
inline void v8SetReturnValue(const CallbackInfo& callbackInfo, RequestOrUSVString& impl) {
  v8SetReturnValue(callbackInfo, toV8(impl, callbackInfo.Holder(), callbackInfo.GetIsolate()));
}

template <>
struct NativeValueTraits<RequestOrUSVString> {
  MODULES_EXPORT static RequestOrUSVString nativeValue(v8::Isolate*, v8::Local<v8::Value>, ExceptionState&);
};

}  // namespace blink

// We need to set canInitializeWithMemset=true because HeapVector supports
// items that can initialize with memset or have a vtable. It is safe to
// set canInitializeWithMemset=true for a union type object in practice.
// See https://codereview.chromium.org/1118993002/#msg5 for more details.
WTF_ALLOW_MOVE_AND_INIT_WITH_MEM_FUNCTIONS(blink::RequestOrUSVString);

#endif  // RequestOrUSVString_h
