// Copyright 2014 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// This file has been auto-generated by code_generator_v8.py.
// DO NOT MODIFY!

// clang-format off
#include "V8AccelerometerOptions.h"

#include "bindings/core/v8/ExceptionState.h"
#include "bindings/modules/v8/V8SensorOptions.h"

namespace blink {

void V8AccelerometerOptions::toImpl(v8::Isolate* isolate, v8::Local<v8::Value> v8Value, AccelerometerOptions& impl, ExceptionState& exceptionState) {
  if (isUndefinedOrNull(v8Value)) {
    return;
  }
  if (!v8Value->IsObject()) {
    exceptionState.throwTypeError("cannot convert to dictionary.");
    return;
  }

  V8SensorOptions::toImpl(isolate, v8Value, impl, exceptionState);
  if (exceptionState.hadException())
    return;

  v8::TryCatch block(isolate);
  v8::Local<v8::Object> v8Object;
  if (!v8Call(v8Value->ToObject(isolate->GetCurrentContext()), v8Object, block)) {
    exceptionState.rethrowV8Exception(block.Exception());
    return;
  }
  v8::Local<v8::Value> includeGravityValue;
  if (!v8Object->Get(isolate->GetCurrentContext(), v8String(isolate, "includeGravity")).ToLocal(&includeGravityValue)) {
    exceptionState.rethrowV8Exception(block.Exception());
    return;
  }
  if (includeGravityValue.IsEmpty() || includeGravityValue->IsUndefined()) {
    // Do nothing.
  } else {
    bool includeGravity = toBoolean(isolate, includeGravityValue, exceptionState);
    if (exceptionState.hadException())
      return;
    impl.setIncludeGravity(includeGravity);
  }
}

v8::Local<v8::Value> AccelerometerOptions::toV8Impl(v8::Local<v8::Object> creationContext, v8::Isolate* isolate) const {
  v8::Local<v8::Object> v8Object = v8::Object::New(isolate);
  if (!toV8AccelerometerOptions(*this, v8Object, creationContext, isolate))
    return v8::Undefined(isolate);
  return v8Object;
}

bool toV8AccelerometerOptions(const AccelerometerOptions& impl, v8::Local<v8::Object> dictionary, v8::Local<v8::Object> creationContext, v8::Isolate* isolate) {
  if (!toV8SensorOptions(impl, dictionary, creationContext, isolate))
    return false;

  if (impl.hasIncludeGravity()) {
    if (!v8CallBoolean(dictionary->CreateDataProperty(isolate->GetCurrentContext(), v8String(isolate, "includeGravity"), v8Boolean(impl.includeGravity(), isolate))))
      return false;
  } else {
    if (!v8CallBoolean(dictionary->CreateDataProperty(isolate->GetCurrentContext(), v8String(isolate, "includeGravity"), v8Boolean(true, isolate))))
      return false;
  }

  return true;
}

AccelerometerOptions NativeValueTraits<AccelerometerOptions>::nativeValue(v8::Isolate* isolate, v8::Local<v8::Value> value, ExceptionState& exceptionState) {
  AccelerometerOptions impl;
  V8AccelerometerOptions::toImpl(isolate, value, impl, exceptionState);
  return impl;
}

}  // namespace blink
