// Copyright 2014 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// This file has been auto-generated by code_generator_v8.py.
// DO NOT MODIFY!

// clang-format off
#include "V8AmbientLightSensorReadingInit.h"

#include "bindings/core/v8/ExceptionState.h"

namespace blink {

void V8AmbientLightSensorReadingInit::toImpl(v8::Isolate* isolate, v8::Local<v8::Value> v8Value, AmbientLightSensorReadingInit& impl, ExceptionState& exceptionState) {
  if (isUndefinedOrNull(v8Value)) {
    return;
  }
  if (!v8Value->IsObject()) {
    exceptionState.throwTypeError("cannot convert to dictionary.");
    return;
  }

  v8::TryCatch block(isolate);
  v8::Local<v8::Object> v8Object;
  if (!v8Call(v8Value->ToObject(isolate->GetCurrentContext()), v8Object, block)) {
    exceptionState.rethrowV8Exception(block.Exception());
    return;
  }
  v8::Local<v8::Value> illuminanceValue;
  if (!v8Object->Get(isolate->GetCurrentContext(), v8String(isolate, "illuminance")).ToLocal(&illuminanceValue)) {
    exceptionState.rethrowV8Exception(block.Exception());
    return;
  }
  if (illuminanceValue.IsEmpty() || illuminanceValue->IsUndefined()) {
    // Do nothing.
  } else {
    double illuminance = toDouble(isolate, illuminanceValue, exceptionState);
    if (exceptionState.hadException())
      return;
    impl.setIlluminance(illuminance);
  }
}

v8::Local<v8::Value> AmbientLightSensorReadingInit::toV8Impl(v8::Local<v8::Object> creationContext, v8::Isolate* isolate) const {
  v8::Local<v8::Object> v8Object = v8::Object::New(isolate);
  if (!toV8AmbientLightSensorReadingInit(*this, v8Object, creationContext, isolate))
    return v8::Undefined(isolate);
  return v8Object;
}

bool toV8AmbientLightSensorReadingInit(const AmbientLightSensorReadingInit& impl, v8::Local<v8::Object> dictionary, v8::Local<v8::Object> creationContext, v8::Isolate* isolate) {
  if (impl.hasIlluminance()) {
    if (!v8CallBoolean(dictionary->CreateDataProperty(isolate->GetCurrentContext(), v8String(isolate, "illuminance"), v8::Number::New(isolate, impl.illuminance()))))
      return false;
  }

  return true;
}

AmbientLightSensorReadingInit NativeValueTraits<AmbientLightSensorReadingInit>::nativeValue(v8::Isolate* isolate, v8::Local<v8::Value> value, ExceptionState& exceptionState) {
  AmbientLightSensorReadingInit impl;
  V8AmbientLightSensorReadingInit::toImpl(isolate, value, impl, exceptionState);
  return impl;
}

}  // namespace blink
