// Copyright 2014 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// This file has been auto-generated by code_generator_v8.py.
// DO NOT MODIFY!

// clang-format off
#include "V8AnalyserNode.h"

#include "bindings/core/v8/ExceptionState.h"
#include "bindings/core/v8/GeneratedCodeHelper.h"
#include "bindings/core/v8/V8ArrayBufferView.h"
#include "bindings/core/v8/V8DOMConfiguration.h"
#include "bindings/core/v8/V8Float32Array.h"
#include "bindings/core/v8/V8ObjectConstructor.h"
#include "bindings/core/v8/V8Uint8Array.h"
#include "bindings/modules/v8/V8AnalyserOptions.h"
#include "bindings/modules/v8/V8BaseAudioContext.h"
#include "core/dom/Document.h"
#include "core/dom/FlexibleArrayBufferView.h"
#include "core/frame/LocalDOMWindow.h"
#include "wtf/GetPtr.h"
#include "wtf/RefPtr.h"

namespace blink {

// Suppress warning: global constructors, because struct WrapperTypeInfo is trivial
// and does not depend on another global objects.
#if defined(COMPONENT_BUILD) && defined(WIN32) && COMPILER(CLANG)
#pragma clang diagnostic push
#pragma clang diagnostic ignored "-Wglobal-constructors"
#endif
const WrapperTypeInfo V8AnalyserNode::wrapperTypeInfo = { gin::kEmbedderBlink, V8AnalyserNode::domTemplate, V8AnalyserNode::trace, V8AnalyserNode::traceWrappers, 0, nullptr, "AnalyserNode", &V8AudioNode::wrapperTypeInfo, WrapperTypeInfo::WrapperTypeObjectPrototype, WrapperTypeInfo::ObjectClassId, WrapperTypeInfo::NotInheritFromActiveScriptWrappable, WrapperTypeInfo::InheritFromEventTarget, WrapperTypeInfo::Independent };
#if defined(COMPONENT_BUILD) && defined(WIN32) && COMPILER(CLANG)
#pragma clang diagnostic pop
#endif

// This static member must be declared by DEFINE_WRAPPERTYPEINFO in AnalyserNode.h.
// For details, see the comment of DEFINE_WRAPPERTYPEINFO in
// bindings/core/v8/ScriptWrappable.h.
const WrapperTypeInfo& AnalyserNode::s_wrapperTypeInfo = V8AnalyserNode::wrapperTypeInfo;

// not [ActiveScriptWrappable]
static_assert(
    !std::is_base_of<ActiveScriptWrappable, AnalyserNode>::value,
    "AnalyserNode inherits from ActiveScriptWrappable, but is not specifying "
    "[ActiveScriptWrappable] extended attribute in the IDL file.  "
    "Be consistent.");
static_assert(
    std::is_same<decltype(&AnalyserNode::hasPendingActivity),
                 decltype(&ScriptWrappable::hasPendingActivity)>::value,
    "AnalyserNode is overriding hasPendingActivity(), but is not specifying "
    "[ActiveScriptWrappable] extended attribute in the IDL file.  "
    "Be consistent.");

namespace AnalyserNodeV8Internal {

static void fftSizeAttributeGetter(const v8::FunctionCallbackInfo<v8::Value>& info) {
  v8::Local<v8::Object> holder = info.Holder();

  AnalyserNode* impl = V8AnalyserNode::toImpl(holder);

  v8SetReturnValueUnsigned(info, impl->fftSize());
}

void fftSizeAttributeGetterCallback(const v8::FunctionCallbackInfo<v8::Value>& info) {
  AnalyserNodeV8Internal::fftSizeAttributeGetter(info);
}

static void fftSizeAttributeSetter(v8::Local<v8::Value> v8Value, const v8::FunctionCallbackInfo<v8::Value>& info) {
  v8::Local<v8::Object> holder = info.Holder();
  AnalyserNode* impl = V8AnalyserNode::toImpl(holder);

  ExceptionState exceptionState(info.GetIsolate(), ExceptionState::SetterContext, "AnalyserNode", "fftSize");

  // Prepare the value to be set.
  unsigned cppValue = toUInt32(info.GetIsolate(), v8Value, NormalConversion, exceptionState);
  if (exceptionState.hadException())
    return;

  impl->setFftSize(cppValue, exceptionState);
}

void fftSizeAttributeSetterCallback(const v8::FunctionCallbackInfo<v8::Value>& info) {
  v8::Local<v8::Value> v8Value = info[0];

  AnalyserNodeV8Internal::fftSizeAttributeSetter(v8Value, info);
}

static void frequencyBinCountAttributeGetter(const v8::FunctionCallbackInfo<v8::Value>& info) {
  v8::Local<v8::Object> holder = info.Holder();

  AnalyserNode* impl = V8AnalyserNode::toImpl(holder);

  v8SetReturnValueUnsigned(info, impl->frequencyBinCount());
}

void frequencyBinCountAttributeGetterCallback(const v8::FunctionCallbackInfo<v8::Value>& info) {
  AnalyserNodeV8Internal::frequencyBinCountAttributeGetter(info);
}

static void minDecibelsAttributeGetter(const v8::FunctionCallbackInfo<v8::Value>& info) {
  v8::Local<v8::Object> holder = info.Holder();

  AnalyserNode* impl = V8AnalyserNode::toImpl(holder);

  v8SetReturnValue(info, impl->minDecibels());
}

void minDecibelsAttributeGetterCallback(const v8::FunctionCallbackInfo<v8::Value>& info) {
  AnalyserNodeV8Internal::minDecibelsAttributeGetter(info);
}

static void minDecibelsAttributeSetter(v8::Local<v8::Value> v8Value, const v8::FunctionCallbackInfo<v8::Value>& info) {
  v8::Local<v8::Object> holder = info.Holder();
  AnalyserNode* impl = V8AnalyserNode::toImpl(holder);

  ExceptionState exceptionState(info.GetIsolate(), ExceptionState::SetterContext, "AnalyserNode", "minDecibels");

  // Prepare the value to be set.
  double cppValue = toRestrictedDouble(info.GetIsolate(), v8Value, exceptionState);
  if (exceptionState.hadException())
    return;

  impl->setMinDecibels(cppValue, exceptionState);
}

void minDecibelsAttributeSetterCallback(const v8::FunctionCallbackInfo<v8::Value>& info) {
  v8::Local<v8::Value> v8Value = info[0];

  AnalyserNodeV8Internal::minDecibelsAttributeSetter(v8Value, info);
}

static void maxDecibelsAttributeGetter(const v8::FunctionCallbackInfo<v8::Value>& info) {
  v8::Local<v8::Object> holder = info.Holder();

  AnalyserNode* impl = V8AnalyserNode::toImpl(holder);

  v8SetReturnValue(info, impl->maxDecibels());
}

void maxDecibelsAttributeGetterCallback(const v8::FunctionCallbackInfo<v8::Value>& info) {
  AnalyserNodeV8Internal::maxDecibelsAttributeGetter(info);
}

static void maxDecibelsAttributeSetter(v8::Local<v8::Value> v8Value, const v8::FunctionCallbackInfo<v8::Value>& info) {
  v8::Local<v8::Object> holder = info.Holder();
  AnalyserNode* impl = V8AnalyserNode::toImpl(holder);

  ExceptionState exceptionState(info.GetIsolate(), ExceptionState::SetterContext, "AnalyserNode", "maxDecibels");

  // Prepare the value to be set.
  double cppValue = toRestrictedDouble(info.GetIsolate(), v8Value, exceptionState);
  if (exceptionState.hadException())
    return;

  impl->setMaxDecibels(cppValue, exceptionState);
}

void maxDecibelsAttributeSetterCallback(const v8::FunctionCallbackInfo<v8::Value>& info) {
  v8::Local<v8::Value> v8Value = info[0];

  AnalyserNodeV8Internal::maxDecibelsAttributeSetter(v8Value, info);
}

static void smoothingTimeConstantAttributeGetter(const v8::FunctionCallbackInfo<v8::Value>& info) {
  v8::Local<v8::Object> holder = info.Holder();

  AnalyserNode* impl = V8AnalyserNode::toImpl(holder);

  v8SetReturnValue(info, impl->smoothingTimeConstant());
}

void smoothingTimeConstantAttributeGetterCallback(const v8::FunctionCallbackInfo<v8::Value>& info) {
  AnalyserNodeV8Internal::smoothingTimeConstantAttributeGetter(info);
}

static void smoothingTimeConstantAttributeSetter(v8::Local<v8::Value> v8Value, const v8::FunctionCallbackInfo<v8::Value>& info) {
  v8::Local<v8::Object> holder = info.Holder();
  AnalyserNode* impl = V8AnalyserNode::toImpl(holder);

  ExceptionState exceptionState(info.GetIsolate(), ExceptionState::SetterContext, "AnalyserNode", "smoothingTimeConstant");

  // Prepare the value to be set.
  double cppValue = toRestrictedDouble(info.GetIsolate(), v8Value, exceptionState);
  if (exceptionState.hadException())
    return;

  impl->setSmoothingTimeConstant(cppValue, exceptionState);
}

void smoothingTimeConstantAttributeSetterCallback(const v8::FunctionCallbackInfo<v8::Value>& info) {
  v8::Local<v8::Value> v8Value = info[0];

  AnalyserNodeV8Internal::smoothingTimeConstantAttributeSetter(v8Value, info);
}

static void getFloatFrequencyDataMethod(const v8::FunctionCallbackInfo<v8::Value>& info) {
  AnalyserNode* impl = V8AnalyserNode::toImpl(info.Holder());

  if (UNLIKELY(info.Length() < 1)) {
    V8ThrowException::throwTypeError(info.GetIsolate(), ExceptionMessages::failedToExecute("getFloatFrequencyData", "AnalyserNode", ExceptionMessages::notEnoughArguments(1, info.Length())));
    return;
  }

  DOMFloat32Array* array;
  array = info[0]->IsFloat32Array() ? V8Float32Array::toImpl(v8::Local<v8::Float32Array>::Cast(info[0])) : 0;
  if (!array) {
    V8ThrowException::throwTypeError(info.GetIsolate(), ExceptionMessages::failedToExecute("getFloatFrequencyData", "AnalyserNode", "parameter 1 is not of type 'Float32Array'."));

    return;
  }

  impl->getFloatFrequencyData(array);
}

void getFloatFrequencyDataMethodCallback(const v8::FunctionCallbackInfo<v8::Value>& info) {
  AnalyserNodeV8Internal::getFloatFrequencyDataMethod(info);
}

static void getByteFrequencyDataMethod(const v8::FunctionCallbackInfo<v8::Value>& info) {
  AnalyserNode* impl = V8AnalyserNode::toImpl(info.Holder());

  if (UNLIKELY(info.Length() < 1)) {
    V8ThrowException::throwTypeError(info.GetIsolate(), ExceptionMessages::failedToExecute("getByteFrequencyData", "AnalyserNode", ExceptionMessages::notEnoughArguments(1, info.Length())));
    return;
  }

  DOMUint8Array* array;
  array = info[0]->IsUint8Array() ? V8Uint8Array::toImpl(v8::Local<v8::Uint8Array>::Cast(info[0])) : 0;
  if (!array) {
    V8ThrowException::throwTypeError(info.GetIsolate(), ExceptionMessages::failedToExecute("getByteFrequencyData", "AnalyserNode", "parameter 1 is not of type 'Uint8Array'."));

    return;
  }

  impl->getByteFrequencyData(array);
}

void getByteFrequencyDataMethodCallback(const v8::FunctionCallbackInfo<v8::Value>& info) {
  AnalyserNodeV8Internal::getByteFrequencyDataMethod(info);
}

static void getFloatTimeDomainDataMethod(const v8::FunctionCallbackInfo<v8::Value>& info) {
  AnalyserNode* impl = V8AnalyserNode::toImpl(info.Holder());

  if (UNLIKELY(info.Length() < 1)) {
    V8ThrowException::throwTypeError(info.GetIsolate(), ExceptionMessages::failedToExecute("getFloatTimeDomainData", "AnalyserNode", ExceptionMessages::notEnoughArguments(1, info.Length())));
    return;
  }

  DOMFloat32Array* array;
  array = info[0]->IsFloat32Array() ? V8Float32Array::toImpl(v8::Local<v8::Float32Array>::Cast(info[0])) : 0;
  if (!array) {
    V8ThrowException::throwTypeError(info.GetIsolate(), ExceptionMessages::failedToExecute("getFloatTimeDomainData", "AnalyserNode", "parameter 1 is not of type 'Float32Array'."));

    return;
  }

  impl->getFloatTimeDomainData(array);
}

void getFloatTimeDomainDataMethodCallback(const v8::FunctionCallbackInfo<v8::Value>& info) {
  AnalyserNodeV8Internal::getFloatTimeDomainDataMethod(info);
}

static void getByteTimeDomainDataMethod(const v8::FunctionCallbackInfo<v8::Value>& info) {
  AnalyserNode* impl = V8AnalyserNode::toImpl(info.Holder());

  if (UNLIKELY(info.Length() < 1)) {
    V8ThrowException::throwTypeError(info.GetIsolate(), ExceptionMessages::failedToExecute("getByteTimeDomainData", "AnalyserNode", ExceptionMessages::notEnoughArguments(1, info.Length())));
    return;
  }

  DOMUint8Array* array;
  array = info[0]->IsUint8Array() ? V8Uint8Array::toImpl(v8::Local<v8::Uint8Array>::Cast(info[0])) : 0;
  if (!array) {
    V8ThrowException::throwTypeError(info.GetIsolate(), ExceptionMessages::failedToExecute("getByteTimeDomainData", "AnalyserNode", "parameter 1 is not of type 'Uint8Array'."));

    return;
  }

  impl->getByteTimeDomainData(array);
}

void getByteTimeDomainDataMethodCallback(const v8::FunctionCallbackInfo<v8::Value>& info) {
  AnalyserNodeV8Internal::getByteTimeDomainDataMethod(info);
}

static void constructor(const v8::FunctionCallbackInfo<v8::Value>& info) {
  ExceptionState exceptionState(info.GetIsolate(), ExceptionState::ConstructionContext, "AnalyserNode");

  if (UNLIKELY(info.Length() < 1)) {
    exceptionState.throwTypeError(ExceptionMessages::notEnoughArguments(1, info.Length()));
    return;
  }

  BaseAudioContext* context;
  AnalyserOptions options;
  context = V8BaseAudioContext::toImplWithTypeCheck(info.GetIsolate(), info[0]);
  if (!context) {
    exceptionState.throwTypeError("parameter 1 is not of type 'BaseAudioContext'.");

    return;
  }

  if (!isUndefinedOrNull(info[1]) && !info[1]->IsObject()) {
    exceptionState.throwTypeError("parameter 2 ('options') is not an object.");

    return;
  }
  V8AnalyserOptions::toImpl(info.GetIsolate(), info[1], options, exceptionState);
  if (exceptionState.hadException())
    return;

  AnalyserNode* impl = AnalyserNode::create(context, options, exceptionState);
  if (exceptionState.hadException()) {
    return;
  }
  v8::Local<v8::Object> wrapper = info.Holder();
  wrapper = impl->associateWithWrapper(info.GetIsolate(), &V8AnalyserNode::wrapperTypeInfo, wrapper);
  v8SetReturnValue(info, wrapper);
}

} // namespace AnalyserNodeV8Internal

const V8DOMConfiguration::AccessorConfiguration V8AnalyserNodeAccessors[] = {
    {"fftSize", AnalyserNodeV8Internal::fftSizeAttributeGetterCallback, AnalyserNodeV8Internal::fftSizeAttributeSetterCallback, 0, 0, nullptr, 0, v8::DEFAULT, static_cast<v8::PropertyAttribute>(v8::None), V8DOMConfiguration::ExposedToAllScripts, V8DOMConfiguration::OnPrototype, V8DOMConfiguration::CheckHolder},
    {"frequencyBinCount", AnalyserNodeV8Internal::frequencyBinCountAttributeGetterCallback, 0, 0, 0, nullptr, 0, v8::DEFAULT, static_cast<v8::PropertyAttribute>(v8::ReadOnly), V8DOMConfiguration::ExposedToAllScripts, V8DOMConfiguration::OnPrototype, V8DOMConfiguration::CheckHolder},
    {"minDecibels", AnalyserNodeV8Internal::minDecibelsAttributeGetterCallback, AnalyserNodeV8Internal::minDecibelsAttributeSetterCallback, 0, 0, nullptr, 0, v8::DEFAULT, static_cast<v8::PropertyAttribute>(v8::None), V8DOMConfiguration::ExposedToAllScripts, V8DOMConfiguration::OnPrototype, V8DOMConfiguration::CheckHolder},
    {"maxDecibels", AnalyserNodeV8Internal::maxDecibelsAttributeGetterCallback, AnalyserNodeV8Internal::maxDecibelsAttributeSetterCallback, 0, 0, nullptr, 0, v8::DEFAULT, static_cast<v8::PropertyAttribute>(v8::None), V8DOMConfiguration::ExposedToAllScripts, V8DOMConfiguration::OnPrototype, V8DOMConfiguration::CheckHolder},
    {"smoothingTimeConstant", AnalyserNodeV8Internal::smoothingTimeConstantAttributeGetterCallback, AnalyserNodeV8Internal::smoothingTimeConstantAttributeSetterCallback, 0, 0, nullptr, 0, v8::DEFAULT, static_cast<v8::PropertyAttribute>(v8::None), V8DOMConfiguration::ExposedToAllScripts, V8DOMConfiguration::OnPrototype, V8DOMConfiguration::CheckHolder},
};

const V8DOMConfiguration::MethodConfiguration V8AnalyserNodeMethods[] = {
    {"getFloatFrequencyData", AnalyserNodeV8Internal::getFloatFrequencyDataMethodCallback, 0, 1, v8::None, V8DOMConfiguration::ExposedToAllScripts, V8DOMConfiguration::OnPrototype, V8DOMConfiguration::CheckHolder},
    {"getByteFrequencyData", AnalyserNodeV8Internal::getByteFrequencyDataMethodCallback, 0, 1, v8::None, V8DOMConfiguration::ExposedToAllScripts, V8DOMConfiguration::OnPrototype, V8DOMConfiguration::CheckHolder},
    {"getFloatTimeDomainData", AnalyserNodeV8Internal::getFloatTimeDomainDataMethodCallback, 0, 1, v8::None, V8DOMConfiguration::ExposedToAllScripts, V8DOMConfiguration::OnPrototype, V8DOMConfiguration::CheckHolder},
    {"getByteTimeDomainData", AnalyserNodeV8Internal::getByteTimeDomainDataMethodCallback, 0, 1, v8::None, V8DOMConfiguration::ExposedToAllScripts, V8DOMConfiguration::OnPrototype, V8DOMConfiguration::CheckHolder},
};

void V8AnalyserNode::constructorCallback(const v8::FunctionCallbackInfo<v8::Value>& info) {
  if (!info.IsConstructCall()) {
    V8ThrowException::throwTypeError(info.GetIsolate(), ExceptionMessages::constructorNotCallableAsFunction("AnalyserNode"));
    return;
  }

  if (ConstructorMode::current(info.GetIsolate()) == ConstructorMode::WrapExistingObject) {
    v8SetReturnValue(info, info.Holder());
    return;
  }

  AnalyserNodeV8Internal::constructor(info);
}

static void installV8AnalyserNodeTemplate(v8::Isolate* isolate, const DOMWrapperWorld& world, v8::Local<v8::FunctionTemplate> interfaceTemplate) {
  // Initialize the interface object's template.
  V8DOMConfiguration::initializeDOMInterfaceTemplate(isolate, interfaceTemplate, V8AnalyserNode::wrapperTypeInfo.interfaceName, V8AudioNode::domTemplate(isolate, world), V8AnalyserNode::internalFieldCount);
  interfaceTemplate->SetCallHandler(V8AnalyserNode::constructorCallback);
  interfaceTemplate->SetLength(1);
  v8::Local<v8::Signature> signature = v8::Signature::New(isolate, interfaceTemplate);
  ALLOW_UNUSED_LOCAL(signature);
  v8::Local<v8::ObjectTemplate> instanceTemplate = interfaceTemplate->InstanceTemplate();
  ALLOW_UNUSED_LOCAL(instanceTemplate);
  v8::Local<v8::ObjectTemplate> prototypeTemplate = interfaceTemplate->PrototypeTemplate();
  ALLOW_UNUSED_LOCAL(prototypeTemplate);
  // Register DOM constants, attributes and operations.
  V8DOMConfiguration::installAccessors(isolate, world, instanceTemplate, prototypeTemplate, interfaceTemplate, signature, V8AnalyserNodeAccessors, WTF_ARRAY_LENGTH(V8AnalyserNodeAccessors));
  V8DOMConfiguration::installMethods(isolate, world, instanceTemplate, prototypeTemplate, interfaceTemplate, signature, V8AnalyserNodeMethods, WTF_ARRAY_LENGTH(V8AnalyserNodeMethods));
}

v8::Local<v8::FunctionTemplate> V8AnalyserNode::domTemplate(v8::Isolate* isolate, const DOMWrapperWorld& world) {
  return V8DOMConfiguration::domClassTemplate(isolate, world, const_cast<WrapperTypeInfo*>(&wrapperTypeInfo), installV8AnalyserNodeTemplate);
}

bool V8AnalyserNode::hasInstance(v8::Local<v8::Value> v8Value, v8::Isolate* isolate) {
  return V8PerIsolateData::from(isolate)->hasInstance(&wrapperTypeInfo, v8Value);
}

v8::Local<v8::Object> V8AnalyserNode::findInstanceInPrototypeChain(v8::Local<v8::Value> v8Value, v8::Isolate* isolate) {
  return V8PerIsolateData::from(isolate)->findInstanceInPrototypeChain(&wrapperTypeInfo, v8Value);
}

AnalyserNode* V8AnalyserNode::toImplWithTypeCheck(v8::Isolate* isolate, v8::Local<v8::Value> value) {
  return hasInstance(value, isolate) ? toImpl(v8::Local<v8::Object>::Cast(value)) : nullptr;
}

}  // namespace blink
