// Copyright 2014 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// This file has been auto-generated by code_generator_v8.py.
// DO NOT MODIFY!

// clang-format off
#include "V8AndroidPayTokenization.h"

#include "bindings/core/v8/Dictionary.h"
#include "bindings/core/v8/ExceptionState.h"

namespace blink {

void V8AndroidPayTokenization::toImpl(v8::Isolate* isolate, v8::Local<v8::Value> v8Value, AndroidPayTokenization& impl, ExceptionState& exceptionState) {
  if (isUndefinedOrNull(v8Value)) {
    return;
  }
  if (!v8Value->IsObject()) {
    exceptionState.throwTypeError("cannot convert to dictionary.");
    return;
  }

  v8::TryCatch block(isolate);
  v8::Local<v8::Object> v8Object;
  if (!v8Call(v8Value->ToObject(isolate->GetCurrentContext()), v8Object, block)) {
    exceptionState.rethrowV8Exception(block.Exception());
    return;
  }
  v8::Local<v8::Value> parametersValue;
  if (!v8Object->Get(isolate->GetCurrentContext(), v8String(isolate, "parameters")).ToLocal(&parametersValue)) {
    exceptionState.rethrowV8Exception(block.Exception());
    return;
  }
  if (parametersValue.IsEmpty() || parametersValue->IsUndefined()) {
    // Do nothing.
  } else {
    Dictionary parameters = Dictionary(parametersValue, isolate, exceptionState);
    if (exceptionState.hadException())
      return;
    if (!parameters.isObject()) {
      exceptionState.throwTypeError("member parameters is not an object.");
      return;
    }
    impl.setParameters(parameters);
  }

  v8::Local<v8::Value> tokenizationTypeValue;
  if (!v8Object->Get(isolate->GetCurrentContext(), v8String(isolate, "tokenizationType")).ToLocal(&tokenizationTypeValue)) {
    exceptionState.rethrowV8Exception(block.Exception());
    return;
  }
  if (tokenizationTypeValue.IsEmpty() || tokenizationTypeValue->IsUndefined()) {
    // Do nothing.
  } else {
    V8StringResource<> tokenizationType = tokenizationTypeValue;
    if (!tokenizationType.prepare(exceptionState))
      return;
    impl.setTokenizationType(tokenizationType);
  }
}

v8::Local<v8::Value> AndroidPayTokenization::toV8Impl(v8::Local<v8::Object> creationContext, v8::Isolate* isolate) const {
  v8::Local<v8::Object> v8Object = v8::Object::New(isolate);
  if (!toV8AndroidPayTokenization(*this, v8Object, creationContext, isolate))
    return v8::Undefined(isolate);
  return v8Object;
}

bool toV8AndroidPayTokenization(const AndroidPayTokenization& impl, v8::Local<v8::Object> dictionary, v8::Local<v8::Object> creationContext, v8::Isolate* isolate) {
  if (impl.hasParameters()) {
    DCHECK(impl.parameters().isObject());
    if (!v8CallBoolean(dictionary->CreateDataProperty(isolate->GetCurrentContext(), v8String(isolate, "parameters"), impl.parameters().v8Value())))
      return false;
  }

  if (impl.hasTokenizationType()) {
    if (!v8CallBoolean(dictionary->CreateDataProperty(isolate->GetCurrentContext(), v8String(isolate, "tokenizationType"), v8String(isolate, impl.tokenizationType()))))
      return false;
  }

  return true;
}

AndroidPayTokenization NativeValueTraits<AndroidPayTokenization>::nativeValue(v8::Isolate* isolate, v8::Local<v8::Value> value, ExceptionState& exceptionState) {
  AndroidPayTokenization impl;
  V8AndroidPayTokenization::toImpl(isolate, value, impl, exceptionState);
  return impl;
}

}  // namespace blink
