// Copyright 2014 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// This file has been auto-generated by code_generator_v8.py.
// DO NOT MODIFY!

// clang-format off
#include "V8AudioBufferOptions.h"

#include "bindings/core/v8/ExceptionState.h"

namespace blink {

void V8AudioBufferOptions::toImpl(v8::Isolate* isolate, v8::Local<v8::Value> v8Value, AudioBufferOptions& impl, ExceptionState& exceptionState) {
  if (isUndefinedOrNull(v8Value)) {
    exceptionState.throwTypeError("Missing required member(s): length.");
    return;
  }
  if (!v8Value->IsObject()) {
    exceptionState.throwTypeError("cannot convert to dictionary.");
    return;
  }

  v8::TryCatch block(isolate);
  v8::Local<v8::Object> v8Object;
  if (!v8Call(v8Value->ToObject(isolate->GetCurrentContext()), v8Object, block)) {
    exceptionState.rethrowV8Exception(block.Exception());
    return;
  }
  v8::Local<v8::Value> lengthValue;
  if (!v8Object->Get(isolate->GetCurrentContext(), v8String(isolate, "length")).ToLocal(&lengthValue)) {
    exceptionState.rethrowV8Exception(block.Exception());
    return;
  }
  if (lengthValue.IsEmpty() || lengthValue->IsUndefined()) {
    exceptionState.throwTypeError("required member length is undefined.");
    return;
  } else {
    unsigned length = toUInt32(isolate, lengthValue, NormalConversion, exceptionState);
    if (exceptionState.hadException())
      return;
    impl.setLength(length);
  }

  v8::Local<v8::Value> numberOfChannelsValue;
  if (!v8Object->Get(isolate->GetCurrentContext(), v8String(isolate, "numberOfChannels")).ToLocal(&numberOfChannelsValue)) {
    exceptionState.rethrowV8Exception(block.Exception());
    return;
  }
  if (numberOfChannelsValue.IsEmpty() || numberOfChannelsValue->IsUndefined()) {
    // Do nothing.
  } else {
    unsigned numberOfChannels = toUInt32(isolate, numberOfChannelsValue, NormalConversion, exceptionState);
    if (exceptionState.hadException())
      return;
    impl.setNumberOfChannels(numberOfChannels);
  }

  v8::Local<v8::Value> sampleRateValue;
  if (!v8Object->Get(isolate->GetCurrentContext(), v8String(isolate, "sampleRate")).ToLocal(&sampleRateValue)) {
    exceptionState.rethrowV8Exception(block.Exception());
    return;
  }
  if (sampleRateValue.IsEmpty() || sampleRateValue->IsUndefined()) {
    // Do nothing.
  } else {
    float sampleRate = toRestrictedFloat(isolate, sampleRateValue, exceptionState);
    if (exceptionState.hadException())
      return;
    impl.setSampleRate(sampleRate);
  }
}

v8::Local<v8::Value> AudioBufferOptions::toV8Impl(v8::Local<v8::Object> creationContext, v8::Isolate* isolate) const {
  v8::Local<v8::Object> v8Object = v8::Object::New(isolate);
  if (!toV8AudioBufferOptions(*this, v8Object, creationContext, isolate))
    return v8::Undefined(isolate);
  return v8Object;
}

bool toV8AudioBufferOptions(const AudioBufferOptions& impl, v8::Local<v8::Object> dictionary, v8::Local<v8::Object> creationContext, v8::Isolate* isolate) {
  if (impl.hasLength()) {
    if (!v8CallBoolean(dictionary->CreateDataProperty(isolate->GetCurrentContext(), v8String(isolate, "length"), v8::Integer::NewFromUnsigned(isolate, impl.length()))))
      return false;
  } else {
    NOTREACHED();
  }

  if (impl.hasNumberOfChannels()) {
    if (!v8CallBoolean(dictionary->CreateDataProperty(isolate->GetCurrentContext(), v8String(isolate, "numberOfChannels"), v8::Integer::NewFromUnsigned(isolate, impl.numberOfChannels()))))
      return false;
  } else {
    if (!v8CallBoolean(dictionary->CreateDataProperty(isolate->GetCurrentContext(), v8String(isolate, "numberOfChannels"), v8::Integer::NewFromUnsigned(isolate, 1u))))
      return false;
  }

  if (impl.hasSampleRate()) {
    if (!v8CallBoolean(dictionary->CreateDataProperty(isolate->GetCurrentContext(), v8String(isolate, "sampleRate"), v8::Number::New(isolate, impl.sampleRate()))))
      return false;
  }

  return true;
}

AudioBufferOptions NativeValueTraits<AudioBufferOptions>::nativeValue(v8::Isolate* isolate, v8::Local<v8::Value> value, ExceptionState& exceptionState) {
  AudioBufferOptions impl;
  V8AudioBufferOptions::toImpl(isolate, value, impl, exceptionState);
  return impl;
}

}  // namespace blink
