// Copyright 2014 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// This file has been auto-generated by code_generator_v8.py.
// DO NOT MODIFY!

// clang-format off
#include "V8BatteryManager.h"

#include "bindings/core/v8/ExceptionState.h"
#include "bindings/core/v8/GeneratedCodeHelper.h"
#include "bindings/core/v8/V8AbstractEventListener.h"
#include "bindings/core/v8/V8DOMConfiguration.h"
#include "bindings/core/v8/V8EventListenerHelper.h"
#include "bindings/core/v8/V8ObjectConstructor.h"
#include "core/dom/Document.h"
#include "wtf/GetPtr.h"
#include "wtf/RefPtr.h"

namespace blink {

// Suppress warning: global constructors, because struct WrapperTypeInfo is trivial
// and does not depend on another global objects.
#if defined(COMPONENT_BUILD) && defined(WIN32) && COMPILER(CLANG)
#pragma clang diagnostic push
#pragma clang diagnostic ignored "-Wglobal-constructors"
#endif
const WrapperTypeInfo V8BatteryManager::wrapperTypeInfo = { gin::kEmbedderBlink, V8BatteryManager::domTemplate, V8BatteryManager::trace, V8BatteryManager::traceWrappers, 0, nullptr, "BatteryManager", &V8EventTarget::wrapperTypeInfo, WrapperTypeInfo::WrapperTypeObjectPrototype, WrapperTypeInfo::ObjectClassId, WrapperTypeInfo::InheritFromActiveScriptWrappable, WrapperTypeInfo::InheritFromEventTarget, WrapperTypeInfo::Dependent };
#if defined(COMPONENT_BUILD) && defined(WIN32) && COMPILER(CLANG)
#pragma clang diagnostic pop
#endif

// This static member must be declared by DEFINE_WRAPPERTYPEINFO in BatteryManager.h.
// For details, see the comment of DEFINE_WRAPPERTYPEINFO in
// bindings/core/v8/ScriptWrappable.h.
const WrapperTypeInfo& BatteryManager::s_wrapperTypeInfo = V8BatteryManager::wrapperTypeInfo;

// [ActiveScriptWrappable]
static_assert(
    std::is_base_of<ActiveScriptWrappable, BatteryManager>::value,
    "BatteryManager does not inherit from ActiveScriptWrappable, but specifying "
    "[ActiveScriptWrappable] extended attribute in the IDL file.  "
    "Be consistent.");
static_assert(
    !std::is_same<decltype(&BatteryManager::hasPendingActivity),
                  decltype(&ScriptWrappable::hasPendingActivity)>::value,
    "BatteryManager is not overriding hasPendingActivity(), but is specifying "
    "[ActiveScriptWrappable] extended attribute in the IDL file.  "
    "Be consistent.");

namespace BatteryManagerV8Internal {

static void chargingAttributeGetter(const v8::FunctionCallbackInfo<v8::Value>& info) {
  v8::Local<v8::Object> holder = info.Holder();

  BatteryManager* impl = V8BatteryManager::toImpl(holder);

  v8SetReturnValueBool(info, impl->charging());
}

void chargingAttributeGetterCallback(const v8::FunctionCallbackInfo<v8::Value>& info) {
  BatteryManagerV8Internal::chargingAttributeGetter(info);
}

static void chargingTimeAttributeGetter(const v8::FunctionCallbackInfo<v8::Value>& info) {
  v8::Local<v8::Object> holder = info.Holder();

  BatteryManager* impl = V8BatteryManager::toImpl(holder);

  v8SetReturnValue(info, impl->chargingTime());
}

void chargingTimeAttributeGetterCallback(const v8::FunctionCallbackInfo<v8::Value>& info) {
  BatteryManagerV8Internal::chargingTimeAttributeGetter(info);
}

static void dischargingTimeAttributeGetter(const v8::FunctionCallbackInfo<v8::Value>& info) {
  v8::Local<v8::Object> holder = info.Holder();

  BatteryManager* impl = V8BatteryManager::toImpl(holder);

  v8SetReturnValue(info, impl->dischargingTime());
}

void dischargingTimeAttributeGetterCallback(const v8::FunctionCallbackInfo<v8::Value>& info) {
  BatteryManagerV8Internal::dischargingTimeAttributeGetter(info);
}

static void levelAttributeGetter(const v8::FunctionCallbackInfo<v8::Value>& info) {
  v8::Local<v8::Object> holder = info.Holder();

  BatteryManager* impl = V8BatteryManager::toImpl(holder);

  v8SetReturnValue(info, impl->level());
}

void levelAttributeGetterCallback(const v8::FunctionCallbackInfo<v8::Value>& info) {
  BatteryManagerV8Internal::levelAttributeGetter(info);
}

static void onchargingchangeAttributeGetter(const v8::FunctionCallbackInfo<v8::Value>& info) {
  v8::Local<v8::Object> holder = info.Holder();

  BatteryManager* impl = V8BatteryManager::toImpl(holder);

  EventListener* cppValue(WTF::getPtr(impl->onchargingchange()));

  v8SetReturnValue(info, cppValue ? V8AbstractEventListener::cast(cppValue)->getListenerOrNull(info.GetIsolate(), impl->getExecutionContext()) : v8::Null(info.GetIsolate()).As<v8::Value>());
}

void onchargingchangeAttributeGetterCallback(const v8::FunctionCallbackInfo<v8::Value>& info) {
  BatteryManagerV8Internal::onchargingchangeAttributeGetter(info);
}

static void onchargingchangeAttributeSetter(v8::Local<v8::Value> v8Value, const v8::FunctionCallbackInfo<v8::Value>& info) {
  v8::Local<v8::Object> holder = info.Holder();
  BatteryManager* impl = V8BatteryManager::toImpl(holder);

  // Prepare the value to be set.
  moveEventListenerToNewWrapper(info.GetIsolate(), holder, impl->onchargingchange(), v8Value, V8BatteryManager::eventListenerCacheIndex);

  impl->setOnchargingchange(V8EventListenerHelper::getEventListener(ScriptState::forReceiverObject(info), v8Value, true, ListenerFindOrCreate));
}

void onchargingchangeAttributeSetterCallback(const v8::FunctionCallbackInfo<v8::Value>& info) {
  v8::Local<v8::Value> v8Value = info[0];

  BatteryManagerV8Internal::onchargingchangeAttributeSetter(v8Value, info);
}

static void onchargingtimechangeAttributeGetter(const v8::FunctionCallbackInfo<v8::Value>& info) {
  v8::Local<v8::Object> holder = info.Holder();

  BatteryManager* impl = V8BatteryManager::toImpl(holder);

  EventListener* cppValue(WTF::getPtr(impl->onchargingtimechange()));

  v8SetReturnValue(info, cppValue ? V8AbstractEventListener::cast(cppValue)->getListenerOrNull(info.GetIsolate(), impl->getExecutionContext()) : v8::Null(info.GetIsolate()).As<v8::Value>());
}

void onchargingtimechangeAttributeGetterCallback(const v8::FunctionCallbackInfo<v8::Value>& info) {
  BatteryManagerV8Internal::onchargingtimechangeAttributeGetter(info);
}

static void onchargingtimechangeAttributeSetter(v8::Local<v8::Value> v8Value, const v8::FunctionCallbackInfo<v8::Value>& info) {
  v8::Local<v8::Object> holder = info.Holder();
  BatteryManager* impl = V8BatteryManager::toImpl(holder);

  // Prepare the value to be set.
  moveEventListenerToNewWrapper(info.GetIsolate(), holder, impl->onchargingtimechange(), v8Value, V8BatteryManager::eventListenerCacheIndex);

  impl->setOnchargingtimechange(V8EventListenerHelper::getEventListener(ScriptState::forReceiverObject(info), v8Value, true, ListenerFindOrCreate));
}

void onchargingtimechangeAttributeSetterCallback(const v8::FunctionCallbackInfo<v8::Value>& info) {
  v8::Local<v8::Value> v8Value = info[0];

  BatteryManagerV8Internal::onchargingtimechangeAttributeSetter(v8Value, info);
}

static void ondischargingtimechangeAttributeGetter(const v8::FunctionCallbackInfo<v8::Value>& info) {
  v8::Local<v8::Object> holder = info.Holder();

  BatteryManager* impl = V8BatteryManager::toImpl(holder);

  EventListener* cppValue(WTF::getPtr(impl->ondischargingtimechange()));

  v8SetReturnValue(info, cppValue ? V8AbstractEventListener::cast(cppValue)->getListenerOrNull(info.GetIsolate(), impl->getExecutionContext()) : v8::Null(info.GetIsolate()).As<v8::Value>());
}

void ondischargingtimechangeAttributeGetterCallback(const v8::FunctionCallbackInfo<v8::Value>& info) {
  BatteryManagerV8Internal::ondischargingtimechangeAttributeGetter(info);
}

static void ondischargingtimechangeAttributeSetter(v8::Local<v8::Value> v8Value, const v8::FunctionCallbackInfo<v8::Value>& info) {
  v8::Local<v8::Object> holder = info.Holder();
  BatteryManager* impl = V8BatteryManager::toImpl(holder);

  // Prepare the value to be set.
  moveEventListenerToNewWrapper(info.GetIsolate(), holder, impl->ondischargingtimechange(), v8Value, V8BatteryManager::eventListenerCacheIndex);

  impl->setOndischargingtimechange(V8EventListenerHelper::getEventListener(ScriptState::forReceiverObject(info), v8Value, true, ListenerFindOrCreate));
}

void ondischargingtimechangeAttributeSetterCallback(const v8::FunctionCallbackInfo<v8::Value>& info) {
  v8::Local<v8::Value> v8Value = info[0];

  BatteryManagerV8Internal::ondischargingtimechangeAttributeSetter(v8Value, info);
}

static void onlevelchangeAttributeGetter(const v8::FunctionCallbackInfo<v8::Value>& info) {
  v8::Local<v8::Object> holder = info.Holder();

  BatteryManager* impl = V8BatteryManager::toImpl(holder);

  EventListener* cppValue(WTF::getPtr(impl->onlevelchange()));

  v8SetReturnValue(info, cppValue ? V8AbstractEventListener::cast(cppValue)->getListenerOrNull(info.GetIsolate(), impl->getExecutionContext()) : v8::Null(info.GetIsolate()).As<v8::Value>());
}

void onlevelchangeAttributeGetterCallback(const v8::FunctionCallbackInfo<v8::Value>& info) {
  BatteryManagerV8Internal::onlevelchangeAttributeGetter(info);
}

static void onlevelchangeAttributeSetter(v8::Local<v8::Value> v8Value, const v8::FunctionCallbackInfo<v8::Value>& info) {
  v8::Local<v8::Object> holder = info.Holder();
  BatteryManager* impl = V8BatteryManager::toImpl(holder);

  // Prepare the value to be set.
  moveEventListenerToNewWrapper(info.GetIsolate(), holder, impl->onlevelchange(), v8Value, V8BatteryManager::eventListenerCacheIndex);

  impl->setOnlevelchange(V8EventListenerHelper::getEventListener(ScriptState::forReceiverObject(info), v8Value, true, ListenerFindOrCreate));
}

void onlevelchangeAttributeSetterCallback(const v8::FunctionCallbackInfo<v8::Value>& info) {
  v8::Local<v8::Value> v8Value = info[0];

  BatteryManagerV8Internal::onlevelchangeAttributeSetter(v8Value, info);
}

} // namespace BatteryManagerV8Internal

const V8DOMConfiguration::AccessorConfiguration V8BatteryManagerAccessors[] = {
    {"charging", BatteryManagerV8Internal::chargingAttributeGetterCallback, 0, 0, 0, nullptr, 0, v8::DEFAULT, static_cast<v8::PropertyAttribute>(v8::ReadOnly), V8DOMConfiguration::ExposedToAllScripts, V8DOMConfiguration::OnPrototype, V8DOMConfiguration::CheckHolder},
    {"chargingTime", BatteryManagerV8Internal::chargingTimeAttributeGetterCallback, 0, 0, 0, nullptr, 0, v8::DEFAULT, static_cast<v8::PropertyAttribute>(v8::ReadOnly), V8DOMConfiguration::ExposedToAllScripts, V8DOMConfiguration::OnPrototype, V8DOMConfiguration::CheckHolder},
    {"dischargingTime", BatteryManagerV8Internal::dischargingTimeAttributeGetterCallback, 0, 0, 0, nullptr, 0, v8::DEFAULT, static_cast<v8::PropertyAttribute>(v8::ReadOnly), V8DOMConfiguration::ExposedToAllScripts, V8DOMConfiguration::OnPrototype, V8DOMConfiguration::CheckHolder},
    {"level", BatteryManagerV8Internal::levelAttributeGetterCallback, 0, 0, 0, nullptr, 0, v8::DEFAULT, static_cast<v8::PropertyAttribute>(v8::ReadOnly), V8DOMConfiguration::ExposedToAllScripts, V8DOMConfiguration::OnPrototype, V8DOMConfiguration::CheckHolder},
    {"onchargingchange", BatteryManagerV8Internal::onchargingchangeAttributeGetterCallback, BatteryManagerV8Internal::onchargingchangeAttributeSetterCallback, 0, 0, nullptr, 0, v8::DEFAULT, static_cast<v8::PropertyAttribute>(v8::None), V8DOMConfiguration::ExposedToAllScripts, V8DOMConfiguration::OnPrototype, V8DOMConfiguration::CheckHolder},
    {"onchargingtimechange", BatteryManagerV8Internal::onchargingtimechangeAttributeGetterCallback, BatteryManagerV8Internal::onchargingtimechangeAttributeSetterCallback, 0, 0, nullptr, 0, v8::DEFAULT, static_cast<v8::PropertyAttribute>(v8::None), V8DOMConfiguration::ExposedToAllScripts, V8DOMConfiguration::OnPrototype, V8DOMConfiguration::CheckHolder},
    {"ondischargingtimechange", BatteryManagerV8Internal::ondischargingtimechangeAttributeGetterCallback, BatteryManagerV8Internal::ondischargingtimechangeAttributeSetterCallback, 0, 0, nullptr, 0, v8::DEFAULT, static_cast<v8::PropertyAttribute>(v8::None), V8DOMConfiguration::ExposedToAllScripts, V8DOMConfiguration::OnPrototype, V8DOMConfiguration::CheckHolder},
    {"onlevelchange", BatteryManagerV8Internal::onlevelchangeAttributeGetterCallback, BatteryManagerV8Internal::onlevelchangeAttributeSetterCallback, 0, 0, nullptr, 0, v8::DEFAULT, static_cast<v8::PropertyAttribute>(v8::None), V8DOMConfiguration::ExposedToAllScripts, V8DOMConfiguration::OnPrototype, V8DOMConfiguration::CheckHolder},
};

static void installV8BatteryManagerTemplate(v8::Isolate* isolate, const DOMWrapperWorld& world, v8::Local<v8::FunctionTemplate> interfaceTemplate) {
  // Initialize the interface object's template.
  V8DOMConfiguration::initializeDOMInterfaceTemplate(isolate, interfaceTemplate, V8BatteryManager::wrapperTypeInfo.interfaceName, V8EventTarget::domTemplate(isolate, world), V8BatteryManager::internalFieldCount);
  v8::Local<v8::Signature> signature = v8::Signature::New(isolate, interfaceTemplate);
  ALLOW_UNUSED_LOCAL(signature);
  v8::Local<v8::ObjectTemplate> instanceTemplate = interfaceTemplate->InstanceTemplate();
  ALLOW_UNUSED_LOCAL(instanceTemplate);
  v8::Local<v8::ObjectTemplate> prototypeTemplate = interfaceTemplate->PrototypeTemplate();
  ALLOW_UNUSED_LOCAL(prototypeTemplate);
  // Register DOM constants, attributes and operations.
  V8DOMConfiguration::installAccessors(isolate, world, instanceTemplate, prototypeTemplate, interfaceTemplate, signature, V8BatteryManagerAccessors, WTF_ARRAY_LENGTH(V8BatteryManagerAccessors));
}

v8::Local<v8::FunctionTemplate> V8BatteryManager::domTemplate(v8::Isolate* isolate, const DOMWrapperWorld& world) {
  return V8DOMConfiguration::domClassTemplate(isolate, world, const_cast<WrapperTypeInfo*>(&wrapperTypeInfo), installV8BatteryManagerTemplate);
}

bool V8BatteryManager::hasInstance(v8::Local<v8::Value> v8Value, v8::Isolate* isolate) {
  return V8PerIsolateData::from(isolate)->hasInstance(&wrapperTypeInfo, v8Value);
}

v8::Local<v8::Object> V8BatteryManager::findInstanceInPrototypeChain(v8::Local<v8::Value> v8Value, v8::Isolate* isolate) {
  return V8PerIsolateData::from(isolate)->findInstanceInPrototypeChain(&wrapperTypeInfo, v8Value);
}

BatteryManager* V8BatteryManager::toImplWithTypeCheck(v8::Isolate* isolate, v8::Local<v8::Value> value) {
  return hasInstance(value, isolate) ? toImpl(v8::Local<v8::Object>::Cast(value)) : nullptr;
}

}  // namespace blink
