// Copyright 2014 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// This file has been auto-generated by code_generator_v8.py.
// DO NOT MODIFY!

// clang-format off
#include "V8BiquadFilterOptions.h"

#include "bindings/core/v8/ExceptionState.h"
#include "bindings/modules/v8/V8AudioNodeOptions.h"

namespace blink {

void V8BiquadFilterOptions::toImpl(v8::Isolate* isolate, v8::Local<v8::Value> v8Value, BiquadFilterOptions& impl, ExceptionState& exceptionState) {
  if (isUndefinedOrNull(v8Value)) {
    return;
  }
  if (!v8Value->IsObject()) {
    exceptionState.throwTypeError("cannot convert to dictionary.");
    return;
  }

  V8AudioNodeOptions::toImpl(isolate, v8Value, impl, exceptionState);
  if (exceptionState.hadException())
    return;

  v8::TryCatch block(isolate);
  v8::Local<v8::Object> v8Object;
  if (!v8Call(v8Value->ToObject(isolate->GetCurrentContext()), v8Object, block)) {
    exceptionState.rethrowV8Exception(block.Exception());
    return;
  }
  v8::Local<v8::Value> QValue;
  if (!v8Object->Get(isolate->GetCurrentContext(), v8String(isolate, "Q")).ToLocal(&QValue)) {
    exceptionState.rethrowV8Exception(block.Exception());
    return;
  }
  if (QValue.IsEmpty() || QValue->IsUndefined()) {
    // Do nothing.
  } else {
    float Q = toRestrictedFloat(isolate, QValue, exceptionState);
    if (exceptionState.hadException())
      return;
    impl.setQ(Q);
  }

  v8::Local<v8::Value> detuneValue;
  if (!v8Object->Get(isolate->GetCurrentContext(), v8String(isolate, "detune")).ToLocal(&detuneValue)) {
    exceptionState.rethrowV8Exception(block.Exception());
    return;
  }
  if (detuneValue.IsEmpty() || detuneValue->IsUndefined()) {
    // Do nothing.
  } else {
    float detune = toRestrictedFloat(isolate, detuneValue, exceptionState);
    if (exceptionState.hadException())
      return;
    impl.setDetune(detune);
  }

  v8::Local<v8::Value> frequencyValue;
  if (!v8Object->Get(isolate->GetCurrentContext(), v8String(isolate, "frequency")).ToLocal(&frequencyValue)) {
    exceptionState.rethrowV8Exception(block.Exception());
    return;
  }
  if (frequencyValue.IsEmpty() || frequencyValue->IsUndefined()) {
    // Do nothing.
  } else {
    float frequency = toRestrictedFloat(isolate, frequencyValue, exceptionState);
    if (exceptionState.hadException())
      return;
    impl.setFrequency(frequency);
  }

  v8::Local<v8::Value> gainValue;
  if (!v8Object->Get(isolate->GetCurrentContext(), v8String(isolate, "gain")).ToLocal(&gainValue)) {
    exceptionState.rethrowV8Exception(block.Exception());
    return;
  }
  if (gainValue.IsEmpty() || gainValue->IsUndefined()) {
    // Do nothing.
  } else {
    float gain = toRestrictedFloat(isolate, gainValue, exceptionState);
    if (exceptionState.hadException())
      return;
    impl.setGain(gain);
  }

  v8::Local<v8::Value> typeValue;
  if (!v8Object->Get(isolate->GetCurrentContext(), v8String(isolate, "type")).ToLocal(&typeValue)) {
    exceptionState.rethrowV8Exception(block.Exception());
    return;
  }
  if (typeValue.IsEmpty() || typeValue->IsUndefined()) {
    // Do nothing.
  } else {
    V8StringResource<> type = typeValue;
    if (!type.prepare(exceptionState))
      return;
    const char* validValues[] = {
        "lowpass",
        "highpass",
        "bandpass",
        "lowshelf",
        "highshelf",
        "peaking",
        "notch",
        "allpass",
    };
    if (!isValidEnum(type, validValues, WTF_ARRAY_LENGTH(validValues), "BiquadFilterType", exceptionState))
      return;
    impl.setType(type);
  }
}

v8::Local<v8::Value> BiquadFilterOptions::toV8Impl(v8::Local<v8::Object> creationContext, v8::Isolate* isolate) const {
  v8::Local<v8::Object> v8Object = v8::Object::New(isolate);
  if (!toV8BiquadFilterOptions(*this, v8Object, creationContext, isolate))
    return v8::Undefined(isolate);
  return v8Object;
}

bool toV8BiquadFilterOptions(const BiquadFilterOptions& impl, v8::Local<v8::Object> dictionary, v8::Local<v8::Object> creationContext, v8::Isolate* isolate) {
  if (!toV8AudioNodeOptions(impl, dictionary, creationContext, isolate))
    return false;

  if (impl.hasQ()) {
    if (!v8CallBoolean(dictionary->CreateDataProperty(isolate->GetCurrentContext(), v8String(isolate, "Q"), v8::Number::New(isolate, impl.Q()))))
      return false;
  }

  if (impl.hasDetune()) {
    if (!v8CallBoolean(dictionary->CreateDataProperty(isolate->GetCurrentContext(), v8String(isolate, "detune"), v8::Number::New(isolate, impl.detune()))))
      return false;
  }

  if (impl.hasFrequency()) {
    if (!v8CallBoolean(dictionary->CreateDataProperty(isolate->GetCurrentContext(), v8String(isolate, "frequency"), v8::Number::New(isolate, impl.frequency()))))
      return false;
  }

  if (impl.hasGain()) {
    if (!v8CallBoolean(dictionary->CreateDataProperty(isolate->GetCurrentContext(), v8String(isolate, "gain"), v8::Number::New(isolate, impl.gain()))))
      return false;
  }

  if (impl.hasType()) {
    if (!v8CallBoolean(dictionary->CreateDataProperty(isolate->GetCurrentContext(), v8String(isolate, "type"), v8String(isolate, impl.type()))))
      return false;
  }

  return true;
}

BiquadFilterOptions NativeValueTraits<BiquadFilterOptions>::nativeValue(v8::Isolate* isolate, v8::Local<v8::Value> value, ExceptionState& exceptionState) {
  BiquadFilterOptions impl;
  V8BiquadFilterOptions::toImpl(isolate, value, impl, exceptionState);
  return impl;
}

}  // namespace blink
