// Copyright 2014 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// This file has been auto-generated by code_generator_v8.py.
// DO NOT MODIFY!

// clang-format off
#include "V8ChannelMergerOptions.h"

#include "bindings/core/v8/ExceptionState.h"
#include "bindings/modules/v8/V8AudioNodeOptions.h"

namespace blink {

void V8ChannelMergerOptions::toImpl(v8::Isolate* isolate, v8::Local<v8::Value> v8Value, ChannelMergerOptions& impl, ExceptionState& exceptionState) {
  if (isUndefinedOrNull(v8Value)) {
    return;
  }
  if (!v8Value->IsObject()) {
    exceptionState.throwTypeError("cannot convert to dictionary.");
    return;
  }

  V8AudioNodeOptions::toImpl(isolate, v8Value, impl, exceptionState);
  if (exceptionState.hadException())
    return;

  v8::TryCatch block(isolate);
  v8::Local<v8::Object> v8Object;
  if (!v8Call(v8Value->ToObject(isolate->GetCurrentContext()), v8Object, block)) {
    exceptionState.rethrowV8Exception(block.Exception());
    return;
  }
  v8::Local<v8::Value> numberOfInputsValue;
  if (!v8Object->Get(isolate->GetCurrentContext(), v8String(isolate, "numberOfInputs")).ToLocal(&numberOfInputsValue)) {
    exceptionState.rethrowV8Exception(block.Exception());
    return;
  }
  if (numberOfInputsValue.IsEmpty() || numberOfInputsValue->IsUndefined()) {
    // Do nothing.
  } else {
    unsigned numberOfInputs = toUInt32(isolate, numberOfInputsValue, NormalConversion, exceptionState);
    if (exceptionState.hadException())
      return;
    impl.setNumberOfInputs(numberOfInputs);
  }
}

v8::Local<v8::Value> ChannelMergerOptions::toV8Impl(v8::Local<v8::Object> creationContext, v8::Isolate* isolate) const {
  v8::Local<v8::Object> v8Object = v8::Object::New(isolate);
  if (!toV8ChannelMergerOptions(*this, v8Object, creationContext, isolate))
    return v8::Undefined(isolate);
  return v8Object;
}

bool toV8ChannelMergerOptions(const ChannelMergerOptions& impl, v8::Local<v8::Object> dictionary, v8::Local<v8::Object> creationContext, v8::Isolate* isolate) {
  if (!toV8AudioNodeOptions(impl, dictionary, creationContext, isolate))
    return false;

  if (impl.hasNumberOfInputs()) {
    if (!v8CallBoolean(dictionary->CreateDataProperty(isolate->GetCurrentContext(), v8String(isolate, "numberOfInputs"), v8::Integer::NewFromUnsigned(isolate, impl.numberOfInputs()))))
      return false;
  } else {
    if (!v8CallBoolean(dictionary->CreateDataProperty(isolate->GetCurrentContext(), v8String(isolate, "numberOfInputs"), v8::Integer::NewFromUnsigned(isolate, 6u))))
      return false;
  }

  return true;
}

ChannelMergerOptions NativeValueTraits<ChannelMergerOptions>::nativeValue(v8::Isolate* isolate, v8::Local<v8::Value> value, ExceptionState& exceptionState) {
  ChannelMergerOptions impl;
  V8ChannelMergerOptions::toImpl(isolate, value, impl, exceptionState);
  return impl;
}

}  // namespace blink
