// Copyright 2014 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// This file has been auto-generated by code_generator_v8.py.
// DO NOT MODIFY!

// clang-format off
#include "V8CompositorWorkerGlobalScope.h"

#include "bindings/core/v8/ExceptionState.h"
#include "bindings/core/v8/GeneratedCodeHelper.h"
#include "bindings/core/v8/ScriptValue.h"
#include "bindings/core/v8/SerializedScriptValueFactory.h"
#include "bindings/core/v8/Transferables.h"
#include "bindings/core/v8/V8AbstractEventListener.h"
#include "bindings/core/v8/V8CompositorProxy.h"
#include "bindings/core/v8/V8DOMConfiguration.h"
#include "bindings/core/v8/V8EventListenerHelper.h"
#include "bindings/core/v8/V8FrameRequestCallback.h"
#include "bindings/core/v8/V8MessagePort.h"
#include "bindings/core/v8/V8ObjectConstructor.h"
#include "bindings/modules/v8/V8CompositorWorkerGlobalScope.h"
#include "core/dom/DOMArrayBufferBase.h"
#include "core/dom/Document.h"
#include "modules/CompositorWorkerGlobalScopeCoreConstructors.h"
#include "modules/CompositorWorkerGlobalScopeModulesConstructors.h"
#include "modules/cachestorage/GlobalCacheStorage.h"
#include "modules/crypto/WorkerGlobalScopeCrypto.h"
#include "modules/fetch/GlobalFetch.h"
#include "modules/indexeddb/GlobalIndexedDB.h"
#include "platform/RuntimeEnabledFeatures.h"
#include "wtf/GetPtr.h"
#include "wtf/RefPtr.h"

namespace blink {

// Suppress warning: global constructors, because struct WrapperTypeInfo is trivial
// and does not depend on another global objects.
#if defined(COMPONENT_BUILD) && defined(WIN32) && COMPILER(CLANG)
#pragma clang diagnostic push
#pragma clang diagnostic ignored "-Wglobal-constructors"
#endif
const WrapperTypeInfo V8CompositorWorkerGlobalScope::wrapperTypeInfo = { gin::kEmbedderBlink, V8CompositorWorkerGlobalScope::domTemplate, V8CompositorWorkerGlobalScope::trace, V8CompositorWorkerGlobalScope::traceWrappers, 0, nullptr, "CompositorWorkerGlobalScope", &V8WorkerGlobalScope::wrapperTypeInfo, WrapperTypeInfo::WrapperTypeObjectPrototype, WrapperTypeInfo::ObjectClassId, WrapperTypeInfo::InheritFromActiveScriptWrappable, WrapperTypeInfo::InheritFromEventTarget, WrapperTypeInfo::Dependent };
#if defined(COMPONENT_BUILD) && defined(WIN32) && COMPILER(CLANG)
#pragma clang diagnostic pop
#endif

// This static member must be declared by DEFINE_WRAPPERTYPEINFO in CompositorWorkerGlobalScope.h.
// For details, see the comment of DEFINE_WRAPPERTYPEINFO in
// bindings/core/v8/ScriptWrappable.h.
const WrapperTypeInfo& CompositorWorkerGlobalScope::s_wrapperTypeInfo = V8CompositorWorkerGlobalScope::wrapperTypeInfo;

// [ActiveScriptWrappable]
static_assert(
    std::is_base_of<ActiveScriptWrappable, CompositorWorkerGlobalScope>::value,
    "CompositorWorkerGlobalScope does not inherit from ActiveScriptWrappable, but specifying "
    "[ActiveScriptWrappable] extended attribute in the IDL file.  "
    "Be consistent.");
static_assert(
    !std::is_same<decltype(&CompositorWorkerGlobalScope::hasPendingActivity),
                  decltype(&ScriptWrappable::hasPendingActivity)>::value,
    "CompositorWorkerGlobalScope is not overriding hasPendingActivity(), but is specifying "
    "[ActiveScriptWrappable] extended attribute in the IDL file.  "
    "Be consistent.");

namespace CompositorWorkerGlobalScopeV8Internal {

static void onmessageAttributeGetter(const v8::FunctionCallbackInfo<v8::Value>& info) {
  v8::Local<v8::Object> holder = info.Holder();

  CompositorWorkerGlobalScope* impl = V8CompositorWorkerGlobalScope::toImpl(holder);

  EventListener* cppValue(WTF::getPtr(impl->onmessage()));

  v8SetReturnValue(info, cppValue ? V8AbstractEventListener::cast(cppValue)->getListenerOrNull(info.GetIsolate(), impl->getExecutionContext()) : v8::Null(info.GetIsolate()).As<v8::Value>());
}

void onmessageAttributeGetterCallback(const v8::FunctionCallbackInfo<v8::Value>& info) {
  CompositorWorkerGlobalScopeV8Internal::onmessageAttributeGetter(info);
}

static void onmessageAttributeSetter(v8::Local<v8::Value> v8Value, const v8::FunctionCallbackInfo<v8::Value>& info) {
  v8::Local<v8::Object> holder = info.Holder();
  CompositorWorkerGlobalScope* impl = V8CompositorWorkerGlobalScope::toImpl(holder);

  // Prepare the value to be set.
  moveEventListenerToNewWrapper(info.GetIsolate(), holder, impl->onmessage(), v8Value, V8CompositorWorkerGlobalScope::eventListenerCacheIndex);

  impl->setOnmessage(V8EventListenerHelper::getEventListener(ScriptState::forReceiverObject(info), v8Value, true, ListenerFindOrCreate));
}

void onmessageAttributeSetterCallback(const v8::FunctionCallbackInfo<v8::Value>& info) {
  v8::Local<v8::Value> v8Value = info[0];

  CompositorWorkerGlobalScopeV8Internal::onmessageAttributeSetter(v8Value, info);
}

static void postMessageImpl(const char* interfaceName, CompositorWorkerGlobalScope* instance, const v8::FunctionCallbackInfo<v8::Value>& info) {
  ExceptionState exceptionState(info.GetIsolate(), ExceptionState::ExecutionContext, interfaceName, "postMessage");
  if (UNLIKELY(info.Length() < 1)) {
    exceptionState.throwTypeError(ExceptionMessages::notEnoughArguments(1, info.Length()));
    return;
  }

  Transferables transferables;
  if (info.Length() > 1) {
    const int transferablesArgIndex = 1;
    if (!SerializedScriptValue::extractTransferables(info.GetIsolate(), info[transferablesArgIndex], transferablesArgIndex, transferables, exceptionState)) {
      return;
    }
  }

  RefPtr<SerializedScriptValue> message;
  if (instance->canTransferArrayBuffer()) {
    // This instance supports sending array buffers by move semantics.
    message = SerializedScriptValue::serialize(info.GetIsolate(), info[0], &transferables, nullptr, exceptionState);
    if (exceptionState.hadException())
      return;
  } else {
    // This instance doesn't support sending array buffers by move
    // semantics. Emulate it by copy-and-neuter semantics that sends array
    // buffers by copy semantics and then neuters the original array
    // buffers.

    // Clear references to array buffers from transferables so that the
    // serializer can consider the array buffers as non-transferable and
    // copy them into the message.
    ArrayBufferArray transferableArrayBuffers = transferables.arrayBuffers;
    transferables.arrayBuffers.clear();
    message = SerializedScriptValue::serialize(info.GetIsolate(), info[0], &transferables, nullptr, exceptionState);
    if (exceptionState.hadException())
      return;

    // Neuter the original array buffers on the sender context.
    SerializedScriptValue::transferArrayBufferContents(info.GetIsolate(), transferableArrayBuffers, exceptionState);
    if (exceptionState.hadException())
      return;
  }

  // FIXME: Only pass context/exceptionState if instance really requires it.
  ExecutionContext* context = currentExecutionContext(info.GetIsolate());
  instance->postMessage(context, message.release(), transferables.messagePorts, exceptionState);
}

void postMessageMethodCallback(const v8::FunctionCallbackInfo<v8::Value>& info) {
  postMessageImpl("CompositorWorkerGlobalScope", V8CompositorWorkerGlobalScope::toImpl(info.Holder()), info);
}

static void requestAnimationFrameMethod(const v8::FunctionCallbackInfo<v8::Value>& info) {
  CompositorWorkerGlobalScope* impl = V8CompositorWorkerGlobalScope::toImpl(info.Holder());

  if (UNLIKELY(info.Length() < 1)) {
    V8ThrowException::throwTypeError(info.GetIsolate(), ExceptionMessages::failedToExecute("requestAnimationFrame", "CompositorWorkerGlobalScope", ExceptionMessages::notEnoughArguments(1, info.Length())));
    return;
  }

  FrameRequestCallback* callback;
  if (info.Length() <= 0 || !info[0]->IsFunction()) {
    V8ThrowException::throwTypeError(info.GetIsolate(), ExceptionMessages::failedToExecute("requestAnimationFrame", "CompositorWorkerGlobalScope", "The callback provided as parameter 1 is not a function."));

    return;
  }
  callback = V8FrameRequestCallback::create(v8::Local<v8::Function>::Cast(info[0]), ScriptState::current(info.GetIsolate()));

  v8SetReturnValueInt(info, impl->requestAnimationFrame(callback));
}

void requestAnimationFrameMethodCallback(const v8::FunctionCallbackInfo<v8::Value>& info) {
  CompositorWorkerGlobalScopeV8Internal::requestAnimationFrameMethod(info);
}

static void cancelAnimationFrameMethod(const v8::FunctionCallbackInfo<v8::Value>& info) {
  ExceptionState exceptionState(info.GetIsolate(), ExceptionState::ExecutionContext, "CompositorWorkerGlobalScope", "cancelAnimationFrame");

  CompositorWorkerGlobalScope* impl = V8CompositorWorkerGlobalScope::toImpl(info.Holder());

  if (UNLIKELY(info.Length() < 1)) {
    exceptionState.throwTypeError(ExceptionMessages::notEnoughArguments(1, info.Length()));
    return;
  }

  int handle;
  handle = toInt32(info.GetIsolate(), info[0], NormalConversion, exceptionState);
  if (exceptionState.hadException())
    return;

  impl->cancelAnimationFrame(handle);
}

void cancelAnimationFrameMethodCallback(const v8::FunctionCallbackInfo<v8::Value>& info) {
  CompositorWorkerGlobalScopeV8Internal::cancelAnimationFrameMethod(info);
}

} // namespace CompositorWorkerGlobalScopeV8Internal

const V8DOMConfiguration::AccessorConfiguration V8CompositorWorkerGlobalScopeAccessors[] = {
    {"onmessage", CompositorWorkerGlobalScopeV8Internal::onmessageAttributeGetterCallback, CompositorWorkerGlobalScopeV8Internal::onmessageAttributeSetterCallback, 0, 0, nullptr, 0, v8::DEFAULT, static_cast<v8::PropertyAttribute>(v8::None), V8DOMConfiguration::ExposedToAllScripts, V8DOMConfiguration::OnInstance, V8DOMConfiguration::CheckHolder},
};

const V8DOMConfiguration::MethodConfiguration V8CompositorWorkerGlobalScopeMethods[] = {
    {"postMessage", CompositorWorkerGlobalScopeV8Internal::postMessageMethodCallback, 0, 1, v8::None, V8DOMConfiguration::ExposedToAllScripts, V8DOMConfiguration::OnInstance, V8DOMConfiguration::CheckHolder},
    {"requestAnimationFrame", CompositorWorkerGlobalScopeV8Internal::requestAnimationFrameMethodCallback, 0, 1, v8::None, V8DOMConfiguration::ExposedToAllScripts, V8DOMConfiguration::OnInstance, V8DOMConfiguration::CheckHolder},
    {"cancelAnimationFrame", CompositorWorkerGlobalScopeV8Internal::cancelAnimationFrameMethodCallback, 0, 1, v8::None, V8DOMConfiguration::ExposedToAllScripts, V8DOMConfiguration::OnInstance, V8DOMConfiguration::CheckHolder},
};

static void installV8CompositorWorkerGlobalScopeTemplate(v8::Isolate* isolate, const DOMWrapperWorld& world, v8::Local<v8::FunctionTemplate> interfaceTemplate) {
  // Initialize the interface object's template.
  V8DOMConfiguration::initializeDOMInterfaceTemplate(isolate, interfaceTemplate, V8CompositorWorkerGlobalScope::wrapperTypeInfo.interfaceName, V8WorkerGlobalScope::domTemplate(isolate, world), V8CompositorWorkerGlobalScope::internalFieldCount);
  v8::Local<v8::Signature> signature = v8::Signature::New(isolate, interfaceTemplate);
  ALLOW_UNUSED_LOCAL(signature);
  v8::Local<v8::ObjectTemplate> instanceTemplate = interfaceTemplate->InstanceTemplate();
  ALLOW_UNUSED_LOCAL(instanceTemplate);
  v8::Local<v8::ObjectTemplate> prototypeTemplate = interfaceTemplate->PrototypeTemplate();
  ALLOW_UNUSED_LOCAL(prototypeTemplate);
  // Global object prototype chain consists of Immutable Prototype Exotic Objects
  prototypeTemplate->SetImmutableProto();

  // Global objects are Immutable Prototype Exotic Objects
  instanceTemplate->SetImmutableProto();

  // Register DOM constants, attributes and operations.
  if (RuntimeEnabledFeatures::compositorWorkerEnabled()) {
      V8DOMConfiguration::installAccessors(isolate, world, instanceTemplate, prototypeTemplate, interfaceTemplate, signature, V8CompositorWorkerGlobalScopeAccessors, WTF_ARRAY_LENGTH(V8CompositorWorkerGlobalScopeAccessors));
      V8DOMConfiguration::installMethods(isolate, world, instanceTemplate, prototypeTemplate, interfaceTemplate, signature, V8CompositorWorkerGlobalScopeMethods, WTF_ARRAY_LENGTH(V8CompositorWorkerGlobalScopeMethods));
  }

  if (RuntimeEnabledFeatures::compositorWorkerEnabled()) {
    const V8DOMConfiguration::AttributeConfiguration attributeCompositorProxyConfiguration = {"CompositorProxy", v8ConstructorAttributeGetter, 0, 0, 0, nullptr, const_cast<WrapperTypeInfo*>(&V8CompositorProxy::wrapperTypeInfo), static_cast<v8::AccessControl>(v8::DEFAULT), static_cast<v8::PropertyAttribute>(v8::DontEnum), V8DOMConfiguration::ExposedToAllScripts, V8DOMConfiguration::OnInstance, V8DOMConfiguration::CheckHolder};
    V8DOMConfiguration::installAttribute(isolate, world, instanceTemplate, prototypeTemplate, attributeCompositorProxyConfiguration);
    const V8DOMConfiguration::AttributeConfiguration attributeCompositorWorkerGlobalScopeConfiguration = {"CompositorWorkerGlobalScope", v8ConstructorAttributeGetter, 0, 0, 0, nullptr, const_cast<WrapperTypeInfo*>(&V8CompositorWorkerGlobalScope::wrapperTypeInfo), static_cast<v8::AccessControl>(v8::DEFAULT), static_cast<v8::PropertyAttribute>(v8::DontEnum), V8DOMConfiguration::ExposedToAllScripts, V8DOMConfiguration::OnInstance, V8DOMConfiguration::CheckHolder};
    V8DOMConfiguration::installAttribute(isolate, world, instanceTemplate, prototypeTemplate, attributeCompositorWorkerGlobalScopeConfiguration);
  }
}

v8::Local<v8::FunctionTemplate> V8CompositorWorkerGlobalScope::domTemplate(v8::Isolate* isolate, const DOMWrapperWorld& world) {
  return V8DOMConfiguration::domClassTemplate(isolate, world, const_cast<WrapperTypeInfo*>(&wrapperTypeInfo), installV8CompositorWorkerGlobalScopeTemplate);
}

bool V8CompositorWorkerGlobalScope::hasInstance(v8::Local<v8::Value> v8Value, v8::Isolate* isolate) {
  return V8PerIsolateData::from(isolate)->hasInstance(&wrapperTypeInfo, v8Value);
}

v8::Local<v8::Object> V8CompositorWorkerGlobalScope::findInstanceInPrototypeChain(v8::Local<v8::Value> v8Value, v8::Isolate* isolate) {
  return V8PerIsolateData::from(isolate)->findInstanceInPrototypeChain(&wrapperTypeInfo, v8Value);
}

CompositorWorkerGlobalScope* V8CompositorWorkerGlobalScope::toImplWithTypeCheck(v8::Isolate* isolate, v8::Local<v8::Value> value) {
  return hasInstance(value, isolate) ? toImpl(v8::Local<v8::Object>::Cast(value)) : nullptr;
}

}  // namespace blink
