// Copyright 2014 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// This file has been auto-generated by code_generator_v8.py.
// DO NOT MODIFY!

// clang-format off
#include "V8ConstantSourceOptions.h"

#include "bindings/core/v8/ExceptionState.h"

namespace blink {

void V8ConstantSourceOptions::toImpl(v8::Isolate* isolate, v8::Local<v8::Value> v8Value, ConstantSourceOptions& impl, ExceptionState& exceptionState) {
  if (isUndefinedOrNull(v8Value)) {
    return;
  }
  if (!v8Value->IsObject()) {
    exceptionState.throwTypeError("cannot convert to dictionary.");
    return;
  }

  v8::TryCatch block(isolate);
  v8::Local<v8::Object> v8Object;
  if (!v8Call(v8Value->ToObject(isolate->GetCurrentContext()), v8Object, block)) {
    exceptionState.rethrowV8Exception(block.Exception());
    return;
  }
  v8::Local<v8::Value> offsetValue;
  if (!v8Object->Get(isolate->GetCurrentContext(), v8String(isolate, "offset")).ToLocal(&offsetValue)) {
    exceptionState.rethrowV8Exception(block.Exception());
    return;
  }
  if (offsetValue.IsEmpty() || offsetValue->IsUndefined()) {
    // Do nothing.
  } else {
    float offset = toRestrictedFloat(isolate, offsetValue, exceptionState);
    if (exceptionState.hadException())
      return;
    impl.setOffset(offset);
  }
}

v8::Local<v8::Value> ConstantSourceOptions::toV8Impl(v8::Local<v8::Object> creationContext, v8::Isolate* isolate) const {
  v8::Local<v8::Object> v8Object = v8::Object::New(isolate);
  if (!toV8ConstantSourceOptions(*this, v8Object, creationContext, isolate))
    return v8::Undefined(isolate);
  return v8Object;
}

bool toV8ConstantSourceOptions(const ConstantSourceOptions& impl, v8::Local<v8::Object> dictionary, v8::Local<v8::Object> creationContext, v8::Isolate* isolate) {
  if (impl.hasOffset()) {
    if (!v8CallBoolean(dictionary->CreateDataProperty(isolate->GetCurrentContext(), v8String(isolate, "offset"), v8::Number::New(isolate, impl.offset()))))
      return false;
  } else {
    if (!v8CallBoolean(dictionary->CreateDataProperty(isolate->GetCurrentContext(), v8String(isolate, "offset"), v8::Number::New(isolate, 1))))
      return false;
  }

  return true;
}

ConstantSourceOptions NativeValueTraits<ConstantSourceOptions>::nativeValue(v8::Isolate* isolate, v8::Local<v8::Value> value, ExceptionState& exceptionState) {
  ConstantSourceOptions impl;
  V8ConstantSourceOptions::toImpl(isolate, value, impl, exceptionState);
  return impl;
}

}  // namespace blink
