// Copyright 2014 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// This file has been auto-generated by code_generator_v8.py.
// DO NOT MODIFY!

// clang-format off
#include "V8ConstrainDoubleRange.h"

#include "bindings/core/v8/ExceptionState.h"
#include "bindings/modules/v8/V8DoubleRange.h"

namespace blink {

void V8ConstrainDoubleRange::toImpl(v8::Isolate* isolate, v8::Local<v8::Value> v8Value, ConstrainDoubleRange& impl, ExceptionState& exceptionState) {
  if (isUndefinedOrNull(v8Value)) {
    return;
  }
  if (!v8Value->IsObject()) {
    exceptionState.throwTypeError("cannot convert to dictionary.");
    return;
  }

  V8DoubleRange::toImpl(isolate, v8Value, impl, exceptionState);
  if (exceptionState.hadException())
    return;

  v8::TryCatch block(isolate);
  v8::Local<v8::Object> v8Object;
  if (!v8Call(v8Value->ToObject(isolate->GetCurrentContext()), v8Object, block)) {
    exceptionState.rethrowV8Exception(block.Exception());
    return;
  }
  v8::Local<v8::Value> exactValue;
  if (!v8Object->Get(isolate->GetCurrentContext(), v8String(isolate, "exact")).ToLocal(&exactValue)) {
    exceptionState.rethrowV8Exception(block.Exception());
    return;
  }
  if (exactValue.IsEmpty() || exactValue->IsUndefined()) {
    // Do nothing.
  } else {
    double exact = toRestrictedDouble(isolate, exactValue, exceptionState);
    if (exceptionState.hadException())
      return;
    impl.setExact(exact);
  }

  v8::Local<v8::Value> idealValue;
  if (!v8Object->Get(isolate->GetCurrentContext(), v8String(isolate, "ideal")).ToLocal(&idealValue)) {
    exceptionState.rethrowV8Exception(block.Exception());
    return;
  }
  if (idealValue.IsEmpty() || idealValue->IsUndefined()) {
    // Do nothing.
  } else {
    double ideal = toRestrictedDouble(isolate, idealValue, exceptionState);
    if (exceptionState.hadException())
      return;
    impl.setIdeal(ideal);
  }
}

v8::Local<v8::Value> ConstrainDoubleRange::toV8Impl(v8::Local<v8::Object> creationContext, v8::Isolate* isolate) const {
  v8::Local<v8::Object> v8Object = v8::Object::New(isolate);
  if (!toV8ConstrainDoubleRange(*this, v8Object, creationContext, isolate))
    return v8::Undefined(isolate);
  return v8Object;
}

bool toV8ConstrainDoubleRange(const ConstrainDoubleRange& impl, v8::Local<v8::Object> dictionary, v8::Local<v8::Object> creationContext, v8::Isolate* isolate) {
  if (!toV8DoubleRange(impl, dictionary, creationContext, isolate))
    return false;

  if (impl.hasExact()) {
    if (!v8CallBoolean(dictionary->CreateDataProperty(isolate->GetCurrentContext(), v8String(isolate, "exact"), v8::Number::New(isolate, impl.exact()))))
      return false;
  }

  if (impl.hasIdeal()) {
    if (!v8CallBoolean(dictionary->CreateDataProperty(isolate->GetCurrentContext(), v8String(isolate, "ideal"), v8::Number::New(isolate, impl.ideal()))))
      return false;
  }

  return true;
}

ConstrainDoubleRange NativeValueTraits<ConstrainDoubleRange>::nativeValue(v8::Isolate* isolate, v8::Local<v8::Value> value, ExceptionState& exceptionState) {
  ConstrainDoubleRange impl;
  V8ConstrainDoubleRange::toImpl(isolate, value, impl, exceptionState);
  return impl;
}

}  // namespace blink
