// Copyright 2014 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// This file has been auto-generated by code_generator_v8.py.
// DO NOT MODIFY!

// clang-format off
#include "V8DirectoryEntry.h"

#include "bindings/core/v8/ExceptionState.h"
#include "bindings/core/v8/GeneratedCodeHelper.h"
#include "bindings/core/v8/V8DOMConfiguration.h"
#include "bindings/core/v8/V8ObjectConstructor.h"
#include "bindings/core/v8/V8VoidCallback.h"
#include "bindings/modules/v8/V8DirectoryReader.h"
#include "bindings/modules/v8/V8EntryCallback.h"
#include "bindings/modules/v8/V8ErrorCallback.h"
#include "bindings/modules/v8/V8FileSystemFlags.h"
#include "core/dom/Document.h"
#include "wtf/GetPtr.h"
#include "wtf/RefPtr.h"

namespace blink {

// Suppress warning: global constructors, because struct WrapperTypeInfo is trivial
// and does not depend on another global objects.
#if defined(COMPONENT_BUILD) && defined(WIN32) && COMPILER(CLANG)
#pragma clang diagnostic push
#pragma clang diagnostic ignored "-Wglobal-constructors"
#endif
const WrapperTypeInfo V8DirectoryEntry::wrapperTypeInfo = { gin::kEmbedderBlink, V8DirectoryEntry::domTemplate, V8DirectoryEntry::trace, V8DirectoryEntry::traceWrappers, 0, nullptr, "DirectoryEntry", &V8Entry::wrapperTypeInfo, WrapperTypeInfo::WrapperTypeObjectPrototype, WrapperTypeInfo::ObjectClassId, WrapperTypeInfo::NotInheritFromActiveScriptWrappable, WrapperTypeInfo::NotInheritFromEventTarget, WrapperTypeInfo::Independent };
#if defined(COMPONENT_BUILD) && defined(WIN32) && COMPILER(CLANG)
#pragma clang diagnostic pop
#endif

// This static member must be declared by DEFINE_WRAPPERTYPEINFO in DirectoryEntry.h.
// For details, see the comment of DEFINE_WRAPPERTYPEINFO in
// bindings/core/v8/ScriptWrappable.h.
const WrapperTypeInfo& DirectoryEntry::s_wrapperTypeInfo = V8DirectoryEntry::wrapperTypeInfo;

// not [ActiveScriptWrappable]
static_assert(
    !std::is_base_of<ActiveScriptWrappable, DirectoryEntry>::value,
    "DirectoryEntry inherits from ActiveScriptWrappable, but is not specifying "
    "[ActiveScriptWrappable] extended attribute in the IDL file.  "
    "Be consistent.");
static_assert(
    std::is_same<decltype(&DirectoryEntry::hasPendingActivity),
                 decltype(&ScriptWrappable::hasPendingActivity)>::value,
    "DirectoryEntry is overriding hasPendingActivity(), but is not specifying "
    "[ActiveScriptWrappable] extended attribute in the IDL file.  "
    "Be consistent.");

namespace DirectoryEntryV8Internal {

static void createReaderMethod(const v8::FunctionCallbackInfo<v8::Value>& info) {
  DirectoryEntry* impl = V8DirectoryEntry::toImpl(info.Holder());

  v8SetReturnValue(info, impl->createReader());
}

void createReaderMethodCallback(const v8::FunctionCallbackInfo<v8::Value>& info) {
  DirectoryEntryV8Internal::createReaderMethod(info);
}

static void getFileMethod(const v8::FunctionCallbackInfo<v8::Value>& info) {
  ExceptionState exceptionState(info.GetIsolate(), ExceptionState::ExecutionContext, "DirectoryEntry", "getFile");

  DirectoryEntry* impl = V8DirectoryEntry::toImpl(info.Holder());

  if (UNLIKELY(info.Length() < 1)) {
    exceptionState.throwTypeError(ExceptionMessages::notEnoughArguments(1, info.Length()));
    return;
  }

  V8StringResource<TreatNullAndUndefinedAsNullString> path;
  FileSystemFlags options;
  EntryCallback* successCallback;
  ErrorCallback* errorCallback;
  path = info[0];
  if (!path.prepare())
    return;

  if (!isUndefinedOrNull(info[1]) && !info[1]->IsObject()) {
    exceptionState.throwTypeError("parameter 2 ('options') is not an object.");

    return;
  }
  V8FileSystemFlags::toImpl(info.GetIsolate(), info[1], options, exceptionState);
  if (exceptionState.hadException())
    return;

  if (!isUndefinedOrNull(info[2])) {
    if (!info[2]->IsFunction()) {
      exceptionState.throwTypeError("The callback provided as parameter 3 is not a function.");

      return;
    }
    successCallback = V8EntryCallback::create(v8::Local<v8::Function>::Cast(info[2]), ScriptState::current(info.GetIsolate()));
  } else {
    successCallback = nullptr;
  }

  if (!isUndefinedOrNull(info[3])) {
    if (!info[3]->IsFunction()) {
      exceptionState.throwTypeError("The callback provided as parameter 4 is not a function.");

      return;
    }
    errorCallback = V8ErrorCallback::create(v8::Local<v8::Function>::Cast(info[3]), ScriptState::current(info.GetIsolate()));
  } else {
    errorCallback = nullptr;
  }

  impl->getFile(path, options, successCallback, errorCallback);
}

void getFileMethodCallback(const v8::FunctionCallbackInfo<v8::Value>& info) {
  DirectoryEntryV8Internal::getFileMethod(info);
}

static void getDirectoryMethod(const v8::FunctionCallbackInfo<v8::Value>& info) {
  ExceptionState exceptionState(info.GetIsolate(), ExceptionState::ExecutionContext, "DirectoryEntry", "getDirectory");

  DirectoryEntry* impl = V8DirectoryEntry::toImpl(info.Holder());

  if (UNLIKELY(info.Length() < 1)) {
    exceptionState.throwTypeError(ExceptionMessages::notEnoughArguments(1, info.Length()));
    return;
  }

  V8StringResource<TreatNullAndUndefinedAsNullString> path;
  FileSystemFlags options;
  EntryCallback* successCallback;
  ErrorCallback* errorCallback;
  path = info[0];
  if (!path.prepare())
    return;

  if (!isUndefinedOrNull(info[1]) && !info[1]->IsObject()) {
    exceptionState.throwTypeError("parameter 2 ('options') is not an object.");

    return;
  }
  V8FileSystemFlags::toImpl(info.GetIsolate(), info[1], options, exceptionState);
  if (exceptionState.hadException())
    return;

  if (!isUndefinedOrNull(info[2])) {
    if (!info[2]->IsFunction()) {
      exceptionState.throwTypeError("The callback provided as parameter 3 is not a function.");

      return;
    }
    successCallback = V8EntryCallback::create(v8::Local<v8::Function>::Cast(info[2]), ScriptState::current(info.GetIsolate()));
  } else {
    successCallback = nullptr;
  }

  if (!isUndefinedOrNull(info[3])) {
    if (!info[3]->IsFunction()) {
      exceptionState.throwTypeError("The callback provided as parameter 4 is not a function.");

      return;
    }
    errorCallback = V8ErrorCallback::create(v8::Local<v8::Function>::Cast(info[3]), ScriptState::current(info.GetIsolate()));
  } else {
    errorCallback = nullptr;
  }

  impl->getDirectory(path, options, successCallback, errorCallback);
}

void getDirectoryMethodCallback(const v8::FunctionCallbackInfo<v8::Value>& info) {
  DirectoryEntryV8Internal::getDirectoryMethod(info);
}

static void removeRecursivelyMethod(const v8::FunctionCallbackInfo<v8::Value>& info) {
  DirectoryEntry* impl = V8DirectoryEntry::toImpl(info.Holder());

  if (UNLIKELY(info.Length() < 1)) {
    V8ThrowException::throwTypeError(info.GetIsolate(), ExceptionMessages::failedToExecute("removeRecursively", "DirectoryEntry", ExceptionMessages::notEnoughArguments(1, info.Length())));
    return;
  }

  VoidCallback* successCallback;
  ErrorCallback* errorCallback;
  if (info.Length() <= 0 || !info[0]->IsFunction()) {
    V8ThrowException::throwTypeError(info.GetIsolate(), ExceptionMessages::failedToExecute("removeRecursively", "DirectoryEntry", "The callback provided as parameter 1 is not a function."));

    return;
  }
  successCallback = V8VoidCallback::create(v8::Local<v8::Function>::Cast(info[0]), ScriptState::current(info.GetIsolate()));

  if (!isUndefinedOrNull(info[1])) {
    if (!info[1]->IsFunction()) {
      V8ThrowException::throwTypeError(info.GetIsolate(), ExceptionMessages::failedToExecute("removeRecursively", "DirectoryEntry", "The callback provided as parameter 2 is not a function."));

      return;
    }
    errorCallback = V8ErrorCallback::create(v8::Local<v8::Function>::Cast(info[1]), ScriptState::current(info.GetIsolate()));
  } else {
    errorCallback = nullptr;
  }

  impl->removeRecursively(successCallback, errorCallback);
}

void removeRecursivelyMethodCallback(const v8::FunctionCallbackInfo<v8::Value>& info) {
  DirectoryEntryV8Internal::removeRecursivelyMethod(info);
}

} // namespace DirectoryEntryV8Internal

const V8DOMConfiguration::MethodConfiguration V8DirectoryEntryMethods[] = {
    {"createReader", DirectoryEntryV8Internal::createReaderMethodCallback, 0, 0, v8::None, V8DOMConfiguration::ExposedToAllScripts, V8DOMConfiguration::OnPrototype, V8DOMConfiguration::CheckHolder},
    {"getFile", DirectoryEntryV8Internal::getFileMethodCallback, 0, 1, v8::None, V8DOMConfiguration::ExposedToAllScripts, V8DOMConfiguration::OnPrototype, V8DOMConfiguration::CheckHolder},
    {"getDirectory", DirectoryEntryV8Internal::getDirectoryMethodCallback, 0, 1, v8::None, V8DOMConfiguration::ExposedToAllScripts, V8DOMConfiguration::OnPrototype, V8DOMConfiguration::CheckHolder},
    {"removeRecursively", DirectoryEntryV8Internal::removeRecursivelyMethodCallback, 0, 1, v8::None, V8DOMConfiguration::ExposedToAllScripts, V8DOMConfiguration::OnPrototype, V8DOMConfiguration::CheckHolder},
};

static void installV8DirectoryEntryTemplate(v8::Isolate* isolate, const DOMWrapperWorld& world, v8::Local<v8::FunctionTemplate> interfaceTemplate) {
  // Initialize the interface object's template.
  V8DOMConfiguration::initializeDOMInterfaceTemplate(isolate, interfaceTemplate, V8DirectoryEntry::wrapperTypeInfo.interfaceName, V8Entry::domTemplate(isolate, world), V8DirectoryEntry::internalFieldCount);
  v8::Local<v8::Signature> signature = v8::Signature::New(isolate, interfaceTemplate);
  ALLOW_UNUSED_LOCAL(signature);
  v8::Local<v8::ObjectTemplate> instanceTemplate = interfaceTemplate->InstanceTemplate();
  ALLOW_UNUSED_LOCAL(instanceTemplate);
  v8::Local<v8::ObjectTemplate> prototypeTemplate = interfaceTemplate->PrototypeTemplate();
  ALLOW_UNUSED_LOCAL(prototypeTemplate);
  // Register DOM constants, attributes and operations.
  V8DOMConfiguration::installMethods(isolate, world, instanceTemplate, prototypeTemplate, interfaceTemplate, signature, V8DirectoryEntryMethods, WTF_ARRAY_LENGTH(V8DirectoryEntryMethods));
}

v8::Local<v8::FunctionTemplate> V8DirectoryEntry::domTemplate(v8::Isolate* isolate, const DOMWrapperWorld& world) {
  return V8DOMConfiguration::domClassTemplate(isolate, world, const_cast<WrapperTypeInfo*>(&wrapperTypeInfo), installV8DirectoryEntryTemplate);
}

bool V8DirectoryEntry::hasInstance(v8::Local<v8::Value> v8Value, v8::Isolate* isolate) {
  return V8PerIsolateData::from(isolate)->hasInstance(&wrapperTypeInfo, v8Value);
}

v8::Local<v8::Object> V8DirectoryEntry::findInstanceInPrototypeChain(v8::Local<v8::Value> v8Value, v8::Isolate* isolate) {
  return V8PerIsolateData::from(isolate)->findInstanceInPrototypeChain(&wrapperTypeInfo, v8Value);
}

DirectoryEntry* V8DirectoryEntry::toImplWithTypeCheck(v8::Isolate* isolate, v8::Local<v8::Value> value) {
  return hasInstance(value, isolate) ? toImpl(v8::Local<v8::Object>::Cast(value)) : nullptr;
}

}  // namespace blink
