// Copyright 2014 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// This file has been auto-generated by code_generator_v8.py.
// DO NOT MODIFY!

// clang-format off
#include "V8EXTDisjointTimerQuery.h"

#include "bindings/core/v8/ExceptionState.h"
#include "bindings/core/v8/GeneratedCodeHelper.h"
#include "bindings/core/v8/ScriptState.h"
#include "bindings/core/v8/ScriptValue.h"
#include "bindings/core/v8/V8DOMConfiguration.h"
#include "bindings/core/v8/V8GCController.h"
#include "bindings/core/v8/V8ObjectConstructor.h"
#include "bindings/modules/v8/V8WebGLTimerQueryEXT.h"
#include "core/dom/Document.h"
#include "core/dom/Element.h"
#include "wtf/GetPtr.h"
#include "wtf/RefPtr.h"

namespace blink {

// Suppress warning: global constructors, because struct WrapperTypeInfo is trivial
// and does not depend on another global objects.
#if defined(COMPONENT_BUILD) && defined(WIN32) && COMPILER(CLANG)
#pragma clang diagnostic push
#pragma clang diagnostic ignored "-Wglobal-constructors"
#endif
const WrapperTypeInfo V8EXTDisjointTimerQuery::wrapperTypeInfo = { gin::kEmbedderBlink, V8EXTDisjointTimerQuery::domTemplate, V8EXTDisjointTimerQuery::trace, V8EXTDisjointTimerQuery::traceWrappers, V8EXTDisjointTimerQuery::visitDOMWrapper, nullptr, "EXTDisjointTimerQuery", 0, WrapperTypeInfo::WrapperTypeObjectPrototype, WrapperTypeInfo::ObjectClassId, WrapperTypeInfo::NotInheritFromActiveScriptWrappable, WrapperTypeInfo::NotInheritFromEventTarget, WrapperTypeInfo::Dependent };
#if defined(COMPONENT_BUILD) && defined(WIN32) && COMPILER(CLANG)
#pragma clang diagnostic pop
#endif

// This static member must be declared by DEFINE_WRAPPERTYPEINFO in EXTDisjointTimerQuery.h.
// For details, see the comment of DEFINE_WRAPPERTYPEINFO in
// bindings/core/v8/ScriptWrappable.h.
const WrapperTypeInfo& EXTDisjointTimerQuery::s_wrapperTypeInfo = V8EXTDisjointTimerQuery::wrapperTypeInfo;

// not [ActiveScriptWrappable]
static_assert(
    !std::is_base_of<ActiveScriptWrappable, EXTDisjointTimerQuery>::value,
    "EXTDisjointTimerQuery inherits from ActiveScriptWrappable, but is not specifying "
    "[ActiveScriptWrappable] extended attribute in the IDL file.  "
    "Be consistent.");
static_assert(
    std::is_same<decltype(&EXTDisjointTimerQuery::hasPendingActivity),
                 decltype(&ScriptWrappable::hasPendingActivity)>::value,
    "EXTDisjointTimerQuery is overriding hasPendingActivity(), but is not specifying "
    "[ActiveScriptWrappable] extended attribute in the IDL file.  "
    "Be consistent.");

namespace EXTDisjointTimerQueryV8Internal {

static void createQueryEXTMethod(const v8::FunctionCallbackInfo<v8::Value>& info) {
  EXTDisjointTimerQuery* impl = V8EXTDisjointTimerQuery::toImpl(info.Holder());

  v8SetReturnValue(info, impl->createQueryEXT());
}

void createQueryEXTMethodCallback(const v8::FunctionCallbackInfo<v8::Value>& info) {
  EXTDisjointTimerQueryV8Internal::createQueryEXTMethod(info);
}

static void deleteQueryEXTMethod(const v8::FunctionCallbackInfo<v8::Value>& info) {
  EXTDisjointTimerQuery* impl = V8EXTDisjointTimerQuery::toImpl(info.Holder());

  if (UNLIKELY(info.Length() < 1)) {
    V8ThrowException::throwTypeError(info.GetIsolate(), ExceptionMessages::failedToExecute("deleteQueryEXT", "EXTDisjointTimerQuery", ExceptionMessages::notEnoughArguments(1, info.Length())));
    return;
  }

  WebGLTimerQueryEXT* query;
  query = V8WebGLTimerQueryEXT::toImplWithTypeCheck(info.GetIsolate(), info[0]);
  if (!query && !isUndefinedOrNull(info[0])) {
    V8ThrowException::throwTypeError(info.GetIsolate(), ExceptionMessages::failedToExecute("deleteQueryEXT", "EXTDisjointTimerQuery", "parameter 1 is not of type 'WebGLTimerQueryEXT'."));

    return;
  }

  impl->deleteQueryEXT(query);
}

void deleteQueryEXTMethodCallback(const v8::FunctionCallbackInfo<v8::Value>& info) {
  EXTDisjointTimerQueryV8Internal::deleteQueryEXTMethod(info);
}

static void isQueryEXTMethod(const v8::FunctionCallbackInfo<v8::Value>& info) {
  EXTDisjointTimerQuery* impl = V8EXTDisjointTimerQuery::toImpl(info.Holder());

  if (UNLIKELY(info.Length() < 1)) {
    V8ThrowException::throwTypeError(info.GetIsolate(), ExceptionMessages::failedToExecute("isQueryEXT", "EXTDisjointTimerQuery", ExceptionMessages::notEnoughArguments(1, info.Length())));
    return;
  }

  WebGLTimerQueryEXT* query;
  query = V8WebGLTimerQueryEXT::toImplWithTypeCheck(info.GetIsolate(), info[0]);
  if (!query && !isUndefinedOrNull(info[0])) {
    V8ThrowException::throwTypeError(info.GetIsolate(), ExceptionMessages::failedToExecute("isQueryEXT", "EXTDisjointTimerQuery", "parameter 1 is not of type 'WebGLTimerQueryEXT'."));

    return;
  }

  v8SetReturnValueBool(info, impl->isQueryEXT(query));
}

void isQueryEXTMethodCallback(const v8::FunctionCallbackInfo<v8::Value>& info) {
  EXTDisjointTimerQueryV8Internal::isQueryEXTMethod(info);
}

static void beginQueryEXTMethod(const v8::FunctionCallbackInfo<v8::Value>& info) {
  ExceptionState exceptionState(info.GetIsolate(), ExceptionState::ExecutionContext, "EXTDisjointTimerQuery", "beginQueryEXT");

  EXTDisjointTimerQuery* impl = V8EXTDisjointTimerQuery::toImpl(info.Holder());

  if (UNLIKELY(info.Length() < 2)) {
    exceptionState.throwTypeError(ExceptionMessages::notEnoughArguments(2, info.Length()));
    return;
  }

  unsigned target;
  WebGLTimerQueryEXT* query;
  target = toUInt32(info.GetIsolate(), info[0], NormalConversion, exceptionState);
  if (exceptionState.hadException())
    return;

  query = V8WebGLTimerQueryEXT::toImplWithTypeCheck(info.GetIsolate(), info[1]);
  if (!query) {
    exceptionState.throwTypeError("parameter 2 is not of type 'WebGLTimerQueryEXT'.");

    return;
  }

  impl->beginQueryEXT(target, query);
}

void beginQueryEXTMethodCallback(const v8::FunctionCallbackInfo<v8::Value>& info) {
  EXTDisjointTimerQueryV8Internal::beginQueryEXTMethod(info);
}

static void endQueryEXTMethod(const v8::FunctionCallbackInfo<v8::Value>& info) {
  ExceptionState exceptionState(info.GetIsolate(), ExceptionState::ExecutionContext, "EXTDisjointTimerQuery", "endQueryEXT");

  EXTDisjointTimerQuery* impl = V8EXTDisjointTimerQuery::toImpl(info.Holder());

  if (UNLIKELY(info.Length() < 1)) {
    exceptionState.throwTypeError(ExceptionMessages::notEnoughArguments(1, info.Length()));
    return;
  }

  unsigned target;
  target = toUInt32(info.GetIsolate(), info[0], NormalConversion, exceptionState);
  if (exceptionState.hadException())
    return;

  impl->endQueryEXT(target);
}

void endQueryEXTMethodCallback(const v8::FunctionCallbackInfo<v8::Value>& info) {
  EXTDisjointTimerQueryV8Internal::endQueryEXTMethod(info);
}

static void queryCounterEXTMethod(const v8::FunctionCallbackInfo<v8::Value>& info) {
  ExceptionState exceptionState(info.GetIsolate(), ExceptionState::ExecutionContext, "EXTDisjointTimerQuery", "queryCounterEXT");

  EXTDisjointTimerQuery* impl = V8EXTDisjointTimerQuery::toImpl(info.Holder());

  if (UNLIKELY(info.Length() < 2)) {
    exceptionState.throwTypeError(ExceptionMessages::notEnoughArguments(2, info.Length()));
    return;
  }

  WebGLTimerQueryEXT* query;
  unsigned target;
  query = V8WebGLTimerQueryEXT::toImplWithTypeCheck(info.GetIsolate(), info[0]);
  if (!query) {
    exceptionState.throwTypeError("parameter 1 is not of type 'WebGLTimerQueryEXT'.");

    return;
  }

  target = toUInt32(info.GetIsolate(), info[1], NormalConversion, exceptionState);
  if (exceptionState.hadException())
    return;

  impl->queryCounterEXT(query, target);
}

void queryCounterEXTMethodCallback(const v8::FunctionCallbackInfo<v8::Value>& info) {
  EXTDisjointTimerQueryV8Internal::queryCounterEXTMethod(info);
}

static void getQueryEXTMethod(const v8::FunctionCallbackInfo<v8::Value>& info) {
  ExceptionState exceptionState(info.GetIsolate(), ExceptionState::ExecutionContext, "EXTDisjointTimerQuery", "getQueryEXT");

  EXTDisjointTimerQuery* impl = V8EXTDisjointTimerQuery::toImpl(info.Holder());

  ScriptState* scriptState = ScriptState::forReceiverObject(info);

  if (UNLIKELY(info.Length() < 2)) {
    exceptionState.throwTypeError(ExceptionMessages::notEnoughArguments(2, info.Length()));
    return;
  }

  unsigned target;
  unsigned pname;
  target = toUInt32(info.GetIsolate(), info[0], NormalConversion, exceptionState);
  if (exceptionState.hadException())
    return;

  pname = toUInt32(info.GetIsolate(), info[1], NormalConversion, exceptionState);
  if (exceptionState.hadException())
    return;

  ScriptValue result = impl->getQueryEXT(scriptState, target, pname);
  v8SetReturnValue(info, result.v8Value());
}

void getQueryEXTMethodCallback(const v8::FunctionCallbackInfo<v8::Value>& info) {
  EXTDisjointTimerQueryV8Internal::getQueryEXTMethod(info);
}

static void getQueryObjectEXTMethod(const v8::FunctionCallbackInfo<v8::Value>& info) {
  ExceptionState exceptionState(info.GetIsolate(), ExceptionState::ExecutionContext, "EXTDisjointTimerQuery", "getQueryObjectEXT");

  EXTDisjointTimerQuery* impl = V8EXTDisjointTimerQuery::toImpl(info.Holder());

  ScriptState* scriptState = ScriptState::forReceiverObject(info);

  if (UNLIKELY(info.Length() < 2)) {
    exceptionState.throwTypeError(ExceptionMessages::notEnoughArguments(2, info.Length()));
    return;
  }

  WebGLTimerQueryEXT* query;
  unsigned pname;
  query = V8WebGLTimerQueryEXT::toImplWithTypeCheck(info.GetIsolate(), info[0]);
  if (!query) {
    exceptionState.throwTypeError("parameter 1 is not of type 'WebGLTimerQueryEXT'.");

    return;
  }

  pname = toUInt32(info.GetIsolate(), info[1], NormalConversion, exceptionState);
  if (exceptionState.hadException())
    return;

  ScriptValue result = impl->getQueryObjectEXT(scriptState, query, pname);
  v8SetReturnValue(info, result.v8Value());
}

void getQueryObjectEXTMethodCallback(const v8::FunctionCallbackInfo<v8::Value>& info) {
  EXTDisjointTimerQueryV8Internal::getQueryObjectEXTMethod(info);
}

} // namespace EXTDisjointTimerQueryV8Internal

void V8EXTDisjointTimerQuery::visitDOMWrapper(v8::Isolate* isolate, ScriptWrappable* scriptWrappable, const v8::Persistent<v8::Object>& wrapper) {
  EXTDisjointTimerQuery* impl = scriptWrappable->toImpl<EXTDisjointTimerQuery>();
  // The canvas() method may return a reference or a pointer.
  if (Node* owner = WTF::getPtr(impl->canvas())) {
    Node* root = V8GCController::opaqueRootForGC(isolate, owner);
    isolate->SetReferenceFromGroup(v8::UniqueId(reinterpret_cast<intptr_t>(root)), wrapper);
    return;
  }
}

const V8DOMConfiguration::MethodConfiguration V8EXTDisjointTimerQueryMethods[] = {
    {"createQueryEXT", EXTDisjointTimerQueryV8Internal::createQueryEXTMethodCallback, 0, 0, v8::None, V8DOMConfiguration::ExposedToAllScripts, V8DOMConfiguration::OnPrototype, V8DOMConfiguration::CheckHolder},
    {"deleteQueryEXT", EXTDisjointTimerQueryV8Internal::deleteQueryEXTMethodCallback, 0, 1, v8::None, V8DOMConfiguration::ExposedToAllScripts, V8DOMConfiguration::OnPrototype, V8DOMConfiguration::CheckHolder},
    {"isQueryEXT", EXTDisjointTimerQueryV8Internal::isQueryEXTMethodCallback, 0, 1, v8::None, V8DOMConfiguration::ExposedToAllScripts, V8DOMConfiguration::OnPrototype, V8DOMConfiguration::CheckHolder},
    {"beginQueryEXT", EXTDisjointTimerQueryV8Internal::beginQueryEXTMethodCallback, 0, 2, v8::None, V8DOMConfiguration::ExposedToAllScripts, V8DOMConfiguration::OnPrototype, V8DOMConfiguration::CheckHolder},
    {"endQueryEXT", EXTDisjointTimerQueryV8Internal::endQueryEXTMethodCallback, 0, 1, v8::None, V8DOMConfiguration::ExposedToAllScripts, V8DOMConfiguration::OnPrototype, V8DOMConfiguration::CheckHolder},
    {"queryCounterEXT", EXTDisjointTimerQueryV8Internal::queryCounterEXTMethodCallback, 0, 2, v8::None, V8DOMConfiguration::ExposedToAllScripts, V8DOMConfiguration::OnPrototype, V8DOMConfiguration::CheckHolder},
    {"getQueryEXT", EXTDisjointTimerQueryV8Internal::getQueryEXTMethodCallback, 0, 2, v8::None, V8DOMConfiguration::ExposedToAllScripts, V8DOMConfiguration::OnPrototype, V8DOMConfiguration::CheckHolder},
    {"getQueryObjectEXT", EXTDisjointTimerQueryV8Internal::getQueryObjectEXTMethodCallback, 0, 2, v8::None, V8DOMConfiguration::ExposedToAllScripts, V8DOMConfiguration::OnPrototype, V8DOMConfiguration::CheckHolder},
};

static void installV8EXTDisjointTimerQueryTemplate(v8::Isolate* isolate, const DOMWrapperWorld& world, v8::Local<v8::FunctionTemplate> interfaceTemplate) {
  // Initialize the interface object's template.
  V8DOMConfiguration::initializeDOMInterfaceTemplate(isolate, interfaceTemplate, V8EXTDisjointTimerQuery::wrapperTypeInfo.interfaceName, v8::Local<v8::FunctionTemplate>(), V8EXTDisjointTimerQuery::internalFieldCount);
  v8::Local<v8::Signature> signature = v8::Signature::New(isolate, interfaceTemplate);
  ALLOW_UNUSED_LOCAL(signature);
  v8::Local<v8::ObjectTemplate> instanceTemplate = interfaceTemplate->InstanceTemplate();
  ALLOW_UNUSED_LOCAL(instanceTemplate);
  v8::Local<v8::ObjectTemplate> prototypeTemplate = interfaceTemplate->PrototypeTemplate();
  ALLOW_UNUSED_LOCAL(prototypeTemplate);
  // Register DOM constants, attributes and operations.
  const V8DOMConfiguration::ConstantConfiguration V8EXTDisjointTimerQueryConstants[] = {
      {"QUERY_COUNTER_BITS_EXT", 0x8864, 0, V8DOMConfiguration::ConstantTypeUnsignedLong},
      {"CURRENT_QUERY_EXT", 0x8865, 0, V8DOMConfiguration::ConstantTypeUnsignedLong},
      {"QUERY_RESULT_EXT", 0x8866, 0, V8DOMConfiguration::ConstantTypeUnsignedLong},
      {"QUERY_RESULT_AVAILABLE_EXT", 0x8867, 0, V8DOMConfiguration::ConstantTypeUnsignedLong},
      {"TIME_ELAPSED_EXT", 0x88BF, 0, V8DOMConfiguration::ConstantTypeUnsignedLong},
      {"TIMESTAMP_EXT", 0x8E28, 0, V8DOMConfiguration::ConstantTypeUnsignedLong},
      {"GPU_DISJOINT_EXT", 0x8FBB, 0, V8DOMConfiguration::ConstantTypeUnsignedLong},
  };
  V8DOMConfiguration::installConstants(isolate, interfaceTemplate, prototypeTemplate, V8EXTDisjointTimerQueryConstants, WTF_ARRAY_LENGTH(V8EXTDisjointTimerQueryConstants));
  V8DOMConfiguration::installMethods(isolate, world, instanceTemplate, prototypeTemplate, interfaceTemplate, signature, V8EXTDisjointTimerQueryMethods, WTF_ARRAY_LENGTH(V8EXTDisjointTimerQueryMethods));
}

v8::Local<v8::FunctionTemplate> V8EXTDisjointTimerQuery::domTemplate(v8::Isolate* isolate, const DOMWrapperWorld& world) {
  return V8DOMConfiguration::domClassTemplate(isolate, world, const_cast<WrapperTypeInfo*>(&wrapperTypeInfo), installV8EXTDisjointTimerQueryTemplate);
}

bool V8EXTDisjointTimerQuery::hasInstance(v8::Local<v8::Value> v8Value, v8::Isolate* isolate) {
  return V8PerIsolateData::from(isolate)->hasInstance(&wrapperTypeInfo, v8Value);
}

v8::Local<v8::Object> V8EXTDisjointTimerQuery::findInstanceInPrototypeChain(v8::Local<v8::Value> v8Value, v8::Isolate* isolate) {
  return V8PerIsolateData::from(isolate)->findInstanceInPrototypeChain(&wrapperTypeInfo, v8Value);
}

EXTDisjointTimerQuery* V8EXTDisjointTimerQuery::toImplWithTypeCheck(v8::Isolate* isolate, v8::Local<v8::Value> value) {
  return hasInstance(value, isolate) ? toImpl(v8::Local<v8::Object>::Cast(value)) : nullptr;
}

}  // namespace blink
