// Copyright 2014 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// This file has been auto-generated by code_generator_v8.py.
// DO NOT MODIFY!

// clang-format off
#include "V8ForeignFetchOptions.h"

#include "bindings/core/v8/ExceptionState.h"

namespace blink {

void V8ForeignFetchOptions::toImpl(v8::Isolate* isolate, v8::Local<v8::Value> v8Value, ForeignFetchOptions& impl, ExceptionState& exceptionState) {
  if (isUndefinedOrNull(v8Value)) {
    exceptionState.throwTypeError("Missing required member(s): origins, scopes.");
    return;
  }
  if (!v8Value->IsObject()) {
    exceptionState.throwTypeError("cannot convert to dictionary.");
    return;
  }

  v8::TryCatch block(isolate);
  v8::Local<v8::Object> v8Object;
  if (!v8Call(v8Value->ToObject(isolate->GetCurrentContext()), v8Object, block)) {
    exceptionState.rethrowV8Exception(block.Exception());
    return;
  }
  v8::Local<v8::Value> originsValue;
  if (!v8Object->Get(isolate->GetCurrentContext(), v8String(isolate, "origins")).ToLocal(&originsValue)) {
    exceptionState.rethrowV8Exception(block.Exception());
    return;
  }
  if (originsValue.IsEmpty() || originsValue->IsUndefined()) {
    exceptionState.throwTypeError("required member origins is undefined.");
    return;
  } else {
    Vector<String> origins = toImplArray<Vector<String>>(originsValue, 0, isolate, exceptionState);
    if (exceptionState.hadException())
      return;
    impl.setOrigins(origins);
  }

  v8::Local<v8::Value> scopesValue;
  if (!v8Object->Get(isolate->GetCurrentContext(), v8String(isolate, "scopes")).ToLocal(&scopesValue)) {
    exceptionState.rethrowV8Exception(block.Exception());
    return;
  }
  if (scopesValue.IsEmpty() || scopesValue->IsUndefined()) {
    exceptionState.throwTypeError("required member scopes is undefined.");
    return;
  } else {
    Vector<String> scopes = toImplArray<Vector<String>>(scopesValue, 0, isolate, exceptionState);
    if (exceptionState.hadException())
      return;
    impl.setScopes(scopes);
  }
}

v8::Local<v8::Value> ForeignFetchOptions::toV8Impl(v8::Local<v8::Object> creationContext, v8::Isolate* isolate) const {
  v8::Local<v8::Object> v8Object = v8::Object::New(isolate);
  if (!toV8ForeignFetchOptions(*this, v8Object, creationContext, isolate))
    return v8::Undefined(isolate);
  return v8Object;
}

bool toV8ForeignFetchOptions(const ForeignFetchOptions& impl, v8::Local<v8::Object> dictionary, v8::Local<v8::Object> creationContext, v8::Isolate* isolate) {
  if (impl.hasOrigins()) {
    if (!v8CallBoolean(dictionary->CreateDataProperty(isolate->GetCurrentContext(), v8String(isolate, "origins"), toV8(impl.origins(), creationContext, isolate))))
      return false;
  } else {
    NOTREACHED();
  }

  if (impl.hasScopes()) {
    if (!v8CallBoolean(dictionary->CreateDataProperty(isolate->GetCurrentContext(), v8String(isolate, "scopes"), toV8(impl.scopes(), creationContext, isolate))))
      return false;
  } else {
    NOTREACHED();
  }

  return true;
}

ForeignFetchOptions NativeValueTraits<ForeignFetchOptions>::nativeValue(v8::Isolate* isolate, v8::Local<v8::Value> value, ExceptionState& exceptionState) {
  ForeignFetchOptions impl;
  V8ForeignFetchOptions::toImpl(isolate, value, impl, exceptionState);
  return impl;
}

}  // namespace blink
