// Copyright 2014 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// This file has been auto-generated by code_generator_v8.py.
// DO NOT MODIFY!

// clang-format off
#include "V8LongRange.h"

#include "bindings/core/v8/ExceptionState.h"

namespace blink {

void V8LongRange::toImpl(v8::Isolate* isolate, v8::Local<v8::Value> v8Value, LongRange& impl, ExceptionState& exceptionState) {
  if (isUndefinedOrNull(v8Value)) {
    return;
  }
  if (!v8Value->IsObject()) {
    exceptionState.throwTypeError("cannot convert to dictionary.");
    return;
  }

  v8::TryCatch block(isolate);
  v8::Local<v8::Object> v8Object;
  if (!v8Call(v8Value->ToObject(isolate->GetCurrentContext()), v8Object, block)) {
    exceptionState.rethrowV8Exception(block.Exception());
    return;
  }
  v8::Local<v8::Value> maxValue;
  if (!v8Object->Get(isolate->GetCurrentContext(), v8String(isolate, "max")).ToLocal(&maxValue)) {
    exceptionState.rethrowV8Exception(block.Exception());
    return;
  }
  if (maxValue.IsEmpty() || maxValue->IsUndefined()) {
    // Do nothing.
  } else {
    int max = toInt32(isolate, maxValue, NormalConversion, exceptionState);
    if (exceptionState.hadException())
      return;
    impl.setMax(max);
  }

  v8::Local<v8::Value> minValue;
  if (!v8Object->Get(isolate->GetCurrentContext(), v8String(isolate, "min")).ToLocal(&minValue)) {
    exceptionState.rethrowV8Exception(block.Exception());
    return;
  }
  if (minValue.IsEmpty() || minValue->IsUndefined()) {
    // Do nothing.
  } else {
    int min = toInt32(isolate, minValue, NormalConversion, exceptionState);
    if (exceptionState.hadException())
      return;
    impl.setMin(min);
  }
}

v8::Local<v8::Value> LongRange::toV8Impl(v8::Local<v8::Object> creationContext, v8::Isolate* isolate) const {
  v8::Local<v8::Object> v8Object = v8::Object::New(isolate);
  if (!toV8LongRange(*this, v8Object, creationContext, isolate))
    return v8::Undefined(isolate);
  return v8Object;
}

bool toV8LongRange(const LongRange& impl, v8::Local<v8::Object> dictionary, v8::Local<v8::Object> creationContext, v8::Isolate* isolate) {
  if (impl.hasMax()) {
    if (!v8CallBoolean(dictionary->CreateDataProperty(isolate->GetCurrentContext(), v8String(isolate, "max"), v8::Integer::New(isolate, impl.max()))))
      return false;
  }

  if (impl.hasMin()) {
    if (!v8CallBoolean(dictionary->CreateDataProperty(isolate->GetCurrentContext(), v8String(isolate, "min"), v8::Integer::New(isolate, impl.min()))))
      return false;
  }

  return true;
}

LongRange NativeValueTraits<LongRange>::nativeValue(v8::Isolate* isolate, v8::Local<v8::Value> value, ExceptionState& exceptionState) {
  LongRange impl;
  V8LongRange::toImpl(isolate, value, impl, exceptionState);
  return impl;
}

}  // namespace blink
