// Copyright 2014 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// This file has been auto-generated by code_generator_v8.py.
// DO NOT MODIFY!

// clang-format off
#include "V8MIDIConnectionEventInit.h"

#include "bindings/core/v8/ExceptionState.h"
#include "bindings/core/v8/V8EventInit.h"
#include "bindings/modules/v8/V8MIDIPort.h"

namespace blink {

void V8MIDIConnectionEventInit::toImpl(v8::Isolate* isolate, v8::Local<v8::Value> v8Value, MIDIConnectionEventInit& impl, ExceptionState& exceptionState) {
  if (isUndefinedOrNull(v8Value)) {
    return;
  }
  if (!v8Value->IsObject()) {
    exceptionState.throwTypeError("cannot convert to dictionary.");
    return;
  }

  V8EventInit::toImpl(isolate, v8Value, impl, exceptionState);
  if (exceptionState.hadException())
    return;

  v8::TryCatch block(isolate);
  v8::Local<v8::Object> v8Object;
  if (!v8Call(v8Value->ToObject(isolate->GetCurrentContext()), v8Object, block)) {
    exceptionState.rethrowV8Exception(block.Exception());
    return;
  }
  v8::Local<v8::Value> portValue;
  if (!v8Object->Get(isolate->GetCurrentContext(), v8String(isolate, "port")).ToLocal(&portValue)) {
    exceptionState.rethrowV8Exception(block.Exception());
    return;
  }
  if (portValue.IsEmpty() || portValue->IsUndefined()) {
    // Do nothing.
  } else if (portValue->IsNull()) {
    impl.setPortToNull();
  } else {
    MIDIPort* port = V8MIDIPort::toImplWithTypeCheck(isolate, portValue);
    if (!port) {
      exceptionState.throwTypeError("member port is not of type MIDIPort.");
      return;
    }
    impl.setPort(port);
  }
}

v8::Local<v8::Value> MIDIConnectionEventInit::toV8Impl(v8::Local<v8::Object> creationContext, v8::Isolate* isolate) const {
  v8::Local<v8::Object> v8Object = v8::Object::New(isolate);
  if (!toV8MIDIConnectionEventInit(*this, v8Object, creationContext, isolate))
    return v8::Undefined(isolate);
  return v8Object;
}

bool toV8MIDIConnectionEventInit(const MIDIConnectionEventInit& impl, v8::Local<v8::Object> dictionary, v8::Local<v8::Object> creationContext, v8::Isolate* isolate) {
  if (!toV8EventInit(impl, dictionary, creationContext, isolate))
    return false;

  if (impl.hasPort()) {
    if (!v8CallBoolean(dictionary->CreateDataProperty(isolate->GetCurrentContext(), v8String(isolate, "port"), toV8(impl.port(), creationContext, isolate))))
      return false;
  } else {
    if (!v8CallBoolean(dictionary->CreateDataProperty(isolate->GetCurrentContext(), v8String(isolate, "port"), v8::Null(isolate))))
      return false;
  }

  return true;
}

MIDIConnectionEventInit NativeValueTraits<MIDIConnectionEventInit>::nativeValue(v8::Isolate* isolate, v8::Local<v8::Value> value, ExceptionState& exceptionState) {
  MIDIConnectionEventInit impl;
  V8MIDIConnectionEventInit::toImpl(isolate, value, impl, exceptionState);
  return impl;
}

}  // namespace blink
