// Copyright 2014 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// This file has been auto-generated by code_generator_v8.py.
// DO NOT MODIFY!

// clang-format off
#include "V8MediaDeviceInfo.h"

#include "bindings/core/v8/ExceptionState.h"
#include "bindings/core/v8/GeneratedCodeHelper.h"
#include "bindings/core/v8/ScriptState.h"
#include "bindings/core/v8/ScriptValue.h"
#include "bindings/core/v8/V8DOMConfiguration.h"
#include "bindings/core/v8/V8ObjectConstructor.h"
#include "core/dom/Document.h"
#include "core/inspector/ConsoleMessage.h"
#include "wtf/GetPtr.h"
#include "wtf/RefPtr.h"

namespace blink {

// Suppress warning: global constructors, because struct WrapperTypeInfo is trivial
// and does not depend on another global objects.
#if defined(COMPONENT_BUILD) && defined(WIN32) && COMPILER(CLANG)
#pragma clang diagnostic push
#pragma clang diagnostic ignored "-Wglobal-constructors"
#endif
const WrapperTypeInfo V8MediaDeviceInfo::wrapperTypeInfo = { gin::kEmbedderBlink, V8MediaDeviceInfo::domTemplate, V8MediaDeviceInfo::trace, V8MediaDeviceInfo::traceWrappers, 0, nullptr, "MediaDeviceInfo", 0, WrapperTypeInfo::WrapperTypeObjectPrototype, WrapperTypeInfo::ObjectClassId, WrapperTypeInfo::NotInheritFromActiveScriptWrappable, WrapperTypeInfo::NotInheritFromEventTarget, WrapperTypeInfo::Independent };
#if defined(COMPONENT_BUILD) && defined(WIN32) && COMPILER(CLANG)
#pragma clang diagnostic pop
#endif

// This static member must be declared by DEFINE_WRAPPERTYPEINFO in MediaDeviceInfo.h.
// For details, see the comment of DEFINE_WRAPPERTYPEINFO in
// bindings/core/v8/ScriptWrappable.h.
const WrapperTypeInfo& MediaDeviceInfo::s_wrapperTypeInfo = V8MediaDeviceInfo::wrapperTypeInfo;

// not [ActiveScriptWrappable]
static_assert(
    !std::is_base_of<ActiveScriptWrappable, MediaDeviceInfo>::value,
    "MediaDeviceInfo inherits from ActiveScriptWrappable, but is not specifying "
    "[ActiveScriptWrappable] extended attribute in the IDL file.  "
    "Be consistent.");
static_assert(
    std::is_same<decltype(&MediaDeviceInfo::hasPendingActivity),
                 decltype(&ScriptWrappable::hasPendingActivity)>::value,
    "MediaDeviceInfo is overriding hasPendingActivity(), but is not specifying "
    "[ActiveScriptWrappable] extended attribute in the IDL file.  "
    "Be consistent.");

namespace MediaDeviceInfoV8Internal {

static void deviceIdAttributeGetter(const v8::FunctionCallbackInfo<v8::Value>& info) {
  v8::Local<v8::Object> holder = info.Holder();

  MediaDeviceInfo* impl = V8MediaDeviceInfo::toImpl(holder);

  v8SetReturnValueString(info, impl->deviceId(), info.GetIsolate());
}

void deviceIdAttributeGetterCallback(const v8::FunctionCallbackInfo<v8::Value>& info) {
  MediaDeviceInfoV8Internal::deviceIdAttributeGetter(info);
}

static void kindAttributeGetter(const v8::FunctionCallbackInfo<v8::Value>& info) {
  v8::Local<v8::Object> holder = info.Holder();

  MediaDeviceInfo* impl = V8MediaDeviceInfo::toImpl(holder);

  v8SetReturnValueString(info, impl->kind(), info.GetIsolate());
}

void kindAttributeGetterCallback(const v8::FunctionCallbackInfo<v8::Value>& info) {
  MediaDeviceInfoV8Internal::kindAttributeGetter(info);
}

static void labelAttributeGetter(const v8::FunctionCallbackInfo<v8::Value>& info) {
  v8::Local<v8::Object> holder = info.Holder();

  MediaDeviceInfo* impl = V8MediaDeviceInfo::toImpl(holder);

  v8SetReturnValueString(info, impl->label(), info.GetIsolate());
}

void labelAttributeGetterCallback(const v8::FunctionCallbackInfo<v8::Value>& info) {
  MediaDeviceInfoV8Internal::labelAttributeGetter(info);
}

static void groupIdAttributeGetter(const v8::FunctionCallbackInfo<v8::Value>& info) {
  v8::Local<v8::Object> holder = info.Holder();

  MediaDeviceInfo* impl = V8MediaDeviceInfo::toImpl(holder);

  v8SetReturnValueString(info, impl->groupId(), info.GetIsolate());
}

void groupIdAttributeGetterCallback(const v8::FunctionCallbackInfo<v8::Value>& info) {
  MediaDeviceInfoV8Internal::groupIdAttributeGetter(info);
}

static void toJSONMethod(const v8::FunctionCallbackInfo<v8::Value>& info) {
  MediaDeviceInfo* impl = V8MediaDeviceInfo::toImpl(info.Holder());

  ScriptState* scriptState = ScriptState::forReceiverObject(info);

  ScriptValue result = impl->toJSONForBinding(scriptState);
  v8SetReturnValue(info, result.v8Value());
}

void toJSONMethodCallback(const v8::FunctionCallbackInfo<v8::Value>& info) {
  MediaDeviceInfoV8Internal::toJSONMethod(info);
}

} // namespace MediaDeviceInfoV8Internal

const V8DOMConfiguration::AccessorConfiguration V8MediaDeviceInfoAccessors[] = {
    {"deviceId", MediaDeviceInfoV8Internal::deviceIdAttributeGetterCallback, 0, 0, 0, nullptr, 0, v8::DEFAULT, static_cast<v8::PropertyAttribute>(v8::ReadOnly), V8DOMConfiguration::ExposedToAllScripts, V8DOMConfiguration::OnPrototype, V8DOMConfiguration::CheckHolder},
    {"kind", MediaDeviceInfoV8Internal::kindAttributeGetterCallback, 0, 0, 0, nullptr, 0, v8::DEFAULT, static_cast<v8::PropertyAttribute>(v8::ReadOnly), V8DOMConfiguration::ExposedToAllScripts, V8DOMConfiguration::OnPrototype, V8DOMConfiguration::CheckHolder},
    {"label", MediaDeviceInfoV8Internal::labelAttributeGetterCallback, 0, 0, 0, nullptr, 0, v8::DEFAULT, static_cast<v8::PropertyAttribute>(v8::ReadOnly), V8DOMConfiguration::ExposedToAllScripts, V8DOMConfiguration::OnPrototype, V8DOMConfiguration::CheckHolder},
    {"groupId", MediaDeviceInfoV8Internal::groupIdAttributeGetterCallback, 0, 0, 0, nullptr, 0, v8::DEFAULT, static_cast<v8::PropertyAttribute>(v8::ReadOnly), V8DOMConfiguration::ExposedToAllScripts, V8DOMConfiguration::OnPrototype, V8DOMConfiguration::CheckHolder},
};

const V8DOMConfiguration::MethodConfiguration V8MediaDeviceInfoMethods[] = {
    {"toJSON", MediaDeviceInfoV8Internal::toJSONMethodCallback, 0, 0, v8::None, V8DOMConfiguration::ExposedToAllScripts, V8DOMConfiguration::OnPrototype, V8DOMConfiguration::CheckHolder},
};

static void installV8MediaDeviceInfoTemplate(v8::Isolate* isolate, const DOMWrapperWorld& world, v8::Local<v8::FunctionTemplate> interfaceTemplate) {
  // Initialize the interface object's template.
  V8DOMConfiguration::initializeDOMInterfaceTemplate(isolate, interfaceTemplate, V8MediaDeviceInfo::wrapperTypeInfo.interfaceName, v8::Local<v8::FunctionTemplate>(), V8MediaDeviceInfo::internalFieldCount);
  v8::Local<v8::Signature> signature = v8::Signature::New(isolate, interfaceTemplate);
  ALLOW_UNUSED_LOCAL(signature);
  v8::Local<v8::ObjectTemplate> instanceTemplate = interfaceTemplate->InstanceTemplate();
  ALLOW_UNUSED_LOCAL(instanceTemplate);
  v8::Local<v8::ObjectTemplate> prototypeTemplate = interfaceTemplate->PrototypeTemplate();
  ALLOW_UNUSED_LOCAL(prototypeTemplate);
  // Register DOM constants, attributes and operations.
  V8DOMConfiguration::installAccessors(isolate, world, instanceTemplate, prototypeTemplate, interfaceTemplate, signature, V8MediaDeviceInfoAccessors, WTF_ARRAY_LENGTH(V8MediaDeviceInfoAccessors));
  V8DOMConfiguration::installMethods(isolate, world, instanceTemplate, prototypeTemplate, interfaceTemplate, signature, V8MediaDeviceInfoMethods, WTF_ARRAY_LENGTH(V8MediaDeviceInfoMethods));
}

v8::Local<v8::FunctionTemplate> V8MediaDeviceInfo::domTemplate(v8::Isolate* isolate, const DOMWrapperWorld& world) {
  return V8DOMConfiguration::domClassTemplate(isolate, world, const_cast<WrapperTypeInfo*>(&wrapperTypeInfo), installV8MediaDeviceInfoTemplate);
}

bool V8MediaDeviceInfo::hasInstance(v8::Local<v8::Value> v8Value, v8::Isolate* isolate) {
  return V8PerIsolateData::from(isolate)->hasInstance(&wrapperTypeInfo, v8Value);
}

v8::Local<v8::Object> V8MediaDeviceInfo::findInstanceInPrototypeChain(v8::Local<v8::Value> v8Value, v8::Isolate* isolate) {
  return V8PerIsolateData::from(isolate)->findInstanceInPrototypeChain(&wrapperTypeInfo, v8Value);
}

MediaDeviceInfo* V8MediaDeviceInfo::toImplWithTypeCheck(v8::Isolate* isolate, v8::Local<v8::Value> value) {
  return hasInstance(value, isolate) ? toImpl(v8::Local<v8::Object>::Cast(value)) : nullptr;
}

}  // namespace blink
