// Copyright 2014 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// This file has been auto-generated by code_generator_v8.py.
// DO NOT MODIFY!

// clang-format off
#include "V8MediaStreamConstraints.h"

#include "bindings/core/v8/ExceptionState.h"
#include "bindings/modules/v8/BooleanOrMediaTrackConstraints.h"
#include "bindings/modules/v8/V8MediaTrackConstraints.h"

namespace blink {

void V8MediaStreamConstraints::toImpl(v8::Isolate* isolate, v8::Local<v8::Value> v8Value, MediaStreamConstraints& impl, ExceptionState& exceptionState) {
  if (isUndefinedOrNull(v8Value)) {
    return;
  }
  if (!v8Value->IsObject()) {
    exceptionState.throwTypeError("cannot convert to dictionary.");
    return;
  }

  v8::TryCatch block(isolate);
  v8::Local<v8::Object> v8Object;
  if (!v8Call(v8Value->ToObject(isolate->GetCurrentContext()), v8Object, block)) {
    exceptionState.rethrowV8Exception(block.Exception());
    return;
  }
  v8::Local<v8::Value> audioValue;
  if (!v8Object->Get(isolate->GetCurrentContext(), v8String(isolate, "audio")).ToLocal(&audioValue)) {
    exceptionState.rethrowV8Exception(block.Exception());
    return;
  }
  if (audioValue.IsEmpty() || audioValue->IsUndefined()) {
    // Do nothing.
  } else {
    BooleanOrMediaTrackConstraints audio;
    V8BooleanOrMediaTrackConstraints::toImpl(isolate, audioValue, audio, UnionTypeConversionMode::NotNullable, exceptionState);
    if (exceptionState.hadException())
      return;
    impl.setAudio(audio);
  }

  v8::Local<v8::Value> videoValue;
  if (!v8Object->Get(isolate->GetCurrentContext(), v8String(isolate, "video")).ToLocal(&videoValue)) {
    exceptionState.rethrowV8Exception(block.Exception());
    return;
  }
  if (videoValue.IsEmpty() || videoValue->IsUndefined()) {
    // Do nothing.
  } else {
    BooleanOrMediaTrackConstraints video;
    V8BooleanOrMediaTrackConstraints::toImpl(isolate, videoValue, video, UnionTypeConversionMode::NotNullable, exceptionState);
    if (exceptionState.hadException())
      return;
    impl.setVideo(video);
  }
}

v8::Local<v8::Value> MediaStreamConstraints::toV8Impl(v8::Local<v8::Object> creationContext, v8::Isolate* isolate) const {
  v8::Local<v8::Object> v8Object = v8::Object::New(isolate);
  if (!toV8MediaStreamConstraints(*this, v8Object, creationContext, isolate))
    return v8::Undefined(isolate);
  return v8Object;
}

bool toV8MediaStreamConstraints(const MediaStreamConstraints& impl, v8::Local<v8::Object> dictionary, v8::Local<v8::Object> creationContext, v8::Isolate* isolate) {
  if (impl.hasAudio()) {
    if (!v8CallBoolean(dictionary->CreateDataProperty(isolate->GetCurrentContext(), v8String(isolate, "audio"), toV8(impl.audio(), creationContext, isolate))))
      return false;
  } else {
    if (!v8CallBoolean(dictionary->CreateDataProperty(isolate->GetCurrentContext(), v8String(isolate, "audio"), toV8(BooleanOrMediaTrackConstraints::fromBoolean(false), creationContext, isolate))))
      return false;
  }

  if (impl.hasVideo()) {
    if (!v8CallBoolean(dictionary->CreateDataProperty(isolate->GetCurrentContext(), v8String(isolate, "video"), toV8(impl.video(), creationContext, isolate))))
      return false;
  } else {
    if (!v8CallBoolean(dictionary->CreateDataProperty(isolate->GetCurrentContext(), v8String(isolate, "video"), toV8(BooleanOrMediaTrackConstraints::fromBoolean(false), creationContext, isolate))))
      return false;
  }

  return true;
}

MediaStreamConstraints NativeValueTraits<MediaStreamConstraints>::nativeValue(v8::Isolate* isolate, v8::Local<v8::Value> value, ExceptionState& exceptionState) {
  MediaStreamConstraints impl;
  V8MediaStreamConstraints::toImpl(isolate, value, impl, exceptionState);
  return impl;
}

}  // namespace blink
