// Copyright 2014 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// This file has been auto-generated by code_generator_v8.py.
// DO NOT MODIFY!

// clang-format off
#include "V8NavigationPreloadState.h"

#include "bindings/core/v8/ExceptionState.h"

namespace blink {

void V8NavigationPreloadState::toImpl(v8::Isolate* isolate, v8::Local<v8::Value> v8Value, NavigationPreloadState& impl, ExceptionState& exceptionState) {
  if (isUndefinedOrNull(v8Value)) {
    return;
  }
  if (!v8Value->IsObject()) {
    exceptionState.throwTypeError("cannot convert to dictionary.");
    return;
  }

  v8::TryCatch block(isolate);
  v8::Local<v8::Object> v8Object;
  if (!v8Call(v8Value->ToObject(isolate->GetCurrentContext()), v8Object, block)) {
    exceptionState.rethrowV8Exception(block.Exception());
    return;
  }
  v8::Local<v8::Value> enabledValue;
  if (!v8Object->Get(isolate->GetCurrentContext(), v8String(isolate, "enabled")).ToLocal(&enabledValue)) {
    exceptionState.rethrowV8Exception(block.Exception());
    return;
  }
  if (enabledValue.IsEmpty() || enabledValue->IsUndefined()) {
    // Do nothing.
  } else {
    bool enabled = toBoolean(isolate, enabledValue, exceptionState);
    if (exceptionState.hadException())
      return;
    impl.setEnabled(enabled);
  }

  v8::Local<v8::Value> headerValueValue;
  if (!v8Object->Get(isolate->GetCurrentContext(), v8String(isolate, "headerValue")).ToLocal(&headerValueValue)) {
    exceptionState.rethrowV8Exception(block.Exception());
    return;
  }
  if (headerValueValue.IsEmpty() || headerValueValue->IsUndefined()) {
    // Do nothing.
  } else {
    V8StringResource<> headerValue = toByteString(isolate, headerValueValue, exceptionState);
    if (exceptionState.hadException())
      return;
    impl.setHeaderValue(headerValue);
  }
}

v8::Local<v8::Value> NavigationPreloadState::toV8Impl(v8::Local<v8::Object> creationContext, v8::Isolate* isolate) const {
  v8::Local<v8::Object> v8Object = v8::Object::New(isolate);
  if (!toV8NavigationPreloadState(*this, v8Object, creationContext, isolate))
    return v8::Undefined(isolate);
  return v8Object;
}

bool toV8NavigationPreloadState(const NavigationPreloadState& impl, v8::Local<v8::Object> dictionary, v8::Local<v8::Object> creationContext, v8::Isolate* isolate) {
  if (impl.hasEnabled()) {
    if (!v8CallBoolean(dictionary->CreateDataProperty(isolate->GetCurrentContext(), v8String(isolate, "enabled"), v8Boolean(impl.enabled(), isolate))))
      return false;
  } else {
    if (!v8CallBoolean(dictionary->CreateDataProperty(isolate->GetCurrentContext(), v8String(isolate, "enabled"), v8Boolean(false, isolate))))
      return false;
  }

  if (impl.hasHeaderValue()) {
    if (!v8CallBoolean(dictionary->CreateDataProperty(isolate->GetCurrentContext(), v8String(isolate, "headerValue"), v8String(isolate, impl.headerValue()))))
      return false;
  }

  return true;
}

NavigationPreloadState NativeValueTraits<NavigationPreloadState>::nativeValue(v8::Isolate* isolate, v8::Local<v8::Value> value, ExceptionState& exceptionState) {
  NavigationPreloadState impl;
  V8NavigationPreloadState::toImpl(isolate, value, impl, exceptionState);
  return impl;
}

}  // namespace blink
