// Copyright 2014 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// This file has been auto-generated by code_generator_v8.py.
// DO NOT MODIFY!

// clang-format off
#include "V8PaymentCurrencyAmount.h"

#include "bindings/core/v8/ExceptionState.h"

namespace blink {

void V8PaymentCurrencyAmount::toImpl(v8::Isolate* isolate, v8::Local<v8::Value> v8Value, PaymentCurrencyAmount& impl, ExceptionState& exceptionState) {
  if (isUndefinedOrNull(v8Value)) {
    exceptionState.throwTypeError("Missing required member(s): currency, value.");
    return;
  }
  if (!v8Value->IsObject()) {
    exceptionState.throwTypeError("cannot convert to dictionary.");
    return;
  }

  v8::TryCatch block(isolate);
  v8::Local<v8::Object> v8Object;
  if (!v8Call(v8Value->ToObject(isolate->GetCurrentContext()), v8Object, block)) {
    exceptionState.rethrowV8Exception(block.Exception());
    return;
  }
  v8::Local<v8::Value> currencyValue;
  if (!v8Object->Get(isolate->GetCurrentContext(), v8String(isolate, "currency")).ToLocal(&currencyValue)) {
    exceptionState.rethrowV8Exception(block.Exception());
    return;
  }
  if (currencyValue.IsEmpty() || currencyValue->IsUndefined()) {
    exceptionState.throwTypeError("required member currency is undefined.");
    return;
  } else {
    V8StringResource<> currency = currencyValue;
    if (!currency.prepare(exceptionState))
      return;
    impl.setCurrency(currency);
  }

  v8::Local<v8::Value> currencySystemValue;
  if (!v8Object->Get(isolate->GetCurrentContext(), v8String(isolate, "currencySystem")).ToLocal(&currencySystemValue)) {
    exceptionState.rethrowV8Exception(block.Exception());
    return;
  }
  if (currencySystemValue.IsEmpty() || currencySystemValue->IsUndefined()) {
    // Do nothing.
  } else {
    V8StringResource<> currencySystem = currencySystemValue;
    if (!currencySystem.prepare(exceptionState))
      return;
    impl.setCurrencySystem(currencySystem);
  }

  v8::Local<v8::Value> valueValue;
  if (!v8Object->Get(isolate->GetCurrentContext(), v8String(isolate, "value")).ToLocal(&valueValue)) {
    exceptionState.rethrowV8Exception(block.Exception());
    return;
  }
  if (valueValue.IsEmpty() || valueValue->IsUndefined()) {
    exceptionState.throwTypeError("required member value is undefined.");
    return;
  } else {
    V8StringResource<> value = valueValue;
    if (!value.prepare(exceptionState))
      return;
    impl.setValue(value);
  }
}

v8::Local<v8::Value> PaymentCurrencyAmount::toV8Impl(v8::Local<v8::Object> creationContext, v8::Isolate* isolate) const {
  v8::Local<v8::Object> v8Object = v8::Object::New(isolate);
  if (!toV8PaymentCurrencyAmount(*this, v8Object, creationContext, isolate))
    return v8::Undefined(isolate);
  return v8Object;
}

bool toV8PaymentCurrencyAmount(const PaymentCurrencyAmount& impl, v8::Local<v8::Object> dictionary, v8::Local<v8::Object> creationContext, v8::Isolate* isolate) {
  if (impl.hasCurrency()) {
    if (!v8CallBoolean(dictionary->CreateDataProperty(isolate->GetCurrentContext(), v8String(isolate, "currency"), v8String(isolate, impl.currency()))))
      return false;
  } else {
    NOTREACHED();
  }

  if (impl.hasCurrencySystem()) {
    if (!v8CallBoolean(dictionary->CreateDataProperty(isolate->GetCurrentContext(), v8String(isolate, "currencySystem"), v8String(isolate, impl.currencySystem()))))
      return false;
  } else {
    if (!v8CallBoolean(dictionary->CreateDataProperty(isolate->GetCurrentContext(), v8String(isolate, "currencySystem"), v8String(isolate, String("urn:iso:std:iso:4217")))))
      return false;
  }

  if (impl.hasValue()) {
    if (!v8CallBoolean(dictionary->CreateDataProperty(isolate->GetCurrentContext(), v8String(isolate, "value"), v8String(isolate, impl.value()))))
      return false;
  } else {
    NOTREACHED();
  }

  return true;
}

PaymentCurrencyAmount NativeValueTraits<PaymentCurrencyAmount>::nativeValue(v8::Isolate* isolate, v8::Local<v8::Value> value, ExceptionState& exceptionState) {
  PaymentCurrencyAmount impl;
  V8PaymentCurrencyAmount::toImpl(isolate, value, impl, exceptionState);
  return impl;
}

}  // namespace blink
