// Copyright 2014 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// This file has been auto-generated by code_generator_v8.py.
// DO NOT MODIFY!

// clang-format off
#include "V8PaymentMethodData.h"

#include "bindings/core/v8/ExceptionState.h"
#include "bindings/core/v8/ScriptValue.h"

namespace blink {

void V8PaymentMethodData::toImpl(v8::Isolate* isolate, v8::Local<v8::Value> v8Value, PaymentMethodData& impl, ExceptionState& exceptionState) {
  if (isUndefinedOrNull(v8Value)) {
    exceptionState.throwTypeError("Missing required member(s): supportedMethods.");
    return;
  }
  if (!v8Value->IsObject()) {
    exceptionState.throwTypeError("cannot convert to dictionary.");
    return;
  }

  v8::TryCatch block(isolate);
  v8::Local<v8::Object> v8Object;
  if (!v8Call(v8Value->ToObject(isolate->GetCurrentContext()), v8Object, block)) {
    exceptionState.rethrowV8Exception(block.Exception());
    return;
  }
  v8::Local<v8::Value> dataValue;
  if (!v8Object->Get(isolate->GetCurrentContext(), v8String(isolate, "data")).ToLocal(&dataValue)) {
    exceptionState.rethrowV8Exception(block.Exception());
    return;
  }
  if (dataValue.IsEmpty() || dataValue->IsUndefined()) {
    // Do nothing.
  } else {
    ScriptValue data = ScriptValue(ScriptState::current(isolate), dataValue);
    if (!data.isObject()) {
      exceptionState.throwTypeError("member data is not an object.");
      return;
    }
    impl.setData(data);
  }

  v8::Local<v8::Value> supportedMethodsValue;
  if (!v8Object->Get(isolate->GetCurrentContext(), v8String(isolate, "supportedMethods")).ToLocal(&supportedMethodsValue)) {
    exceptionState.rethrowV8Exception(block.Exception());
    return;
  }
  if (supportedMethodsValue.IsEmpty() || supportedMethodsValue->IsUndefined()) {
    exceptionState.throwTypeError("required member supportedMethods is undefined.");
    return;
  } else {
    Vector<String> supportedMethods = toImplArray<Vector<String>>(supportedMethodsValue, 0, isolate, exceptionState);
    if (exceptionState.hadException())
      return;
    impl.setSupportedMethods(supportedMethods);
  }
}

v8::Local<v8::Value> PaymentMethodData::toV8Impl(v8::Local<v8::Object> creationContext, v8::Isolate* isolate) const {
  v8::Local<v8::Object> v8Object = v8::Object::New(isolate);
  if (!toV8PaymentMethodData(*this, v8Object, creationContext, isolate))
    return v8::Undefined(isolate);
  return v8Object;
}

bool toV8PaymentMethodData(const PaymentMethodData& impl, v8::Local<v8::Object> dictionary, v8::Local<v8::Object> creationContext, v8::Isolate* isolate) {
  if (impl.hasData()) {
    DCHECK(impl.data().isObject());
    if (!v8CallBoolean(dictionary->CreateDataProperty(isolate->GetCurrentContext(), v8String(isolate, "data"), impl.data().v8Value())))
      return false;
  }

  if (impl.hasSupportedMethods()) {
    if (!v8CallBoolean(dictionary->CreateDataProperty(isolate->GetCurrentContext(), v8String(isolate, "supportedMethods"), toV8(impl.supportedMethods(), creationContext, isolate))))
      return false;
  } else {
    NOTREACHED();
  }

  return true;
}

PaymentMethodData NativeValueTraits<PaymentMethodData>::nativeValue(v8::Isolate* isolate, v8::Local<v8::Value> value, ExceptionState& exceptionState) {
  PaymentMethodData impl;
  V8PaymentMethodData::toImpl(isolate, value, impl, exceptionState);
  return impl;
}

}  // namespace blink
