// Copyright 2014 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// This file has been auto-generated by code_generator_v8.py.
// DO NOT MODIFY!

// clang-format off
#include "V8PeriodicWaveConstraints.h"

#include "bindings/core/v8/ExceptionState.h"

namespace blink {

void V8PeriodicWaveConstraints::toImpl(v8::Isolate* isolate, v8::Local<v8::Value> v8Value, PeriodicWaveConstraints& impl, ExceptionState& exceptionState) {
  if (isUndefinedOrNull(v8Value)) {
    return;
  }
  if (!v8Value->IsObject()) {
    exceptionState.throwTypeError("cannot convert to dictionary.");
    return;
  }

  v8::TryCatch block(isolate);
  v8::Local<v8::Object> v8Object;
  if (!v8Call(v8Value->ToObject(isolate->GetCurrentContext()), v8Object, block)) {
    exceptionState.rethrowV8Exception(block.Exception());
    return;
  }
  v8::Local<v8::Value> disableNormalizationValue;
  if (!v8Object->Get(isolate->GetCurrentContext(), v8String(isolate, "disableNormalization")).ToLocal(&disableNormalizationValue)) {
    exceptionState.rethrowV8Exception(block.Exception());
    return;
  }
  if (disableNormalizationValue.IsEmpty() || disableNormalizationValue->IsUndefined()) {
    // Do nothing.
  } else {
    bool disableNormalization = toBoolean(isolate, disableNormalizationValue, exceptionState);
    if (exceptionState.hadException())
      return;
    impl.setDisableNormalization(disableNormalization);
  }
}

v8::Local<v8::Value> PeriodicWaveConstraints::toV8Impl(v8::Local<v8::Object> creationContext, v8::Isolate* isolate) const {
  v8::Local<v8::Object> v8Object = v8::Object::New(isolate);
  if (!toV8PeriodicWaveConstraints(*this, v8Object, creationContext, isolate))
    return v8::Undefined(isolate);
  return v8Object;
}

bool toV8PeriodicWaveConstraints(const PeriodicWaveConstraints& impl, v8::Local<v8::Object> dictionary, v8::Local<v8::Object> creationContext, v8::Isolate* isolate) {
  if (impl.hasDisableNormalization()) {
    if (!v8CallBoolean(dictionary->CreateDataProperty(isolate->GetCurrentContext(), v8String(isolate, "disableNormalization"), v8Boolean(impl.disableNormalization(), isolate))))
      return false;
  }

  return true;
}

PeriodicWaveConstraints NativeValueTraits<PeriodicWaveConstraints>::nativeValue(v8::Isolate* isolate, v8::Local<v8::Value> value, ExceptionState& exceptionState) {
  PeriodicWaveConstraints impl;
  V8PeriodicWaveConstraints::toImpl(isolate, value, impl, exceptionState);
  return impl;
}

}  // namespace blink
