// Copyright 2014 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// This file has been auto-generated by code_generator_v8.py.
// DO NOT MODIFY!

// clang-format off
#include "V8RTCLegacyStatsReport.h"

#include "bindings/core/v8/ExceptionState.h"
#include "bindings/core/v8/GeneratedCodeHelper.h"
#include "bindings/core/v8/V8DOMConfiguration.h"
#include "bindings/core/v8/V8ObjectConstructor.h"
#include "core/dom/Document.h"
#include "wtf/GetPtr.h"
#include "wtf/RefPtr.h"

namespace blink {

// Suppress warning: global constructors, because struct WrapperTypeInfo is trivial
// and does not depend on another global objects.
#if defined(COMPONENT_BUILD) && defined(WIN32) && COMPILER(CLANG)
#pragma clang diagnostic push
#pragma clang diagnostic ignored "-Wglobal-constructors"
#endif
const WrapperTypeInfo V8RTCLegacyStatsReport::wrapperTypeInfo = { gin::kEmbedderBlink, V8RTCLegacyStatsReport::domTemplate, V8RTCLegacyStatsReport::trace, V8RTCLegacyStatsReport::traceWrappers, 0, nullptr, "RTCLegacyStatsReport", 0, WrapperTypeInfo::WrapperTypeObjectPrototype, WrapperTypeInfo::ObjectClassId, WrapperTypeInfo::NotInheritFromActiveScriptWrappable, WrapperTypeInfo::NotInheritFromEventTarget, WrapperTypeInfo::Independent };
#if defined(COMPONENT_BUILD) && defined(WIN32) && COMPILER(CLANG)
#pragma clang diagnostic pop
#endif

// This static member must be declared by DEFINE_WRAPPERTYPEINFO in RTCLegacyStatsReport.h.
// For details, see the comment of DEFINE_WRAPPERTYPEINFO in
// bindings/core/v8/ScriptWrappable.h.
const WrapperTypeInfo& RTCLegacyStatsReport::s_wrapperTypeInfo = V8RTCLegacyStatsReport::wrapperTypeInfo;

// not [ActiveScriptWrappable]
static_assert(
    !std::is_base_of<ActiveScriptWrappable, RTCLegacyStatsReport>::value,
    "RTCLegacyStatsReport inherits from ActiveScriptWrappable, but is not specifying "
    "[ActiveScriptWrappable] extended attribute in the IDL file.  "
    "Be consistent.");
static_assert(
    std::is_same<decltype(&RTCLegacyStatsReport::hasPendingActivity),
                 decltype(&ScriptWrappable::hasPendingActivity)>::value,
    "RTCLegacyStatsReport is overriding hasPendingActivity(), but is not specifying "
    "[ActiveScriptWrappable] extended attribute in the IDL file.  "
    "Be consistent.");

namespace RTCLegacyStatsReportV8Internal {

static void timestampAttributeGetter(const v8::FunctionCallbackInfo<v8::Value>& info) {
  v8::Local<v8::Object> holder = info.Holder();

  RTCLegacyStatsReport* impl = V8RTCLegacyStatsReport::toImpl(holder);

  v8SetReturnValue(info, v8DateOrNaN(info.GetIsolate(), impl->timestamp()));
}

void timestampAttributeGetterCallback(const v8::FunctionCallbackInfo<v8::Value>& info) {
  RTCLegacyStatsReportV8Internal::timestampAttributeGetter(info);
}

static void idAttributeGetter(const v8::FunctionCallbackInfo<v8::Value>& info) {
  v8::Local<v8::Object> holder = info.Holder();

  RTCLegacyStatsReport* impl = V8RTCLegacyStatsReport::toImpl(holder);

  v8SetReturnValueString(info, impl->id(), info.GetIsolate());
}

void idAttributeGetterCallback(const v8::FunctionCallbackInfo<v8::Value>& info) {
  RTCLegacyStatsReportV8Internal::idAttributeGetter(info);
}

static void typeAttributeGetter(const v8::FunctionCallbackInfo<v8::Value>& info) {
  v8::Local<v8::Object> holder = info.Holder();

  RTCLegacyStatsReport* impl = V8RTCLegacyStatsReport::toImpl(holder);

  v8SetReturnValueString(info, impl->type(), info.GetIsolate());
}

void typeAttributeGetterCallback(const v8::FunctionCallbackInfo<v8::Value>& info) {
  RTCLegacyStatsReportV8Internal::typeAttributeGetter(info);
}

static void statMethod(const v8::FunctionCallbackInfo<v8::Value>& info) {
  RTCLegacyStatsReport* impl = V8RTCLegacyStatsReport::toImpl(info.Holder());

  if (UNLIKELY(info.Length() < 1)) {
    V8ThrowException::throwTypeError(info.GetIsolate(), ExceptionMessages::failedToExecute("stat", "RTCLegacyStatsReport", ExceptionMessages::notEnoughArguments(1, info.Length())));
    return;
  }

  V8StringResource<> name;
  name = info[0];
  if (!name.prepare())
    return;

  v8SetReturnValueString(info, impl->stat(name), info.GetIsolate());
}

void statMethodCallback(const v8::FunctionCallbackInfo<v8::Value>& info) {
  RTCLegacyStatsReportV8Internal::statMethod(info);
}

static void namesMethod(const v8::FunctionCallbackInfo<v8::Value>& info) {
  RTCLegacyStatsReport* impl = V8RTCLegacyStatsReport::toImpl(info.Holder());

  v8SetReturnValue(info, toV8(impl->names(), info.Holder(), info.GetIsolate()));
}

void namesMethodCallback(const v8::FunctionCallbackInfo<v8::Value>& info) {
  RTCLegacyStatsReportV8Internal::namesMethod(info);
}

} // namespace RTCLegacyStatsReportV8Internal

const V8DOMConfiguration::AccessorConfiguration V8RTCLegacyStatsReportAccessors[] = {
    {"timestamp", RTCLegacyStatsReportV8Internal::timestampAttributeGetterCallback, 0, 0, 0, nullptr, 0, v8::DEFAULT, static_cast<v8::PropertyAttribute>(v8::ReadOnly), V8DOMConfiguration::ExposedToAllScripts, V8DOMConfiguration::OnPrototype, V8DOMConfiguration::CheckHolder},
    {"id", RTCLegacyStatsReportV8Internal::idAttributeGetterCallback, 0, 0, 0, nullptr, 0, v8::DEFAULT, static_cast<v8::PropertyAttribute>(v8::ReadOnly), V8DOMConfiguration::ExposedToAllScripts, V8DOMConfiguration::OnPrototype, V8DOMConfiguration::CheckHolder},
    {"type", RTCLegacyStatsReportV8Internal::typeAttributeGetterCallback, 0, 0, 0, nullptr, 0, v8::DEFAULT, static_cast<v8::PropertyAttribute>(v8::ReadOnly), V8DOMConfiguration::ExposedToAllScripts, V8DOMConfiguration::OnPrototype, V8DOMConfiguration::CheckHolder},
};

const V8DOMConfiguration::MethodConfiguration V8RTCLegacyStatsReportMethods[] = {
    {"stat", RTCLegacyStatsReportV8Internal::statMethodCallback, 0, 1, v8::None, V8DOMConfiguration::ExposedToAllScripts, V8DOMConfiguration::OnPrototype, V8DOMConfiguration::CheckHolder},
    {"names", RTCLegacyStatsReportV8Internal::namesMethodCallback, 0, 0, v8::None, V8DOMConfiguration::ExposedToAllScripts, V8DOMConfiguration::OnPrototype, V8DOMConfiguration::CheckHolder},
};

static void installV8RTCLegacyStatsReportTemplate(v8::Isolate* isolate, const DOMWrapperWorld& world, v8::Local<v8::FunctionTemplate> interfaceTemplate) {
  // Initialize the interface object's template.
  V8DOMConfiguration::initializeDOMInterfaceTemplate(isolate, interfaceTemplate, V8RTCLegacyStatsReport::wrapperTypeInfo.interfaceName, v8::Local<v8::FunctionTemplate>(), V8RTCLegacyStatsReport::internalFieldCount);
  v8::Local<v8::Signature> signature = v8::Signature::New(isolate, interfaceTemplate);
  ALLOW_UNUSED_LOCAL(signature);
  v8::Local<v8::ObjectTemplate> instanceTemplate = interfaceTemplate->InstanceTemplate();
  ALLOW_UNUSED_LOCAL(instanceTemplate);
  v8::Local<v8::ObjectTemplate> prototypeTemplate = interfaceTemplate->PrototypeTemplate();
  ALLOW_UNUSED_LOCAL(prototypeTemplate);
  // Register DOM constants, attributes and operations.
  V8DOMConfiguration::installAccessors(isolate, world, instanceTemplate, prototypeTemplate, interfaceTemplate, signature, V8RTCLegacyStatsReportAccessors, WTF_ARRAY_LENGTH(V8RTCLegacyStatsReportAccessors));
  V8DOMConfiguration::installMethods(isolate, world, instanceTemplate, prototypeTemplate, interfaceTemplate, signature, V8RTCLegacyStatsReportMethods, WTF_ARRAY_LENGTH(V8RTCLegacyStatsReportMethods));
}

v8::Local<v8::FunctionTemplate> V8RTCLegacyStatsReport::domTemplate(v8::Isolate* isolate, const DOMWrapperWorld& world) {
  return V8DOMConfiguration::domClassTemplate(isolate, world, const_cast<WrapperTypeInfo*>(&wrapperTypeInfo), installV8RTCLegacyStatsReportTemplate);
}

bool V8RTCLegacyStatsReport::hasInstance(v8::Local<v8::Value> v8Value, v8::Isolate* isolate) {
  return V8PerIsolateData::from(isolate)->hasInstance(&wrapperTypeInfo, v8Value);
}

v8::Local<v8::Object> V8RTCLegacyStatsReport::findInstanceInPrototypeChain(v8::Local<v8::Value> v8Value, v8::Isolate* isolate) {
  return V8PerIsolateData::from(isolate)->findInstanceInPrototypeChain(&wrapperTypeInfo, v8Value);
}

RTCLegacyStatsReport* V8RTCLegacyStatsReport::toImplWithTypeCheck(v8::Isolate* isolate, v8::Local<v8::Value> value) {
  return hasInstance(value, isolate) ? toImpl(v8::Local<v8::Object>::Cast(value)) : nullptr;
}

}  // namespace blink
