// Copyright 2014 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// This file has been auto-generated by code_generator_v8.py.
// DO NOT MODIFY!

// clang-format off
#include "V8RTCPeerConnectionIceEventInit.h"

#include "bindings/core/v8/ExceptionState.h"
#include "bindings/core/v8/V8EventInit.h"
#include "bindings/modules/v8/V8RTCIceCandidate.h"

namespace blink {

void V8RTCPeerConnectionIceEventInit::toImpl(v8::Isolate* isolate, v8::Local<v8::Value> v8Value, RTCPeerConnectionIceEventInit& impl, ExceptionState& exceptionState) {
  if (isUndefinedOrNull(v8Value)) {
    return;
  }
  if (!v8Value->IsObject()) {
    exceptionState.throwTypeError("cannot convert to dictionary.");
    return;
  }

  V8EventInit::toImpl(isolate, v8Value, impl, exceptionState);
  if (exceptionState.hadException())
    return;

  v8::TryCatch block(isolate);
  v8::Local<v8::Object> v8Object;
  if (!v8Call(v8Value->ToObject(isolate->GetCurrentContext()), v8Object, block)) {
    exceptionState.rethrowV8Exception(block.Exception());
    return;
  }
  v8::Local<v8::Value> candidateValue;
  if (!v8Object->Get(isolate->GetCurrentContext(), v8String(isolate, "candidate")).ToLocal(&candidateValue)) {
    exceptionState.rethrowV8Exception(block.Exception());
    return;
  }
  if (candidateValue.IsEmpty() || candidateValue->IsUndefined()) {
    // Do nothing.
  } else if (candidateValue->IsNull()) {
    impl.setCandidateToNull();
  } else {
    RTCIceCandidate* candidate = V8RTCIceCandidate::toImplWithTypeCheck(isolate, candidateValue);
    if (!candidate) {
      exceptionState.throwTypeError("member candidate is not of type RTCIceCandidate.");
      return;
    }
    impl.setCandidate(candidate);
  }
}

v8::Local<v8::Value> RTCPeerConnectionIceEventInit::toV8Impl(v8::Local<v8::Object> creationContext, v8::Isolate* isolate) const {
  v8::Local<v8::Object> v8Object = v8::Object::New(isolate);
  if (!toV8RTCPeerConnectionIceEventInit(*this, v8Object, creationContext, isolate))
    return v8::Undefined(isolate);
  return v8Object;
}

bool toV8RTCPeerConnectionIceEventInit(const RTCPeerConnectionIceEventInit& impl, v8::Local<v8::Object> dictionary, v8::Local<v8::Object> creationContext, v8::Isolate* isolate) {
  if (!toV8EventInit(impl, dictionary, creationContext, isolate))
    return false;

  if (impl.hasCandidate()) {
    if (!v8CallBoolean(dictionary->CreateDataProperty(isolate->GetCurrentContext(), v8String(isolate, "candidate"), toV8(impl.candidate(), creationContext, isolate))))
      return false;
  } else {
    if (!v8CallBoolean(dictionary->CreateDataProperty(isolate->GetCurrentContext(), v8String(isolate, "candidate"), v8::Null(isolate))))
      return false;
  }

  return true;
}

RTCPeerConnectionIceEventInit NativeValueTraits<RTCPeerConnectionIceEventInit>::nativeValue(v8::Isolate* isolate, v8::Local<v8::Value> value, ExceptionState& exceptionState) {
  RTCPeerConnectionIceEventInit impl;
  V8RTCPeerConnectionIceEventInit::toImpl(isolate, value, impl, exceptionState);
  return impl;
}

}  // namespace blink
