// Copyright 2014 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// This file has been auto-generated by code_generator_v8.py.
// DO NOT MODIFY!

// clang-format off
#include "V8SQLTransaction.h"

#include "bindings/core/v8/ExceptionState.h"
#include "bindings/core/v8/GeneratedCodeHelper.h"
#include "bindings/core/v8/ScriptState.h"
#include "bindings/core/v8/ScriptValue.h"
#include "bindings/core/v8/V8DOMConfiguration.h"
#include "bindings/core/v8/V8ObjectConstructor.h"
#include "bindings/modules/v8/V8SQLStatementCallback.h"
#include "bindings/modules/v8/V8SQLStatementErrorCallback.h"
#include "core/dom/Document.h"
#include "wtf/GetPtr.h"
#include "wtf/RefPtr.h"

namespace blink {

// Suppress warning: global constructors, because struct WrapperTypeInfo is trivial
// and does not depend on another global objects.
#if defined(COMPONENT_BUILD) && defined(WIN32) && COMPILER(CLANG)
#pragma clang diagnostic push
#pragma clang diagnostic ignored "-Wglobal-constructors"
#endif
const WrapperTypeInfo V8SQLTransaction::wrapperTypeInfo = { gin::kEmbedderBlink, V8SQLTransaction::domTemplate, V8SQLTransaction::trace, V8SQLTransaction::traceWrappers, 0, nullptr, "SQLTransaction", 0, WrapperTypeInfo::WrapperTypeObjectPrototype, WrapperTypeInfo::ObjectClassId, WrapperTypeInfo::NotInheritFromActiveScriptWrappable, WrapperTypeInfo::NotInheritFromEventTarget, WrapperTypeInfo::Independent };
#if defined(COMPONENT_BUILD) && defined(WIN32) && COMPILER(CLANG)
#pragma clang diagnostic pop
#endif

// This static member must be declared by DEFINE_WRAPPERTYPEINFO in SQLTransaction.h.
// For details, see the comment of DEFINE_WRAPPERTYPEINFO in
// bindings/core/v8/ScriptWrappable.h.
const WrapperTypeInfo& SQLTransaction::s_wrapperTypeInfo = V8SQLTransaction::wrapperTypeInfo;

// not [ActiveScriptWrappable]
static_assert(
    !std::is_base_of<ActiveScriptWrappable, SQLTransaction>::value,
    "SQLTransaction inherits from ActiveScriptWrappable, but is not specifying "
    "[ActiveScriptWrappable] extended attribute in the IDL file.  "
    "Be consistent.");
static_assert(
    std::is_same<decltype(&SQLTransaction::hasPendingActivity),
                 decltype(&ScriptWrappable::hasPendingActivity)>::value,
    "SQLTransaction is overriding hasPendingActivity(), but is not specifying "
    "[ActiveScriptWrappable] extended attribute in the IDL file.  "
    "Be consistent.");

namespace SQLTransactionV8Internal {

static void executeSqlMethod(const v8::FunctionCallbackInfo<v8::Value>& info) {
  ExceptionState exceptionState(info.GetIsolate(), ExceptionState::ExecutionContext, "SQLTransaction", "executeSql");

  SQLTransaction* impl = V8SQLTransaction::toImpl(info.Holder());

  ScriptState* scriptState = ScriptState::forReceiverObject(info);

  if (UNLIKELY(info.Length() < 1)) {
    exceptionState.throwTypeError(ExceptionMessages::notEnoughArguments(1, info.Length()));
    return;
  }

  V8StringResource<> sqlStatement;
  Nullable<Vector<ScriptValue>> arguments;
  SQLStatementCallback* callback;
  SQLStatementErrorCallback* errorCallback;
  int numArgsPassed = info.Length();
  while (numArgsPassed > 0) {
    if (!info[numArgsPassed - 1]->IsUndefined())
      break;
    --numArgsPassed;
  }
  sqlStatement = info[0];
  if (!sqlStatement.prepare())
    return;

  if (UNLIKELY(numArgsPassed <= 1)) {
    impl->executeSql(scriptState, sqlStatement, exceptionState);
    if (exceptionState.hadException()) {
      return;
    }
    return;
  }
  if (!isUndefinedOrNull(info[1])) {
    arguments = toImplArray<Vector<ScriptValue>>(info[1], 2, info.GetIsolate(), exceptionState);
    if (exceptionState.hadException())
      return;
  }

  if (!isUndefinedOrNull(info[2])) {
    if (!info[2]->IsFunction()) {
      exceptionState.throwTypeError("The callback provided as parameter 3 is not a function.");

      return;
    }
    callback = V8SQLStatementCallback::create(v8::Local<v8::Function>::Cast(info[2]), ScriptState::current(info.GetIsolate()));
  } else {
    callback = nullptr;
  }

  if (!isUndefinedOrNull(info[3])) {
    if (!info[3]->IsFunction()) {
      exceptionState.throwTypeError("The callback provided as parameter 4 is not a function.");

      return;
    }
    errorCallback = V8SQLStatementErrorCallback::create(v8::Local<v8::Function>::Cast(info[3]), ScriptState::current(info.GetIsolate()));
  } else {
    errorCallback = nullptr;
  }

  impl->executeSql(scriptState, sqlStatement, arguments, callback, errorCallback, exceptionState);
  if (exceptionState.hadException()) {
    return;
  }
}

void executeSqlMethodCallback(const v8::FunctionCallbackInfo<v8::Value>& info) {
  SQLTransactionV8Internal::executeSqlMethod(info);
}

} // namespace SQLTransactionV8Internal

const V8DOMConfiguration::MethodConfiguration V8SQLTransactionMethods[] = {
    {"executeSql", SQLTransactionV8Internal::executeSqlMethodCallback, 0, 1, v8::None, V8DOMConfiguration::ExposedToAllScripts, V8DOMConfiguration::OnPrototype, V8DOMConfiguration::CheckHolder},
};

static void installV8SQLTransactionTemplate(v8::Isolate* isolate, const DOMWrapperWorld& world, v8::Local<v8::FunctionTemplate> interfaceTemplate) {
  // Initialize the interface object's template.
  V8DOMConfiguration::initializeDOMInterfaceTemplate(isolate, interfaceTemplate, V8SQLTransaction::wrapperTypeInfo.interfaceName, v8::Local<v8::FunctionTemplate>(), V8SQLTransaction::internalFieldCount);
  v8::Local<v8::Signature> signature = v8::Signature::New(isolate, interfaceTemplate);
  ALLOW_UNUSED_LOCAL(signature);
  v8::Local<v8::ObjectTemplate> instanceTemplate = interfaceTemplate->InstanceTemplate();
  ALLOW_UNUSED_LOCAL(instanceTemplate);
  v8::Local<v8::ObjectTemplate> prototypeTemplate = interfaceTemplate->PrototypeTemplate();
  ALLOW_UNUSED_LOCAL(prototypeTemplate);
  // Register DOM constants, attributes and operations.
  V8DOMConfiguration::installMethods(isolate, world, instanceTemplate, prototypeTemplate, interfaceTemplate, signature, V8SQLTransactionMethods, WTF_ARRAY_LENGTH(V8SQLTransactionMethods));
}

v8::Local<v8::FunctionTemplate> V8SQLTransaction::domTemplate(v8::Isolate* isolate, const DOMWrapperWorld& world) {
  return V8DOMConfiguration::domClassTemplate(isolate, world, const_cast<WrapperTypeInfo*>(&wrapperTypeInfo), installV8SQLTransactionTemplate);
}

bool V8SQLTransaction::hasInstance(v8::Local<v8::Value> v8Value, v8::Isolate* isolate) {
  return V8PerIsolateData::from(isolate)->hasInstance(&wrapperTypeInfo, v8Value);
}

v8::Local<v8::Object> V8SQLTransaction::findInstanceInPrototypeChain(v8::Local<v8::Value> v8Value, v8::Isolate* isolate) {
  return V8PerIsolateData::from(isolate)->findInstanceInPrototypeChain(&wrapperTypeInfo, v8Value);
}

SQLTransaction* V8SQLTransaction::toImplWithTypeCheck(v8::Isolate* isolate, v8::Local<v8::Value> value) {
  return hasInstance(value, isolate) ? toImpl(v8::Local<v8::Object>::Cast(value)) : nullptr;
}

}  // namespace blink
