// Copyright 2014 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// This file has been auto-generated by code_generator_v8.py.
// DO NOT MODIFY!

// clang-format off
#include "V8SensorErrorEventInit.h"

#include "bindings/core/v8/ExceptionState.h"
#include "bindings/core/v8/V8DOMException.h"
#include "bindings/core/v8/V8EventInit.h"

namespace blink {

void V8SensorErrorEventInit::toImpl(v8::Isolate* isolate, v8::Local<v8::Value> v8Value, SensorErrorEventInit& impl, ExceptionState& exceptionState) {
  if (isUndefinedOrNull(v8Value)) {
    return;
  }
  if (!v8Value->IsObject()) {
    exceptionState.throwTypeError("cannot convert to dictionary.");
    return;
  }

  V8EventInit::toImpl(isolate, v8Value, impl, exceptionState);
  if (exceptionState.hadException())
    return;

  v8::TryCatch block(isolate);
  v8::Local<v8::Object> v8Object;
  if (!v8Call(v8Value->ToObject(isolate->GetCurrentContext()), v8Object, block)) {
    exceptionState.rethrowV8Exception(block.Exception());
    return;
  }
  v8::Local<v8::Value> errorValue;
  if (!v8Object->Get(isolate->GetCurrentContext(), v8String(isolate, "error")).ToLocal(&errorValue)) {
    exceptionState.rethrowV8Exception(block.Exception());
    return;
  }
  if (errorValue.IsEmpty() || errorValue->IsUndefined()) {
    // Do nothing.
  } else {
    DOMException* error = V8DOMException::toImplWithTypeCheck(isolate, errorValue);
    if (!error) {
      exceptionState.throwTypeError("member error is not of type DOMException.");
      return;
    }
    impl.setError(error);
  }
}

v8::Local<v8::Value> SensorErrorEventInit::toV8Impl(v8::Local<v8::Object> creationContext, v8::Isolate* isolate) const {
  v8::Local<v8::Object> v8Object = v8::Object::New(isolate);
  if (!toV8SensorErrorEventInit(*this, v8Object, creationContext, isolate))
    return v8::Undefined(isolate);
  return v8Object;
}

bool toV8SensorErrorEventInit(const SensorErrorEventInit& impl, v8::Local<v8::Object> dictionary, v8::Local<v8::Object> creationContext, v8::Isolate* isolate) {
  if (!toV8EventInit(impl, dictionary, creationContext, isolate))
    return false;

  if (impl.hasError()) {
    if (!v8CallBoolean(dictionary->CreateDataProperty(isolate->GetCurrentContext(), v8String(isolate, "error"), toV8(impl.error(), creationContext, isolate))))
      return false;
  }

  return true;
}

SensorErrorEventInit NativeValueTraits<SensorErrorEventInit>::nativeValue(v8::Isolate* isolate, v8::Local<v8::Value> value, ExceptionState& exceptionState) {
  SensorErrorEventInit impl;
  V8SensorErrorEventInit::toImpl(isolate, value, impl, exceptionState);
  return impl;
}

}  // namespace blink
