// Copyright 2014 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// This file has been auto-generated by code_generator_v8.py.
// DO NOT MODIFY!

// clang-format off
#include "V8TextDecoder.h"

#include "bindings/core/v8/ExceptionState.h"
#include "bindings/core/v8/GeneratedCodeHelper.h"
#include "bindings/core/v8/V8ArrayBuffer.h"
#include "bindings/core/v8/V8ArrayBufferView.h"
#include "bindings/core/v8/V8DOMConfiguration.h"
#include "bindings/core/v8/V8ObjectConstructor.h"
#include "bindings/modules/v8/V8TextDecodeOptions.h"
#include "bindings/modules/v8/V8TextDecoderOptions.h"
#include "core/dom/Document.h"
#include "core/dom/FlexibleArrayBufferView.h"
#include "core/frame/LocalDOMWindow.h"
#include "core/frame/UseCounter.h"
#include "wtf/GetPtr.h"
#include "wtf/RefPtr.h"

namespace blink {

// Suppress warning: global constructors, because struct WrapperTypeInfo is trivial
// and does not depend on another global objects.
#if defined(COMPONENT_BUILD) && defined(WIN32) && COMPILER(CLANG)
#pragma clang diagnostic push
#pragma clang diagnostic ignored "-Wglobal-constructors"
#endif
const WrapperTypeInfo V8TextDecoder::wrapperTypeInfo = { gin::kEmbedderBlink, V8TextDecoder::domTemplate, V8TextDecoder::trace, V8TextDecoder::traceWrappers, 0, nullptr, "TextDecoder", 0, WrapperTypeInfo::WrapperTypeObjectPrototype, WrapperTypeInfo::ObjectClassId, WrapperTypeInfo::NotInheritFromActiveScriptWrappable, WrapperTypeInfo::NotInheritFromEventTarget, WrapperTypeInfo::Independent };
#if defined(COMPONENT_BUILD) && defined(WIN32) && COMPILER(CLANG)
#pragma clang diagnostic pop
#endif

// This static member must be declared by DEFINE_WRAPPERTYPEINFO in TextDecoder.h.
// For details, see the comment of DEFINE_WRAPPERTYPEINFO in
// bindings/core/v8/ScriptWrappable.h.
const WrapperTypeInfo& TextDecoder::s_wrapperTypeInfo = V8TextDecoder::wrapperTypeInfo;

// not [ActiveScriptWrappable]
static_assert(
    !std::is_base_of<ActiveScriptWrappable, TextDecoder>::value,
    "TextDecoder inherits from ActiveScriptWrappable, but is not specifying "
    "[ActiveScriptWrappable] extended attribute in the IDL file.  "
    "Be consistent.");
static_assert(
    std::is_same<decltype(&TextDecoder::hasPendingActivity),
                 decltype(&ScriptWrappable::hasPendingActivity)>::value,
    "TextDecoder is overriding hasPendingActivity(), but is not specifying "
    "[ActiveScriptWrappable] extended attribute in the IDL file.  "
    "Be consistent.");

namespace TextDecoderV8Internal {

static void encodingAttributeGetter(const v8::FunctionCallbackInfo<v8::Value>& info) {
  v8::Local<v8::Object> holder = info.Holder();

  TextDecoder* impl = V8TextDecoder::toImpl(holder);

  v8SetReturnValueString(info, impl->encoding(), info.GetIsolate());
}

void encodingAttributeGetterCallback(const v8::FunctionCallbackInfo<v8::Value>& info) {
  TextDecoderV8Internal::encodingAttributeGetter(info);
}

static void fatalAttributeGetter(const v8::FunctionCallbackInfo<v8::Value>& info) {
  v8::Local<v8::Object> holder = info.Holder();

  TextDecoder* impl = V8TextDecoder::toImpl(holder);

  v8SetReturnValueBool(info, impl->fatal());
}

void fatalAttributeGetterCallback(const v8::FunctionCallbackInfo<v8::Value>& info) {
  TextDecoderV8Internal::fatalAttributeGetter(info);
}

static void ignoreBOMAttributeGetter(const v8::FunctionCallbackInfo<v8::Value>& info) {
  v8::Local<v8::Object> holder = info.Holder();

  TextDecoder* impl = V8TextDecoder::toImpl(holder);

  v8SetReturnValueBool(info, impl->ignoreBOM());
}

void ignoreBOMAttributeGetterCallback(const v8::FunctionCallbackInfo<v8::Value>& info) {
  TextDecoderV8Internal::ignoreBOMAttributeGetter(info);
}

static void decodeMethod(const v8::FunctionCallbackInfo<v8::Value>& info) {
  ExceptionState exceptionState(info.GetIsolate(), ExceptionState::ExecutionContext, "TextDecoder", "decode");

  TextDecoder* impl = V8TextDecoder::toImpl(info.Holder());

  ArrayBufferOrArrayBufferView input;
  TextDecodeOptions options;
  int numArgsPassed = info.Length();
  while (numArgsPassed > 0) {
    if (!info[numArgsPassed - 1]->IsUndefined())
      break;
    --numArgsPassed;
  }
  if (UNLIKELY(numArgsPassed <= 0)) {
    String result = impl->decode(exceptionState);
    if (exceptionState.hadException()) {
      return;
    }
    v8SetReturnValueString(info, result, info.GetIsolate());
    return;
  }
  V8ArrayBufferOrArrayBufferView::toImpl(info.GetIsolate(), info[0], input, UnionTypeConversionMode::NotNullable, exceptionState);
  if (exceptionState.hadException())
    return;

  if (!isUndefinedOrNull(info[1]) && !info[1]->IsObject()) {
    exceptionState.throwTypeError("parameter 2 ('options') is not an object.");

    return;
  }
  V8TextDecodeOptions::toImpl(info.GetIsolate(), info[1], options, exceptionState);
  if (exceptionState.hadException())
    return;

  String result = impl->decode(input, options, exceptionState);
  if (exceptionState.hadException()) {
    return;
  }
  v8SetReturnValueString(info, result, info.GetIsolate());
}

void decodeMethodCallback(const v8::FunctionCallbackInfo<v8::Value>& info) {
  UseCounter::countIfNotPrivateScript(info.GetIsolate(), currentExecutionContext(info.GetIsolate()), UseCounter::TextDecoderDecode);
  TextDecoderV8Internal::decodeMethod(info);
}

static void constructor(const v8::FunctionCallbackInfo<v8::Value>& info) {
  ExceptionState exceptionState(info.GetIsolate(), ExceptionState::ConstructionContext, "TextDecoder");

  V8StringResource<> label;
  TextDecoderOptions options;
  if (!info[0]->IsUndefined()) {
    label = info[0];
    if (!label.prepare())
      return;
  } else {
    label = String("utf-8");
  }
  if (!isUndefinedOrNull(info[1]) && !info[1]->IsObject()) {
    exceptionState.throwTypeError("parameter 2 ('options') is not an object.");

    return;
  }
  V8TextDecoderOptions::toImpl(info.GetIsolate(), info[1], options, exceptionState);
  if (exceptionState.hadException())
    return;

  TextDecoder* impl = TextDecoder::create(label, options, exceptionState);
  if (exceptionState.hadException()) {
    return;
  }
  v8::Local<v8::Object> wrapper = info.Holder();
  wrapper = impl->associateWithWrapper(info.GetIsolate(), &V8TextDecoder::wrapperTypeInfo, wrapper);
  v8SetReturnValue(info, wrapper);
}

} // namespace TextDecoderV8Internal

const V8DOMConfiguration::AccessorConfiguration V8TextDecoderAccessors[] = {
    {"encoding", TextDecoderV8Internal::encodingAttributeGetterCallback, 0, 0, 0, nullptr, 0, v8::DEFAULT, static_cast<v8::PropertyAttribute>(v8::ReadOnly), V8DOMConfiguration::ExposedToAllScripts, V8DOMConfiguration::OnPrototype, V8DOMConfiguration::CheckHolder},
    {"fatal", TextDecoderV8Internal::fatalAttributeGetterCallback, 0, 0, 0, nullptr, 0, v8::DEFAULT, static_cast<v8::PropertyAttribute>(v8::ReadOnly), V8DOMConfiguration::ExposedToAllScripts, V8DOMConfiguration::OnPrototype, V8DOMConfiguration::CheckHolder},
    {"ignoreBOM", TextDecoderV8Internal::ignoreBOMAttributeGetterCallback, 0, 0, 0, nullptr, 0, v8::DEFAULT, static_cast<v8::PropertyAttribute>(v8::ReadOnly), V8DOMConfiguration::ExposedToAllScripts, V8DOMConfiguration::OnPrototype, V8DOMConfiguration::CheckHolder},
};

const V8DOMConfiguration::MethodConfiguration V8TextDecoderMethods[] = {
    {"decode", TextDecoderV8Internal::decodeMethodCallback, 0, 0, v8::None, V8DOMConfiguration::ExposedToAllScripts, V8DOMConfiguration::OnPrototype, V8DOMConfiguration::CheckHolder},
};

void V8TextDecoder::constructorCallback(const v8::FunctionCallbackInfo<v8::Value>& info) {
  UseCounter::countIfNotPrivateScript(info.GetIsolate(), currentExecutionContext(info.GetIsolate()), UseCounter::TextDecoderConstructor);
  if (!info.IsConstructCall()) {
    V8ThrowException::throwTypeError(info.GetIsolate(), ExceptionMessages::constructorNotCallableAsFunction("TextDecoder"));
    return;
  }

  if (ConstructorMode::current(info.GetIsolate()) == ConstructorMode::WrapExistingObject) {
    v8SetReturnValue(info, info.Holder());
    return;
  }

  TextDecoderV8Internal::constructor(info);
}

static void installV8TextDecoderTemplate(v8::Isolate* isolate, const DOMWrapperWorld& world, v8::Local<v8::FunctionTemplate> interfaceTemplate) {
  // Initialize the interface object's template.
  V8DOMConfiguration::initializeDOMInterfaceTemplate(isolate, interfaceTemplate, V8TextDecoder::wrapperTypeInfo.interfaceName, v8::Local<v8::FunctionTemplate>(), V8TextDecoder::internalFieldCount);
  interfaceTemplate->SetCallHandler(V8TextDecoder::constructorCallback);
  interfaceTemplate->SetLength(0);
  v8::Local<v8::Signature> signature = v8::Signature::New(isolate, interfaceTemplate);
  ALLOW_UNUSED_LOCAL(signature);
  v8::Local<v8::ObjectTemplate> instanceTemplate = interfaceTemplate->InstanceTemplate();
  ALLOW_UNUSED_LOCAL(instanceTemplate);
  v8::Local<v8::ObjectTemplate> prototypeTemplate = interfaceTemplate->PrototypeTemplate();
  ALLOW_UNUSED_LOCAL(prototypeTemplate);
  // Register DOM constants, attributes and operations.
  V8DOMConfiguration::installAccessors(isolate, world, instanceTemplate, prototypeTemplate, interfaceTemplate, signature, V8TextDecoderAccessors, WTF_ARRAY_LENGTH(V8TextDecoderAccessors));
  V8DOMConfiguration::installMethods(isolate, world, instanceTemplate, prototypeTemplate, interfaceTemplate, signature, V8TextDecoderMethods, WTF_ARRAY_LENGTH(V8TextDecoderMethods));
}

v8::Local<v8::FunctionTemplate> V8TextDecoder::domTemplate(v8::Isolate* isolate, const DOMWrapperWorld& world) {
  return V8DOMConfiguration::domClassTemplate(isolate, world, const_cast<WrapperTypeInfo*>(&wrapperTypeInfo), installV8TextDecoderTemplate);
}

bool V8TextDecoder::hasInstance(v8::Local<v8::Value> v8Value, v8::Isolate* isolate) {
  return V8PerIsolateData::from(isolate)->hasInstance(&wrapperTypeInfo, v8Value);
}

v8::Local<v8::Object> V8TextDecoder::findInstanceInPrototypeChain(v8::Local<v8::Value> v8Value, v8::Isolate* isolate) {
  return V8PerIsolateData::from(isolate)->findInstanceInPrototypeChain(&wrapperTypeInfo, v8Value);
}

TextDecoder* V8TextDecoder::toImplWithTypeCheck(v8::Isolate* isolate, v8::Local<v8::Value> value) {
  return hasInstance(value, isolate) ? toImpl(v8::Local<v8::Object>::Cast(value)) : nullptr;
}

}  // namespace blink
