// Copyright 2014 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// This file has been auto-generated by code_generator_v8.py.
// DO NOT MODIFY!

// clang-format off
#include "V8USBDeviceRequestOptions.h"

#include "bindings/core/v8/ExceptionState.h"
#include "bindings/modules/v8/V8USBDeviceFilter.h"

namespace blink {

void V8USBDeviceRequestOptions::toImpl(v8::Isolate* isolate, v8::Local<v8::Value> v8Value, USBDeviceRequestOptions& impl, ExceptionState& exceptionState) {
  if (isUndefinedOrNull(v8Value)) {
    exceptionState.throwTypeError("Missing required member(s): filters.");
    return;
  }
  if (!v8Value->IsObject()) {
    exceptionState.throwTypeError("cannot convert to dictionary.");
    return;
  }

  v8::TryCatch block(isolate);
  v8::Local<v8::Object> v8Object;
  if (!v8Call(v8Value->ToObject(isolate->GetCurrentContext()), v8Object, block)) {
    exceptionState.rethrowV8Exception(block.Exception());
    return;
  }
  v8::Local<v8::Value> filtersValue;
  if (!v8Object->Get(isolate->GetCurrentContext(), v8String(isolate, "filters")).ToLocal(&filtersValue)) {
    exceptionState.rethrowV8Exception(block.Exception());
    return;
  }
  if (filtersValue.IsEmpty() || filtersValue->IsUndefined()) {
    exceptionState.throwTypeError("required member filters is undefined.");
    return;
  } else {
    HeapVector<USBDeviceFilter> filters = toImplArray<HeapVector<USBDeviceFilter>>(filtersValue, 0, isolate, exceptionState);
    if (exceptionState.hadException())
      return;
    impl.setFilters(filters);
  }
}

v8::Local<v8::Value> USBDeviceRequestOptions::toV8Impl(v8::Local<v8::Object> creationContext, v8::Isolate* isolate) const {
  v8::Local<v8::Object> v8Object = v8::Object::New(isolate);
  if (!toV8USBDeviceRequestOptions(*this, v8Object, creationContext, isolate))
    return v8::Undefined(isolate);
  return v8Object;
}

bool toV8USBDeviceRequestOptions(const USBDeviceRequestOptions& impl, v8::Local<v8::Object> dictionary, v8::Local<v8::Object> creationContext, v8::Isolate* isolate) {
  if (impl.hasFilters()) {
    if (!v8CallBoolean(dictionary->CreateDataProperty(isolate->GetCurrentContext(), v8String(isolate, "filters"), toV8(impl.filters(), creationContext, isolate))))
      return false;
  } else {
    NOTREACHED();
  }

  return true;
}

USBDeviceRequestOptions NativeValueTraits<USBDeviceRequestOptions>::nativeValue(v8::Isolate* isolate, v8::Local<v8::Value> value, ExceptionState& exceptionState) {
  USBDeviceRequestOptions impl;
  V8USBDeviceRequestOptions::toImpl(isolate, value, impl, exceptionState);
  return impl;
}

}  // namespace blink
