// Copyright 2014 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// This file has been auto-generated by code_generator_v8.py.
// DO NOT MODIFY!

// clang-format off
#include "V8VRDisplayCapabilities.h"

#include "bindings/core/v8/ExceptionState.h"
#include "bindings/core/v8/GeneratedCodeHelper.h"
#include "bindings/core/v8/V8DOMConfiguration.h"
#include "bindings/core/v8/V8ObjectConstructor.h"
#include "core/dom/Document.h"
#include "wtf/GetPtr.h"
#include "wtf/RefPtr.h"

namespace blink {

// Suppress warning: global constructors, because struct WrapperTypeInfo is trivial
// and does not depend on another global objects.
#if defined(COMPONENT_BUILD) && defined(WIN32) && COMPILER(CLANG)
#pragma clang diagnostic push
#pragma clang diagnostic ignored "-Wglobal-constructors"
#endif
const WrapperTypeInfo V8VRDisplayCapabilities::wrapperTypeInfo = { gin::kEmbedderBlink, V8VRDisplayCapabilities::domTemplate, V8VRDisplayCapabilities::trace, V8VRDisplayCapabilities::traceWrappers, 0, nullptr, "VRDisplayCapabilities", 0, WrapperTypeInfo::WrapperTypeObjectPrototype, WrapperTypeInfo::ObjectClassId, WrapperTypeInfo::NotInheritFromActiveScriptWrappable, WrapperTypeInfo::NotInheritFromEventTarget, WrapperTypeInfo::Independent };
#if defined(COMPONENT_BUILD) && defined(WIN32) && COMPILER(CLANG)
#pragma clang diagnostic pop
#endif

// This static member must be declared by DEFINE_WRAPPERTYPEINFO in VRDisplayCapabilities.h.
// For details, see the comment of DEFINE_WRAPPERTYPEINFO in
// bindings/core/v8/ScriptWrappable.h.
const WrapperTypeInfo& VRDisplayCapabilities::s_wrapperTypeInfo = V8VRDisplayCapabilities::wrapperTypeInfo;

// not [ActiveScriptWrappable]
static_assert(
    !std::is_base_of<ActiveScriptWrappable, VRDisplayCapabilities>::value,
    "VRDisplayCapabilities inherits from ActiveScriptWrappable, but is not specifying "
    "[ActiveScriptWrappable] extended attribute in the IDL file.  "
    "Be consistent.");
static_assert(
    std::is_same<decltype(&VRDisplayCapabilities::hasPendingActivity),
                 decltype(&ScriptWrappable::hasPendingActivity)>::value,
    "VRDisplayCapabilities is overriding hasPendingActivity(), but is not specifying "
    "[ActiveScriptWrappable] extended attribute in the IDL file.  "
    "Be consistent.");

namespace VRDisplayCapabilitiesV8Internal {

static void hasOrientationAttributeGetter(const v8::FunctionCallbackInfo<v8::Value>& info) {
  v8::Local<v8::Object> holder = info.Holder();

  VRDisplayCapabilities* impl = V8VRDisplayCapabilities::toImpl(holder);

  v8SetReturnValueBool(info, impl->hasOrientation());
}

void hasOrientationAttributeGetterCallback(const v8::FunctionCallbackInfo<v8::Value>& info) {
  VRDisplayCapabilitiesV8Internal::hasOrientationAttributeGetter(info);
}

static void hasPositionAttributeGetter(const v8::FunctionCallbackInfo<v8::Value>& info) {
  v8::Local<v8::Object> holder = info.Holder();

  VRDisplayCapabilities* impl = V8VRDisplayCapabilities::toImpl(holder);

  v8SetReturnValueBool(info, impl->hasPosition());
}

void hasPositionAttributeGetterCallback(const v8::FunctionCallbackInfo<v8::Value>& info) {
  VRDisplayCapabilitiesV8Internal::hasPositionAttributeGetter(info);
}

static void hasExternalDisplayAttributeGetter(const v8::FunctionCallbackInfo<v8::Value>& info) {
  v8::Local<v8::Object> holder = info.Holder();

  VRDisplayCapabilities* impl = V8VRDisplayCapabilities::toImpl(holder);

  v8SetReturnValueBool(info, impl->hasExternalDisplay());
}

void hasExternalDisplayAttributeGetterCallback(const v8::FunctionCallbackInfo<v8::Value>& info) {
  VRDisplayCapabilitiesV8Internal::hasExternalDisplayAttributeGetter(info);
}

static void canPresentAttributeGetter(const v8::FunctionCallbackInfo<v8::Value>& info) {
  v8::Local<v8::Object> holder = info.Holder();

  VRDisplayCapabilities* impl = V8VRDisplayCapabilities::toImpl(holder);

  v8SetReturnValueBool(info, impl->canPresent());
}

void canPresentAttributeGetterCallback(const v8::FunctionCallbackInfo<v8::Value>& info) {
  VRDisplayCapabilitiesV8Internal::canPresentAttributeGetter(info);
}

static void maxLayersAttributeGetter(const v8::FunctionCallbackInfo<v8::Value>& info) {
  v8::Local<v8::Object> holder = info.Holder();

  VRDisplayCapabilities* impl = V8VRDisplayCapabilities::toImpl(holder);

  v8SetReturnValueUnsigned(info, impl->maxLayers());
}

void maxLayersAttributeGetterCallback(const v8::FunctionCallbackInfo<v8::Value>& info) {
  VRDisplayCapabilitiesV8Internal::maxLayersAttributeGetter(info);
}

} // namespace VRDisplayCapabilitiesV8Internal

const V8DOMConfiguration::AccessorConfiguration V8VRDisplayCapabilitiesAccessors[] = {
    {"hasOrientation", VRDisplayCapabilitiesV8Internal::hasOrientationAttributeGetterCallback, 0, 0, 0, nullptr, 0, v8::DEFAULT, static_cast<v8::PropertyAttribute>(v8::ReadOnly), V8DOMConfiguration::ExposedToAllScripts, V8DOMConfiguration::OnPrototype, V8DOMConfiguration::CheckHolder},
    {"hasPosition", VRDisplayCapabilitiesV8Internal::hasPositionAttributeGetterCallback, 0, 0, 0, nullptr, 0, v8::DEFAULT, static_cast<v8::PropertyAttribute>(v8::ReadOnly), V8DOMConfiguration::ExposedToAllScripts, V8DOMConfiguration::OnPrototype, V8DOMConfiguration::CheckHolder},
    {"hasExternalDisplay", VRDisplayCapabilitiesV8Internal::hasExternalDisplayAttributeGetterCallback, 0, 0, 0, nullptr, 0, v8::DEFAULT, static_cast<v8::PropertyAttribute>(v8::ReadOnly), V8DOMConfiguration::ExposedToAllScripts, V8DOMConfiguration::OnPrototype, V8DOMConfiguration::CheckHolder},
    {"canPresent", VRDisplayCapabilitiesV8Internal::canPresentAttributeGetterCallback, 0, 0, 0, nullptr, 0, v8::DEFAULT, static_cast<v8::PropertyAttribute>(v8::ReadOnly), V8DOMConfiguration::ExposedToAllScripts, V8DOMConfiguration::OnPrototype, V8DOMConfiguration::CheckHolder},
    {"maxLayers", VRDisplayCapabilitiesV8Internal::maxLayersAttributeGetterCallback, 0, 0, 0, nullptr, 0, v8::DEFAULT, static_cast<v8::PropertyAttribute>(v8::ReadOnly), V8DOMConfiguration::ExposedToAllScripts, V8DOMConfiguration::OnPrototype, V8DOMConfiguration::CheckHolder},
};

static void installV8VRDisplayCapabilitiesTemplate(v8::Isolate* isolate, const DOMWrapperWorld& world, v8::Local<v8::FunctionTemplate> interfaceTemplate) {
  // Initialize the interface object's template.
  V8DOMConfiguration::initializeDOMInterfaceTemplate(isolate, interfaceTemplate, V8VRDisplayCapabilities::wrapperTypeInfo.interfaceName, v8::Local<v8::FunctionTemplate>(), V8VRDisplayCapabilities::internalFieldCount);
  v8::Local<v8::Signature> signature = v8::Signature::New(isolate, interfaceTemplate);
  ALLOW_UNUSED_LOCAL(signature);
  v8::Local<v8::ObjectTemplate> instanceTemplate = interfaceTemplate->InstanceTemplate();
  ALLOW_UNUSED_LOCAL(instanceTemplate);
  v8::Local<v8::ObjectTemplate> prototypeTemplate = interfaceTemplate->PrototypeTemplate();
  ALLOW_UNUSED_LOCAL(prototypeTemplate);
  // Register DOM constants, attributes and operations.
  V8DOMConfiguration::installAccessors(isolate, world, instanceTemplate, prototypeTemplate, interfaceTemplate, signature, V8VRDisplayCapabilitiesAccessors, WTF_ARRAY_LENGTH(V8VRDisplayCapabilitiesAccessors));
}

v8::Local<v8::FunctionTemplate> V8VRDisplayCapabilities::domTemplate(v8::Isolate* isolate, const DOMWrapperWorld& world) {
  return V8DOMConfiguration::domClassTemplate(isolate, world, const_cast<WrapperTypeInfo*>(&wrapperTypeInfo), installV8VRDisplayCapabilitiesTemplate);
}

bool V8VRDisplayCapabilities::hasInstance(v8::Local<v8::Value> v8Value, v8::Isolate* isolate) {
  return V8PerIsolateData::from(isolate)->hasInstance(&wrapperTypeInfo, v8Value);
}

v8::Local<v8::Object> V8VRDisplayCapabilities::findInstanceInPrototypeChain(v8::Local<v8::Value> v8Value, v8::Isolate* isolate) {
  return V8PerIsolateData::from(isolate)->findInstanceInPrototypeChain(&wrapperTypeInfo, v8Value);
}

VRDisplayCapabilities* V8VRDisplayCapabilities::toImplWithTypeCheck(v8::Isolate* isolate, v8::Local<v8::Value> value) {
  return hasInstance(value, isolate) ? toImpl(v8::Local<v8::Object>::Cast(value)) : nullptr;
}

}  // namespace blink
