// Copyright 2014 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// This file has been auto-generated by code_generator_v8.py.
// DO NOT MODIFY!

// clang-format off
#include "V8VRDisplayEventInit.h"

#include "bindings/core/v8/ExceptionState.h"
#include "bindings/core/v8/V8EventInit.h"
#include "bindings/modules/v8/V8VRDisplay.h"

namespace blink {

void V8VRDisplayEventInit::toImpl(v8::Isolate* isolate, v8::Local<v8::Value> v8Value, VRDisplayEventInit& impl, ExceptionState& exceptionState) {
  if (isUndefinedOrNull(v8Value)) {
    return;
  }
  if (!v8Value->IsObject()) {
    exceptionState.throwTypeError("cannot convert to dictionary.");
    return;
  }

  V8EventInit::toImpl(isolate, v8Value, impl, exceptionState);
  if (exceptionState.hadException())
    return;

  v8::TryCatch block(isolate);
  v8::Local<v8::Object> v8Object;
  if (!v8Call(v8Value->ToObject(isolate->GetCurrentContext()), v8Object, block)) {
    exceptionState.rethrowV8Exception(block.Exception());
    return;
  }
  v8::Local<v8::Value> displayValue;
  if (!v8Object->Get(isolate->GetCurrentContext(), v8String(isolate, "display")).ToLocal(&displayValue)) {
    exceptionState.rethrowV8Exception(block.Exception());
    return;
  }
  if (displayValue.IsEmpty() || displayValue->IsUndefined()) {
    // Do nothing.
  } else if (displayValue->IsNull()) {
    impl.setDisplayToNull();
  } else {
    VRDisplay* display = V8VRDisplay::toImplWithTypeCheck(isolate, displayValue);
    if (!display) {
      exceptionState.throwTypeError("member display is not of type VRDisplay.");
      return;
    }
    impl.setDisplay(display);
  }

  v8::Local<v8::Value> reasonValue;
  if (!v8Object->Get(isolate->GetCurrentContext(), v8String(isolate, "reason")).ToLocal(&reasonValue)) {
    exceptionState.rethrowV8Exception(block.Exception());
    return;
  }
  if (reasonValue.IsEmpty() || reasonValue->IsUndefined()) {
    // Do nothing.
  } else {
    V8StringResource<> reason = reasonValue;
    if (!reason.prepare(exceptionState))
      return;
    const char* validValues[] = {
        "connected",
        "disconnected",
        "navigation",
        "mounted",
        "unmounted",
    };
    if (!isValidEnum(reason, validValues, WTF_ARRAY_LENGTH(validValues), "VRDisplayEventReason", exceptionState))
      return;
    impl.setReason(reason);
  }
}

v8::Local<v8::Value> VRDisplayEventInit::toV8Impl(v8::Local<v8::Object> creationContext, v8::Isolate* isolate) const {
  v8::Local<v8::Object> v8Object = v8::Object::New(isolate);
  if (!toV8VRDisplayEventInit(*this, v8Object, creationContext, isolate))
    return v8::Undefined(isolate);
  return v8Object;
}

bool toV8VRDisplayEventInit(const VRDisplayEventInit& impl, v8::Local<v8::Object> dictionary, v8::Local<v8::Object> creationContext, v8::Isolate* isolate) {
  if (!toV8EventInit(impl, dictionary, creationContext, isolate))
    return false;

  if (impl.hasDisplay()) {
    if (!v8CallBoolean(dictionary->CreateDataProperty(isolate->GetCurrentContext(), v8String(isolate, "display"), toV8(impl.display(), creationContext, isolate))))
      return false;
  } else {
    if (!v8CallBoolean(dictionary->CreateDataProperty(isolate->GetCurrentContext(), v8String(isolate, "display"), v8::Null(isolate))))
      return false;
  }

  if (impl.hasReason()) {
    if (!v8CallBoolean(dictionary->CreateDataProperty(isolate->GetCurrentContext(), v8String(isolate, "reason"), v8String(isolate, impl.reason()))))
      return false;
  }

  return true;
}

VRDisplayEventInit NativeValueTraits<VRDisplayEventInit>::nativeValue(v8::Isolate* isolate, v8::Local<v8::Value> value, ExceptionState& exceptionState) {
  VRDisplayEventInit impl;
  V8VRDisplayEventInit::toImpl(isolate, value, impl, exceptionState);
  return impl;
}

}  // namespace blink
