// Copyright 2014 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// This file has been auto-generated by code_generator_v8.py.
// DO NOT MODIFY!

// clang-format off
#include "V8VideoPlaybackQuality.h"

#include "bindings/core/v8/ExceptionState.h"
#include "bindings/core/v8/GeneratedCodeHelper.h"
#include "bindings/core/v8/V8DOMConfiguration.h"
#include "bindings/core/v8/V8ObjectConstructor.h"
#include "core/dom/Document.h"
#include "platform/RuntimeEnabledFeatures.h"
#include "wtf/GetPtr.h"
#include "wtf/RefPtr.h"

namespace blink {

// Suppress warning: global constructors, because struct WrapperTypeInfo is trivial
// and does not depend on another global objects.
#if defined(COMPONENT_BUILD) && defined(WIN32) && COMPILER(CLANG)
#pragma clang diagnostic push
#pragma clang diagnostic ignored "-Wglobal-constructors"
#endif
const WrapperTypeInfo V8VideoPlaybackQuality::wrapperTypeInfo = { gin::kEmbedderBlink, V8VideoPlaybackQuality::domTemplate, V8VideoPlaybackQuality::trace, V8VideoPlaybackQuality::traceWrappers, 0, nullptr, "VideoPlaybackQuality", 0, WrapperTypeInfo::WrapperTypeObjectPrototype, WrapperTypeInfo::ObjectClassId, WrapperTypeInfo::NotInheritFromActiveScriptWrappable, WrapperTypeInfo::NotInheritFromEventTarget, WrapperTypeInfo::Independent };
#if defined(COMPONENT_BUILD) && defined(WIN32) && COMPILER(CLANG)
#pragma clang diagnostic pop
#endif

// This static member must be declared by DEFINE_WRAPPERTYPEINFO in VideoPlaybackQuality.h.
// For details, see the comment of DEFINE_WRAPPERTYPEINFO in
// bindings/core/v8/ScriptWrappable.h.
const WrapperTypeInfo& VideoPlaybackQuality::s_wrapperTypeInfo = V8VideoPlaybackQuality::wrapperTypeInfo;

// not [ActiveScriptWrappable]
static_assert(
    !std::is_base_of<ActiveScriptWrappable, VideoPlaybackQuality>::value,
    "VideoPlaybackQuality inherits from ActiveScriptWrappable, but is not specifying "
    "[ActiveScriptWrappable] extended attribute in the IDL file.  "
    "Be consistent.");
static_assert(
    std::is_same<decltype(&VideoPlaybackQuality::hasPendingActivity),
                 decltype(&ScriptWrappable::hasPendingActivity)>::value,
    "VideoPlaybackQuality is overriding hasPendingActivity(), but is not specifying "
    "[ActiveScriptWrappable] extended attribute in the IDL file.  "
    "Be consistent.");

namespace VideoPlaybackQualityV8Internal {

static void creationTimeAttributeGetter(const v8::FunctionCallbackInfo<v8::Value>& info) {
  v8::Local<v8::Object> holder = info.Holder();

  VideoPlaybackQuality* impl = V8VideoPlaybackQuality::toImpl(holder);

  v8SetReturnValue(info, impl->creationTime());
}

void creationTimeAttributeGetterCallback(const v8::FunctionCallbackInfo<v8::Value>& info) {
  VideoPlaybackQualityV8Internal::creationTimeAttributeGetter(info);
}

static void totalVideoFramesAttributeGetter(const v8::FunctionCallbackInfo<v8::Value>& info) {
  v8::Local<v8::Object> holder = info.Holder();

  VideoPlaybackQuality* impl = V8VideoPlaybackQuality::toImpl(holder);

  v8SetReturnValueUnsigned(info, impl->totalVideoFrames());
}

void totalVideoFramesAttributeGetterCallback(const v8::FunctionCallbackInfo<v8::Value>& info) {
  VideoPlaybackQualityV8Internal::totalVideoFramesAttributeGetter(info);
}

static void droppedVideoFramesAttributeGetter(const v8::FunctionCallbackInfo<v8::Value>& info) {
  v8::Local<v8::Object> holder = info.Holder();

  VideoPlaybackQuality* impl = V8VideoPlaybackQuality::toImpl(holder);

  v8SetReturnValueUnsigned(info, impl->droppedVideoFrames());
}

void droppedVideoFramesAttributeGetterCallback(const v8::FunctionCallbackInfo<v8::Value>& info) {
  VideoPlaybackQualityV8Internal::droppedVideoFramesAttributeGetter(info);
}

static void corruptedVideoFramesAttributeGetter(const v8::FunctionCallbackInfo<v8::Value>& info) {
  v8::Local<v8::Object> holder = info.Holder();

  VideoPlaybackQuality* impl = V8VideoPlaybackQuality::toImpl(holder);

  v8SetReturnValueUnsigned(info, impl->corruptedVideoFrames());
}

void corruptedVideoFramesAttributeGetterCallback(const v8::FunctionCallbackInfo<v8::Value>& info) {
  VideoPlaybackQualityV8Internal::corruptedVideoFramesAttributeGetter(info);
}

} // namespace VideoPlaybackQualityV8Internal

const V8DOMConfiguration::AccessorConfiguration V8VideoPlaybackQualityAccessors[] = {
    {"creationTime", VideoPlaybackQualityV8Internal::creationTimeAttributeGetterCallback, 0, 0, 0, nullptr, 0, v8::DEFAULT, static_cast<v8::PropertyAttribute>(v8::ReadOnly), V8DOMConfiguration::ExposedToAllScripts, V8DOMConfiguration::OnPrototype, V8DOMConfiguration::CheckHolder},
    {"totalVideoFrames", VideoPlaybackQualityV8Internal::totalVideoFramesAttributeGetterCallback, 0, 0, 0, nullptr, 0, v8::DEFAULT, static_cast<v8::PropertyAttribute>(v8::ReadOnly), V8DOMConfiguration::ExposedToAllScripts, V8DOMConfiguration::OnPrototype, V8DOMConfiguration::CheckHolder},
    {"droppedVideoFrames", VideoPlaybackQualityV8Internal::droppedVideoFramesAttributeGetterCallback, 0, 0, 0, nullptr, 0, v8::DEFAULT, static_cast<v8::PropertyAttribute>(v8::ReadOnly), V8DOMConfiguration::ExposedToAllScripts, V8DOMConfiguration::OnPrototype, V8DOMConfiguration::CheckHolder},
    {"corruptedVideoFrames", VideoPlaybackQualityV8Internal::corruptedVideoFramesAttributeGetterCallback, 0, 0, 0, nullptr, 0, v8::DEFAULT, static_cast<v8::PropertyAttribute>(v8::ReadOnly), V8DOMConfiguration::ExposedToAllScripts, V8DOMConfiguration::OnPrototype, V8DOMConfiguration::CheckHolder},
};

static void installV8VideoPlaybackQualityTemplate(v8::Isolate* isolate, const DOMWrapperWorld& world, v8::Local<v8::FunctionTemplate> interfaceTemplate) {
  // Initialize the interface object's template.
  V8DOMConfiguration::initializeDOMInterfaceTemplate(isolate, interfaceTemplate, V8VideoPlaybackQuality::wrapperTypeInfo.interfaceName, v8::Local<v8::FunctionTemplate>(), V8VideoPlaybackQuality::internalFieldCount);
  v8::Local<v8::Signature> signature = v8::Signature::New(isolate, interfaceTemplate);
  ALLOW_UNUSED_LOCAL(signature);
  v8::Local<v8::ObjectTemplate> instanceTemplate = interfaceTemplate->InstanceTemplate();
  ALLOW_UNUSED_LOCAL(instanceTemplate);
  v8::Local<v8::ObjectTemplate> prototypeTemplate = interfaceTemplate->PrototypeTemplate();
  ALLOW_UNUSED_LOCAL(prototypeTemplate);
  // Register DOM constants, attributes and operations.
  if (RuntimeEnabledFeatures::mediaSourceExperimentalEnabled()) {
      V8DOMConfiguration::installAccessors(isolate, world, instanceTemplate, prototypeTemplate, interfaceTemplate, signature, V8VideoPlaybackQualityAccessors, WTF_ARRAY_LENGTH(V8VideoPlaybackQualityAccessors));
  }
}

v8::Local<v8::FunctionTemplate> V8VideoPlaybackQuality::domTemplate(v8::Isolate* isolate, const DOMWrapperWorld& world) {
  return V8DOMConfiguration::domClassTemplate(isolate, world, const_cast<WrapperTypeInfo*>(&wrapperTypeInfo), installV8VideoPlaybackQualityTemplate);
}

bool V8VideoPlaybackQuality::hasInstance(v8::Local<v8::Value> v8Value, v8::Isolate* isolate) {
  return V8PerIsolateData::from(isolate)->hasInstance(&wrapperTypeInfo, v8Value);
}

v8::Local<v8::Object> V8VideoPlaybackQuality::findInstanceInPrototypeChain(v8::Local<v8::Value> v8Value, v8::Isolate* isolate) {
  return V8PerIsolateData::from(isolate)->findInstanceInPrototypeChain(&wrapperTypeInfo, v8Value);
}

VideoPlaybackQuality* V8VideoPlaybackQuality::toImplWithTypeCheck(v8::Isolate* isolate, v8::Local<v8::Value> value) {
  return hasInstance(value, isolate) ? toImpl(v8::Local<v8::Object>::Cast(value)) : nullptr;
}

}  // namespace blink
