// Copyright 2014 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// This file has been auto-generated by code_generator_v8.py.
// DO NOT MODIFY!

// clang-format off
#include "V8WebSocket.h"

#include "bindings/core/v8/ExceptionState.h"
#include "bindings/core/v8/GeneratedCodeHelper.h"
#include "bindings/core/v8/V8AbstractEventListener.h"
#include "bindings/core/v8/V8ArrayBuffer.h"
#include "bindings/core/v8/V8ArrayBufferView.h"
#include "bindings/core/v8/V8Blob.h"
#include "bindings/core/v8/V8DOMConfiguration.h"
#include "bindings/core/v8/V8EventListenerHelper.h"
#include "bindings/core/v8/V8ObjectConstructor.h"
#include "bindings/modules/v8/StringOrStringSequence.h"
#include "core/dom/Document.h"
#include "core/dom/FlexibleArrayBufferView.h"
#include "core/frame/LocalDOMWindow.h"
#include "core/inspector/ConsoleMessage.h"
#include "wtf/GetPtr.h"
#include "wtf/RefPtr.h"

namespace blink {

// Suppress warning: global constructors, because struct WrapperTypeInfo is trivial
// and does not depend on another global objects.
#if defined(COMPONENT_BUILD) && defined(WIN32) && COMPILER(CLANG)
#pragma clang diagnostic push
#pragma clang diagnostic ignored "-Wglobal-constructors"
#endif
const WrapperTypeInfo V8WebSocket::wrapperTypeInfo = { gin::kEmbedderBlink, V8WebSocket::domTemplate, V8WebSocket::trace, V8WebSocket::traceWrappers, 0, nullptr, "WebSocket", &V8EventTarget::wrapperTypeInfo, WrapperTypeInfo::WrapperTypeObjectPrototype, WrapperTypeInfo::ObjectClassId, WrapperTypeInfo::InheritFromActiveScriptWrappable, WrapperTypeInfo::InheritFromEventTarget, WrapperTypeInfo::Dependent };
#if defined(COMPONENT_BUILD) && defined(WIN32) && COMPILER(CLANG)
#pragma clang diagnostic pop
#endif

// This static member must be declared by DEFINE_WRAPPERTYPEINFO in DOMWebSocket.h.
// For details, see the comment of DEFINE_WRAPPERTYPEINFO in
// bindings/core/v8/ScriptWrappable.h.
const WrapperTypeInfo& DOMWebSocket::s_wrapperTypeInfo = V8WebSocket::wrapperTypeInfo;

// [ActiveScriptWrappable]
static_assert(
    std::is_base_of<ActiveScriptWrappable, DOMWebSocket>::value,
    "DOMWebSocket does not inherit from ActiveScriptWrappable, but specifying "
    "[ActiveScriptWrappable] extended attribute in the IDL file.  "
    "Be consistent.");
static_assert(
    !std::is_same<decltype(&DOMWebSocket::hasPendingActivity),
                  decltype(&ScriptWrappable::hasPendingActivity)>::value,
    "DOMWebSocket is not overriding hasPendingActivity(), but is specifying "
    "[ActiveScriptWrappable] extended attribute in the IDL file.  "
    "Be consistent.");

namespace DOMWebSocketV8Internal {

static void urlAttributeGetter(const v8::FunctionCallbackInfo<v8::Value>& info) {
  v8::Local<v8::Object> holder = info.Holder();

  DOMWebSocket* impl = V8WebSocket::toImpl(holder);

  v8SetReturnValueString(info, impl->url(), info.GetIsolate());
}

void urlAttributeGetterCallback(const v8::FunctionCallbackInfo<v8::Value>& info) {
  DOMWebSocketV8Internal::urlAttributeGetter(info);
}

static void readyStateAttributeGetter(const v8::FunctionCallbackInfo<v8::Value>& info) {
  v8::Local<v8::Object> holder = info.Holder();

  DOMWebSocket* impl = V8WebSocket::toImpl(holder);

  v8SetReturnValueUnsigned(info, impl->readyState());
}

void readyStateAttributeGetterCallback(const v8::FunctionCallbackInfo<v8::Value>& info) {
  DOMWebSocketV8Internal::readyStateAttributeGetter(info);
}

static void bufferedAmountAttributeGetter(const v8::FunctionCallbackInfo<v8::Value>& info) {
  v8::Local<v8::Object> holder = info.Holder();

  DOMWebSocket* impl = V8WebSocket::toImpl(holder);

  v8SetReturnValueUnsigned(info, impl->bufferedAmount());
}

void bufferedAmountAttributeGetterCallback(const v8::FunctionCallbackInfo<v8::Value>& info) {
  DOMWebSocketV8Internal::bufferedAmountAttributeGetter(info);
}

static void onopenAttributeGetter(const v8::FunctionCallbackInfo<v8::Value>& info) {
  v8::Local<v8::Object> holder = info.Holder();

  DOMWebSocket* impl = V8WebSocket::toImpl(holder);

  EventListener* cppValue(WTF::getPtr(impl->onopen()));

  v8SetReturnValue(info, cppValue ? V8AbstractEventListener::cast(cppValue)->getListenerOrNull(info.GetIsolate(), impl->getExecutionContext()) : v8::Null(info.GetIsolate()).As<v8::Value>());
}

void onopenAttributeGetterCallback(const v8::FunctionCallbackInfo<v8::Value>& info) {
  DOMWebSocketV8Internal::onopenAttributeGetter(info);
}

static void onopenAttributeSetter(v8::Local<v8::Value> v8Value, const v8::FunctionCallbackInfo<v8::Value>& info) {
  v8::Local<v8::Object> holder = info.Holder();
  DOMWebSocket* impl = V8WebSocket::toImpl(holder);

  // Prepare the value to be set.
  moveEventListenerToNewWrapper(info.GetIsolate(), holder, impl->onopen(), v8Value, V8WebSocket::eventListenerCacheIndex);

  impl->setOnopen(V8EventListenerHelper::getEventListener(ScriptState::forReceiverObject(info), v8Value, true, ListenerFindOrCreate));
}

void onopenAttributeSetterCallback(const v8::FunctionCallbackInfo<v8::Value>& info) {
  v8::Local<v8::Value> v8Value = info[0];

  DOMWebSocketV8Internal::onopenAttributeSetter(v8Value, info);
}

static void onerrorAttributeGetter(const v8::FunctionCallbackInfo<v8::Value>& info) {
  v8::Local<v8::Object> holder = info.Holder();

  DOMWebSocket* impl = V8WebSocket::toImpl(holder);

  EventListener* cppValue(WTF::getPtr(impl->onerror()));

  v8SetReturnValue(info, cppValue ? V8AbstractEventListener::cast(cppValue)->getListenerOrNull(info.GetIsolate(), impl->getExecutionContext()) : v8::Null(info.GetIsolate()).As<v8::Value>());
}

void onerrorAttributeGetterCallback(const v8::FunctionCallbackInfo<v8::Value>& info) {
  DOMWebSocketV8Internal::onerrorAttributeGetter(info);
}

static void onerrorAttributeSetter(v8::Local<v8::Value> v8Value, const v8::FunctionCallbackInfo<v8::Value>& info) {
  v8::Local<v8::Object> holder = info.Holder();
  DOMWebSocket* impl = V8WebSocket::toImpl(holder);

  // Prepare the value to be set.
  moveEventListenerToNewWrapper(info.GetIsolate(), holder, impl->onerror(), v8Value, V8WebSocket::eventListenerCacheIndex);

  impl->setOnerror(V8EventListenerHelper::getEventListener(ScriptState::forReceiverObject(info), v8Value, true, ListenerFindOrCreate));
}

void onerrorAttributeSetterCallback(const v8::FunctionCallbackInfo<v8::Value>& info) {
  v8::Local<v8::Value> v8Value = info[0];

  DOMWebSocketV8Internal::onerrorAttributeSetter(v8Value, info);
}

static void oncloseAttributeGetter(const v8::FunctionCallbackInfo<v8::Value>& info) {
  v8::Local<v8::Object> holder = info.Holder();

  DOMWebSocket* impl = V8WebSocket::toImpl(holder);

  EventListener* cppValue(WTF::getPtr(impl->onclose()));

  v8SetReturnValue(info, cppValue ? V8AbstractEventListener::cast(cppValue)->getListenerOrNull(info.GetIsolate(), impl->getExecutionContext()) : v8::Null(info.GetIsolate()).As<v8::Value>());
}

void oncloseAttributeGetterCallback(const v8::FunctionCallbackInfo<v8::Value>& info) {
  DOMWebSocketV8Internal::oncloseAttributeGetter(info);
}

static void oncloseAttributeSetter(v8::Local<v8::Value> v8Value, const v8::FunctionCallbackInfo<v8::Value>& info) {
  v8::Local<v8::Object> holder = info.Holder();
  DOMWebSocket* impl = V8WebSocket::toImpl(holder);

  // Prepare the value to be set.
  moveEventListenerToNewWrapper(info.GetIsolate(), holder, impl->onclose(), v8Value, V8WebSocket::eventListenerCacheIndex);

  impl->setOnclose(V8EventListenerHelper::getEventListener(ScriptState::forReceiverObject(info), v8Value, true, ListenerFindOrCreate));
}

void oncloseAttributeSetterCallback(const v8::FunctionCallbackInfo<v8::Value>& info) {
  v8::Local<v8::Value> v8Value = info[0];

  DOMWebSocketV8Internal::oncloseAttributeSetter(v8Value, info);
}

static void extensionsAttributeGetter(const v8::FunctionCallbackInfo<v8::Value>& info) {
  v8::Local<v8::Object> holder = info.Holder();

  DOMWebSocket* impl = V8WebSocket::toImpl(holder);

  v8SetReturnValueString(info, impl->extensions(), info.GetIsolate());
}

void extensionsAttributeGetterCallback(const v8::FunctionCallbackInfo<v8::Value>& info) {
  DOMWebSocketV8Internal::extensionsAttributeGetter(info);
}

static void protocolAttributeGetter(const v8::FunctionCallbackInfo<v8::Value>& info) {
  v8::Local<v8::Object> holder = info.Holder();

  DOMWebSocket* impl = V8WebSocket::toImpl(holder);

  v8SetReturnValueString(info, impl->protocol(), info.GetIsolate());
}

void protocolAttributeGetterCallback(const v8::FunctionCallbackInfo<v8::Value>& info) {
  DOMWebSocketV8Internal::protocolAttributeGetter(info);
}

static void onmessageAttributeGetter(const v8::FunctionCallbackInfo<v8::Value>& info) {
  v8::Local<v8::Object> holder = info.Holder();

  DOMWebSocket* impl = V8WebSocket::toImpl(holder);

  EventListener* cppValue(WTF::getPtr(impl->onmessage()));

  v8SetReturnValue(info, cppValue ? V8AbstractEventListener::cast(cppValue)->getListenerOrNull(info.GetIsolate(), impl->getExecutionContext()) : v8::Null(info.GetIsolate()).As<v8::Value>());
}

void onmessageAttributeGetterCallback(const v8::FunctionCallbackInfo<v8::Value>& info) {
  DOMWebSocketV8Internal::onmessageAttributeGetter(info);
}

static void onmessageAttributeSetter(v8::Local<v8::Value> v8Value, const v8::FunctionCallbackInfo<v8::Value>& info) {
  v8::Local<v8::Object> holder = info.Holder();
  DOMWebSocket* impl = V8WebSocket::toImpl(holder);

  // Prepare the value to be set.
  moveEventListenerToNewWrapper(info.GetIsolate(), holder, impl->onmessage(), v8Value, V8WebSocket::eventListenerCacheIndex);

  impl->setOnmessage(V8EventListenerHelper::getEventListener(ScriptState::forReceiverObject(info), v8Value, true, ListenerFindOrCreate));
}

void onmessageAttributeSetterCallback(const v8::FunctionCallbackInfo<v8::Value>& info) {
  v8::Local<v8::Value> v8Value = info[0];

  DOMWebSocketV8Internal::onmessageAttributeSetter(v8Value, info);
}

static void binaryTypeAttributeGetter(const v8::FunctionCallbackInfo<v8::Value>& info) {
  v8::Local<v8::Object> holder = info.Holder();

  DOMWebSocket* impl = V8WebSocket::toImpl(holder);

  v8SetReturnValueString(info, impl->binaryType(), info.GetIsolate());
}

void binaryTypeAttributeGetterCallback(const v8::FunctionCallbackInfo<v8::Value>& info) {
  DOMWebSocketV8Internal::binaryTypeAttributeGetter(info);
}

static void binaryTypeAttributeSetter(v8::Local<v8::Value> v8Value, const v8::FunctionCallbackInfo<v8::Value>& info) {
  v8::Local<v8::Object> holder = info.Holder();
  DOMWebSocket* impl = V8WebSocket::toImpl(holder);

  ExceptionState exceptionState(info.GetIsolate(), ExceptionState::SetterContext, "WebSocket", "binaryType");

  // Prepare the value to be set.
  V8StringResource<> cppValue = v8Value;
  if (!cppValue.prepare())
    return;

  // Type check per: http://heycam.github.io/webidl/#dfn-attribute-setter
  // Returns undefined without setting the value if the value is invalid.
  TrackExceptionState trackExceptionState;
  const char* validValues[] = {
      "blob",
      "arraybuffer",
  };
  if (!isValidEnum(cppValue, validValues, WTF_ARRAY_LENGTH(validValues), "BinaryType", trackExceptionState)) {
    currentExecutionContext(info.GetIsolate())->addConsoleMessage(ConsoleMessage::create(JSMessageSource, WarningMessageLevel, trackExceptionState.message()));
    return;
  }

  impl->setBinaryType(cppValue);
}

void binaryTypeAttributeSetterCallback(const v8::FunctionCallbackInfo<v8::Value>& info) {
  v8::Local<v8::Value> v8Value = info[0];

  DOMWebSocketV8Internal::binaryTypeAttributeSetter(v8Value, info);
}

static void closeMethod(const v8::FunctionCallbackInfo<v8::Value>& info) {
  ExceptionState exceptionState(info.GetIsolate(), ExceptionState::ExecutionContext, "WebSocket", "close");

  DOMWebSocket* impl = V8WebSocket::toImpl(info.Holder());

  unsigned code;
  V8StringResource<> reason;
  int numArgsPassed = info.Length();
  while (numArgsPassed > 0) {
    if (!info[numArgsPassed - 1]->IsUndefined())
      break;
    --numArgsPassed;
  }
  if (UNLIKELY(numArgsPassed <= 0)) {
    impl->close(exceptionState);
    if (exceptionState.hadException()) {
      return;
    }
    return;
  }
  code = toUInt16(info.GetIsolate(), info[0], Clamp, exceptionState);
  if (exceptionState.hadException())
    return;

  if (UNLIKELY(numArgsPassed <= 1)) {
    impl->close(code, exceptionState);
    if (exceptionState.hadException()) {
      return;
    }
    return;
  }
  reason = toUSVString(info.GetIsolate(), info[1], exceptionState);
  if (exceptionState.hadException())
    return;

  impl->close(code, reason, exceptionState);
  if (exceptionState.hadException()) {
    return;
  }
}

void closeMethodCallback(const v8::FunctionCallbackInfo<v8::Value>& info) {
  DOMWebSocketV8Internal::closeMethod(info);
}

static void send1Method(const v8::FunctionCallbackInfo<v8::Value>& info) {
  ExceptionState exceptionState(info.GetIsolate(), ExceptionState::ExecutionContext, "WebSocket", "send");

  DOMWebSocket* impl = V8WebSocket::toImpl(info.Holder());

  V8StringResource<> data;
  data = toUSVString(info.GetIsolate(), info[0], exceptionState);
  if (exceptionState.hadException())
    return;

  impl->send(data, exceptionState);
  if (exceptionState.hadException()) {
    return;
  }
}

static void send2Method(const v8::FunctionCallbackInfo<v8::Value>& info) {
  ExceptionState exceptionState(info.GetIsolate(), ExceptionState::ExecutionContext, "WebSocket", "send");

  DOMWebSocket* impl = V8WebSocket::toImpl(info.Holder());

  Blob* data;
  data = V8Blob::toImplWithTypeCheck(info.GetIsolate(), info[0]);
  if (!data) {
    exceptionState.throwTypeError("parameter 1 is not of type 'Blob'.");

    return;
  }

  impl->send(data, exceptionState);
  if (exceptionState.hadException()) {
    return;
  }
}

static void send3Method(const v8::FunctionCallbackInfo<v8::Value>& info) {
  ExceptionState exceptionState(info.GetIsolate(), ExceptionState::ExecutionContext, "WebSocket", "send");

  DOMWebSocket* impl = V8WebSocket::toImpl(info.Holder());

  DOMArrayBuffer* data;
  data = info[0]->IsArrayBuffer() ? V8ArrayBuffer::toImpl(v8::Local<v8::ArrayBuffer>::Cast(info[0])) : 0;
  if (!data) {
    exceptionState.throwTypeError("parameter 1 is not of type 'ArrayBuffer'.");

    return;
  }

  impl->send(data, exceptionState);
  if (exceptionState.hadException()) {
    return;
  }
}

static void send4Method(const v8::FunctionCallbackInfo<v8::Value>& info) {
  ExceptionState exceptionState(info.GetIsolate(), ExceptionState::ExecutionContext, "WebSocket", "send");

  DOMWebSocket* impl = V8WebSocket::toImpl(info.Holder());

  DOMArrayBufferView* data;
  data = info[0]->IsArrayBufferView() ? V8ArrayBufferView::toImpl(v8::Local<v8::ArrayBufferView>::Cast(info[0])) : 0;
  if (!data) {
    exceptionState.throwTypeError("parameter 1 is not of type 'ArrayBufferView'.");

    return;
  }

  impl->send(data, exceptionState);
  if (exceptionState.hadException()) {
    return;
  }
}

static void sendMethod(const v8::FunctionCallbackInfo<v8::Value>& info) {
  bool isArityError = false;
  switch (std::min(1, info.Length())) {
    case 1:
      if (V8Blob::hasInstance(info[0], info.GetIsolate())) {
        send2Method(info);
        return;
      }
      if (info[0]->IsArrayBuffer()) {
        send3Method(info);
        return;
      }
      if (info[0]->IsArrayBufferView()) {
        send4Method(info);
        return;
      }
      if (true) {
        send1Method(info);
        return;
      }
      break;
    default:
      isArityError = true;
  }

  ExceptionState exceptionState(info.GetIsolate(), ExceptionState::ExecutionContext, "WebSocket", "send");

  if (isArityError) {
    if (info.Length() < 1) {
      exceptionState.throwTypeError(ExceptionMessages::notEnoughArguments(1, info.Length()));
      return;
    }
  }
  exceptionState.throwTypeError("No function was found that matched the signature provided.");
}

void sendMethodCallback(const v8::FunctionCallbackInfo<v8::Value>& info) {
  DOMWebSocketV8Internal::sendMethod(info);
}

static void constructor(const v8::FunctionCallbackInfo<v8::Value>& info) {
  ExceptionState exceptionState(info.GetIsolate(), ExceptionState::ConstructionContext, "WebSocket");

  if (UNLIKELY(info.Length() < 1)) {
    exceptionState.throwTypeError(ExceptionMessages::notEnoughArguments(1, info.Length()));
    return;
  }

  V8StringResource<> url;
  StringOrStringSequence protocols;
  int numArgsPassed = info.Length();
  while (numArgsPassed > 0) {
    if (!info[numArgsPassed - 1]->IsUndefined())
      break;
    --numArgsPassed;
  }
  url = info[0];
  if (!url.prepare())
    return;

  if (UNLIKELY(numArgsPassed <= 1)) {
    ExecutionContext* executionContext = currentExecutionContext(info.GetIsolate());
    DOMWebSocket* impl = DOMWebSocket::create(executionContext, url, exceptionState);
    if (exceptionState.hadException()) {
      return;
    }
    v8::Local<v8::Object> wrapper = info.Holder();
    wrapper = impl->associateWithWrapper(info.GetIsolate(), &V8WebSocket::wrapperTypeInfo, wrapper);
    v8SetReturnValue(info, wrapper);
    return;
  }
  V8StringOrStringSequence::toImpl(info.GetIsolate(), info[1], protocols, UnionTypeConversionMode::NotNullable, exceptionState);
  if (exceptionState.hadException())
    return;

  ExecutionContext* executionContext = currentExecutionContext(info.GetIsolate());
  DOMWebSocket* impl = DOMWebSocket::create(executionContext, url, protocols, exceptionState);
  if (exceptionState.hadException()) {
    return;
  }
  v8::Local<v8::Object> wrapper = info.Holder();
  wrapper = impl->associateWithWrapper(info.GetIsolate(), &V8WebSocket::wrapperTypeInfo, wrapper);
  v8SetReturnValue(info, wrapper);
}

} // namespace DOMWebSocketV8Internal

const V8DOMConfiguration::AccessorConfiguration V8WebSocketAccessors[] = {
    {"url", DOMWebSocketV8Internal::urlAttributeGetterCallback, 0, 0, 0, nullptr, 0, v8::DEFAULT, static_cast<v8::PropertyAttribute>(v8::ReadOnly), V8DOMConfiguration::ExposedToAllScripts, V8DOMConfiguration::OnPrototype, V8DOMConfiguration::CheckHolder},
    {"readyState", DOMWebSocketV8Internal::readyStateAttributeGetterCallback, 0, 0, 0, nullptr, 0, v8::DEFAULT, static_cast<v8::PropertyAttribute>(v8::ReadOnly), V8DOMConfiguration::ExposedToAllScripts, V8DOMConfiguration::OnPrototype, V8DOMConfiguration::CheckHolder},
    {"bufferedAmount", DOMWebSocketV8Internal::bufferedAmountAttributeGetterCallback, 0, 0, 0, nullptr, 0, v8::DEFAULT, static_cast<v8::PropertyAttribute>(v8::ReadOnly), V8DOMConfiguration::ExposedToAllScripts, V8DOMConfiguration::OnPrototype, V8DOMConfiguration::CheckHolder},
    {"onopen", DOMWebSocketV8Internal::onopenAttributeGetterCallback, DOMWebSocketV8Internal::onopenAttributeSetterCallback, 0, 0, nullptr, 0, v8::DEFAULT, static_cast<v8::PropertyAttribute>(v8::None), V8DOMConfiguration::ExposedToAllScripts, V8DOMConfiguration::OnPrototype, V8DOMConfiguration::CheckHolder},
    {"onerror", DOMWebSocketV8Internal::onerrorAttributeGetterCallback, DOMWebSocketV8Internal::onerrorAttributeSetterCallback, 0, 0, nullptr, 0, v8::DEFAULT, static_cast<v8::PropertyAttribute>(v8::None), V8DOMConfiguration::ExposedToAllScripts, V8DOMConfiguration::OnPrototype, V8DOMConfiguration::CheckHolder},
    {"onclose", DOMWebSocketV8Internal::oncloseAttributeGetterCallback, DOMWebSocketV8Internal::oncloseAttributeSetterCallback, 0, 0, nullptr, 0, v8::DEFAULT, static_cast<v8::PropertyAttribute>(v8::None), V8DOMConfiguration::ExposedToAllScripts, V8DOMConfiguration::OnPrototype, V8DOMConfiguration::CheckHolder},
    {"extensions", DOMWebSocketV8Internal::extensionsAttributeGetterCallback, 0, 0, 0, nullptr, 0, v8::DEFAULT, static_cast<v8::PropertyAttribute>(v8::ReadOnly), V8DOMConfiguration::ExposedToAllScripts, V8DOMConfiguration::OnPrototype, V8DOMConfiguration::CheckHolder},
    {"protocol", DOMWebSocketV8Internal::protocolAttributeGetterCallback, 0, 0, 0, nullptr, 0, v8::DEFAULT, static_cast<v8::PropertyAttribute>(v8::ReadOnly), V8DOMConfiguration::ExposedToAllScripts, V8DOMConfiguration::OnPrototype, V8DOMConfiguration::CheckHolder},
    {"onmessage", DOMWebSocketV8Internal::onmessageAttributeGetterCallback, DOMWebSocketV8Internal::onmessageAttributeSetterCallback, 0, 0, nullptr, 0, v8::DEFAULT, static_cast<v8::PropertyAttribute>(v8::None), V8DOMConfiguration::ExposedToAllScripts, V8DOMConfiguration::OnPrototype, V8DOMConfiguration::CheckHolder},
    {"binaryType", DOMWebSocketV8Internal::binaryTypeAttributeGetterCallback, DOMWebSocketV8Internal::binaryTypeAttributeSetterCallback, 0, 0, nullptr, 0, v8::DEFAULT, static_cast<v8::PropertyAttribute>(v8::None), V8DOMConfiguration::ExposedToAllScripts, V8DOMConfiguration::OnPrototype, V8DOMConfiguration::CheckHolder},
};

const V8DOMConfiguration::MethodConfiguration V8WebSocketMethods[] = {
    {"close", DOMWebSocketV8Internal::closeMethodCallback, 0, 0, v8::None, V8DOMConfiguration::ExposedToAllScripts, V8DOMConfiguration::OnPrototype, V8DOMConfiguration::CheckHolder},
    {"send", DOMWebSocketV8Internal::sendMethodCallback, 0, 1, v8::None, V8DOMConfiguration::ExposedToAllScripts, V8DOMConfiguration::OnPrototype, V8DOMConfiguration::CheckHolder},
};

void V8WebSocket::constructorCallback(const v8::FunctionCallbackInfo<v8::Value>& info) {
  if (!info.IsConstructCall()) {
    V8ThrowException::throwTypeError(info.GetIsolate(), ExceptionMessages::constructorNotCallableAsFunction("WebSocket"));
    return;
  }

  if (ConstructorMode::current(info.GetIsolate()) == ConstructorMode::WrapExistingObject) {
    v8SetReturnValue(info, info.Holder());
    return;
  }

  DOMWebSocketV8Internal::constructor(info);
}

static void installV8WebSocketTemplate(v8::Isolate* isolate, const DOMWrapperWorld& world, v8::Local<v8::FunctionTemplate> interfaceTemplate) {
  // Initialize the interface object's template.
  V8DOMConfiguration::initializeDOMInterfaceTemplate(isolate, interfaceTemplate, V8WebSocket::wrapperTypeInfo.interfaceName, V8EventTarget::domTemplate(isolate, world), V8WebSocket::internalFieldCount);
  interfaceTemplate->SetCallHandler(V8WebSocket::constructorCallback);
  interfaceTemplate->SetLength(1);
  v8::Local<v8::Signature> signature = v8::Signature::New(isolate, interfaceTemplate);
  ALLOW_UNUSED_LOCAL(signature);
  v8::Local<v8::ObjectTemplate> instanceTemplate = interfaceTemplate->InstanceTemplate();
  ALLOW_UNUSED_LOCAL(instanceTemplate);
  v8::Local<v8::ObjectTemplate> prototypeTemplate = interfaceTemplate->PrototypeTemplate();
  ALLOW_UNUSED_LOCAL(prototypeTemplate);
  // Register DOM constants, attributes and operations.
  const V8DOMConfiguration::ConstantConfiguration V8WebSocketConstants[] = {
      {"CONNECTING", 0, 0, V8DOMConfiguration::ConstantTypeUnsignedShort},
      {"OPEN", 1, 0, V8DOMConfiguration::ConstantTypeUnsignedShort},
      {"CLOSING", 2, 0, V8DOMConfiguration::ConstantTypeUnsignedShort},
      {"CLOSED", 3, 0, V8DOMConfiguration::ConstantTypeUnsignedShort},
  };
  V8DOMConfiguration::installConstants(isolate, interfaceTemplate, prototypeTemplate, V8WebSocketConstants, WTF_ARRAY_LENGTH(V8WebSocketConstants));
  static_assert(0 == DOMWebSocket::kConnecting, "the value of DOMWebSocket_kConnecting does not match with implementation");
  static_assert(1 == DOMWebSocket::kOpen, "the value of DOMWebSocket_kOpen does not match with implementation");
  static_assert(2 == DOMWebSocket::kClosing, "the value of DOMWebSocket_kClosing does not match with implementation");
  static_assert(3 == DOMWebSocket::kClosed, "the value of DOMWebSocket_kClosed does not match with implementation");
  V8DOMConfiguration::installAccessors(isolate, world, instanceTemplate, prototypeTemplate, interfaceTemplate, signature, V8WebSocketAccessors, WTF_ARRAY_LENGTH(V8WebSocketAccessors));
  V8DOMConfiguration::installMethods(isolate, world, instanceTemplate, prototypeTemplate, interfaceTemplate, signature, V8WebSocketMethods, WTF_ARRAY_LENGTH(V8WebSocketMethods));
}

v8::Local<v8::FunctionTemplate> V8WebSocket::domTemplate(v8::Isolate* isolate, const DOMWrapperWorld& world) {
  return V8DOMConfiguration::domClassTemplate(isolate, world, const_cast<WrapperTypeInfo*>(&wrapperTypeInfo), installV8WebSocketTemplate);
}

bool V8WebSocket::hasInstance(v8::Local<v8::Value> v8Value, v8::Isolate* isolate) {
  return V8PerIsolateData::from(isolate)->hasInstance(&wrapperTypeInfo, v8Value);
}

v8::Local<v8::Object> V8WebSocket::findInstanceInPrototypeChain(v8::Local<v8::Value> v8Value, v8::Isolate* isolate) {
  return V8PerIsolateData::from(isolate)->findInstanceInPrototypeChain(&wrapperTypeInfo, v8Value);
}

DOMWebSocket* V8WebSocket::toImplWithTypeCheck(v8::Isolate* isolate, v8::Local<v8::Value> value) {
  return hasInstance(value, isolate) ? toImpl(v8::Local<v8::Object>::Cast(value)) : nullptr;
}

}  // namespace blink
