// Copyright 2014 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// This file has been auto-generated by code_generator_v8.py.
// DO NOT MODIFY!

// clang-format off
#ifndef ServiceWorkerMessageEventInit_h
#define ServiceWorkerMessageEventInit_h

#include "bindings/core/v8/ScriptValue.h"
#include "bindings/modules/v8/ServiceWorkerOrMessagePort.h"
#include "core/dom/MessagePort.h"
#include "core/events/EventInit.h"
#include "modules/ModulesExport.h"
#include "modules/serviceworkers/ServiceWorker.h"
#include "platform/heap/Handle.h"
#include "wtf/text/WTFString.h"

namespace blink {

class MessagePort;

class MODULES_EXPORT ServiceWorkerMessageEventInit : public EventInit {
  DISALLOW_NEW_EXCEPT_PLACEMENT_NEW();
 public:
  ServiceWorkerMessageEventInit();
  virtual ~ServiceWorkerMessageEventInit();
  ServiceWorkerMessageEventInit(const ServiceWorkerMessageEventInit&);
  ServiceWorkerMessageEventInit& operator=(const ServiceWorkerMessageEventInit&);

  bool hasData() const;
  ScriptValue data() const;
  void setData(ScriptValue);

  bool hasLastEventId() const;
  String lastEventId() const;
  void setLastEventId(String);

  bool hasOrigin() const;
  String origin() const;
  void setOrigin(String);

  bool hasPorts() const;
  const HeapVector<Member<MessagePort>>& ports() const;
  void setPorts(const HeapVector<Member<MessagePort>>&);

  bool hasSource() const;
  const ServiceWorkerOrMessagePort& source() const;
  void setSource(const ServiceWorkerOrMessagePort&);
  void setSourceToNull();

  v8::Local<v8::Value> toV8Impl(v8::Local<v8::Object>, v8::Isolate*) const override;
  DECLARE_VIRTUAL_TRACE();

 private:
  ScriptValue m_data;
  String m_lastEventId;
  String m_origin;
  bool m_hasPorts = false;
  HeapVector<Member<MessagePort>> m_ports;
  ServiceWorkerOrMessagePort m_source;

  friend class V8ServiceWorkerMessageEventInit;
};

}  // namespace blink

#endif  // ServiceWorkerMessageEventInit_h
