// Copyright 2013 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#if defined(__clang__)
#pragma clang diagnostic push
#pragma clang diagnostic ignored "-Wunused-private-field"
#elif defined(_MSC_VER)
#pragma warning(push)
#pragma warning(disable:4056)
#pragma warning(disable:4065)
#pragma warning(disable:4756)
#endif

#include "content/common/service_worker/fetch_event_dispatcher.mojom.h"

#include <math.h>
#include <stdint.h>
#include <utility>

#include "base/logging.h"
#include "base/trace_event/trace_event.h"
#include "mojo/public/cpp/bindings/lib/message_builder.h"
#include "mojo/public/cpp/bindings/lib/serialization_util.h"
#include "mojo/public/cpp/bindings/lib/validate_params.h"
#include "mojo/public/cpp/bindings/lib/validation_context.h"
#include "mojo/public/cpp/bindings/lib/validation_errors.h"
#include "mojo/public/interfaces/bindings/interface_control_messages.mojom.h"
#include "media/base/ipc/media_param_traits_macros.h"
#include "cc/ipc/quads_struct_traits.h"
#include "url/mojo/origin_struct_traits.h"
#include "content/public/common/referrer_struct_traits.h"
#include "media/capture/mojo/video_capture_types_typemap_traits.h"
#include "content/common/bluetooth/web_bluetooth_device_id_struct_traits.h"
#include "media/capture/ipc/capture_param_traits.h"
#include "services/video_capture/public/interfaces/capture_settings_traits.h"
#include "ui/events/mojo/event_struct_traits.h"
#include "gpu/ipc/common/mailbox_struct_traits.h"
#include "content/common/media/media_devices_param_traits.h"
#include "gpu/ipc/common/gpu_command_buffer_traits.h"
#include "cc/ipc/shared_quad_state_struct_traits.h"
#include "ui/gfx/mojo/accelerated_widget_struct_traits.h"
#include "content/common/service_worker/service_worker_messages.h"
#include "ui/gfx/mojo/buffer_types_traits.h"
#include "cc/ipc/transferable_resource_struct_traits.h"
#include "cc/ipc/filter_operations_struct_traits.h"
#include "content/common/indexed_db/indexed_db_param_traits.h"
#include "cc/ipc/render_pass_id_struct_traits.h"
#include "content/common/media/media_session_struct_traits.h"
#include "cc/ipc/filter_operation_struct_traits.h"
#include "device/bluetooth/public/interfaces/uuid_struct_traits.h"
#include "content/common/service_worker/service_worker_status_code_traits.h"
#include "services/ui/public/interfaces/display/display_struct_traits.h"
#include "ipc/ipc_message_utils.h"
#include "content/common/view_messages.h"
#include "ui/gfx/geometry/mojo/geometry_struct_traits.h"
#include "third_party/WebKit/public/platform/ReferrerPolicyEnumTraits.h"
#include "cc/ipc/frame_sink_id_struct_traits.h"
#include "cc/ipc/render_pass_struct_traits.h"
#include "cc/ipc/compositor_frame_metadata_struct_traits.h"
#include "services/service_manager/public/cpp/identity_struct_traits.h"
#include "cc/ipc/surface_sequence_struct_traits.h"
#include "gpu/ipc/common/dx_diag_node_struct_traits.h"
#include "content/public/common/common_param_traits.h"
#include "ui/events/mojo/latency_info_struct_traits.h"
#include "third_party/WebKit/public/web/WindowFeaturesStructTraits.h"
#include "cc/ipc/local_frame_id_struct_traits.h"
#include "services/video_capture/public/interfaces/device_descriptor_struct_traits.h"
#include "services/service_manager/public/cpp/service_info_struct_traits.h"
#include "media/capture/ipc/capture_param_traits_macros.h"
#include "content/common/frame_messages.h"
#include "skia/public/interfaces/bitmap_skbitmap_struct_traits.h"
#include "ui/gfx/mojo/selection_bound_struct_traits.h"
#include "content/public/common/common_param_traits_macros.h"
#include "url/mojo/url_gurl_struct_traits.h"
#include "content/common/service_worker/service_worker_types_traits.h"
#include "gpu/ipc/common/mailbox_holder_struct_traits.h"
#include "cc/ipc/begin_frame_args_struct_traits.h"
#include "gpu/ipc/common/surface_handle_struct_traits.h"
#include "ui/gfx/mojo/transform_struct_traits.h"
#include "content/common/indexed_db/indexed_db_struct_traits.h"
#include "skia/public/interfaces/image_filter_struct_traits.h"
#include "gpu/ipc/common/gpu_info_struct_traits.h"
#include "cc/ipc/selection_struct_traits.h"
#include "content/common/service_worker/embedded_worker_messages.h"
#include "content/common/indexed_db/indexed_db_messages.h"
#include "gpu/ipc/common/sync_token_struct_traits.h"
#include "services/service_manager/public/cpp/interface_provider_spec_struct_traits.h"
#include "mojo/common/common_custom_types_struct_traits.h"
#include "media/mojo/interfaces/pipeline_statistics_struct_traits.h"
#include "media/base/ipc/media_param_traits.h"
#include "content/common/resource_messages.h"
#include "cc/ipc/surface_id_struct_traits.h"
#include "cc/ipc/returned_resource_struct_traits.h"
#include "cc/ipc/compositor_frame_struct_traits.h"
#include "ui/gfx/mojo/icc_profile_struct_traits.h"
#include "ui/base/mojo/window_open_disposition_enum_traits.h"
namespace content {
namespace mojom {// static
FetchEventPreloadHandlePtr FetchEventPreloadHandle::New() {
  FetchEventPreloadHandlePtr rv;
  mojo::internal::StructHelper<FetchEventPreloadHandle>::Initialize(&rv);
  return rv;
}

FetchEventPreloadHandle::FetchEventPreloadHandle()
    : url_loader(),
      url_loader_client_request() {
}

FetchEventPreloadHandle::~FetchEventPreloadHandle() {
}
const char FetchEventDispatcher::Name_[] = "content::mojom::FetchEventDispatcher";
const uint32_t FetchEventDispatcher::Version_;

class FetchEventDispatcher_DispatchFetchEvent_ForwardToCallback
    : public mojo::MessageReceiver {
 public:
  FetchEventDispatcher_DispatchFetchEvent_ForwardToCallback(
      const FetchEventDispatcher::DispatchFetchEventCallback& callback,
      scoped_refptr<mojo::AssociatedGroupController> group_controller)
      : callback_(callback),
        serialization_context_(std::move(group_controller)) {
  }
  bool Accept(mojo::Message* message) override;
 private:
  FetchEventDispatcher::DispatchFetchEventCallback callback_;
  mojo::internal::SerializationContext serialization_context_;
  DISALLOW_COPY_AND_ASSIGN(FetchEventDispatcher_DispatchFetchEvent_ForwardToCallback);
};
bool FetchEventDispatcher_DispatchFetchEvent_ForwardToCallback::Accept(
    mojo::Message* message) {
  internal::FetchEventDispatcher_DispatchFetchEvent_ResponseParams_Data* params =
      reinterpret_cast<internal::FetchEventDispatcher_DispatchFetchEvent_ResponseParams_Data*>(
          message->mutable_payload());
  
  (&serialization_context_)->handles.Swap((message)->mutable_handles());
  bool success = true;
  ::content::ServiceWorkerStatusCode p_status{};
  base::Time p_dispatch_event_time{};
  FetchEventDispatcher_DispatchFetchEvent_ResponseParamsDataView input_data_view(params,
                                          &serialization_context_);
  
  if (!input_data_view.ReadStatus(&p_status))
    success = false;
  if (!input_data_view.ReadDispatchEventTime(&p_dispatch_event_time))
    success = false;
  if (!success) {
    ReportValidationErrorForMessage(
        message,
        mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
        "FetchEventDispatcher::DispatchFetchEvent response deserializer");
    return false;
  }
  if (!callback_.is_null()) {
    mojo::internal::MessageDispatchContext context(message);
    callback_.Run(
std::move(p_status), 
std::move(p_dispatch_event_time));
  }
  return true;
}

FetchEventDispatcherProxy::FetchEventDispatcherProxy(mojo::MessageReceiverWithResponder* receiver)
    : receiver_(receiver) {
}

void FetchEventDispatcherProxy::DispatchFetchEvent(
    int32_t in_fetch_event_id, const ::content::ServiceWorkerFetchRequest& in_request, FetchEventPreloadHandlePtr in_preload_handle, const DispatchFetchEventCallback& callback) {
   mojo::internal::SerializationContext serialization_context(
      group_controller_);
  size_t size = sizeof(::content::mojom::internal::FetchEventDispatcher_DispatchFetchEvent_Params_Data);
  size += mojo::internal::PrepareToSerialize<::content::mojom::ServiceWorkerFetchRequestDataView>(
      in_request, &serialization_context);
  size += mojo::internal::PrepareToSerialize<::content::mojom::FetchEventPreloadHandleDataView>(
      in_preload_handle, &serialization_context);
  mojo::internal::RequestMessageBuilder builder(internal::kFetchEventDispatcher_DispatchFetchEvent_Name, size);

  auto params =
      ::content::mojom::internal::FetchEventDispatcher_DispatchFetchEvent_Params_Data::New(builder.buffer());
  ALLOW_UNUSED_LOCAL(params);
  params->fetch_event_id = in_fetch_event_id;
  typename decltype(params->request)::BaseType* request_ptr;
  mojo::internal::Serialize<::content::mojom::ServiceWorkerFetchRequestDataView>(
      in_request, builder.buffer(), &request_ptr, &serialization_context);
  params->request.Set(request_ptr);
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      params->request.is_null(),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
      "null request in FetchEventDispatcher.DispatchFetchEvent request");
  typename decltype(params->preload_handle)::BaseType* preload_handle_ptr;
  mojo::internal::Serialize<::content::mojom::FetchEventPreloadHandleDataView>(
      in_preload_handle, builder.buffer(), &preload_handle_ptr, &serialization_context);
  params->preload_handle.Set(preload_handle_ptr);
  (&serialization_context)->handles.Swap(
      builder.message()->mutable_handles());
  mojo::MessageReceiver* responder =
      new FetchEventDispatcher_DispatchFetchEvent_ForwardToCallback(
          callback, group_controller_);
  if (!receiver_->AcceptWithResponder(builder.message(), responder))
    delete responder;
}
class FetchEventDispatcher_DispatchFetchEvent_ProxyToResponder {
 public:
  static FetchEventDispatcher::DispatchFetchEventCallback CreateCallback(
      uint64_t request_id,
      bool is_sync,
      mojo::MessageReceiverWithStatus* responder,
      scoped_refptr<mojo::AssociatedGroupController>
          group_controller) {
    std::unique_ptr<FetchEventDispatcher_DispatchFetchEvent_ProxyToResponder> proxy(
        new FetchEventDispatcher_DispatchFetchEvent_ProxyToResponder(
            request_id, is_sync, responder, group_controller));
    return base::Bind(&FetchEventDispatcher_DispatchFetchEvent_ProxyToResponder::Run,
                      base::Passed(&proxy));
  }

  ~FetchEventDispatcher_DispatchFetchEvent_ProxyToResponder() {
#if DCHECK_IS_ON()
    if (responder_) {
      // Is the Service destroying the callback without running it
      // and without first closing the pipe?
      responder_->DCheckInvalid("The callback passed to "
          "FetchEventDispatcher::DispatchFetchEvent() was never run.");
    }
#endif
    // If the Callback was dropped then deleting the responder will close
    // the pipe so the calling application knows to stop waiting for a reply.
    delete responder_;
  }

 private:
  FetchEventDispatcher_DispatchFetchEvent_ProxyToResponder(
      uint64_t request_id,
      bool is_sync,
      mojo::MessageReceiverWithStatus* responder,
      scoped_refptr<mojo::AssociatedGroupController> group_controller)
      : request_id_(request_id),
        is_sync_(is_sync),
        responder_(responder),
        serialization_context_(std::move(group_controller)) {
  }

  void Run(
      ::content::ServiceWorkerStatusCode in_status, base::Time in_dispatch_event_time);

  uint64_t request_id_;
  bool is_sync_;
  mojo::MessageReceiverWithStatus* responder_;
  // TODO(yzshen): maybe I should use a ref to the original one?
  mojo::internal::SerializationContext serialization_context_;

  DISALLOW_COPY_AND_ASSIGN(FetchEventDispatcher_DispatchFetchEvent_ProxyToResponder);
};

void FetchEventDispatcher_DispatchFetchEvent_ProxyToResponder::Run(
    ::content::ServiceWorkerStatusCode in_status, base::Time in_dispatch_event_time) {
  size_t size = sizeof(::content::mojom::internal::FetchEventDispatcher_DispatchFetchEvent_ResponseParams_Data);
  size += mojo::internal::PrepareToSerialize<::mojo::common::mojom::TimeDataView>(
      in_dispatch_event_time, &serialization_context_);
  mojo::internal::ResponseMessageBuilder builder(
      internal::kFetchEventDispatcher_DispatchFetchEvent_Name, size, request_id_,
      is_sync_ ? mojo::Message::kFlagIsSync : 0);
  auto params =
      ::content::mojom::internal::FetchEventDispatcher_DispatchFetchEvent_ResponseParams_Data::New(builder.buffer());
  ALLOW_UNUSED_LOCAL(params);
  mojo::internal::Serialize<::blink::mojom::ServiceWorkerEventStatus>(
      in_status, &params->status);
  typename decltype(params->dispatch_event_time)::BaseType* dispatch_event_time_ptr;
  mojo::internal::Serialize<::mojo::common::mojom::TimeDataView>(
      in_dispatch_event_time, builder.buffer(), &dispatch_event_time_ptr, &serialization_context_);
  params->dispatch_event_time.Set(dispatch_event_time_ptr);
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      params->dispatch_event_time.is_null(),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
      "null dispatch_event_time in FetchEventDispatcher.DispatchFetchEvent response");
  (&serialization_context_)->handles.Swap(
      builder.message()->mutable_handles());
  bool ok = responder_->Accept(builder.message());
  ALLOW_UNUSED_LOCAL(ok);
  // TODO(darin): !ok returned here indicates a malformed message, and that may
  // be good reason to close the connection. However, we don't have a way to do
  // that from here. We should add a way.
  delete responder_;
  responder_ = nullptr;
}

// static
bool FetchEventDispatcherStubDispatch::Accept(
    FetchEventDispatcher* impl,
    mojo::internal::SerializationContext* context,
    mojo::Message* message) {
  switch (message->header()->name) {
    case internal::kFetchEventDispatcher_DispatchFetchEvent_Name: {
      break;
    }
  }
  return false;
}

// static
bool FetchEventDispatcherStubDispatch::AcceptWithResponder(
    FetchEventDispatcher* impl,
    mojo::internal::SerializationContext* context,
    mojo::Message* message,
    mojo::MessageReceiverWithStatus* responder) {
  switch (message->header()->name) {
    case internal::kFetchEventDispatcher_DispatchFetchEvent_Name: {
      internal::FetchEventDispatcher_DispatchFetchEvent_Params_Data* params =
          reinterpret_cast<internal::FetchEventDispatcher_DispatchFetchEvent_Params_Data*>(
              message->mutable_payload());
      
      (context)->handles.Swap((message)->mutable_handles());
      bool success = true;
      int32_t p_fetch_event_id{};
      ::content::ServiceWorkerFetchRequest p_request{};
      FetchEventPreloadHandlePtr p_preload_handle{};
      FetchEventDispatcher_DispatchFetchEvent_ParamsDataView input_data_view(params,
                                              context);
      
      p_fetch_event_id = input_data_view.fetch_event_id();
      if (!input_data_view.ReadRequest(&p_request))
        success = false;
      if (!input_data_view.ReadPreloadHandle(&p_preload_handle))
        success = false;
      if (!success) {
        ReportValidationErrorForMessage(
            message,
            mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
            "FetchEventDispatcher::DispatchFetchEvent deserializer");
        return false;
      }
      FetchEventDispatcher::DispatchFetchEventCallback callback =
          FetchEventDispatcher_DispatchFetchEvent_ProxyToResponder::CreateCallback(
              message->request_id(),
              message->has_flag(mojo::Message::kFlagIsSync), responder,
              context->group_controller);
      // A null |impl| means no implementation was bound.
      assert(impl);
      TRACE_EVENT0("mojom", "FetchEventDispatcher::DispatchFetchEvent");
      mojo::internal::MessageDispatchContext context(message);
      impl->DispatchFetchEvent(
std::move(p_fetch_event_id), 
std::move(p_request), 
std::move(p_preload_handle), callback);
      return true;
    }
  }
  return false;
}

bool FetchEventDispatcherRequestValidator::Accept(mojo::Message* message) {
  if (mojo::internal::ControlMessageHandler::IsControlMessage(message))
    return true;

  mojo::internal::ValidationContext validation_context(
    message->data(), message->data_num_bytes(), message->handles()->size(),
    message, "FetchEventDispatcher RequestValidator");

  switch (message->header()->name) {
    case internal::kFetchEventDispatcher_DispatchFetchEvent_Name: {
      if (!mojo::internal::ValidateMessageIsRequestExpectingResponse(
              message, &validation_context)) {
        return false;
      }
      if (!mojo::internal::ValidateMessagePayload<
               internal::FetchEventDispatcher_DispatchFetchEvent_Params_Data>(
                  message, &validation_context)) {
        return false;
      }
      return true;
    }
    default:
      break;
  }

  // Unrecognized message.
  ReportValidationError(
      &validation_context,
      mojo::internal::VALIDATION_ERROR_MESSAGE_HEADER_UNKNOWN_METHOD);
  return false;
}

bool FetchEventDispatcherResponseValidator::Accept(mojo::Message* message) {
  if (mojo::internal::ControlMessageHandler::IsControlMessage(message))
    return true;

  mojo::internal::ValidationContext validation_context(
    message->data(), message->data_num_bytes(), message->handles()->size(),
    message, "FetchEventDispatcher ResponseValidator");

  if (!mojo::internal::ValidateMessageIsResponse(message, &validation_context))
    return false;
  switch (message->header()->name) {
    case internal::kFetchEventDispatcher_DispatchFetchEvent_Name: {
      if (!mojo::internal::ValidateMessagePayload<
               internal::FetchEventDispatcher_DispatchFetchEvent_ResponseParams_Data>(
                    message, &validation_context)) {
        return false;
      }
      return true;
    }
    default:
      break;
  }

  // Unrecognized message.
  ReportValidationError(
      &validation_context,
      mojo::internal::VALIDATION_ERROR_MESSAGE_HEADER_UNKNOWN_METHOD);
  return false;
}
}  // namespace mojom
}  // namespace content

namespace mojo {


// static
bool StructTraits<::content::mojom::FetchEventPreloadHandle::DataView, ::content::mojom::FetchEventPreloadHandlePtr>::Read(
    ::content::mojom::FetchEventPreloadHandle::DataView input,
    ::content::mojom::FetchEventPreloadHandlePtr* output) {
  bool success = true;
  ::content::mojom::FetchEventPreloadHandlePtr result(::content::mojom::FetchEventPreloadHandle::New());
  
      result->url_loader =
          input.TakeUrlLoader<decltype(result->url_loader)>();
      result->url_loader_client_request =
          input.TakeUrlLoaderClientRequest<decltype(result->url_loader_client_request)>();
  *output = std::move(result);
  return success;
}

}  // namespace mojo

#if defined(__clang__)
#pragma clang diagnostic pop
#elif defined(_MSC_VER)
#pragma warning(pop)
#endif