// Copyright 2016 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef MOJO_COMMON_COMMON_CUSTOM_TYPES_MOJOM_SHARED_INTERNAL_H_
#define MOJO_COMMON_COMMON_CUSTOM_TYPES_MOJOM_SHARED_INTERNAL_H_

#include <stdint.h>

#include "mojo/public/cpp/bindings/lib/array_internal.h"
#include "mojo/public/cpp/bindings/lib/bindings_internal.h"
#include "mojo/public/cpp/bindings/lib/map_data_internal.h"
#include "mojo/public/cpp/bindings/lib/native_enum_data.h"
#include "mojo/public/cpp/bindings/lib/native_struct_data.h"
#include "mojo/public/cpp/bindings/lib/buffer.h"

namespace mojo {
namespace internal {
class ValidationContext;
}
}
namespace mojo {
namespace common {
namespace mojom {
namespace internal {
using FilePath_Data = mojo::internal::NativeStruct_Data;
using ListValue_Data = mojo::internal::NativeStruct_Data;
using DictionaryValue_Data = mojo::internal::NativeStruct_Data;
using Time_Data = mojo::internal::NativeStruct_Data;
class TimeDelta_Data;
using TimeTicks_Data = mojo::internal::NativeStruct_Data;
class String16_Data;
class UnguessableToken_Data;
class Version_Data;

#pragma pack(push, 1)
class TimeDelta_Data {
 public:
  static TimeDelta_Data* New(mojo::internal::Buffer* buf) {
    return new (buf->Allocate(sizeof(TimeDelta_Data))) TimeDelta_Data();
  }

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  int64_t microseconds;

 private:
  TimeDelta_Data() : header_({sizeof(*this), 0}) {
  }
  ~TimeDelta_Data() = delete;
};
static_assert(sizeof(TimeDelta_Data) == 16,
              "Bad sizeof(TimeDelta_Data)");
class String16_Data {
 public:
  static String16_Data* New(mojo::internal::Buffer* buf) {
    return new (buf->Allocate(sizeof(String16_Data))) String16_Data();
  }

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<mojo::internal::Array_Data<uint16_t>> data;

 private:
  String16_Data() : header_({sizeof(*this), 0}) {
  }
  ~String16_Data() = delete;
};
static_assert(sizeof(String16_Data) == 16,
              "Bad sizeof(String16_Data)");
class UnguessableToken_Data {
 public:
  static UnguessableToken_Data* New(mojo::internal::Buffer* buf) {
    return new (buf->Allocate(sizeof(UnguessableToken_Data))) UnguessableToken_Data();
  }

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  uint64_t high;
  uint64_t low;

 private:
  UnguessableToken_Data() : header_({sizeof(*this), 0}) {
  }
  ~UnguessableToken_Data() = delete;
};
static_assert(sizeof(UnguessableToken_Data) == 24,
              "Bad sizeof(UnguessableToken_Data)");
class Version_Data {
 public:
  static Version_Data* New(mojo::internal::Buffer* buf) {
    return new (buf->Allocate(sizeof(Version_Data))) Version_Data();
  }

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<mojo::internal::Array_Data<uint32_t>> components;

 private:
  Version_Data() : header_({sizeof(*this), 0}) {
  }
  ~Version_Data() = delete;
};
static_assert(sizeof(Version_Data) == 16,
              "Bad sizeof(Version_Data)");

#pragma pack(pop)

}  // namespace internal
}  // namespace mojom
}  // namespace common
}  // namespace mojo

#endif  // MOJO_COMMON_COMMON_CUSTOM_TYPES_MOJOM_SHARED_INTERNAL_H_