// Copyright 2016 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef THIRD_PARTY_WEBKIT_PUBLIC_PLATFORM_MODULES_SHAPEDETECTION_SHAPEDETECTION_MOJOM_SHARED_INTERNAL_H_
#define THIRD_PARTY_WEBKIT_PUBLIC_PLATFORM_MODULES_SHAPEDETECTION_SHAPEDETECTION_MOJOM_SHARED_INTERNAL_H_

#include <stdint.h>

#include "mojo/public/cpp/bindings/lib/array_internal.h"
#include "mojo/public/cpp/bindings/lib/bindings_internal.h"
#include "mojo/public/cpp/bindings/lib/map_data_internal.h"
#include "mojo/public/cpp/bindings/lib/native_enum_data.h"
#include "mojo/public/cpp/bindings/lib/native_struct_data.h"
#include "mojo/public/cpp/bindings/lib/buffer.h"
#include "ui/gfx/geometry/mojo/geometry.mojom-shared-internal.h"

namespace mojo {
namespace internal {
class ValidationContext;
}
}
namespace blink {
namespace mojom {
namespace internal {
class FaceDetectionResult_Data;
class BarcodeDetectionResult_Data;

#pragma pack(push, 1)
class FaceDetectionResult_Data {
 public:
  static FaceDetectionResult_Data* New(mojo::internal::Buffer* buf) {
    return new (buf->Allocate(sizeof(FaceDetectionResult_Data))) FaceDetectionResult_Data();
  }

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<mojo::internal::Array_Data<mojo::internal::Pointer<::gfx::mojom::internal::RectF_Data>>> boundingBoxes;

 private:
  FaceDetectionResult_Data() : header_({sizeof(*this), 0}) {
  }
  ~FaceDetectionResult_Data() = delete;
};
static_assert(sizeof(FaceDetectionResult_Data) == 16,
              "Bad sizeof(FaceDetectionResult_Data)");
class BarcodeDetectionResult_Data {
 public:
  static BarcodeDetectionResult_Data* New(mojo::internal::Buffer* buf) {
    return new (buf->Allocate(sizeof(BarcodeDetectionResult_Data))) BarcodeDetectionResult_Data();
  }

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<mojo::internal::String_Data> raw_value;
  mojo::internal::Pointer<::gfx::mojom::internal::RectF_Data> bounding_box;

 private:
  BarcodeDetectionResult_Data() : header_({sizeof(*this), 0}) {
  }
  ~BarcodeDetectionResult_Data() = delete;
};
static_assert(sizeof(BarcodeDetectionResult_Data) == 24,
              "Bad sizeof(BarcodeDetectionResult_Data)");
const uint32_t kShapeDetection_DetectFaces_Name = 0;
class ShapeDetection_DetectFaces_Params_Data {
 public:
  static ShapeDetection_DetectFaces_Params_Data* New(mojo::internal::Buffer* buf) {
    return new (buf->Allocate(sizeof(ShapeDetection_DetectFaces_Params_Data))) ShapeDetection_DetectFaces_Params_Data();
  }

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Handle_Data frame_data;
  uint32_t width;
  uint32_t height;
  uint8_t padfinal_[4];

 private:
  ShapeDetection_DetectFaces_Params_Data() : header_({sizeof(*this), 0}) {
  }
  ~ShapeDetection_DetectFaces_Params_Data() = delete;
};
static_assert(sizeof(ShapeDetection_DetectFaces_Params_Data) == 24,
              "Bad sizeof(ShapeDetection_DetectFaces_Params_Data)");
class ShapeDetection_DetectFaces_ResponseParams_Data {
 public:
  static ShapeDetection_DetectFaces_ResponseParams_Data* New(mojo::internal::Buffer* buf) {
    return new (buf->Allocate(sizeof(ShapeDetection_DetectFaces_ResponseParams_Data))) ShapeDetection_DetectFaces_ResponseParams_Data();
  }

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<internal::FaceDetectionResult_Data> result;

 private:
  ShapeDetection_DetectFaces_ResponseParams_Data() : header_({sizeof(*this), 0}) {
  }
  ~ShapeDetection_DetectFaces_ResponseParams_Data() = delete;
};
static_assert(sizeof(ShapeDetection_DetectFaces_ResponseParams_Data) == 16,
              "Bad sizeof(ShapeDetection_DetectFaces_ResponseParams_Data)");
const uint32_t kShapeDetection_DetectBarcodes_Name = 1;
class ShapeDetection_DetectBarcodes_Params_Data {
 public:
  static ShapeDetection_DetectBarcodes_Params_Data* New(mojo::internal::Buffer* buf) {
    return new (buf->Allocate(sizeof(ShapeDetection_DetectBarcodes_Params_Data))) ShapeDetection_DetectBarcodes_Params_Data();
  }

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Handle_Data frame_data;
  uint32_t width;
  uint32_t height;
  uint8_t padfinal_[4];

 private:
  ShapeDetection_DetectBarcodes_Params_Data() : header_({sizeof(*this), 0}) {
  }
  ~ShapeDetection_DetectBarcodes_Params_Data() = delete;
};
static_assert(sizeof(ShapeDetection_DetectBarcodes_Params_Data) == 24,
              "Bad sizeof(ShapeDetection_DetectBarcodes_Params_Data)");
class ShapeDetection_DetectBarcodes_ResponseParams_Data {
 public:
  static ShapeDetection_DetectBarcodes_ResponseParams_Data* New(mojo::internal::Buffer* buf) {
    return new (buf->Allocate(sizeof(ShapeDetection_DetectBarcodes_ResponseParams_Data))) ShapeDetection_DetectBarcodes_ResponseParams_Data();
  }

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<mojo::internal::Array_Data<mojo::internal::Pointer<internal::BarcodeDetectionResult_Data>>> results;

 private:
  ShapeDetection_DetectBarcodes_ResponseParams_Data() : header_({sizeof(*this), 0}) {
  }
  ~ShapeDetection_DetectBarcodes_ResponseParams_Data() = delete;
};
static_assert(sizeof(ShapeDetection_DetectBarcodes_ResponseParams_Data) == 16,
              "Bad sizeof(ShapeDetection_DetectBarcodes_ResponseParams_Data)");

#pragma pack(pop)

}  // namespace internal
}  // namespace mojom
}  // namespace blink

#endif  // THIRD_PARTY_WEBKIT_PUBLIC_PLATFORM_MODULES_SHAPEDETECTION_SHAPEDETECTION_MOJOM_SHARED_INTERNAL_H_